SystemOrganization addCategory: #'OB-Enhancements-Commands'!
SystemOrganization addCategory: #'OB-Enhancements-Dynamic'!
SystemOrganization addCategory: #'OB-Enhancements-Morphs'!
SystemOrganization addCategory: #'OB-Enhancements-MultipleSelection'!
SystemOrganization addCategory: #'OB-Enhancements-PackageBrower'!
SystemOrganization addCategory: #'OB-Enhancements-Panels'!
SystemOrganization addCategory: #'OB-Enhancements-Querying'!
SystemOrganization addCategory: #'OB-Enhancements-SUnit'!
SystemOrganization addCategory: #'OB-Enhancements-SmartGroup'!
SystemOrganization addCategory: #'OB-Enhancements-Tests'!
SystemOrganization addCategory: #'OB-Enhancements-Traits'!
SystemOrganization addCategory: #'OB-Enhancements-TraitsTests'!
SystemOrganization addCategory: #'OB-Enhancements-Tree'!
SystemOrganization addCategory: #'OB-Enhancements-Various'!

Trait named: #OBTParentNode
	uses: {}
	category: 'OB-Enhancements-Traits'!

!OBTParentNode classSide methodsFor: 'instance creation' stamp: 'jk 8/14/2007 08:03'!
on: aNestedObject of: aParentNode
	^ self new on: aNestedObject of: aParentNode! !

!OBTParentNode methodsFor: 'testing' stamp: 'jk 8/26/2007 12:07'!
isUsedTrait
	^ true! !

!OBTParentNode methodsFor: 'displaying' stamp: 'jk 8/26/2007 11:37'!
name
	^ self nestedObject asString! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:53'!
nestedObject
	self explicitRequirement ! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:53'!
nestedObject: anObject
	self explicitRequirement ! !

!OBTParentNode methodsFor: 'public' stamp: 'jk 8/20/2007 15:30'!
numberOfPredecessors
	^ self parentNode numberOfPredecessors + 1! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:03'!
on: aNestedObject of: aParentNode
	self parentNode: aParentNode.
	self nestedObject: aNestedObject! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:02'!
parentNode
	self explicitRequirement ! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:02'!
parentNode: anObject
	self explicitRequirement! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 09:01'!
theClass
	^ self parentNode theClass! !

!OBTParentNode methodsFor: 'public' stamp: 'jk 8/14/2007 08:56'!
withAllParents
	^ (OrderedCollection new)
		add: self nestedObject;
		addAll: self parentNode withAllParents;
		yourself! !

Trait named: #TOBCmdMoveToTrait
	uses: {}
	category: 'OB-Enhancements-Traits'!

!TOBCmdMoveToTrait methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/6/2009 15:02'!
askForNewTraitFromClass: actualClass
	| traitName newTrait listOfTraits listOfTraitsNames index |
	listOfTraits := actualClass traitComposition allTraits.
	listOfTraitsNames := #('*New trait*'), (listOfTraits collect: [:tr | tr name]).
	index := UIManager default chooseFrom: listOfTraitsNames title: 'Please choose the trait to move the method to'.

	"Cancel was pressed"
	index = 0 ifTrue: [^ false].

	index ~= 1 ifTrue: [^ Smalltalk at: (listOfTraitsNames at: index)].
	
	traitName := OBTextRequest prompt: 'Name for the new trait'
				template: 'T' , actualClass name asString.
	(traitName isNil or: [traitName isEmpty]) ifTrue: [^ false].
	traitName := traitName asSymbol.
	newTrait := (Smalltalk includesKey: traitName) 
				ifTrue: [Smalltalk at: traitName]
				ifFalse: [self createTraitNamed: traitName inCategory: actualClass category].

	^ newTrait! !

!TOBCmdMoveToTrait methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/16/2009 04:31'!
cannotMoveError: aString for: compiledMethod

	| index v |
	self ignoreNotification
		ifTrue: [^ self].

"	index := UIManager default chooseFrom: #('proceed' 'proceed to all moves' 'open a debugger') title: aString."
	v := #('proceed' 'proceed to all moves' 'open a debugger') .
	index := OBChoiceRequest prompt: aString labels: v values: v.

	(index = v third)
		ifTrue: [self error: aString].
	(index = v second)
		ifTrue: [self doIgnoreNotification]! !

!TOBCmdMoveToTrait methodsFor: 'as yet unclassified' stamp: 'dr 1/21/2009 12:18'!
checkIfOK: compiledMethod

	compiledMethod isCompiledMethod
		ifFalse: [self cannotMoveError: 'The method to move is not a compiled method' for: compiledMethod].
	
	compiledMethod hasInstVarRef
		ifTrue: [self cannotMoveError: 'The method to move refer to instance variables. Please, add accessors'
						for: compiledMethod]
	! !

!TOBCmdMoveToTrait methodsFor: 'as yet unclassified' stamp: 'ab 8/31/2007 19:03'!
createTraitNamed: traitName inCategory: cat 
	^ Trait 
		named: traitName asSymbol
		uses: { }
		category: cat! !

!TOBCmdMoveToTrait methodsFor: 'requirement' stamp: 'AlexandreBergel 1/7/2009 11:28'!
doIgnoreNotification
	self explicitRequirement! !

!TOBCmdMoveToTrait methodsFor: 'requirement' stamp: 'AlexandreBergel 1/7/2009 11:31'!
ignoreNotification
	self explicitRequirement! !

!TOBCmdMoveToTrait methodsFor: 'as yet unclassified' stamp: 'ab 8/31/2007 19:06'!
keystroke
	^ $e! !

!TOBCmdMoveToTrait methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/6/2009 14:37'!
moveMethodNamed: methodReference inTrait: aTrait


	| compiledMethod actualClass |
	compiledMethod := methodReference compiledMethod.

	"the compiled Method to move should not refer to variable"	
	self checkIfOK: compiledMethod.

	actualClass := methodReference actualClass.
	actualClass removeSelector: methodReference methodSymbol.
	(actualClass traitComposition includesTrait: aTrait) 
		ifFalse: 
			[actualClass setTraitComposition: actualClass traitComposition + aTrait].
	aTrait compile: compiledMethod getSourceFromFile classified: methodReference category.
! !

OBCmdRenameCat subclass: #OBCmdRenamePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRenamePackage methodsFor: 'execution' stamp: 'dr 4/11/2008 14:10'!
execute
	| packageName |
	packageName := OBTextRequest
				prompt: 'Please type new package name' 
				template: target name.
	packageName ifNotNil:	
		[target renamePackageTo: packageName.
		target signalChanged]! !

!OBCmdRenamePackage methodsFor: 'execution' stamp: 'dr 7/3/2008 17:19'!
group
	^ #general! !

!OBCmdRenamePackage methodsFor: 'testing' stamp: 'dr 4/11/2008 14:08'!
isActive
	^ target isPackage and: [requestor isSelected: target]! !

!OBCmdRenamePackage methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:08'!
label
	^ 'rename package...'! !

OBCmdRenameCat subclass: #OBCmdRenameSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
execute
	| category |
	category := OBTextRequest
				prompt: 'Please type new category name' 
				template: target name.
	category ifNotNil:	
		[target name: category.
		 requestor panel columns first refresh.]! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
group
	^ #general! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 3/12/2008 15:20'!
isActive 
	^target isSmartGroupCategory and: [target isSearchGroup not]! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 3/1/2008 17:07'!
label
	^ 'rename smart group...'! !

PluggableTreeMorph subclass: #OBPluggableTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tree'!

!OBPluggableTreeMorph methodsFor: 'node access' stamp: 'dr 10/30/2008 16:29'!
contentsOfNode: node 
	| children | 
	self assert: node class == OBPluggableTreeItemWithParentNode. 
	getChildrenSelector ifNil: 
		[ ^ #() ].
	children := model 
		perform: getChildrenSelector
		with: (self pathToItem: node).
	^ children collectWithIndex: 
		[ : item : index | 
		OBPluggableTreeItemWithParentNode 
			with: item
			parent: node
			position: index
			model: self ]! !

!OBPluggableTreeMorph methodsFor: 'events-processing' stamp: 'dr 11/19/2008 11:15'!
handleMouseMove: anEvent
	"slightly updated to make sure that we always have dragging enabled, even when mouseFocus of hand doesn't point to us"
	anEvent wasHandled ifTrue: [^self]. 
	anEvent anyButtonPressed ifFalse: [^self].
	anEvent wasHandled: true.
	
	self mouseMove: anEvent.
	
	(self handlesMouseStillDown: anEvent) ifTrue:[
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!OBPluggableTreeMorph methodsFor: 'node access' stamp: 'dr 9/12/2008 11:16'!
hasNodeContents: node
	hasChildrenSelector ifNil:[ ^ false ]. 
	^ model perform: hasChildrenSelector with: (self pathToItem: node)! !

!OBPluggableTreeMorph methodsFor: 'node access' stamp: 'dr 12/9/2008 20:27'!
iconOfNode: node
	| iconName |
	getIconSelector ifNil: [^nil].
	iconName := model perform: getIconSelector with: node fullPosition.
	iconName ifNotNilDo: [:name | ^OBMorphicIcons iconNamed: name].
	^nil! !

!OBPluggableTreeMorph methodsFor: 'initialization' stamp: 'dr 12/2/2008 15:50'!
indentingItemClass	
	^OBIndentingListItemMorph! !

!OBPluggableTreeMorph methodsFor: 'selection' stamp: 'jk 11/24/2007 16:09'!
indexOfSelectedItem: aPluggableTreeItemNode 
	^ scroller submorphs findFirst: [ :e | e complexContents item = aPluggableTreeItemNode item ]! !

!OBPluggableTreeMorph methodsFor: 'item path' stamp: 'jk 12/9/2007 13:41'!
pathToItem: wrapper
	^ wrapper ifNil: [#()] ifNotNil: [wrapper path]! !

!OBPluggableTreeMorph methodsFor: 'item path' stamp: 'jk 12/8/2007 15:59'!
pathToSelectedItem
	^ self pathToItem: selectedWrapper! !

!OBPluggableTreeMorph methodsFor: 'node access' stamp: 'dr 10/28/2008 10:34'!
roots: anArray 
	roots := anArray collectWithIndex: 
		[ : item : index | 
		OBPluggableTreeItemWithParentNode 
			with: item
			parent: nil
			position: index
			model: self].
	self list: roots! !

!OBPluggableTreeMorph methodsFor: 'item path' stamp: 'jk 11/27/2007 15:10'!
selectPath: path in: listItem
	| i |
	i := 0.
	path isEmpty ifTrue: [^self setSilentSelectedMorph: nil].
	path isEmpty ifTrue: [^nil].
	listItem withSiblingsDo: [:each | 
		i := i + 1.
		i = path first ifTrue: [
			each isExpanded ifFalse: [
				each toggleExpandedState.
				self adjustSubmorphPositions.
			].
			each changed.
			path size = 1 ifTrue: [
				^ self setSilentSelectedMorph: each
			].
			each firstChild ifNil: [^self setSelectedMorph: nil].
			^self selectPath: path allButFirst in: each firstChild
		].
	].
	^ self setSilentSelectedMorph: nil! !

!OBPluggableTreeMorph methodsFor: 'selection' stamp: 'jk 12/8/2007 16:10'!
setSelectedMorph: aMorph
	selectedWrapper := aMorph complexContents.
	self selection: selectedWrapper.
	setSelectedSelector ifNotNil:[
		model 
			perform: setSelectedSelector 
			with: (self pathToItem:  selectedWrapper)
	].! !

!OBPluggableTreeMorph methodsFor: 'selection' stamp: 'jk 11/27/2007 15:09'!
setSilentSelectedMorph: aMorph
	selectedWrapper := aMorph complexContents.
	self selection: selectedWrapper.
! !

!OBPluggableTreeMorph methodsFor: 'updating' stamp: 'dr 9/18/2008 11:36'!
update: what
	| w | 
	w := what.
		what == getRootsSelector ifTrue:[
		self roots: (model perform: getRootsSelector).
		w := getSelectedPathSelector.
	].
	what = #selection ifTrue: [ 
		w := getSelectedPathSelector ].
	^ super update: w! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 14:57'!
alias
   ^self! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 12/15/2008 15:33'!
asFan
	^ OBEnhancementFan parent: self! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 7/7/2008 15:42'!
browser: aBrowser! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 15:35'!
currentParent
    ^nil! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:03'!
displayFullString
    ^self displayString! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/10/2008 15:06'!
getDefinition
    ^self definition! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 10/16/2007 14:55'!
isInstrumented
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 10:17'!
isMethodHolderNode
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 13:40'!
isNodeWithReferences
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 11:57'!
referencingClasses
    ^#()! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 8/15/2008 16:07'!
selectThisOrNextNodeOnSwitch: nextNode
   ^self! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 15:35'!
setCurrentParent: aNode! !

OBCodeNode subclass: #OBMonticelloPackageNode
	instanceVariableNames: 'workingCopy theClass classNode realClasses extensionClasses moreRecentOnServer classCatNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMonticelloPackageNode commentStamp: 'dr 7/16/2007 10:36' prior: 0!
I represent a Monticello package as a node in an OB system browser. My children are class, comment and metaclass nodes. Classes extended in the package I represent are also contained as nodes in my children.!

!OBMonticelloPackageNode class methodsFor: 'instance creation' stamp: 'dr 4/11/2008 14:35'!
on: aWorkingCopy
    ^self new workingCopy: aWorkingCopy! !

!OBMonticelloPackageNode class methodsFor: 'instance creation' stamp: 'dr 4/11/2008 14:36'!
package: aWorkingCopy class: aClass
	^self new workingCopy: aWorkingCopy; theClass: aClass! !

!OBMonticelloPackageNode methodsFor: 'comparing' stamp: 'dr 7/8/2008 11:34'!
= other 
	^(other notNil and: [other isPackage])
		ifTrue: [self name = other name and: [self classNode = other classNode]]
		ifFalse: [super = other]! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 7/10/2008 16:12'!
allCategory
    ^self classNode allCategoryWithPackageNode: self! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 6/26/2008 15:45'!
ancestrySelector
    ^#isDescendantOfPackage:! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:41'!
askForRepository

	| reps index |
	reps := self repositories.
	index := (PopUpMenu labelArray: (reps collect: [:rep | rep description]))
				startUpWithCaption: 'Repository:'.
	^(index = 0) ifTrue: [nil] ifFalse: [reps at: index]! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 4/11/2008 14:55'!
browse
	OBPackageBrowser openOnPackage: self workingCopy! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 11/19/2008 14:21'!
categories
     "answer method protocols (not class cats) of classNode in hierarchy view"
	^self classNode categoriesWithPackageNode: self! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 11/19/2008 14:23'!
categoryNodeNamed: aString
	self classNode ifNil: [^nil].
	^self classNode categoryNodeNamed: aString ! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 4/11/2008 14:27'!
checkForNewerVersionsAndAskIn: repository

	| newer |
	newer := workingCopy possiblyNewerVersionsIn: repository.
	^ newer isEmpty or: [
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, newer asString, String cr,
			'Do you really want to save this version?'].! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 4/11/2008 14:27'!
checkForNewerVersionsIn: repository
	| newer |
	newer := workingCopy possiblyNewerVersionsIn: repository.
	^ newer isEmpty not! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 2/11/2009 10:55'!
classCatNames
	^classCatNames ifNil: [ | pkgName pkgNameSize |
    		self workingCopy isDummyPackage ifTrue: [^self workingCopy categories].
    		pkgName := self systemCategoryPrefix, '-'.
    		pkgNameSize := pkgName size.
    		classCatNames := self class environment organization categories select: [:cat | 
	    			cat size > pkgNameSize and: [(pkgName = (cat first: pkgNameSize))]]
	].
! !

!OBMonticelloPackageNode methodsFor: 'navigating' stamp: 'dr 11/19/2008 14:20'!
classCategories
	^self classCatNames collect: [:ea | OBMonticelloClassCategoryNode on: ea workingCopy: self workingCopy]! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 7/7/2008 17:48'!
classNode
    ^classNode! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 7/7/2008 17:48'!
classNode: aNode
    classNode := aNode! !

!OBMonticelloPackageNode methodsFor: 'navigating' stamp: 'dr 4/11/2008 14:19'!
classes
	"Note: differentiate between classes and extension classes so that I can wrap them differently so that I can control how they are shown, e.g. extension classes in italic."

	| classes extensions | 
	classes := (self packageInfo classes collect: [:each | each asNode]) reject: [:ea | ea isNil].
	extensions := self extensionClasses collect: [:each | (OBClassExtensionNode on: each theNonMetaClass) package: self; yourself]. 
	^(classes asSet addAll: extensions; yourself) asArray! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'rw 7/2/2006 18:42'!
classesForPackage
	"return all classes for the selected package"

	^self classesHierarchically! !

!OBMonticelloPackageNode methodsFor: 'navigating' stamp: 'dr 4/11/2008 14:27'!
classesHierarchically
	^OBClassAwareNode sortHierarchicallyOptimized: self classes! !

!OBMonticelloPackageNode methodsFor: 'navigating' stamp: 'dr 10/28/2008 10:35'!
comments
	| comments extensions | 
	comments := self packageInfo classes collect: [:each | each asCommentNode].
	extensions := self extensionClasses collect: [:each | (OBClassCommentExtensionNode on: each theNonMetaClass) package: self; yourself].
	^(comments asSet addAll: extensions; yourself) asArray! !

!OBMonticelloPackageNode methodsFor: 'navigating' stamp: 'rw 7/18/2006 17:58'!
commentsHierarchically
	^ OBClassAwareNode sortHierarchicallyOptimized: self comments! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 7/11/2008 16:27'!
commentsOfUsedTraits
    ^self classNode commentsOfUsedTraits ! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 9/26/2008 14:31'!
containingPackage
    ^self packageInfo! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 9/2/2008 14:47'!
definition
    self classNode ifNotNil: [^self classNode definition].
    ^OBClassDefinition 
		environment: self environment 
		template: ((self environment at: #Class) template: self name)! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 6/7/2007 16:36'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 10/4/2008 19:50'!
dropSelector
    ^#dropOnPackage:! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 10:39'!
environment
    ^self class environment! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:19'!
extensionClasses
    extensionClasses ifNil: [extensionClasses := self packageInfo extensionClasses].
    ^extensionClasses! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'dr 7/16/2007 10:33'!
findClass
	| pattern foundClassOrTrait package |
	pattern := UIManager default request: 'Class name or fragment?'.
	pattern isEmpty ifTrue: [^ self].
	foundClassOrTrait := Utilities classFromPattern: pattern withCaption: ''.
	foundClassOrTrait ifNil: [^ self].
	package := self packageForClassOrTrait: foundClassOrTrait
				ifAbsent: [^ self].
	(OBMonticelloPackageNode package: package class: foundClassOrTrait asNode) 
		signalSelection! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 10/21/2008 17:28'!
hasComment
    ^self classNode hasComment! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 10/28/2008 15:29'!
hasOrganization
    self classNode ifNotNil: [^true].
    ^false! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 4/11/2008 14:27'!
hasRepository
	^self repositories notEmpty! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 12/22/2008 14:06'!
icon
     ((Smalltalk hasClassNamed: #HODataBase) not or: [OBPackageBrowser dynamicBrowser not]) ifTrue: [^super icon].
    ^((Smalltalk at: #HODataBase) default analyzedClasses anySatisfy: [:class | self packageInfo classes includes: class]) ifTrue: [#flag] ifFalse: [#blank]! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 10/24/2008 11:00'!
includesCategoryWithName: aString
    ^self workingCopy includesCategoryWithName: aString
     ! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 7/18/2008 17:01'!
includesClass: aClass
    ^self realClasses includes: aClass! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 7/11/2008 11:06'!
indentedName
     self classNode ifNotNil: [
	     (self realClasses includes: self classNode theNonMetaClass) ifTrue: [
		    ^Text string: self name emphasis: {TextEmphasis bold}
		]].
     ^(self workingCopy isDummyPackage and: [self workingCopy categories isEmpty]) 
          ifTrue: [Text string: self name emphasis: {TextEmphasis new emphasisCode: 3}] ifFalse: [self name]! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 4/11/2008 14:34'!
isDescendantOf: other
	^other class = self class and: [other workingCopy = self workingCopy]! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 3/1/2008 18:29'!
isDescendantOfClass: other
    ^false! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 7/16/2007 11:32'!
isDescendantOfClassCat: other
    ^self = other! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 12/2/2008 18:42'!
isDescendantOfMethodCat: category
	^ false! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 4/11/2008 14:34'!
isDescendantOfPackage: other
	^other class = self class and: [other workingCopy = self workingCopy]! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 7/11/2008 11:10'!
isDummy
    ^self workingCopy isDummyPackage! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 10/12/2007 14:38'!
isEnrichedDefinition
   ^false! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 9/10/2008 10:27'!
isOnTop
   ^OBPackageBrowser alwaysOnTopPackages includes: self workingCopy ! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 7/11/2008 11:10'!
isPackage
	^ self isDummy not! !

!OBMonticelloPackageNode methodsFor: 'navigating' stamp: 'dr 4/11/2008 14:19'!
metaclasses
	| metaclasses extensions | 
	metaclasses := self packageInfo classes collect: [:each | each asClassSideNode].
	extensions := self extensionClasses collect: [:each | (OBMetaclassExtensionNode on: each theNonMetaClass) package: self; yourself]. 
	^(metaclasses asSet addAll: extensions; yourself) asArray! !

!OBMonticelloPackageNode methodsFor: 'navigating' stamp: 'dr 4/11/2008 14:28'!
metaclassesHierarchically
	^ OBClassAwareNode sortHierarchicallyOptimized: self metaclasses! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 7/11/2008 16:27'!
metaclassesOfUsedTraits
    ^self classNode metaclassesOfUsedTraits ! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 6/27/2008 14:24'!
modified
    ^workingCopy modified! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 7/2/2008 14:04'!
moreRecentOnServer
    moreRecentOnServer ifNil: [^false].
    ^moreRecentOnServer! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 7/8/2008 16:02'!
name
	^workingCopy packageName! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 10/28/2008 15:38'!
organization
    self classNode ifNotNil: [^self classNode organization].
    ^self environment organization! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:30'!
package
    ^workingCopy package! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'dr 4/11/2008 14:29'!
packageForClassOrTrait: classOrTrait ifAbsent: absentblock
	MCWorkingCopy allManagers do: [:wc |
		(wc package packageInfo classes includes: classOrTrait)
			ifTrue: [^wc]
	].
	^absentblock value! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:28'!
packageInfo
    ^workingCopy packageInfo! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:31'!
packageName
    ^self package name! !

!OBMonticelloPackageNode methodsFor: 'printing' stamp: 'dr 9/22/2008 11:13'!
printOn: aStream
     super printOn: aStream.
	aStream
		nextPutAll: ' (';
		nextPutAll: self name;
		nextPut: $)! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 11/29/2008 18:14'!
realClasses
	realClasses ifNil: [realClasses := self packageInfo classes].
	^realClasses! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 11/19/2008 14:12'!
renamePackageTo: aString
    | oldName catName |
    oldName := self packageName.
    self package name: aString.
    self packageInfo packageName: aString.

    self classCatNames do: [:ea | 
	   catName := ea copyFrom: (oldName size + 2) to: ea size.
	   self organization renameCategory: ea toBe: aString, '-', catName].! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 4/11/2008 14:27'!
repositories
	^workingCopy repositoryGroup repositories! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 2/9/2009 16:28'!
resetCache
	classCatNames := nil! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 6/27/2008 15:24'!
resetExtensionClasses
    extensionClasses := nil! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 10/30/2008 09:52'!
shouldBeStyledBy: aShoutMorph
    super shouldBeStyledBy: aShoutMorph.
    ^self classNode isNil or: [self classNode isClassCommentNode not]! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 8/11/2008 11:43'!
systemCategoryPrefix
    ^self packageInfo systemCategoryPrefix! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:29'!
text
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self name, ''''! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 7/11/2008 11:23'!
theClass
    ^self classNode ifNotNil: [self classNode theClass]! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 4/11/2008 14:29'!
theClass: aClassNode
	theClass := aClassNode theClass! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 10/22/2008 18:20'!
theClassName
    ^self theClass name! !

!OBMonticelloPackageNode methodsFor: 'updating' stamp: 'dr 12/10/2008 10:38'!
updateRecentStatus
    self classNode ifNotNil: [^self]. 
    moreRecentOnServer := self repositories anySatisfy: [:repo | self checkForNewerVersionsIn: repo]! !

!OBMonticelloPackageNode methodsFor: 'hierarchy view' stamp: 'dr 7/11/2008 16:18'!
usedTraits
    ^self classNode usedTraits! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:32'!
workingCopy
	^workingCopy! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:32'!
workingCopy: aWorkingCopy
	workingCopy := aWorkingCopy! !

OBCodeNode subclass: #OBPackagesOrClassesNode
	instanceVariableNames: 'mcPackage browser lastSelectedClass packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackagesOrClassesNode commentStamp: 'dr 7/16/2007 10:34' prior: 0!
I represent the root of the node tree in an OB system browser. My children are Monticello packages and Monticello class categories.!

!OBPackagesOrClassesNode methodsFor: 'comparing' stamp: 'dr 10/24/2008 16:38'!
= other
    ^self hash = other hash! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 10/24/2008 10:15'!
addLabelForAllPkgs: recentlyModifiedPackages at: idx
    (idx = (1 + self defaultNumberOfRecentPackages + OBPackageBrowser alwaysOnTopPackages size) 
            and: [recentlyModifiedPackages allSatisfy: [:ea | (OBPackageBrowser modificationOfPackage: ea) > 0]])
              ifTrue: [self addSeparatingLabel: '- All Packages -' separate: true].			
			! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 10/24/2008 10:15'!
addLabelForModifiedPkgs: recentlyModifiedPackages at: idx separate: aBoolean
    (idx = (1 + OBPackageBrowser alwaysOnTopPackages size) 
            and: [recentlyModifiedPackages anySatisfy: [:ea | (OBPackageBrowser modificationOfPackage: ea) > 0]])
              ifTrue: [self addSeparatingLabel: '- Recently Modified -' separate: aBoolean].			
			! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 10/28/2008 10:32'!
addSeparatingLabel: aString separate: aBoolean		
    aBoolean ifTrue: [packages add: (OBMonticelloPackageNode new workingCopy: (OBDummyPackage packageName: ''))].				
    packages add: (OBMonticelloPackageNode new workingCopy: (OBDummyPackage packageName: aString)).
			! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 11/26/2008 11:24'!
addUnpackagedCategories: categories to: pkgs
	| remainingCats |
	remainingCats := SystemOrganization categories asSet difference: categories.
	remainingCats ifNotEmpty: [
	    pkgs add: (OBMonticelloPackageNode new workingCopy: (OBDummyPackage categories: remainingCats asOrderedCollection))].! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 11/19/2008 14:12'!
addWorkingCopy: aWorkingCopy coveredCategories: categories
    | packageNode |
    packageNode := OBMonticelloPackageNode new workingCopy: aWorkingCopy.
	
    categories add: aWorkingCopy packageName.	
    packages add: packageNode.

    packageNode classCatNames do: [:classCategory | categories add: classCategory].! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 9/10/2008 11:27'!
allWorkingCopies
    ^(MCWorkingCopy allManagers 
				asSortedCollection: [:a :b | a package name <= b package name]) asOrderedCollection.! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/7/2008 11:29'!
browser: aBrowser
    browser := aBrowser! !

!OBPackagesOrClassesNode methodsFor: 'navigation' stamp: 'dr 10/23/2008 13:27'!
classesHierarchically

	| selectedClass result | 
	result := OrderedCollection new.
	selectedClass := self selectedClass.
	selectedClass ifNil: [lastSelectedClass ifNil: [^#()]]
	               ifNotNil: [lastSelectedClass := selectedClass].
	lastSelectedClass allSuperclasses reverseDo: [:aClass | result add: aClass].
	lastSelectedClass allSubclassesWithLevelDo: [:aClass :level | result add: aClass] startingLevel: 0.	
	^result collect: [:class | class asNode]! !

!OBPackagesOrClassesNode methodsFor: 'configuration' stamp: 'dr 7/11/2008 10:49'!
defaultNumberOfRecentPackages
    ^5! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/16/2007 15:35'!
environment
    ^Smalltalk! !

!OBPackagesOrClassesNode methodsFor: 'comparing' stamp: 'dr 10/24/2008 16:35'!
hash
	^self identityHash! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:25'!
indentedName 
	^self name! !

!OBPackagesOrClassesNode methodsFor: 'initialize-release' stamp: 'dr 10/24/2008 16:37'!
initialize
	super initialize. 
	PackageOrganizer default addDependent: self.
	MCWorkingCopy addDependent: self.	! !

!OBPackagesOrClassesNode methodsFor: 'testing' stamp: 'dr 7/16/2007 15:33'!
isEnvironment
	^ true! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'dr 9/9/2008 16:52'!
mcPackage: aWorkingCopy
	mcPackage := aWorkingCopy! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'dr 7/16/2007 11:13'!
mcRepository
	^MCCacheRepository default! !

!OBPackagesOrClassesNode methodsFor: 'public' stamp: 'dr 9/18/2008 17:01'!
name
	^'Root Node'! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 12/18/2008 15:26'!
packages
	| coveredCats pkgs |
	packages ifNil: [
		OBPackageBrowser orderedPackages ifEmpty: [
			self packagesInDefaultOrder.
		] ifNotEmpty: [
			self packagesInUserDefinedOrder.
		]
	].

	coveredCats := OrderedCollection new.	 
	packages do: [:pkgNode | 
		coveredCats add: pkgNode name.	
		pkgNode classCatNames do: [:classCategory | coveredCats add: classCategory]].
   	pkgs := packages copy.
	self addUnpackagedCategories: coveredCats to: pkgs.	
	^pkgs

! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 11/26/2008 11:16'!
packagesInDefaultOrder
	| workingCopies lastModifiedPkgs recentlyModifiedPackages coveredCats |
	packages := OrderedCollection new.
	coveredCats := Set new.
	workingCopies := self allWorkingCopies.
	lastModifiedPkgs := self workingCopiesSortedByModification.
	
	"add recently modified packages on top"
	recentlyModifiedPackages := lastModifiedPkgs copyFrom: 1 to: self defaultNumberOfRecentPackages.	
	recentlyModifiedPackages reversed do: [:wc | workingCopies addFirst: wc].	
			
     "add always on top packages at the very top"
	OBPackageBrowser alwaysOnTopPackages reversed do: [:ea | workingCopies addFirst: ea].

     "add all packages to list"
	workingCopies withIndexDo: [:wc :idx |			
	    self addLabelForModifiedPkgs: recentlyModifiedPackages at: idx 
	                            separate: OBPackageBrowser alwaysOnTopPackages notEmpty.
	    self addLabelForAllPkgs: recentlyModifiedPackages at: idx.			
	    self addWorkingCopy: wc coveredCategories: coveredCats].	
			
	^packages
! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 11/26/2008 11:16'!
packagesInUserDefinedOrder
	| workingCopies coveredCats |	
	packages := OrderedCollection new.
	coveredCats := Set new.
	workingCopies := self allWorkingCopies.

     "add all packages in order defined by user"
	OBPackageBrowser orderedPackages do: [:wc |
		workingCopies remove: wc ifAbsent: [nil].				
	 	self addWorkingCopy: wc coveredCategories: coveredCats].	
	
	"add all packages for which there is no order defined yet at the end"
	workingCopies do: [:wc | self addWorkingCopy: wc coveredCategories: coveredCats].
	^packages	
! !

!OBPackagesOrClassesNode methodsFor: 'updating' stamp: 'dr 11/10/2008 15:08'!
resetCache
	packages := nil! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'dr 10/30/2008 09:46'!
selectedClass
	| columns columnsToTest |
	browser ifNil: [^self].
	columns := browser navigationPanel columns.
     columnsToTest := {columns second. columns first}.     
     columnsToTest do: [:col | col selectedNode ifNotNilDo: [:node | node isClassNode ifTrue: [^node theNonMetaClass]]].
	^nil! !

!OBPackagesOrClassesNode methodsFor: 'navigation' stamp: 'dr 9/26/2008 16:48'!
smartGroups
    ^(OBSmartRootNode default root: self; yourself) allNodes! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/16/2007 11:13'!
text
	^'Euh - something regarding an MCCachedRepository ?!!'! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'dr 7/8/2008 15:16'!
treeAround: aClass
	"Return a collection with the complete hierarchy of aClass, and with the chain of aClass up to Object"

	^(aClass withAllSubclasses
		addAll: aClass allSuperclasses;
		yourself)	
			collect: [:each | each asNode]! !

!OBPackagesOrClassesNode methodsFor: 'updating' stamp: 'dr 11/10/2008 15:08'!
update: aSymbol
	(aSymbol = #packages or: [aSymbol = #allManagers]) ifTrue: [self resetCache]	! !

!OBPackagesOrClassesNode methodsFor: 'package list' stamp: 'dr 9/10/2008 11:47'!
workingCopiesSortedByModification
    | workingCopies |
    workingCopies := self allWorkingCopies asSortedCollection: 
                              [:a :b | (OBPackageBrowser modificationOfPackage: a) >= 
		                             (OBPackageBrowser modificationOfPackage: b)].
	^workingCopies removeAllFoundIn: OBPackageBrowser alwaysOnTopPackages; yourself.! !

OBCodeNode subclass: #OBSmartAliasNode
	instanceVariableNames: 'node parentNode level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartAliasNode class methodsFor: 'instance creation' stamp: 'dr 3/13/2007 18:10'!
node: aNode
    ^self new node: aNode! !

!OBSmartAliasNode class methodsFor: 'instance creation' stamp: 'dr 7/4/2008 15:07'!
node: aNode level: anInteger
    ^self new node: aNode; level: anInteger; yourself! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/4/2008 14:57'!
alias
	^self node! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 2/29/2008 15:12'!
allNodes
    ^(self packages detect: [:ea | ea isAncestorOf: self node] ifNone: [^OrderedCollection new]) classes! !

!OBSmartAliasNode methodsFor: 'actions' stamp: 'dr 4/10/2007 10:53'!
browse
    self node browse! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/3/2007 11:18'!
categories
	^ Smalltalk organization categories collect: [:cat | OBClassCategoryNode 
															on: cat
															inEnvironment: Smalltalk]! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/11/2008 10:52'!
classes
    ^self navigateTo: #classes! !

!OBSmartAliasNode methodsFor: 'commands' stamp: 'dr 3/12/2008 15:32'!
cmdBrowse
	^OBCmdSmartGroupBrowse! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/11/2008 10:52'!
comments
    ^self navigateTo: #comments! !

!OBSmartAliasNode methodsFor: 'configuration' stamp: 'dr 7/4/2008 15:08'!
defaultLevel
    ^1! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 15:36'!
definition
    ^nil! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 3/3/2008 11:28'!
displayFullString
	^'Smart Node: ', self name! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 7/4/2008 15:36'!
indent
	| indent |
	indent := Text new: (4 * self level) asInteger.
	indent atAllPut: $ .
	^ indent asString! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 7/4/2008 15:34'!
indentedName
	^ self indent, self name! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 11:34'!
isAncestorOf: aNode using: aSelector
    ^aNode = self node or: [aNode = self]! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 3/12/2008 15:37'!
isBrowseable
    ^self alias isSearch not! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 3/1/2008 16:52'!
isDescendantOf: aNode
    ^aNode = self node! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:32'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 10/22/2008 09:43'!
isDescendantOfPackage: aNode
    ^false! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 7/9/2008 10:39'!
isDummy
    ^self level > self defaultLevel! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 10/30/2008 09:48'!
isPackageAlias
    ^self alias isPackage or: [self alias isClassCategoryNode]! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 8/11/2008 14:48'!
isSearchAlias
    ^self alias isSearch! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 9/22/2008 16:19'!
isSearchOrPackageAlias
    ^self isSearchAlias or: [self isPackageAlias]! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 2/29/2008 15:36'!
isSmartAlias
    ^true! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 10/29/2008 22:14'!
jumpIn: aColumnPanel
    "search for place where we could show class cats upon click on smart package node"
    aColumnPanel jumpTo: (self isSearchOrPackageAlias ifTrue: [self] ifFalse: [self alias]).
    (self alias isSearch and: [self alias classes notEmpty]) ifTrue: [
	    aColumnPanel adaptMetagraphFor: self alias.
	    aColumnPanel columns second selection: 1].! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 7/4/2008 15:08'!
level
    level ifNil: [level := self defaultLevel].
    ^level! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 7/4/2008 15:08'!
level: anInteger
    level := anInteger! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/11/2008 10:52'!
metaclasses
    ^self navigateTo: #metaclasses! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:11'!
name
    ^self node name! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 6/27/2008 15:25'!
navigateTo: aSymbol
    self isSearchOrPackageAlias ifTrue: [
	  self alias isPackage ifTrue: [self alias resetExtensionClasses].
	  ^self alias perform: aSymbol].
    ^self packageForNode ifNotNilDo: [:pkg | pkg perform: aSymbol] ifNil: [^OrderedCollection new]! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node
	^node! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node: aNode
	node := aNode! !

!OBSmartAliasNode methodsFor: 'private' stamp: 'dr 3/1/2008 16:29'!
packageForNode
    ^self packages detect: [:ea | ea isAncestorOf: self node] ifNone: [nil].! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/1/2008 16:20'!
packages
    ^self parentNode parentNode root packages! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode
	^parentNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartAliasNode methodsFor: 'printing' stamp: 'dr 4/5/2007 14:37'!
printOn: aStream
    super printOn: aStream.
    aStream nextPutAll: ' ('.
    self node printOn: aStream. 
    aStream nextPut: $).! !

!OBSmartAliasNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:00'!
remove
    ^self parentNode nodes remove: self.! !

!OBSmartAliasNode methodsFor: 'navigating' stamp: 'dr 8/15/2008 16:09'!
selectThisOrNextNodeOnSwitch: nextNode
   ^nextNode ifNil: [self alias selectThisOrNextNodeOnSwitch: nextNode] ifNotNil: [nextNode selectThisOrNextNodeOnSwitch: nil]! !

OBCodeNode subclass: #OBSmartGroupNode
	instanceVariableNames: 'name nodes parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/5/2007 17:04'!
name: aString
    ^self new name: aString! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 3/5/2008 14:40'!
addAlias: aNode
    | alias |
    alias := (OBSmartAliasNode node: aNode).
    (self nodes includes: alias) ifTrue: [^alias]. 
    ^self addNode: alias.! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 15:58'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 11/19/2008 14:20'!
allNodes
    | tmpNodes |
    tmpNodes := OrderedCollection new.
    self nodes do: [:node | tmpNodes add: node. 
	                    node alias isPackage ifTrue: [
		                   node alias classCategories do: [:classCat | tmpNodes add: (OBSmartAliasNode node: classCat level: 1.5)].
		               ]].
    ^tmpNodes! !

!OBSmartGroupNode methodsFor: 'navigation' stamp: 'dr 9/18/2008 15:54'!
classes
    ^#()! !

!OBSmartGroupNode methodsFor: 'navigation' stamp: 'dr 9/18/2008 15:55'!
comments
    ^#()! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/22/2008 11:27'!
definition
    ^nil! !

!OBSmartGroupNode methodsFor: 'drag and drop' stamp: 'dr 6/7/2007 16:19'!
dropSelector
    ^#dropOnSmartGroup:! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/10/2007 10:58'!
indentedName
    ^self name! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 3/12/2008 15:32'!
isBrowseable
    ^false! !

!OBSmartGroupNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:33'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 3/12/2008 15:20'!
isSearchGroup
    ^self name = OBSmartRootNode searchGroupName! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/16/2007 11:32'!
isSmartGroupCategory
    ^true! !

!OBSmartGroupNode methodsFor: 'navigation' stamp: 'dr 9/18/2008 15:55'!
metaclasses
    ^#()! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 9/10/2007 16:54'!
name
	^name! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 3/13/2008 17:01'!
name: aString
	name = OBSmartRootNode searchGroupName ifFalse: [name := aString]! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 10:48'!
nodes
    nodes ifNil: [nodes := OrderedCollection new].
    ^nodes! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:58'!
parentNode
	^parentNode! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:01'!
remove
    ^self parentNode nodes remove: self.! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 7/17/2008 11:32'!
reset
    nodes := OrderedCollection new.! !

OBCodeNode subclass: #OBSmartRootNode
	instanceVariableNames: 'nodes root'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartRootNode class methodsFor: 'initialization' stamp: 'dr 9/26/2008 11:50'!
default
    self initialize.
    Instances ifEmpty: [Instances add: self new].
    ^Instances last! !

!OBSmartRootNode class methodsFor: 'initialization' stamp: 'dr 9/26/2008 11:50'!
initialize
    "self initialize"
    Instances ifNil: [Instances := OrderedCollection new].! !

!OBSmartRootNode class methodsFor: 'configuration' stamp: 'dr 3/5/2008 15:07'!
searchGroupName
    ^'searches'! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/12/2007 17:12'!
addAlias: aNode
    ^self addNode: (OBSmartAliasNode node: aNode).! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:23'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartRootNode methodsFor: 'searching' stamp: 'dr 7/8/2008 17:27'!
addSearchNode: aSearchNode
    ^self searchGroup addAlias: aSearchNode. ! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 7/8/2008 16:53'!
allNodes
    ^self nodes inject: OrderedCollection new into: [:coll :ea | coll add: ea. coll addAll: ea allNodes. coll].
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 10/29/2008 22:27'!
allSmartNodes
     | smartGroups |
	smartGroups := self nodes reject: [:ea | ea = self searchGroup].
     ^smartGroups inject: OrderedCollection new into: [:coll :group | coll addAll: group nodes; yourself]! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:05'!
isDescendantOf: aNode
    ^false! !

!OBSmartRootNode methodsFor: 'navigating' stamp: 'dr 7/19/2007 15:37'!
name
    ^'smart root node'! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 10/29/2008 22:23'!
nodes
    | rootNode searchNode | 
    nodes ifNil: [ 
        nodes := OrderedCollection new.
        rootNode := OBSmartGroupNode name: 'default'.
        self addNode: rootNode.
        searchNode := OBSmartGroupNode name: 'searches'.
        self addNode: searchNode.
    ].
    ^nodes
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/1/2008 16:20'!
root
	^root! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/1/2008 16:20'!
root: aNode
	root := aNode! !

!OBSmartRootNode methodsFor: 'searching' stamp: 'dr 3/5/2008 15:09'!
searchGroup
    ^self nodes detect: [:node | node isSmartGroupCategory and: [node name = self class searchGroupName]] 
                  ifNone: [self addNode: (OBSmartGroupNode name: self class searchGroupName)].! !

!Trait methodsFor: '*ob-enhancements' stamp: 'dc 4/21/2007 15:34'!
asClassSideNode
	^ OBMetaclassNode on: self
! !

!Trait methodsFor: '*ob-enhancements' stamp: 'jk 8/20/2007 12:14'!
asClassSideNodeOf: aParentNode 
	^ OBUsedTraitMetaclassNode on: self of: aParentNode! !

!Trait methodsFor: '*ob-enhancements' stamp: 'dr 9/25/2008 14:45'!
asCommentNode
	^ OBClassCommentNode on: self theNonMetaClass ! !

!Trait methodsFor: '*ob-enhancements' stamp: 'dc 4/21/2007 15:35'!
asNode
	^ OBClassNode on: self
! !

!Trait methodsFor: '*ob-enhancements' stamp: 'jk 8/14/2007 08:09'!
asNodeOf: aParentNode
	^ OBUsedTraitNode on: self of: aParentNode! !

!OBBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 17:03'!
hasReferencePanel
    ^false! !

!OBBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/25/2008 15:20'!
isHierarchyBrowser
    ^false! !

!OBBrowser methodsFor: '*ob-enhancements' stamp: 'dr 5/24/2007 12:21'!
definitionPanel
	^ panels 
		detect: [:ea | ea isDefinition] 
		ifNone: [self error: 'No definition panel configured']! !

!OBBrowser methodsFor: '*ob-enhancements' stamp: 'dr 8/12/2008 17:15'!
refreshAll
   self navigationPanel columns first refreshAll! !

!OBSenderSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/11/2008 14:52'!
isMethodSearch
    ^true! !

!OBSenderSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 5/14/2008 16:17'!
methodSatisfiesQuery: methodRef 
    ^methodRef compiledMethod sendsSelector: query! !

!OBTextMorph methodsFor: '*ob-enhancements' stamp: 'dr 11/20/2008 14:57'!
keyStroke: anEvent	
	| stringHolder completionAllowed  |

	"eCompletion: to make sure that this also gets executed when we an acceptOnCR textMorph" 
	stringHolder := editor ifNotNil: [editor model]. 
	completionAllowed := (Smalltalk hasClassNamed: #ECController) and: [ECController allowModel: stringHolder].
	completionAllowed
		ifTrue: [(stringHolder completionController handleKeystrokeBefore: anEvent editor: editor)
				ifTrue: [editView scrollSelectionIntoView. ^ self]].
				
	(anEvent anyModifierKeyPressed or: [editView model isEditable])
		ifTrue: [super keyStroke: anEvent. editView removeIcons].! !

!OBList methodsFor: '*ob-enhancements' stamp: 'dr 10/20/2008 18:24'!
at: anInteger putFan: aFan
	self fan
		at: self treeSelection
		putFan: aFan.
	self extendTreeSelection: anInteger.
! !

!OBList methodsFor: '*ob-enhancements' stamp: 'dr 9/23/2008 16:09'!
extendTreeSelection: anInteger 
	self position extendSelection: anInteger! !

!OBList methodsFor: '*ob-enhancements' stamp: 'dr 9/23/2008 16:10'!
treeSelection
	^ self position treeSelection! !

!ParagraphEditor methodsFor: '*ob-enhancements' stamp: 'dr 1/21/2009 14:35'!
findClass: characterStream
	^self find: characterStream! !

!OBTextMorphEditorWithShout class methodsFor: '*ob-enhancements' stamp: 'dr 11/20/2008 15:04'!
initialize
	super initialize.! !

!OBTextMorphEditorWithShout class methodsFor: '*ob-enhancements' stamp: 'dr 11/20/2008 15:03'!
initializeCmdKeyShortcuts
	super initializeCmdKeyShortcuts.
	CmdActions at: ($f asInteger + 1) put: #findClass:.! !

OBMetaclassNode subclass: #OBTraitTransformationMetaclassNode
	uses: OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBTraitTransformationMetaclassNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
nestedObject
	transformation ! !

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
nestedObject: anObject
	transformation := anObject ! !

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
parentNode
	parentNode ! !

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
parentNode: anObject
	parentNode := anObject ! !

OBMetaclassNode subclass: #OBUsedTraitMetaclassNode
	uses: OBTParentNode - {#theClass. #name}
	instanceVariableNames: 'parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBUsedTraitMetaclassNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:30'!
nestedObject
	^ self theClass! !

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:30'!
nestedObject: anObject
	self theClass: anObject ! !

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 12:12'!
parentNode
	^ parentNode! !

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 12:12'!
parentNode: anObject
	parentNode := anObject ! !

TestCase subclass: #OBEnhHierarchyBrowserTest
	instanceVariableNames: 'hierarchyBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhHierarchyBrowserTest methodsFor: 'setup' stamp: 'dr 4/25/2008 17:28'!
setUp
    hierarchyBrowser := OBEnhancementHierarchyBrowser onClass: self class selector: #setUp.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/7/2008 16:20'!
testAutoSelection
    | classColumn columns |
    columns := hierarchyBrowser navigationPanel columns.
    classColumn := columns first.
    self assert: classColumn selection = 4. 
    self assert: classColumn selectedNode theClass = self class.
    self assert: columns last selectedNode selector = #setUp.
    self assert: columns last children size < 10.
    self assert: hierarchyBrowser definitionPanel text = (self class >> #setUp) getSource.
    self assert: hierarchyBrowser currentNode = columns last selectedNode.

    classColumn selection: 3.
    self assert: classColumn selection = 3. 
    self assert: classColumn selectedNode theClass = TestCase.
    self assert: columns last selectedNode theClass = TestCase.
    self assert: columns last selectedNode selector = #setUp.
    self assert: columns last children size > 20.
    self assert: hierarchyBrowser definitionPanel text asString withBlanksTrimmed = 'setUp'. 
    self assert: hierarchyBrowser currentNode = columns last selectedNode.

    classColumn selection: 4.
    self assert: classColumn selection = 4. 
    self assert: classColumn selectedNode theClass = self class.
    self assert: columns last selectedNode theClass = self class.
    self assert: columns last selectedNode selector = #setUp.
    self assert: columns last children size < 10.
    self assert: hierarchyBrowser definitionPanel text = (self class >> #setUp) getSource.
    self assert: hierarchyBrowser currentNode = columns last selectedNode.

    classColumn selection: 2.
    self assert: classColumn selection = 2. 
    self assert: classColumn selectedNode theClass = Object.
    self assert: columns last selectedNode isNil.
    self assert: (hierarchyBrowser definitionPanel getDefinition isKindOf: OBClassDefinition).
    self assert: hierarchyBrowser definitionPanel text = Object definition.
    self assert: hierarchyBrowser currentNode = classColumn selectedNode.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/12/2008 16:09'!
testBrowserSetup
    | classNodes |
    self assert: OBHierarchyBrowser isHierarchyBrowser.
    self assert: (OBHierarchyBrowser definitionPanel isKindOf: OBEnhancementDefinitionPanel).
    self assert: (OBHierarchyBrowser navigationPanel isKindOf: OBEnhancementColumnPanel).

    self assert: (hierarchyBrowser root isKindOf: OBClassNode).
    self assert: hierarchyBrowser root theClass = self class.

    self assert: (hierarchyBrowser currentNode isKindOf: OBMethodNode).
    self assert: hierarchyBrowser currentNode theClass = self class.
    self assert: hierarchyBrowser currentNode selector = #setUp.

    classNodes := hierarchyBrowser navigationPanel columns first children.
    self assert: classNodes size = 4. 
    self assert: classNodes last theClass = self class.
    self assert: classNodes third theClass = TestCase.! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/10/2008 10:30'!
testDoubleClick
    | classColumn columns |
    columns := hierarchyBrowser navigationPanel columns.
    classColumn := columns first.
    self assert: classColumn selection = 4. 
    self assert: classColumn selectedNode theClass = self class.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self deny: (hierarchyBrowser root displayStringForChild: classColumn children third) isText.
    self assert: columns last selectedNode selector = #setUp.

    classColumn selection: 3.
    classColumn doubleClick.
    self assert: classColumn selection = 3. 
    self assert: classColumn selectedNode theClass = TestCase.
    self assert: classColumn children size > 10.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self deny: (hierarchyBrowser root displayStringForChild: classColumn children fourth) isText.
    self assert: hierarchyBrowser definitionPanel text = TestCase definition.
    self assert: columns last children size > 20.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 15:46'!
testMethodSelection
    | hierarchyBrowser2 |
    self assert: (hierarchyBrowser root isKindOf: OBClassNode).
    self assert: (hierarchyBrowser currentNode isKindOf: OBMethodNode).
    self assert: hierarchyBrowser root metaNode ~= hierarchyBrowser currentNode metaNode.
    self assert: hierarchyBrowser root metaNode edges size >= 3.
    self assert: hierarchyBrowser root metaNode edges first selector = #classHierarchy.
    self assert: hierarchyBrowser currentNode metaNode ancestrySelector = #isDescendantOfMethod:.

    hierarchyBrowser2 := OBHierarchyBrowser onClass: self class.
    self assert: (hierarchyBrowser2 root isKindOf: OBClassNode).
    self assert: (hierarchyBrowser2 currentNode isKindOf: OBClassNode).
    self assert: hierarchyBrowser2 root metaNode ~= hierarchyBrowser2 currentNode metaNode.
    self assert: hierarchyBrowser2 root metaNode edges size >= 3.
    self assert: hierarchyBrowser2 root metaNode edges first selector = #classHierarchy.
    self assert: hierarchyBrowser2 currentNode metaNode edges size = 2.
    self assert: hierarchyBrowser2 currentNode metaNode edges first selector = #allCategory.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 15:29'!
testSelectedClassHighlighting
    | classColumn columns |
    columns := hierarchyBrowser navigationPanel columns.
    classColumn := columns first.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
 
    classColumn switch selection: 2.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self assert: columns second children isEmpty.
    self assert: hierarchyBrowser definitionPanel getDefinition text = self class comment.

    classColumn switch selection: 3.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self assert: columns second children size = 2.
    self assert: hierarchyBrowser definitionPanel getDefinition text = self class class definition.
! !

TestCase subclass: #OBEnhPackageBrowserTest
	instanceVariableNames: 'packageBrowser dynamicBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhPackageBrowserTest methodsFor: 'setup' stamp: 'dr 1/28/2008 11:05'!
setUp
    dynamicBrowser := OBPackageBrowser dynamicBrowser.
! !

!OBEnhPackageBrowserTest methodsFor: 'setup' stamp: 'dr 1/28/2008 11:05'!
tearDown
    OBPackageBrowser setDynamicBrowser: dynamicBrowser.
! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 13:20'!
testBackButton
    | classColumn |
    packageBrowser := OBPackageBrowser onClass: OBColumn selector: #list.
    classColumn := packageBrowser navigationPanel columns second.

    self assert: packageBrowser hasHistory.
    self deny: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 1.
    self assert: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBColumn.
    self assert: packageBrowser historyAtCursor selector = #list.
    self assert: packageBrowser historyNodes size = 1.
    self assert: packageBrowser historyBackNodes size = 0.

    classColumn selection: 1.
    self assert: packageBrowser currentNode theClass = OBBrowser. 
    self assert: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 2.
    self deny: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBBrowser.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 1.
    self assert: packageBrowser definitionPanel getDefinition text = OBBrowser definition.

    packageBrowser optionalButtonPanel back.
    self deny: packageBrowser hasBackHistory.
    self assert: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 1.
    self assert: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBColumn.
    self assert: packageBrowser historyAtCursor selector = #list.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 0.
    self assert: packageBrowser historyForwardNodes size = 1.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #list) getSource.
    self assert: packageBrowser currentNode selector = #list.

    packageBrowser optionalButtonPanel forward.
    self assert: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 2.
    self deny: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBBrowser.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 1.
    self assert: packageBrowser historyForwardNodes size = 0.
    self assert: packageBrowser definitionPanel getDefinition text = OBBrowser definition.
    self assert: packageBrowser currentNode theClass = OBBrowser.

    classColumn selection: 4.
    self assert: packageBrowser currentNode theClass = OBFan.    
    self assert: packageBrowser historyCursor = 3.
    self assert: packageBrowser historyAtCursor theClass = OBFan.
    self assert: packageBrowser historyNodes size = 3.

    packageBrowser optionalButtonPanel setBackPressed: true.
    packageBrowser historyGoToIndex: 1.
    self deny: packageBrowser hasBackHistory.
    self assert: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 1.
    self assert: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBColumn.
    self assert: packageBrowser historyAtCursor selector = #list.
    self assert: packageBrowser historyNodes size = 3.
    self assert: packageBrowser historyBackNodes size = 0.
    self assert: packageBrowser historyForwardNodes size = 2.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #list) getSource.
    self assert: packageBrowser currentNode selector = #list.    

    classColumn selection: 2.
    self assert: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 2.
    self assert: packageBrowser historyAtCursor theClass = OBBuilder.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 1.
    self assert: packageBrowser historyForwardNodes size = 0.
    self assert: packageBrowser definitionPanel getDefinition text = OBBuilder definition.
    self assert: packageBrowser currentNode theClass = OBBuilder.
    self assert: (packageBrowser historyBackNodes first theClass = OBColumn).    
! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 2/23/2008 16:28'!
testBrowserSetup
    | envMetaNode packageMetaNode classMetaNode methodMetaNode |
    envMetaNode := OBPackageBrowser defaultMetaNode.
    self assert: envMetaNode name = 'Environment'.
    self assert: (OBPackageBrowser defaultRootNode isKindOf: OBPackagesOrClassesNode).

    self assert: (OBPackageBrowser dynamicBrowser eqv: (OBPackageBrowser definitionPanel isKindOf: OBEnrichedDefinitionPanel)).   
    packageMetaNode := envMetaNode children first.
    self assert: packageMetaNode name = 'Package'.
    classMetaNode := packageMetaNode children first.
    self assert: classMetaNode name = 'Class'.
    self assert: (OBPackageBrowser dynamicBrowser eqv: (classMetaNode filters anySatisfy: [:filter | filter isKindOf: OBClassAnnotationFilter])).
    self assert: packageMetaNode children third name = 'Metaclass'.
    self assert: (OBPackageBrowser dynamicBrowser eqv: (packageMetaNode children third filters anySatisfy: [:filter | filter isKindOf: OBClassAnnotationFilter])).	
    methodMetaNode := classMetaNode children second children first.	
    self assert: methodMetaNode name = 'Method'.
    self assert: (OBPackageBrowser dynamicBrowser eqv: (methodMetaNode filters anySatisfy: [:filter | filter isKindOf: OBDynamicInheritanceFilter])).

    self assert: (OBPackageBrowser dynamicBrowser eqv: OBPackageBrowser hasReferencePanel).
! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 3/12/2008 16:16'!
testDeselection! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 12/22/2008 14:07'!
testDynamicInfo
	| packageNode clMetaNode columnNode pkgMetaNode classCatNode callBacksNode selectionNode methodMetaNode enrichedSelectionNode enrichedColumnNode source hoCollector methodCatMetaNode |
	packageNode _ OBMonticelloPackageNode on: (MCPackage named: 'OmniBrowser') workingCopy.
	classCatNode _ OBMonticelloClassCategoryNode 
		on: 'OmniBrowser-Kernel'
		workingCopy: packageNode workingCopy.
	pkgMetaNode _ (OBMetaNode named: 'Package') addFilter: OBClassSortFilter new.
	packageNode metaNode: pkgMetaNode.
	clMetaNode _ (OBMetaNode named: 'Class') addFilter: OBClassAnnotationFilter new.
	pkgMetaNode 
		childAt: #classes
		put: clMetaNode.
	methodCatMetaNode _ (OBMetaNode named: 'MethodCat') addFilter: OBMethodCategoryFilter new.
	methodMetaNode _ (OBMetaNode named: 'Method') addFilter: OBDynamicInheritanceFilter new.
	self assert: packageNode classes notEmpty.
	self assert: (packageNode classes anySatisfy: [ : ea | ea theClass == OBColumn ]).
	(Smalltalk hasClassNamed: #HOCollector) ifTrue: 
		[ hoCollector _ Smalltalk at: #HOCollector.
		hoCollector default removeClass: OBColumn.
		columnNode _ packageNode classes 
			detect: [ : ea | ea theClass == OBColumn ]
			ifNone: [ nil ].
		columnNode metaNode: clMetaNode.
		self assert: columnNode icon notNil.
		OBPackageBrowser dynamicBrowser 
			ifTrue: [ self assert: packageNode icon notNil ]
			ifFalse: [ self assert: packageNode icon isNil ].
		self deny: (columnNode isKindOf: OBEnrichedClassNode).
		self assert: columnNode icon = #blank.
		hoCollector default addClass: OBColumn.
		enrichedColumnNode _ packageNode classes 
			detect: [ : ea | ea theClass == OBColumn ]
			ifNone: [ nil ].
		self assert: (enrichedColumnNode isKindOf: OBEnrichedClassNode).
		self assert: columnNode icon = #flag.
		OBPackageBrowser dynamicBrowser 
			ifTrue: 
				[ self assert: packageNode icon = #flag.
				self assert: classCatNode icon = #flag ]
			ifFalse: 
				[ self assert: packageNode icon isNil.
				self assert: classCatNode icon isNil ].
		hoCollector default removeClass: OBColumn.

		"test flag for method and method protocols"
		callBacksNode _ columnNode categories 
			detect: [ : ea | ea category = 'callbacks' ]
			ifNone: [ nil ].
		callBacksNode metaNode: methodCatMetaNode.
		self assert: callBacksNode notNil.
		selectionNode _ callBacksNode methods 
			detect: [ : ea | ea selector = #selection ]
			ifNone: [ nil ].
		self assert: selectionNode notNil.
		self deny: (selectionNode isKindOf: OBEnrichedMethodNode).
		selectionNode metaNode: methodMetaNode.
		self assert: callBacksNode icon notNil.
		self assert: selectionNode icon notNil.
		self assert: callBacksNode icon = #blank.
		self assert: selectionNode icon = #blank.
		hoCollector default addMethod: OBColumn >> #selection.
		self assert: callBacksNode icon = #flag.
		self assert: selectionNode icon = #flag.
		enrichedSelectionNode _ callBacksNode methods 
			detect: [ : ea | ea selector = #selection ]
			ifNone: [ nil ].
		self assert: (enrichedSelectionNode isKindOf: OBEnrichedMethodNode).
		self assert: enrichedSelectionNode source size = 35.
		self assert: OBColumn new clearSelection selection = 0.
		source _ enrichedSelectionNode source.
		self assert: source size = 39.
		"test for spaces after selection and ifNil:"
		#(25 26 27 34 35 36 ) do: [ : i | self assert: (source string at: i) = Character space ].
		self assert: enrichedSelectionNode referencingClasses size = 1.
		self assert: (enrichedSelectionNode referencingClasses anySatisfy: [ : ea | ea theClass == SmallInteger ]).

		"there should be two icons in the second line: one after selection, the other after ifNil:, and one in the first line"
		self assert: enrichedSelectionNode formatter iconPositions size = 3.
		self assert: (enrichedSelectionNode formatter iconPositions values includes: #(8 1 )).
		self assert: (enrichedSelectionNode formatter iconPositions values includes: #(11 2 )).
		self assert: (enrichedSelectionNode formatter iconPositions values includes: #(20 2 )).
		hoCollector default removeMethod: OBColumn >> #selection.
		self assert: callBacksNode icon = #blank.
		self assert: selectionNode icon = #blank ]! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:52'!
testEnrichedDefinitionPanel
    | defPanel browser defMorph tabBarMorph textMorph tabPanelMorph referenceMorph hasCodeTabPanel |
    OBPackageBrowser setDynamicBrowser: true.
    defPanel := OBPackageBrowser definitionPanel.
    browser := OBPackageBrowser new.
    defPanel browser: browser.
    hasCodeTabPanel := Preferences visualizations and: [defPanel hasCodeTabPanel].

    self assert: (defPanel isKindOf: OBEnrichedDefinitionPanel). 
    defPanel buildOn: OBMorphBuilder new.
    defMorph := defPanel morph.
    self assert: defMorph submorphs size = (hasCodeTabPanel ifTrue: [2] ifFalse: [1]). 
    tabBarMorph := defMorph submorphs detect: [:ea | ea isKindOf: RectangleMorph] ifNone: [nil].
    textMorph := defMorph submorphs detect: [:ea | ea isKindOf: OBEnrichedPluggableTextMorph] ifNone: [nil].
    self assert: textMorph notNil.
    
    hasCodeTabPanel ifTrue: [
	   self assert: tabBarMorph notNil.
	   self assert: tabBarMorph submorphs size = 1.
        tabPanelMorph := tabBarMorph submorphs detect: [:ea | ea isKindOf: OBRadioButtonBar] ifNone: [nil].
        self assert: tabPanelMorph notNil.
        self assert: tabPanelMorph buttons size > 4.
        self assert: tabPanelMorph buttons first label = (Smalltalk at: #OBCmdSourceCode) new shortLabel.
        self assert: tabPanelMorph buttons last label = (Smalltalk at: #OBCmdUmlDiagram) new shortLabel.
        self assert: tabPanelMorph buttons first isEnabled.
        self assert: tabPanelMorph buttons last isEnabled not. 
    ]. 

    self assert: (defMorph owner isKindOf: RectangleMorph).
    self assert: (defMorph owner submorphs allSatisfy: [:ea | ea isKindOf: RectangleMorph]).
    self assert: (defMorph owner submorphs includes: defMorph).
    referenceMorph := defMorph owner submorphs detect: [:ea | ea ~= defMorph].
    self assert: referenceMorph submorphs size = 2.
    self assert: (referenceMorph submorphs first isKindOf: RectangleMorph).
    self assert: (referenceMorph submorphs second isKindOf: OBPaneScroller).
    self assert: (referenceMorph submorphs first submorphs first contents = defPanel referenceList listTitle).! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 1/28/2008 11:00'!
testExtensionNodes
    | packageNode objectNode textNode pkgMetaNode clMetaNode |
    packageNode := OBMonticelloPackageNode on: (MCPackage named: 'OmniBrowser') workingCopy.
    pkgMetaNode := (OBMetaNode named: 'Package') addFilter: OBClassSortFilter new.
    packageNode metaNode: pkgMetaNode.
    clMetaNode := OBMetaNode named: 'Class'.
    pkgMetaNode childAt: #classes put: clMetaNode.

    self assert: packageNode classes notEmpty.
    self assert: (packageNode classes anySatisfy: [:ea | ea theClass == OBColumn]).
    self assert: (packageNode classes anySatisfy: [:ea | ea theClass == Object]).

    objectNode := packageNode classes detect: [:ea | ea theClass == Object] ifNone: [nil].
    objectNode metaNode: clMetaNode.
    self assert: objectNode notNil.
    self assert: (objectNode isKindOf: OBClassExtensionNode).
    self assert: objectNode name isText.
    self assert: (objectNode name emphasisAt: 1) = TextEmphasis italic emphasisCode.

    "to make sure indents are set in class filter..."
    objectNode := packageNode childNodes detect: [:ea | ea theClass == Object] ifNone: [nil].

    self assert: (packageNode displayStringForChild: objectNode) isText.
    self assert: ((packageNode displayStringForChild: objectNode) emphasisAt: 1) = TextEmphasis italic emphasisCode.
    self assert: (packageNode displayStringForChild: objectNode) string = 'Object'.

    textNode := packageNode classes detect: [:ea | ea theClass == Text] ifNone: [nil].
    textNode metaNode: clMetaNode.
    self assert: textNode notNil.
    self assert: (textNode isKindOf: OBClassExtensionNode).
    self assert: textNode name isText.
    self assert: (textNode name emphasisAt: 1) = TextEmphasis italic emphasisCode.

    "to make sure indents are set in class filter..."
    textNode := packageNode childNodes detect: [:ea | ea theClass == Text] ifNone: [nil].

    self assert: (packageNode displayStringForChild: textNode) isText.
    self assert: ((packageNode displayStringForChild: textNode) emphasisAt: 1) = TextEmphasis italic emphasisCode.
    self assert: (packageNode displayStringForChild: textNode) string = '  Text'.! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 3/10/2008 17:04'!
testRememberingMethod
    | classColumn methodColumn idx |
    packageBrowser := OBPackageBrowser onClass: OBBrowser selector: #buildOn:.
    classColumn := packageBrowser navigationPanel columns second.
    methodColumn := packageBrowser navigationPanel columns last.

    self assert: packageBrowser definitionPanel getDefinition text = (OBBrowser >> #buildOn:) getSource.
    self assert: packageBrowser currentNode selector = #buildOn:.

    classColumn selection: 3.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBColumn.
    self assert: packageBrowser currentNode selector = #buildOn:.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #buildOn:) getSource.

    idx := methodColumn children indexOf: (OBMethodNode on: #children inClass: OBColumn).
    methodColumn selection: idx.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBColumn.
    self assert: packageBrowser currentNode selector = #children.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #children) getSource.

    classColumn selection: 4.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBFan.
    self assert: packageBrowser currentNode selector = #children.
    self assert: packageBrowser definitionPanel getDefinition text = (OBFan >> #children) getSource.

    classColumn selection: 1.
    self deny: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBBrowser.
    self assert: packageBrowser definitionPanel getDefinition text = OBBrowser definition.

    classColumn selection: 3.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBColumn.
    self assert: packageBrowser currentNode selector = #children.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #children) getSource.! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 11/19/2008 14:11'!
testRootNode
    | rootNode packages pkgWithCategories pkgIdx dummyPackage dummyPackages |
    rootNode := OBPackageBrowser defaultRootNode.
    self assert: rootNode isEnvironment.
    self assert: rootNode environment == Smalltalk.

    packages := rootNode packages.
    self assert: packages notEmpty.
    self assert: (packages first isKindOf: OBMonticelloPackageNode).
    pkgWithCategories := packages detect: [:package | package classCatNames notEmpty].
    pkgIdx := packages indexOf: pkgWithCategories.
    self assert: ((packages at: pkgIdx + 1) name = pkgWithCategories classCatNames first).
    self assert: ((packages at: pkgIdx + 1) workingCopy = pkgWithCategories workingCopy).
    self assert: ((packages at: pkgIdx + pkgWithCategories classCatNames size) name = pkgWithCategories classCatNames last).

    "test dummy package"
    self flag: #complete.
    dummyPackages := packages select: [:pkg | pkg workingCopy isKindOf: OBDummyPackage] thenCollect: [:ea | ea workingCopy].
    dummyPackage := dummyPackages fourth.
    dummyPackage ifNotNil: [
	   self deny: dummyPackage modified.
	   self assert: dummyPackage packageName = 'Unpackaged'.
	   self assert: dummyPackage repositories isEmpty.
	   self assert: dummyPackage extensionClasses isEmpty.
	   self deny: dummyPackage categories isEmpty.
    ].
    ! !

TestCase subclass: #OBEnhPackageNodeTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhPackageNodeTest methodsFor: 'configuration' stamp: 'dr 9/2/2008 15:23'!
setUp
    node := OBMonticelloPackageNode on: (MCPackage named: BogusInfo packageName) workingCopy ! !

!OBEnhPackageNodeTest methodsFor: 'tests' stamp: 'dr 9/2/2008 16:31'!
testAncestry
   | otherNode |
   otherNode := OBMonticelloPackageNode on: (MCPackage named: 'OmniBrowser') workingCopy.
   self deny: (node isDescendantOfClass: self class asNode).
   self deny: (node isDescendantOfClassCat: otherNode).
   self assert: (node isDescendantOfClassCat: node copy).
   self deny: (node isDescendantOfPackage: otherNode).
   self assert: (node isDescendantOfPackage: node copy).
! !

!OBEnhPackageNodeTest methodsFor: 'tests' stamp: 'dr 9/2/2008 17:01'!
testDummyPackage
   | otherNode dummyPackage |
   otherNode := node copy.
   dummyPackage := OBDummyPackage packageName: 'dummyPkg'.
   otherNode workingCopy: dummyPackage.

   self deny: node isDummy.
   self assert: otherNode isDummy.  
   self assert: otherNode workingCopy isDummyPackage.
   self assert: otherNode workingCopy packageName = 'dummyPkg'.
   self assert: otherNode workingCopy = dummyPackage.   

   self assert: otherNode workingCopy classes isEmpty.
   self assert: otherNode workingCopy extensionClasses isEmpty.
   self deny: otherNode workingCopy modified.
   self assert: (otherNode workingCopy possiblyNewerVersionsIn: nil) isEmpty.
   self assert: otherNode workingCopy repositories isEmpty.
   self assert: (otherNode workingCopy repositoryGroup isKindOf: MCRepositoryGroup).
   self assert: otherNode workingCopy systemCategoryPrefix isString.
   self assert: otherNode workingCopy systemCategoryPrefix isEmpty.

! !

!OBEnhPackageNodeTest methodsFor: 'tests' stamp: 'dr 11/19/2008 14:20'!
testPackage
   self assert: node package = (MCPackage named: BogusInfo packageName).
   self assert: node packageName = BogusInfo packageName.
   self assert: node name = BogusInfo packageName.
   self assert: node packageInfo = BogusInfo package.
   self assert: node workingCopy = (MCPackage named: BogusInfo packageName) workingCopy.

   self assert: node classCatNames size = 3.
   self assert: (node classCatNames includes: 'Bogus-Base').
   self assert: node classCategories size = 3.
   self assert: (node classCategories allSatisfy: [:e | e isKindOf: OBMonticelloClassCategoryNode]).

   self assert: node classes size = 10.
   self assert: (node classes includes: BogusA asNode).
   self assert: node realClasses size = 10.
   self assert: (node realClasses includes: BogusA).! !

!OBEnhPackageNodeTest methodsFor: 'tests' stamp: 'dr 9/2/2008 16:45'!
testStyling
   self assert: (node shouldBeStyledBy: (PluggableShoutMorph new styler: SHTextStylerST80 new)).! !

!OBEnhPackageNodeTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:11'!
testTemplate
   self assert: (node definition isKindOf: OBClassDefinition).
   self assert: node definition text = (Class template: BogusInfo packageName)! !

!OBEnhPackageNodeTest methodsFor: 'tests' stamp: 'dr 9/2/2008 16:41'!
testWithClassNode
   self deny: node isDummy.! !

TestCase subclass: #OBEnhSetupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhSetupTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:14'!
testInstallation
    "| iconicButtons |
    self assert: (World submorphs anySatisfy: [:morph | morph isKindOf: OBIconicButton]).
    iconicButtons := World submorphs select: [:morph | morph isKindOf: OBIconicButton].
    iconicButtons := iconicButtons asSortedCollection: [:a :b | a left <= b left].
    self assert: iconicButtons size = 4.
    self assert: (iconicButtons first targets includes: OBSystemBrowser).
    self assert: (iconicButtons second targets anyOne = Workspace).
    self assert: (iconicButtons third targets isEmpty).
    self assert: (iconicButtons third windowClass = PreDebugWindow).
    self assert: (iconicButtons fourth targets anyOne = Inspector)."

    self assert: ((Smalltalk at: #SystemBrowser) registeredClasses includes: OBPackageBrowserAdaptor).
    self assert: OBPackageBrowserAdaptor browserClass == OBPackageBrowser.
    self assert: (TheWorldMenu registeredOpenCommands noneSatisfy: [:ea | ea first = 'Package Browser']).
    self deny: (TheWorldMenu registeredOpenCommands anySatisfy: [:ea | ea first = 'SmartGroup Browser']).! !

TestCase subclass: #OBEnhSmartGroupBrowserTest
	instanceVariableNames: 'smartGroupBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhSmartGroupBrowserTest methodsFor: 'setUp' stamp: 'dr 9/2/2008 15:24'!
setUp
    smartGroupBrowser := OBPackageBrowser onClass: self class selector: #setUp.
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:53'!
testAddSmartCategory
    | columns smartGroupColumn |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: OBPackageBrowser smartGroupSwitchIndex.

    self assert: (OBCmdAddSmartCategory on: smartGroupBrowser root for: smartGroupColumn) isActive.! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/7/2008 17:10'!
testBrowserSetup
    | smartGroup smartGroupEdge envNode |
    self assert: OBSmartGroupBrowser paneCount = 4.
    self assert: (OBSmartGroupBrowser definitionPanel isKindOf: OBMultipleDefinitionPanel).
    self assert: (OBSmartGroupBrowser navigationPanel isKindOf: OBSmartGroupColumnPanel).


    self assert: (smartGroupBrowser root isKindOf: OBPackagesOrClassesNode).
    self assert: (smartGroupBrowser currentNode isKindOf: OBMethodNode).
    self assert: smartGroupBrowser currentNode theClass = self class.
    self assert: smartGroupBrowser currentNode selector = #setUp.

    envNode := OBSmartGroupBrowser defaultMetaNode.
    self assert: envNode name = 'Environment'.
    self assert: envNode children size = 2.
    smartGroup := envNode children detect: [:ea | ea name = 'SmartGroup'] ifNone: [nil].
    self assert: smartGroup notNil.
    self assert: envNode edges size = 2.
    smartGroupEdge := envNode edges detect: [:ea | ea metaNode = smartGroup] ifNone: [nil].
    self assert: smartGroupEdge notNil.
    self assert: smartGroupEdge metaNode == smartGroup.
    self assert: smartGroupEdge label = 'smart groups'.
    
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/14/2008 17:06'!
testCommands
    | columns smartGroupColumn scan activeCommands |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: 2.

    scan := smartGroupBrowser announce: OBNodeCommandScan. 
    activeCommands := (scan commandsOn: smartGroupColumn children first for: smartGroupColumn) select: [:ea | ea isActive].
    self deny: (activeCommands select: [:ea | ea isKindOf: OBCmdAddWorkingCopy]) size > 0.! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:25'!
testNoRenameOfSearches
    | columns smartGroupColumn searchGroup cmd |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: OBPackageBrowser smartGroupSwitchIndex.

    searchGroup := smartGroupColumn children detect: [:ea | ea isSmartGroupCategory and: [ea name = OBSmartRootNode searchGroupName]]  
                                                        ifNone: [nil].
    searchGroup name: 'blabla'.
    self assert: searchGroup name = OBSmartRootNode searchGroupName.
    cmd := OBCmdRenameSmartCategory on: searchGroup for: 'dontcare'.
    self deny: cmd isActive.! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:53'!
testRememberingSearchNodeOnSwitch
    | columns smartGroupColumn searchNode query aliasNode |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    query := (OrderedCollection with: 'OBEnhSmart').
    searchNode := OBClassSearchNode on: query.

    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil]. 
    aliasNode ifNotNil: [aliasNode remove].

    smartGroupBrowser navigationPanel addSearchToSmartGroup: searchNode.
    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil].
    self assert: smartGroupColumn selectedNode = aliasNode.
    self assert: columns second selection = 1. 
    self assert: columns second selectedNode theClass = self class.

    smartGroupColumn switch selection: 1.
    self assert: smartGroupBrowser currentNode theClass = self class.
    self assert: columns second selectedNode theClass = self class.   
    self assert: smartGroupColumn selectedNode name = 'OB-Enhancements-Tests'.  
    self assert: smartGroupBrowser definitionPanel getDefinition text = self class definition.

    smartGroupColumn switch selection: OBPackageBrowser smartGroupSwitchIndex.
    self assert: smartGroupBrowser currentNode isNil.
    self assert: columns second selectedNode isNil.   
    self assert: smartGroupColumn selectedNode isNil.  
    self assert: smartGroupBrowser definitionPanel getDefinition isNil.

    aliasNode remove.  
    self assert: (smartGroupBrowser root smartGroups noneSatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 4/25/2008 17:26'!
testSearchSmartGroup
    | columns smartGroupColumn searchNode query aliasNode size |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    query := (OrderedCollection with: 'OBEnhSmart').
    searchNode := OBClassSearchNode on: query.

    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil]. 
    aliasNode ifNotNil: [aliasNode remove].

    self assert: (smartGroupBrowser root smartGroups noneSatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).

    smartGroupBrowser navigationPanel addSearchToSmartGroup: searchNode.
    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil].
    self assert: aliasNode notNil.
    self assert: searchNode = aliasNode alias.

    self assert: (smartGroupColumn children anySatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).
    self assert: smartGroupColumn selectedNode = aliasNode.
    self assert: columns second children size = 1.
    self assert: (columns second children first isKindOf: OBClassNode).
    self assert: columns second children first theClass = self class.
    self assert: columns second selectedNode theClass = self class.
    self assert: smartGroupBrowser definitionPanel getDefinition text = self class definition.

    "no double adding possible"
    size := smartGroupColumn children size.
    smartGroupBrowser navigationPanel addSearchToSmartGroup: searchNode copy.
    self assert: size = smartGroupColumn children size.
    self assert: (smartGroupBrowser root smartGroups select: [:node | node isSmartAlias and: [node alias = searchNode]]) size = 1.

    aliasNode remove.  
    self assert: (smartGroupBrowser root smartGroups noneSatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:53'!
testSmartGroupNodes
    | columns smartGroupColumn searchGroup defaultGroup |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: OBPackageBrowser smartGroupSwitchIndex.

    defaultGroup := smartGroupColumn children detect: [:ea | ea isSmartGroupCategory and: [ea name = 'default']]  
                                                        ifNone: [nil].
    searchGroup := smartGroupColumn children detect: [:ea | ea isSmartGroupCategory and: [ea name = OBSmartRootNode searchGroupName]]  
                                                        ifNone: [nil].
    self assert: searchGroup notNil.
    self assert: defaultGroup notNil.
    self deny: (OBCmdRemoveFromSmartGroup on: defaultGroup for: nil) isActive.
    self deny: (OBCmdRemoveFromSmartGroup on: searchGroup for: nil) isActive.
 
 ! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 9/2/2008 15:53'!
testSmartGroupSwitch
    | columns smartGroupColumn smartCategories smartAlias idx |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    self assert: smartGroupColumn switch selection = 1.
    self assert: smartGroupColumn switch list size = 3.
    self assert: smartGroupColumn children size = smartGroupBrowser root packages size.

    smartGroupColumn switch selection: OBPackageBrowser smartGroupSwitchIndex.
    self assert: smartGroupColumn switch selection = OBPackageBrowser smartGroupSwitchIndex.
    self assert: smartGroupColumn children size = smartGroupBrowser root smartGroups size.

    smartCategories := smartGroupBrowser root smartGroups select: [:ea | ea isSmartGroupCategory]. 
    self assert: (smartCategories anySatisfy: [:ea | ea name = 'default']).
    self assert: (smartCategories anySatisfy: [:ea | ea name = 'searches']).

    smartAlias := smartGroupBrowser root smartGroups detect: [:ea | ea isSmartAlias] ifNone: [nil]. 
    smartAlias ifNotNil: [
	   idx := smartGroupBrowser root smartGroups indexOf: smartAlias.
	   self assert: smartGroupColumn selectedNode isNil.
	   smartGroupColumn selection: idx.
	   self assert: smartGroupColumn selectedNode = smartAlias.
	   self assert: smartGroupBrowser currentNode = smartAlias alias.
	   self assert: smartGroupBrowser definitionPanel getDefinition text = smartAlias alias definition text.
    ].
    
! !

TestCase subclass: #OBFanTestsTraitsIntegration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-TraitsTests'!

!OBFanTestsTraitsIntegration methodsFor: 'support' stamp: 'jk 1/14/2008 13:54'!
metagraphDFG
	| d f g |
	d := OBMetaNode named: 'D'.
	f := OBMetaNode named: 'F'.
	g := OBMetaNode named: 'G'.
	d childAt: #d2f put: f.
	(d childAt: #d2g put: g) navigateTree.
	^ d! !

!OBFanTestsTraitsIntegration methodsFor: 'support' stamp: 'jk 1/14/2008 13:49'!
rootNodeD1FG
	"
	 d1
	 d2 -d2f-> f1
	 d3 -d2f-> f2
	 d3 -d2g-tree-> g1
	 d4 -d2g-tree-> g2
	"
	| root |
	root := OBFakeDNUNode tree: 
		#(d1 ((d2f noChildren) (d2g noChildren))).
	root metaNode: self metagraphDFG.
	^ root! !

!OBFanTestsTraitsIntegration methodsFor: 'support' stamp: 'jk 1/14/2008 13:55'!
rootNodeD2FG
	"
	 d1
	 d2 -d2f-> f1
	 d3 -d2f-> f2
	 d3 -d2g-tree-> g1
	 d4 -d2g-tree-> g2
	"
	| root |
	root := OBFakeDNUNode tree: 
		#(d2 ((d2f (f1 ((f2h noChildren)))) (d2g noChildren))).
	root metaNode: self metagraphDFG.
	^ root! !

!OBFanTestsTraitsIntegration methodsFor: 'support' stamp: 'jk 1/14/2008 14:00'!
rootNodeD3FG
	"
	 d1
	 d2 -d2f-> f1
	 d3 -d2f-> f2
	 d3 -d2g-tree-> g1
	 d4 -d2g-tree-> g2
	"
	| root |
	root := OBFakeDNUNode tree: 
		#(d3 ((d2f f2) (d2g g1))).
	root metaNode: self metagraphDFG.
	^ root! !

!OBFanTestsTraitsIntegration methodsFor: 'support' stamp: 'jk 1/14/2008 13:59'!
rootNodeD4FG
	"
	 d1
	 d2 -d2f-> f1
	 d3 -d2f-> f2
	 d3 -d2g-tree-> g1
	 d4 -d2g-tree-> g2
	"
	| root |
	root := OBFakeDNUNode tree: 
		#(d4 ((d2g g2) (d2f noChildren))).
	root metaNode: self metagraphDFG.
	^ root! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 13:54'!
test01ChildrenOfD1

	| parent fan |
	parent := self rootNodeD1FG.

	fan := OBFan parent: parent.
	self should: fan children size = 0.
	
	fan := OBFan defaultParent: parent.
	self should: fan children size = 0.
	
	fan := OBFan treeParent: parent.
	self should: fan children size = 0.! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:01'!
test02ChildrenOfD2
	| parent fan |
	parent := self rootNodeD2FG.
	fan := OBFan parent: parent.
	self should: fan children size = 1.
	fan := OBFan defaultParent: parent.
	self should: fan children size = 1.
	fan := OBFan treeParent: parent.
	self should: fan children size = 0! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:01'!
test03ChildrenOfD3
	| parent fan |
	parent := self rootNodeD3FG.
	fan := OBFan parent: parent.
	self should: fan children size = 2.
	fan := OBFan defaultParent: parent.
	self should: fan children size = 1.
	fan := OBFan treeParent: parent.
	self should: fan children size = 1! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:01'!
test04ChildrenOfD4
	| parent fan |
	parent := self rootNodeD4FG.
	fan := OBFan parent: parent.
	self should: fan children size = 1.
	fan := OBFan defaultParent: parent.
	self should: fan children size = 0.
	fan := OBFan treeParent: parent.
	self should: fan children size = 1! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:24'!
test05RestrictToDefaultChildrenOfD1
	| parent fan |
	parent := self rootNodeD1FG.

	fan := OBFan parent: parent.
	self should: fan children size = 0.
	
	fan restrictToDefaultChildrenAndAdjustSelection: 0.
	self should: fan children size = 0.
! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:24'!
test06RestrictToTreeChildrenOfD1
	| parent fan |
	parent := self rootNodeD1FG.

	fan := OBFan parent: parent.
	self should: fan children size = 0.
	
	fan restrictToTreeChildrenAndAdjustSelection: 0.
	self should: fan children size = 0.
! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:04'!
test07RestrictToDefaultChildrenOfD2
	| parent fan |
	parent := self rootNodeD2FG.
	fan := OBFan parent: parent.
	self should: fan children size = 1.
	
	fan restrictToDefaultChildrenAndAdjustSelection: 0.
	self should: fan children size = 1.
! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:10'!
test08RestrictToTreeChildrenOfD2
	| parent fan |
	parent := self rootNodeD2FG.
	fan := OBFan parent: parent.
	self should: fan children size = 1.
	
	fan restrictToTreeChildrenAndAdjustSelection: 0.
	self should: fan children size = 0.
! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:15'!
test09RestrictToDefaultChildrenOfD3
	| parent fan |
	parent := self rootNodeD3FG.
	fan := OBFan parent: parent.
	self should: fan children size = 2.

	fan restrictToDefaultChildrenAndAdjustSelection: 1.
	self should: fan children size = 1.
! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:18'!
test10RestrictToTreeChildrenOfD3
	| parent fan |
	parent := self rootNodeD3FG.
	fan := OBFan parent: parent.
	self should: fan children size = 2.

	fan restrictToTreeChildrenAndAdjustSelection: 1.
	self should: fan children size = 1.
! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:23'!
test11RestrictToDefaultChildrenOfD4
	| parent fan |
	parent := self rootNodeD4FG.
	fan := OBFan parent: parent.
	self should: fan children size = 1.

	fan restrictToDefaultChildrenAndAdjustSelection: 0.
	self should: fan children size = 0.
! !

!OBFanTestsTraitsIntegration methodsFor: 'tests' stamp: 'jk 1/14/2008 14:23'!
test12RestrictToTreeChildrenOfD4
	| parent fan |
	parent := self rootNodeD4FG.
	fan := OBFan parent: parent.
	self should: fan children size = 1.

	fan restrictToTreeChildrenAndAdjustSelection: 0.
	self should: fan children size = 1.
! !

TestCase subclass: #OBPluggableTreeItemWithParentNodeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBPluggableTreeItemWithParentNodeTests methodsFor: 'tests' stamp: 'dr 9/22/2008 11:09'!
test01
	| m1 m11 m12 m2 m21 m22 |
	m1 := OBPluggableTreeItemWithParentNode 
		with: 1 
		parent: nil
		position: 1
		model: nil.
	m11 := OBPluggableTreeItemWithParentNode 
		with: 11
		parent: m1
		position: 1
		model: nil.
	m12 := OBPluggableTreeItemWithParentNode 
		with: 12
		parent: m1
		position: 2
		model: nil.
	m2 := OBPluggableTreeItemWithParentNode 
		with: 2
		parent: nil
		position: 2
		model: nil.
	m21 := OBPluggableTreeItemWithParentNode 
		with: 21
		parent: m2
		position: 1
		model: nil.
	m22 := OBPluggableTreeItemWithParentNode 
		with: 22
		parent: m2
		position: 2
		model: nil.
	self should: m1 path asArray = #(1 ).
	self should: m11 path asArray = #(1 1 ).
	self should: m12 path asArray = #(1 2 ).
	self should: m2 path asArray = #(2 ).
	self should: m21 path asArray = #(2 1 ).
	self should: m22 path asArray = #(2 2 )! !

TestCase subclass: #OBTreeColumnTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBTreeColumnTests methodsFor: 'support' stamp: 'jk 1/2/2008 15:15'!
columnPanelABCDEFGH
	| root panel |
	root := self rootNodeABCDEFGH.
	panel := OBTraitColumnPanel minPanes: 1 maxPanes: 1.
	panel browser: self.
	panel setMetaNode: root metaNode node: root.
	^ panel! !

!OBTreeColumnTests methodsFor: 'support' stamp: 'jk 1/1/2008 20:08'!
metagraphABCD
	| a b c d |
	a := OBMetaNode named: 'A'.
	b := OBMetaNode named: 'B'.
	c := OBMetaNode named: 'C'.
	d := OBMetaNode named: 'D'.
	a childAt: #a2b put: b.
	b childAt: #b2c put: c.
	(b childAt: #b2d put: d) navigateTree.
	^ a! !

!OBTreeColumnTests methodsFor: 'support' stamp: 'jk 1/2/2008 15:08'!
metagraphABCDEFGH
	"A --> B --> C -tree-> E
	       B -tree-> D --> F --> H
	                  D -tree-> G
	"
	| a b c d e f g h |
	a := OBMetaNode named: 'A'.
	b := OBMetaNode named: 'B'.
	c := OBMetaNode named: 'C'.
	d := OBMetaNode named: 'D'.
	e := OBMetaNode named: 'E'.
	f := OBMetaNode named: 'F'.
	g := OBMetaNode named: 'G'.
	h := OBMetaNode named: 'H'.
	a childAt: #a2b put: b.
	b childAt: #b2c put: c.
	(b childAt: #b2d put: d) navigateTree.
	(c childAt: #c2e put: e) navigateTree.
	d childAt: #d2f put: f.
	(d childAt: #d2g put: g) navigateTree.
	f childAt: #f2h put: h.
	^ a
! !

!OBTreeColumnTests methodsFor: 'support' stamp: 'jk 1/1/2008 19:11'!
metagraphABD
	| a b d |
	a := OBMetaNode named: 'A'.
	b := OBMetaNode named: 'B'.
	d := OBMetaNode named: 'D'.
	a childAt: #children put: b.
	(b childAt: #children put: d) navigateTree.
	^ a! !

!OBTreeColumnTests methodsFor: 'support' stamp: 'jk 1/1/2008 19:43'!
metagraphABDF
	| a b d f |
	a := OBMetaNode named: 'A'.
	b := OBMetaNode named: 'B'.
	d := OBMetaNode named: 'D'.
	f := OBMetaNode named: 'F'.
	a childAt: #children put: b.
	(b childAt: #children put: d) navigateTree.
	(d childAt: #children put: f) navigateTree.
	^ a! !

!OBTreeColumnTests methodsFor: 'support' stamp: 'jk 1/3/2008 15:18'!
rootNodeABCDEFGH
	"a1 -a2b-> b1 -b2c-> c1 -c2e-tree-> e1
	                       c1 -c2e-tree-> e2
	            b1 -b2c-> c2
	            b1 -b2d-tree-> d1
	            b1 -b2d-tree-> d2 -d2f-> f1
	            b1 -b2d-tree-> d3 -d2f-> f2 -f2h-> h1
	                             d3 -d2g-tree-> g1
	            b1 -b2d-tree-> d4 -d2g-tree-> g2
	 a1 -a2b-> b2
	"
	| root |
	root := OBFakeDNUNode tree: 
		#(a1 (
			(a2b (b1 (
					(b2c (c1 (
							(c2e e1 e2)))
						  (c2 ((c2e noChildren))))
					(b2d (d1 ((d2f noChildren) (d2g noChildren)))
						 (d2 ((d2f (f1 ((f2h noChildren)))) (d2g noChildren)))
						 (d3 (
						     (d2f (f2 ((f2h h1))))
							(d2g g1)
						  ))
						 (d4 ((d2g g2) (d2f noChildren))))
			       ))
			       (b2 ((b2c noChildren)
			             (b2d noChildren)))  )
		)   ).
	root metaNode: self metagraphABCDEFGH.
	^ root! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/1/2008 20:05'!
test01AllInOneColumn
	"Nodes: a1 --> b1 -tree-> d1."
	| root select panel |
	root := OBFake2Node tree: #(a1 ((b1 (d1)))).
	root metaNode: self metagraphABD.
	select := OBFake2Node tree: #d1.
	panel := OBTraitColumnPanel minPanes: 1 maxPanes: 1.
	panel browser: self.
	panel setMetaNode: root metaNode node: root.
	panel jumpTo: select.
	self assert: panel columns size = 1.
	self assert: panel currentNode = select.! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/1/2008 20:05'!
test02AllInOneColumn
	"Nodes: a1 -> b1 -tree-> d1 -tree-> f1."
	| root select panel |
	root := OBFake2Node tree: #(a1 ((b1 ((d1 (f1)))))).
	root metaNode: self metagraphABDF.
	select := OBFake2Node tree: #f1.
	panel := OBTraitColumnPanel minPanes: 1 maxPanes: 1.
	panel browser: self.
	panel setMetaNode: root metaNode node: root.
	panel jumpTo: select.
	self assert: panel columns size = 1.
	self assert: panel currentNode = select.! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/2/2008 01:00'!
test03NodeWithBothTreeChildrenAndDefaultChildren
	"Nodes: a1 -a2b-> b1 -b2d-tree-> d1.
	                    b1 -b2c-> c1"
	| root select panel |
	root := OBFakeDNUNode tree: #(a1 ((a2b #(b1 ((b2d d1) (b2c c1)))))).
	root metaNode: self metagraphABCD.
	panel := OBTraitColumnPanel minPanes: 1 maxPanes: 1.
	panel browser: self.
	panel setMetaNode: root metaNode node: root.

	select := OBFake2Node tree: #d1.
	panel jumpTo: select.
	self assert: panel columns size = 1.
	self assert: panel currentNode = select.
	
	select := OBFake2Node tree: #c1.
	panel jumpTo: select.
	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	
	select := OBFake2Node tree: #d1.
	panel jumpTo: select.
	self assert: panel columns size = 1.
	self assert: panel currentNode = select.
	
	select := OBFake2Node tree: #b1.
	panel jumpTo: select.
	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns first selectedNode = select.
	self assert: panel columns second parent = select.
	self assert: panel columns second children anyOne = (OBFake2Node tree: #c1).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/13/2008 20:14'!
test04JumpToB2
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #b2.
	panel jumpTo: select.

	self assert: panel columns size = 1.
	self assert: panel currentNode = select.
	self assert: panel columns first parent = (OBFake2Node tree: #a1).
	self assert: panel columns first selectedNode = select.

	self assert: panel columns first children size = 2.
	self assert: panel columns first children first = (OBFake2Node tree: #b1).
	self assert: panel columns first children second = select.
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/13/2008 20:18'!
test05JumpToB1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #b1.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns first parent = (OBFake2Node tree: #a1).
	self assert: panel columns first selectedNode = select.
	self assert: panel columns second parent = select.

	self assert: panel columns first children size = 2.
	self assert: panel columns first children first = (OBFake2Node tree: #b1).
	self assert: panel columns first children second = (OBFake2Node tree: #b2).

	self assert: panel columns second children size = 2.
	self assert: panel columns second children first = (OBFake2Node tree: #c1).
	self assert: panel columns second children second = (OBFake2Node tree: #c2).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/13/2008 20:19'!
test06JumpToC2
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #c2.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns second selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #a1).
	self assert: panel columns second parent = (OBFake2Node tree: #b1).

	self assert: panel columns first children size = 2.
	self assert: panel columns first children first = (OBFake2Node tree: #b1).
	self assert: panel columns first children second = (OBFake2Node tree: #b2).

	self assert: panel columns second children size = 2.
	self assert: panel columns second children first = (OBFake2Node tree: #c1).
	self assert: panel columns second children second = (OBFake2Node tree: #c2).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/13/2008 20:20'!
test07JumpToC1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #c1.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns second selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #a1).
	self assert: panel columns second parent = (OBFake2Node tree: #b1).

	self assert: panel columns first children size = 2.
	self assert: panel columns first children first = (OBFake2Node tree: #b1).
	self assert: panel columns first children second = (OBFake2Node tree: #b2).

	self assert: panel columns second children size = 2.
	self assert: panel columns second children first = (OBFake2Node tree: #c1).
	self assert: panel columns second children second = (OBFake2Node tree: #c2).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/13/2008 20:20'!
test08JumpToE1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #e1.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns second selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #a1).
	self assert: panel columns first selectedNode = (OBFake2Node tree: #b1).
	self assert: panel columns second parent = (OBFake2Node tree: #c1).

	self assert: panel columns first children size = 2.
	self assert: panel columns first children first = (OBFake2Node tree: #b1).
	self assert: panel columns first children second = (OBFake2Node tree: #b2).

	self assert: panel columns second children size = 2.
	self assert: panel columns second children first = (OBFake2Node tree: #e1).
	self assert: panel columns second children second = (OBFake2Node tree: #e2).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 12:59'!
test09JumpToE2
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #e2.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns second selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #a1).
	self assert: panel columns first selectedNode = (OBFake2Node tree: #b1).
	self assert: panel columns second parent = (OBFake2Node tree: #c1).

	self assert: panel columns first children size = 2.
	self assert: panel columns first children first = (OBFake2Node tree: #b1).
	self assert: panel columns first children second = (OBFake2Node tree: #b2).

	self assert: panel columns second children size = 2.
	self assert: panel columns second children first = (OBFake2Node tree: #e1).
	self assert: panel columns second children second = (OBFake2Node tree: #e2).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:12'!
test10JumpToD1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #d1.
	panel jumpTo: select.

	self assert: panel columns size = 1.
	self assert: panel currentNode = select.
	self assert: panel columns first selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #b1).

	self assert: panel columns first children size = 4.
	self assert: panel columns first children first = (OBFake2Node tree: #d1).
	self assert: panel columns first children second = (OBFake2Node tree: #d2).
	self assert: panel columns first children third = (OBFake2Node tree: #d3).
	self assert: panel columns first children fourth = (OBFake2Node tree: #d4).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:13'!
test11JumpToD2
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #d2.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns first selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #b1).
	self assert: panel columns second parent = select.
	self assert: panel columns second children size = 1.
	self assert: panel columns second children first = (OBFake2Node tree: #f1).

	self assert: panel columns first children size = 4.
	self assert: panel columns first children first = (OBFake2Node tree: #d1).
	self assert: panel columns first children second = (OBFake2Node tree: #d2).
	self assert: panel columns first children third = (OBFake2Node tree: #d3).
	self assert: panel columns first children fourth = (OBFake2Node tree: #d4).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:14'!
test12JumpToD3
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #d3.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns first selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #b1).
	self assert: panel columns second parent = select.
	self assert: panel columns second children size = 1.
	self assert: panel columns second children first = (OBFake2Node tree: #f2).

	self assert: panel columns first children size = 4.
	self assert: panel columns first children first = (OBFake2Node tree: #d1).
	self assert: panel columns first children second = (OBFake2Node tree: #d2).
	self assert: panel columns first children third = (OBFake2Node tree: #d3).
	self assert: panel columns first children fourth = (OBFake2Node tree: #d4).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:15'!
test13JumpToD4
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #d4.
	panel jumpTo: select.

	self assert: panel columns size = 1.
	self assert: panel currentNode = select.
	self assert: panel columns first selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #b1).

	self assert: panel columns first children size = 4.
	self assert: panel columns first children first = (OBFake2Node tree: #d1).
	self assert: panel columns first children second = (OBFake2Node tree: #d2).
	self assert: panel columns first children third = (OBFake2Node tree: #d3).
	self assert: panel columns first children fourth = (OBFake2Node tree: #d4).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:21'!
test14JumpToF1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #f1.
	panel jumpTo: select.

	self assert: panel columns size = 2.
	self assert: panel currentNode = select.
	self assert: panel columns second selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #b1).
	self assert: panel columns first selectedNode = (OBFake2Node tree: #d2).
	self assert: panel columns second parent = (OBFake2Node tree: #d2).

	self assert: panel columns first children size = 4.
	self assert: panel columns first children first = (OBFake2Node tree: #d1).
	self assert: panel columns first children second = (OBFake2Node tree: #d2).
	self assert: panel columns first children third = (OBFake2Node tree: #d3).
	self assert: panel columns first children fourth = (OBFake2Node tree: #d4).

	self assert: panel columns second children size = 1.
	self assert: panel columns second children first = select.
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:22'!
test15JumpToF2
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #f2.
	panel jumpTo: select.

	self assert: panel columns size = 3.
	self assert: panel currentNode = select.
	self assert: panel columns second selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #b1).
	self assert: panel columns first selectedNode = (OBFake2Node tree: #d3).
	self assert: panel columns second parent = (OBFake2Node tree: #d3).
	self assert: panel columns third parent = select.

	self assert: panel columns first children size = 4.
	self assert: panel columns first children first = (OBFake2Node tree: #d1).
	self assert: panel columns first children second = (OBFake2Node tree: #d2).
	self assert: panel columns first children third = (OBFake2Node tree: #d3).
	self assert: panel columns first children fourth = (OBFake2Node tree: #d4).

	self assert: panel columns second children size = 1.
	self assert: panel columns second children first = select.

	self assert: panel columns third children size = 1.
	self assert: panel columns third children first = (OBFake2Node tree: #h1).
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:23'!
test16JumpToH1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #h1.
	panel jumpTo: select.

	self assert: panel columns size = 3.
	self assert: panel currentNode = select.
	self assert: panel columns third selectedNode = select.
	
	self assert: panel columns first parent = (OBFake2Node tree: #b1).
	self assert: panel columns first selectedNode = (OBFake2Node tree: #d3).
	self assert: panel columns second parent = (OBFake2Node tree: #d3).
	self assert: panel columns second selectedNode = (OBFake2Node tree: #f2).
	self assert: panel columns third parent = (OBFake2Node tree: #f2).

	self assert: panel columns first children size = 4.
	self assert: panel columns first children first = (OBFake2Node tree: #d1).
	self assert: panel columns first children second = (OBFake2Node tree: #d2).
	self assert: panel columns first children third = (OBFake2Node tree: #d3).
	self assert: panel columns first children fourth = (OBFake2Node tree: #d4).

	self assert: panel columns second children size = 1.
	self assert: panel columns second children first = (OBFake2Node tree: #f2).

	self assert: panel columns third children size = 1.
	self assert: panel columns third children first = select.
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:25'!
test17JumpToG1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #g1.
	panel jumpTo: select.
	self assert: panel columns size = 1.
	self assert: panel currentNode = select.
	self assert: panel columns first selectedNode = select.
	self assert: panel columns first parent = (OBFake2Node tree: #d3).
	
	self assert: panel columns first children size = 1.
	self assert: panel columns first children first = select.
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:27'!
test18JumpToG2
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #g2.
	panel jumpTo: select.

	self assert: panel columns size = 1.
	self assert: panel currentNode = select.
	self assert: panel columns first selectedNode = select.
	self assert: panel columns first parent = (OBFake2Node tree: #d4).
	
	self assert: panel columns first children size = 1.
	self assert: panel columns first children first = select.
! !

!OBTreeColumnTests methodsFor: 'tests' stamp: 'jk 1/14/2008 13:28'!
test19JumpToA1
	| select panel |
	panel := self columnPanelABCDEFGH.
	select := OBFake2Node tree: #a1.
	panel jumpTo: select.

	self assert: panel columns size = 1.
	self assert: panel columns first parent = select.
	
	self assert: panel columns first children size = 2.
	self assert: panel columns first children first = (OBFake2Node tree: #b1).
	self assert: panel columns first children second = (OBFake2Node tree: #b2).
! !

TestCase subclass: #OBTreeFanTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBTreeFanTests methodsFor: 'support' stamp: 'dr 9/12/2008 15:58'!
makeTreeFanStructure
	"
aTreeFan<fan: 0>
  - aTreeFan<fan: 1>
  - aTreeFan<fan: 2>
    + aTreeFan<fan: 3>
       - aTreeFan<fan: 4>
       - aTreeFan<fan: 5>
	"
	| t0 t01 t02 t021 t0211 t0212 |
	t0 := OBTreeNodeMediator fan: (OBFan 
			parent: 0
			children: #('1' '2' )).
	t01 := OBTreeNodeMediator 
		fan: (OBFan 
				parent: 1
				children: #())
		parent: t0
		at: 1.
	t02 := OBTreeNodeMediator 
		fan: (OBFan 
				parent: 2
				children: #('3' ))
		parent: t0
		at: 2.
	t021 := OBTreeNodeMediator 
		fan: (OBFan 
				parent: 3
				children: #('4' '5' ))
		parent: t02
		at: 1.
	t0211 := OBTreeNodeMediator 
		fan: (OBFan 
				parent: 4
				children: #())
		parent: t021
		at: 1.
	t0212 := OBTreeNodeMediator 
		fan: (OBFan 
				parent: 5
				children: #())
		parent: t021
		at: 2.
	^ t0! !

!OBTreeFanTests methodsFor: 'tests' stamp: 'jk 12/10/2007 14:15'!
test01fanAt

	| f |
	f := self makeTreeFanStructure.
	
	self assert: (f fanAt: #(1)) parent = 0.
	self assert: (f fanAt: #(2)) parent = 0.
	self assert: (f fanAt: #(2 1)) parent = 2.
	self assert: (f fanAt: #(2 1 1)) parent = 3.
	self assert: (f fanAt: #(2 1 2)) parent = 3.
! !

!OBTreeFanTests methodsFor: 'tests' stamp: 'jk 12/10/2007 20:23'!
test02nodeAt

	| f |
	f := self makeTreeFanStructure.
	
	self assert: (f nodeAt: #(1)) = '1'.
	self assert: (f nodeAt: #(2)) = '2'.
	self assert: (f nodeAt: #(2 1)) = '3'.
	self assert: (f nodeAt: #(2 1 1)) = '4'.
	self assert: (f nodeAt: #(2 1 2)) = '5'.
! !

!TestCase class methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2008 11:09'!
methodsFailed
	^(self lastRun at: #failures), (self lastRun at: #errors)! !

!TestCase class methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2008 11:08'!
methodsPassed
	^self lastRun at: #passed! !

!OBCommandScan methodsFor: '*ob-enhancements' stamp: 'dr 2/7/2008 10:10'!
populateMenu: aMenu withNode: aNode forRequestor: aRequestor filter: aBlock
	| commands cluster |
	commands := IdentitySet new.
	self addCommandsOn: aNode for: aRequestor to: commands.
	commands := commands select: [:cmd | aBlock value: cmd].
	cluster := self clusterCommands: commands.
	cluster populateMenu: aMenu! !

!OBDefinition methodsFor: '*ob-enhancements' stamp: 'dr 9/28/2007 13:43'!
isEnrichedDefinition
    ^false! !

OBMercuryPanel subclass: #OBEnrichedMercuryPanel
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBEnrichedMercuryPanel methodsFor: 'callbacks' stamp: 'dr 10/29/2008 21:57'!
accept: aText notifying: anObject 
 	aText asString withBlanksTrimmed ifEmpty: [^self].
	text := aText.
	browser navigationPanel selectSwitchTab: browser class packageSwitchIndex.
	OBEnrichedMercuryQuery find: aText for: self.
	self changed: #text! !

!OBEnrichedMercuryPanel methodsFor: 'configuration' stamp: 'dr 10/20/2008 18:08'!
helperText
    ^'C... (class search), i... (implementor search), #C... (class ref search), #s... (sender search)'! !

!OBEnrichedMercuryPanel methodsFor: 'callbacks' stamp: 'dr 10/20/2008 18:08'!
notifyMouseEnter
    text = self helperText ifTrue: [text := ''. self changed: #text].! !

!OBEnrichedMercuryPanel methodsFor: 'callbacks' stamp: 'dr 10/20/2008 17:40'!
text
     (text isNil "or: [text isEmpty]") ifTrue: [text := self helperText].
	^text! !

OBClassNode subclass: #OBClassExtensionNode
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBClassExtensionNode methodsFor: 'navigating' stamp: 'dr 10/30/2008 21:09'!
allCategory
	^ Array with: ((OBAllMethodExtensionCategoryNode on: self theClass) classExtensionNode: self; yourself) ! !

!OBClassExtensionNode methodsFor: 'navigating' stamp: 'dr 11/12/2008 09:30'!
categories
	^self theClass organization categories
		collect: [:cat | (OBMethodCategoryExtensionNode on: cat inClass: self theClass) classExtensionNode: self] ! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:31'!
extensionName
    ^package packageName ! !

!OBClassExtensionNode methodsFor: 'testing' stamp: 'dr 2/24/2008 14:44'!
isDescendantOfClass: other
     ^other = self! !

!OBClassExtensionNode methodsFor: 'testing' stamp: 'dr 3/3/2008 17:22'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self package ifFalse: [^false].
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'dr 6/26/2008 16:01'!
isDescendantOfPackage: aNode
     aNode isPackage ifTrue: [^self package = aNode].
	^false! !

!OBClassExtensionNode methodsFor: 'displaying' stamp: 'dr 1/8/2008 17:17'!
name 
	^Text string: super name asString emphasis: {TextEmphasis italic} ! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 13:17'!
package
	^ package! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 15:12'!
package: aPackageNode
	package := aPackageNode ! !

OBClassExtensionNode subclass: #OBMetaclassExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMetaclassExtensionNode methodsFor: 'actions' stamp: 'dr 2/15/2008 16:22'!
browse
	^ OBCodeBrowser defaultBrowserClass openOnClass: self theNonMetaClass ! !

!OBMetaclassExtensionNode methodsFor: 'displaying' stamp: 'dr 3/3/2008 16:59'!
displayFullString
    ^self theClass name! !

!OBMetaclassExtensionNode methodsFor: 'displaying' stamp: 'dr 1/8/2008 17:17'!
name 
	^Text string: self nonMetaName emphasis: {TextEmphasis italic} ! !

!OBMetaclassExtensionNode methodsFor: 'as yet unclassified' stamp: 'ms 12/19/2007 00:28'!
nonMetaName
	^ self theNonMetaClass name! !

!OBMetaclassExtensionNode methodsFor: 'initializing' stamp: 'ms 12/19/2007 00:28'!
setClass: aClass
	self theClass: aClass theMetaClass! !

!OBClassNode methodsFor: '*ob-enhancements-navigating' stamp: 'jk 8/14/2007 11:37'!
addTraitsOf: aClassOrTrait bySelector: aSelector into: aCollection ofParentNode: aNode 
	aClassOrTrait traitTransformations
		do: [:t | 
			| n | 
			n := t asNodeOf: aNode.
			aCollection
				add: (t perform: aSelector with: aNode).
			self
				addTraitsOf: t
				bySelector: aSelector
				into: aCollection
				ofParentNode: n].
	^ aCollection! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/28/2008 10:34'!
allCategoryWithPackageNode: aPackageNode
	^ Array with: ((OBPackageAllMethodCategoryNode on: self theClass) packageNode: aPackageNode)! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 7/3/2008 11:02'!
allMethods
    ^(theClass methodDict values, theClass class methodDict values) collect: [:ea | ea methodReference asNode]! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/28/2008 15:20'!
categoriesWithPackageNode: aPackageNode
    ^self categories collect: [:ea | (OBPackageMethodCategoryNode on: ea name inClass: ea theClass) packageNode: aPackageNode] ! !

!OBClassNode methodsFor: '*ob-enhancements-navigating' stamp: 'jk 8/23/2007 17:11'!
commentsOfUsedTraits
	| result root |
	result := OrderedCollection new.
	root := self theClass asCommentNode.
	result add: root.
	self addTraitsOf: self theClass bySelector: #asCommentNodeOf: into: result ofParentNode: root.
	^ result! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 11/18/2008 16:12'!
dropOnPackage: aNode
	self theNonMetaClass category: aNode packageName.
	self signalSelection.
	^ true! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:34'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 7/11/2008 16:06'!
extensionPackageNames
	| names packageNameIndex |
	
	names := Set new.
	(theClass theNonMetaClass organization categories asOrderedCollection addAll: theClass theMetaClass organization categories; yourself) do: [:category | | cat |
		cat := category asString.
		(cat first = $*) ifTrue: [
			packageNameIndex := (cat lastIndexOf: $-) - 1.
			packageNameIndex < 4 ifTrue: [packageNameIndex := cat size].
			names add: (cat copyFrom: 2 to: packageNameIndex) asLowercase.
			names add: (cat copyFrom: 2 to: cat size) asLowercase].
	].
	^names! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/21/2008 13:55'!
hasComment
    ^theClass hasComment! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 7/7/2008 15:48'!
indent
	| indent |
	indent := Text new: (2 * self theClass allSuperclasses size) asInteger.
	indent atAllPut: $ .
	^ indent asString! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 7/7/2008 15:48'!
indentedName
	^ self indent, self name! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/22/2008 11:08'!
isDescendantOfPackage: aNode
     aNode isPackage ifTrue: [^aNode realClasses includes: self theNonMetaClass].
	^false! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 12/22/2008 14:02'!
isInstrumented 
    ^(Smalltalk hasClassNamed: #HODataBase) and: [(Smalltalk at: #HODataBase) default includesClass: self theNonMetaClass]! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 13:40'!
isNodeWithReferences
    ^true! !

!OBClassNode methodsFor: '*ob-enhancements-testing' stamp: 'jk 8/26/2007 12:10'!
isUsedTrait
	^ false! !

!OBClassNode methodsFor: '*ob-enhancements-navigating' stamp: 'jk 8/23/2007 16:54'!
metaclassesOfUsedTraits
	| result root |
	result := OrderedCollection new.
	root := self theClass asClassSideNode.
	result add: root.
	self
		addTraitsOf: root theClass
		bySelector: #asClassSideNodeOf:
		into: result
		ofParentNode: root.
	^ result! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/29/2008 22:43'!
packagesForClass
	"return the package this class is defined in, as well as the packages that extend it."
	| packages  extensionNames allPackages usedPackage |

	packages := Set new.	
	allPackages := PackageInfo allPackages.	
	extensionNames := self extensionPackageNames add: self classCategory asString asLowercase; yourself.

	extensionNames do: [:extName |
		usedPackage := allPackages detect: [:pkg | extName beginsWith: pkg packageName asLowercase]
		                                 ifNone: [nil].
		usedPackage ifNotNil: [
			packages add: (OBMonticelloPackageNode package: 
			                    (MCWorkingCopy forPackage: (MCPackage named: usedPackage packageName))
			                   class: self)].
	]. 

	^packages asSortedCollection: [:a :b | a packageName asLowercase >= b packageName asLowercase]! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 7/8/2008 11:42'!
packagesForClassClass
	^self packagesForClass collect: [:pkg | pkg classNode: (OBClassNode on: theClass); yourself].! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 7/7/2008 17:49'!
packagesForClassComment
	^self packagesForClass collect: [:pkg | pkg classNode: (OBClassCommentNode on: theClass); yourself].! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 7/7/2008 18:21'!
packagesForClassMetaclass 
	^self packagesForClass collect: [:pkg | pkg classNode: (OBMetaclassNode on: theClass); yourself].! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 14:23'!
prefixedName
    ^self name! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 12/16/2008 15:43'!
runTestCommandClass
	"answer cmd class to run tests of this type of node"
	^OBCmdTestClass! !

!OBClassNode methodsFor: '*ob-enhancements-navigating' stamp: 'jk 12/18/2007 10:23'!
traitTransformationNodes
	^ self theClass traitTransformations collect: [ :e | e asNode ]! !

!OBClassNode methodsFor: '*ob-enhancements-navigating' stamp: 'jk 8/23/2007 17:11'!
usedTraits
	| result root |
	result := OrderedCollection new.
	root := self copy.
	result add: root.
	self addTraitsOf: self theClass bySelector: #asNodeOf: into: result ofParentNode: root.
	^ result! !

OBClassNode subclass: #OBClassReferenceNode
	instanceVariableNames: 'modelClass classNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBClassReferenceNode commentStamp: 'dr 8/15/2008 15:24' prior: 0!
I relate referencing classes, i.e. classes that reference each other dynamically. I know in which methods of my associated class the referenced class is used.
I am used in the dependency browser and in the querying dyn. information tool.  !

!OBClassReferenceNode class methodsFor: 'as yet unclassified' stamp: 'dr 10/5/2007 10:42'!
on: aClass modelClass: modelClass
    ^self new setClass: aClass setModelClass: modelClass! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 10/11/2007 17:23'!
asClassNode
    ^OBClassNode on: self theClass! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 12/22/2008 14:02'!
classNode
    classNode ifNotNil: [^classNode].
    ((Smalltalk hasClassNamed: #HODataBase) and: [(Smalltalk at: #HODataBase) default isInstrumentedClass: self theClass]) ifTrue: [
	    classNode _ OBEnrichedClassNode on: ((Smalltalk at: #HODataBase) default modelClassFor: self theClass).
	    ^classNode
    ].
    self theClass isMeta ifTrue: [classNode _ OBMetaclassNode on: self theClass. ^classNode].
    ^self! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 16:30'!
definition
    self classNode.
    ^classNode ifNotNil: [classNode definition] ifNil: [super definition]! !

!OBClassReferenceNode methodsFor: 'displaying' stamp: 'dr 10/11/2007 17:19'!
displayString
    ^self name! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 16:31'!
formatter
    self classNode.
    ^classNode ifNotNil: [classNode formatter] ifNil: [nil]! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 12/22/2008 14:02'!
icon
    (Smalltalk hasClassNamed: #HODataBase) ifFalse: [^nil].
    ^((Smalltalk at: #HODataBase) default includesClass: self theClass) ifTrue: [#flag] ifFalse: [#blank]! !

!OBClassReferenceNode methodsFor: 'ancestry' stamp: 'dr 8/15/2008 15:25'!
isAncestorOf: aNode using: aSelector
    ^self = aNode! !

!OBClassReferenceNode methodsFor: 'testing' stamp: 'dr 2/21/2008 14:50'!
isDescendantOfClassRef: aNode
    ^aNode = self! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 16:30'!
modelClass
    self classNode.
    ^classNode ifNotNil: [classNode modelClass] ifNil: [nil]! !

!OBClassReferenceNode methodsFor: 'navigating' stamp: 'dr 4/23/2008 10:09'!
referencingMethods
    | referencingMethods totalNumberOfRefs |
    referencingMethods := (modelClass methodsReferencingClass: self theClass) asSortedCollection: [:a :b | a selector <= b selector].
    totalNumberOfRefs := referencingMethods inject: 0 into: [:sum :method | sum + (method numberOfReferencesToClass: self theClass)].
    ^referencingMethods collect: [:ea | (OBEnrichedMethodNode on: ea referencedClass: self theClass) setTotalNumberOfRefs: totalNumberOfRefs]! !

!OBClassReferenceNode methodsFor: 'navigating' stamp: 'dr 8/15/2008 16:01'!
selectThisOrNextNodeOnSwitch: nextNode
   ^self classNode! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 16:15'!
setClass: aClass setModelClass: secondClass
    theClass := aClass.
    modelClass := secondClass.
! !

!OBClassReferenceNode methodsFor: 'configuration' stamp: 'dr 8/15/2008 17:16'!
species
   ^OBClassNode
   "^self theClass isMeta ifTrue: [OBMetaclassNode] ifFalse: [OBClassNode]"! !

OBClassNode subclass: #OBEnrichedClassNode
	instanceVariableNames: 'modelClass formatter methodInvocation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedClassNode class methodsFor: 'instance creation' stamp: 'dr 4/21/2008 16:16'!
on: aHOClass
    ^(super on: aHOClass actualClass) setModelClass: aHOClass; yourself! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 11:25'!
definition
	^(OBEnrichedClassDefinition 
		environment: self theClass environment 
		template: self theClass definition) setFormatter: self formatter! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 16:17'!
formatter
    formatter ifNil: [formatter := HOClassFormatter modelClass: self modelClass].
    ^formatter! !

!OBEnrichedClassNode methodsFor: 'navigating' stamp: 'dr 4/23/2008 12:34'!
methodReferences
   ^#()! !

!OBEnrichedClassNode methodsFor: 'navigating' stamp: 'dr 4/25/2008 14:51'!
methods
    methodInvocation ifNil: [^super methods].
    ^(super methods select: [:ea | ea invokesMethod: methodInvocation]) asSortedCollection: [:a :b | a selector <= b selector]. ! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 16:16'!
modelClass
    ^modelClass! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 16:14'!
reference
    ^nil! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 4/25/2008 11:23'!
setMethodInvocation: aMethodInvocation
    methodInvocation := aMethodInvocation! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 16:16'!
setModelClass: aHOClass
    modelClass := aHOClass! !

!OBEnrichedClassNode methodsFor: 'private' stamp: 'dr 4/17/2008 15:40'!
species
   ^OBClassNode! !

OBClassNode subclass: #OBTraitTransformationNode
	uses: OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBTraitTransformationNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:52'!
nestedObject
	^ transformation! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:52'!
nestedObject: anObject
	transformation := anObject! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:51'!
parentNode
	^ parentNode! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:51'!
parentNode: anObject
	parentNode := anObject! !

OBClassNode subclass: #OBUsedTraitNode
	uses: OBTParentNode - {#theClass. #name}
	instanceVariableNames: 'parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBUsedTraitNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 17:57'!
nestedObject
	^ self theClass! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 17:58'!
nestedObject: anObject
	self theClass: anObject! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:07'!
parentNode
	^ parentNode! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:07'!
parentNode: anObject
	parentNode := anObject ! !

!IndentingListItemMorph methodsFor: '*ob-enhancements' stamp: 'dr 9/15/2008 16:35'!
initWithContents: aString font: aFont emphasis: emphasisCode
   "fix problem of wrong emphasis of font used for tree items"
   super initWithContents: aString font: (aFont emphasis: 0) emphasis: emphasisCode! !

IndentingListItemMorph subclass: #OBIndentingListItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tree'!

!OBIndentingListItemMorph methodsFor: 'drawing' stamp: 'dr 12/2/2008 15:50'!
drawOn: aCanvas
	| tRect sRect columnRect columnScanner columnData columnLeft colorToUse |

	tRect := self toggleRectangle.
	sRect := bounds withLeft: tRect right + 4.
	self drawToggleOn: aCanvas in: tRect.
	colorToUse := complexContents preferredColor ifNil: [color].

	complexContents backgroundColor ifNotNilDo: [:aColor | aCanvas fillRectangle: sRect color: aColor].

	icon isNil ifFalse:[
		aCanvas
			translucentImage: icon
			at: sRect left @ (self top + (self height - icon height // 2)).

		sRect := sRect left: sRect left + icon width + 2.
	].

	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		sRect := sRect top: sRect top + sRect bottom - self fontToUse height // 2.
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: colorToUse.
	] ifFalse: [
		columnLeft := sRect left.
		columnScanner := ReadStream on: contents asString.
		container columns do: [ :width |
			columnRect := columnLeft @ sRect top extent: width @ sRect height.
			columnData := columnScanner upTo: Character tab.
			columnData isEmpty ifFalse: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: colorToUse.
			].
			columnLeft := columnRect right + 5.
		].
	]
! !

OBMethodDefinition subclass: #OBEnrichedMethodDefinition
	instanceVariableNames: 'formatter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedMethodDefinition commentStamp: 'dr 10/9/2007 17:11' prior: 0!
I am an enriched definition. I know how to display and format dynamic information about the method's source code I represent.!

!OBEnrichedMethodDefinition methodsFor: 'accessing' stamp: 'dr 9/28/2007 11:39'!
formatter
    ^formatter! !

!OBEnrichedMethodDefinition methodsFor: 'testing' stamp: 'dr 9/28/2007 13:43'!
isEnrichedDefinition
    ^true! !

!OBEnrichedMethodDefinition methodsFor: 'accessing' stamp: 'dr 9/28/2007 11:39'!
setFormatter: aHOFormatter
    formatter := aHOFormatter! !

!OBEnrichedMethodDefinition methodsFor: 'accessing' stamp: 'dr 11/21/2007 11:19'!
text
	^ source 
		ifNotNil: [source asText]
		ifNil: [self theClass sourceCodeTemplate]! !

!OBMethodDefinition methodsFor: '*ob-enhancements' stamp: 'dr 1/21/2009 12:17'!
confirmCompileLocalyOrInUsedTrait: aTrait 
	| result prompt m1 m2 m3 r1 r3 |
	prompt := 'You are compiling a method that already exists in a
used trait. What do you want to do:' translated.
	r1 := self compileClass.
	r3 := nil.
	m1 := 'Compile the method locally in ' translated , r1 asString.
	m2 := 'Compile the method in the trait ' translated , aTrait asString.
	m3 := 'Cancel' translated.
	result := OBChoiceRequest
				prompt: prompt
				labels: (Array with: m1 with: m2 with: m3)
				values: (Array with: r1 with: aTrait with: r3 ).
	result = aTrait
		ifTrue: [self compileClass: aTrait].
	result isNil
		ifTrue: [^ false].
	^ true! !

!OBMethodDefinition methodsFor: '*ob-enhancements' stamp: 'dr 1/21/2009 12:11'!
validateMethodOfUsedTrait
	| messageLocation |
	
	messageLocation := self compileClass traitOrClassOfSelector: self compileSelector.
	self compileClass = messageLocation ifTrue: [^ true]. "it is local message"
	messageLocation isTrait ifTrue: 
		[^ self confirmCompileLocalyOrInUsedTrait: messageLocation ].
	^ true! !

OBCmdFindClass subclass: #OBCmdFindClassOrTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdFindClassOrTrait methodsFor: 'private' stamp: 'dc 5/17/2007 12:54'!
allBehaviorsIn: anEnvironment
	^ Array streamContents: [:stream|
		
		stream
			nextPutAll: anEnvironment classNames;
			nextPutAll: anEnvironment traitNames 
		
		]! !

OBInheritanceFilter subclass: #OBEnhancementInheritanceFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

OBEnhancementInheritanceFilter subclass: #OBDynamicInheritanceFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicInheritanceFilter methodsFor: 'filtering' stamp: 'dr 10/20/2008 18:42'!
icon: aSymbol forNode: aNode
	| method |
	method _ aNode theClass lookupSelector: aNode selector.
	method ifNil: [^ #blank].
	(Smalltalk at: #HODataBase ifAbsent: [^#blank]).
	((Smalltalk at: #HODataBase) default isInstrumentedMethod: aNode reference) ifTrue: [
		(aNode isKindOf: OBEnrichedMethodNode) ifFalse: [
			aNode become: (OBEnrichedMethodNode fromMethodNode: aNode)].
		^#flag].			
	^ super icon: aSymbol forNode: aNode! !

!OBEnhancementInheritanceFilter methodsFor: 'filtering' stamp: 'dr 1/9/2009 09:53'!
icon: aSymbol forNode: aNode 
	| method |
	method := aNode theClass lookupSelector: aNode selector.
	method ifNil: [ ^ #blank ].
	"icons for test methods"
	((aNode theClass inheritsFrom: TestCase) and: 
		[ ((aNode selector beginsWith: 'test') and: [aNode selector isUnary]) and: [ TestCase class includesSelector: #methodProgressed: ] ]) ifTrue: 
		[ (aNode theClass hasMethodBeenRun: aNode selector) ifFalse: [ ^ #testNotRun ].
		(aNode theClass methodProgressed: aNode selector) ifTrue: [ ^ #arrowUp ].
		(aNode theClass methodRegressed: aNode selector) ifTrue: [ ^ #abstractWithOverride ].
		(aNode theClass methodPassed: aNode selector) ifTrue: [ ^ #testGreen ].
		(aNode theClass methodFailed: aNode selector) ifTrue: [ ^ #testYellow ].
		(aNode theClass methodRaisedError: aNode selector) ifTrue: [ ^ #testRed ].	
		^ #blank ].
	method class = CompiledMethod ifFalse: [ method := method compiledMethod ].
	method isSubclassResponsibility ifTrue: 
		[ ^ aNode isOverridden 
			ifTrue: [ #abstractWithOverride ]
			ifFalse: [ #abstractWithoutOverride ] ].
	method sendsToSuper ifTrue: 
		[ | icon | 
		   	aNode isOverridden 
			 	ifTrue: [icon := 'superSendWithOverride']
			 	ifFalse: [icon := 'superSendWithoutOverride'].
			(method sendsSelector: aNode selector) 
				ifFalse: [icon := icon, 'OtherSelector'] 
				ifTrue: [aNode isOverride ifFalse: [icon := icon, 'NoSuperMethod']].
			^icon asSymbol		
		 ].
	method literals do: 
		[ :literal | 
		(literal == #halt or: 
			[ literal == #haltIfNil or: [ literal == #haltIf: or: [ literal == #haltOnce ] ] ]) ifTrue: [ ^ #breakpoint ].
		(literal == #flag: or: [ literal == #needsWork ]) ifTrue: [ ^ #needsWork ] ].
	^ aNode isOverride 
		ifTrue: 
			[ aNode isOverridden 
				ifTrue: [ #overriddenAndOverrides ]
				ifFalse: [ #overrides ] ]
		ifFalse: 
			[ aNode isOverridden 
				ifTrue: [ #overridden ]
				ifFalse: [ #blank ] ]! !

OBSystemBrowser subclass: #OBPackageBrowser
	instanceVariableNames: 'browseHistory historyCursor historyIndexOnSwitch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

OBPackageBrowser class
	instanceVariableNames: 'packageModification alwaysOnTopPackages packageOrganization'!

OBPackageBrowser class
	instanceVariableNames: 'packageModification alwaysOnTopPackages packageOrganization'!

OBPackageBrowser subclass: #OBMultipleSelectionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 10/9/2007 17:09'!
definitionPanel
	^ OBMultipleDefinitionPanel new! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:10'!
initialize
	self registerInOpenMenu! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:17'!
methodColumnIndex
    ^4! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 17:52'!
navigationPanel
	^OBMultipleSelectionColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 2/23/2008 15:22'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Multiple Selection Browser'. {self. #open}}.! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 5/14/2008 10:31'!
title
    ^'OB Multiple Selection Browser'! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 10/18/2008 10:29'!
unload
   super unload.
   TheWorldMenu unregisterOpenCommandWithReceiver: self.! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:15'!
useMultipleSelection
    ^true! !

OBMultipleSelectionBrowser subclass: #OBSmartGroupBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 2/29/2008 16:31'!
defaultMetaNode
     | env smartGroup package |
	env := OBMetaNode named: 'Environment'.
	package := OBMetaNode named: 'Package'.
	package
	      displaySelector: #indentedName;
	      ancestrySelector: #isDescendantOfClassCat:.
	self buildMetagraphOn: package.
     smartGroup := OBMetaNode named: 'SmartGroup'.
     smartGroup
		displaySelector: #indentedName.
	self buildMetagraphOn: smartGroup.	
	
     env
		childAt: #packages
			labeled: 'packages'
			put: package;
		childAt: #smartGroups
			labeled: 'smart groups'
			put: smartGroup;
		addFilter: OBModalFilter new.
     ^env       ! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 10:47'!
navigationPanel
	^OBSmartGroupColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 5/14/2008 10:32'!
title
    ^'OB Smart Group Browser'! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddSmartCategory
	^OBCmdAddSmartCategory! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddToSmartGroup
	^OBCmdAddToSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 9/22/2008 10:32'!
cmdBrowse 
	^OBCmdSmartGroupBrowse! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRemoveFromSmartGroup
	^OBCmdRemoveFromSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRenameSmartCategory
	^OBCmdRenameSmartCategory! !

!OBSmartGroupBrowser methodsFor: 'testing' stamp: 'dr 3/11/2008 10:15'!
isSearchBrowser
	^ true ! !

!OBPackageBrowser class methodsFor: 'initializing' stamp: 'dr 11/28/2008 14:18'!
addPreferences
	Preferences 
		addPreference: #visualizations
		categories: #('browsing')
		default: true
		balloonHelp: 'Display visualizations in the code browser such as UML, system complexity, etc..'.
		
	Preferences 
		addPreference: #classCommentOnClassSelect
		categories: #('browsing')
		default: self isDeveloperImage
		balloonHelp: 'Automatically display class comment when selecting a class.'.	
		
	Preferences 
		addPreference: #beDynamic
		categories: #('browsing')
		default: false
		balloonHelp: 'Integrate facilities to reason about dynamic information of the software being developed.'.	
			
	Preferences setDefaultAnnotationInfo.				! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 9/9/2008 17:29'!
addTopPackage: aWorkingCopy
    ^self alwaysOnTopPackages add: aWorkingCopy! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 9/9/2008 16:58'!
alwaysOnTopPackages
    alwaysOnTopPackages ifNil: [alwaysOnTopPackages := OrderedCollection new].
    ^alwaysOnTopPackages! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 8/15/2008 11:37'!
beDynamic
   Preferences enable: #beDynamic.! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 10/28/2008 10:32'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
     | metaGraph |
     metaGraph := (self dynamicBrowser ifTrue: [OBDynamicMetagraphBuilder] ifFalse: [OBEnhancementMetagraphBuilder])
		               on: root class: classSel comment: commentSel metaclass: metaclassSel.
	metaGraph classMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	metaGraph metaclassMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	"metaGraph methodMetaNode doubleClickCommandClass: OBCmdSelectMethodCategory."
	^metaGraph execute ! !

!OBPackageBrowser class methodsFor: 'system changes' stamp: 'dr 7/10/2008 11:51'!
classModified: anEvent
	MCWorkingCopy managersForClass: anEvent item do: [:mgr| mgr modified: true].! !

!OBPackageBrowser class methodsFor: 'system changes' stamp: 'dr 7/10/2008 11:51'!
classMoved: anEvent
	self classModified: anEvent.
	MCWorkingCopy managersForCategory: anEvent oldCategory do:[:mgr | mgr modified: true].! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 10/20/2008 18:53'!
defaultExtent
    ^800@450
    ! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 11/19/2008 14:19'!
defaultMetaNode
     | env smartGroup package cats classes builder |
	env := OBMetaNode named: 'Environment'.
	package := OBMetaNode named: 'Package'.
	package
	      displaySelector: #indentedName;
	      ancestrySelector: #isDescendantOfPackage:.
	cats := OBMetaNode named: 'Cats'.
	cats
	      displaySelector: #nameWithoutPrefix;	
	      ancestrySelector: #isDescendantOfClassCat:.	
	(package childAt: #classCategories put: cats) navigateTree.
	
	self buildMetagraphOn: package.
	"self buildMetagraphOn: cats."
     (package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | cats addEdge: edge].
	package filters do: [:filter | cats addFilter: filter].

	classes := OBMetaNode named: 'Classes'.
	classes
		displaySelector: #indentedName;
		ancestrySelector: #isDescendantOfClass:.
	builder := OBEnhancementMetagraphBuilder
		         on: classes 
	              class: #packagesForClassClass 
	              comment: #packagesForClassComment 
	              metaclass: #packagesForClassMetaclass.
	builder execute.
	builder classMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder metaclassMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder classCommentMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.							
	classes removeFilter: OBQueryingClassSortFilter new.
	
     smartGroup := OBMetaNode named: 'SmartGroup'.
     smartGroup
		displaySelector: #indentedName.
	(package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | smartGroup addEdge: edge].
	smartGroup addFilter: OBModalFilter new;
		          addFilter: OBClassSortFilter new.
	
     env
		childAt: #packages
			labeled: 'pkgs'
			put: package;
		childAt: #classesHierarchically
			labeled: 'hier.'
			put: classes;				
		childAt: #smartGroups
			labeled: 'smart groups'
			put: smartGroup;
		addFilter: OBModalFilter new.
     ^env! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 7/20/2007 15:03'!
defaultRootNode
	^ OBPackagesOrClassesNode new! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 11/4/2008 19:54'!
definitionPanel
	^(self dynamicBrowser ifTrue: [OBEnrichedDefinitionPanel new] ifFalse: [OBEnhancementDefinitionPanel new]) ! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 9/2/2008 15:51'!
dynamicBrowser
	^Preferences beDynamic! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/27/2008 15:43'!
hasHistoryButtons
    ^true! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/22/2008 15:15'!
hasReferencePanel
    ^self dynamicBrowser! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 4/17/2008 15:43'!
hierarchyBrowserClass
	^ OBEnhancementHierarchyBrowser! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 7/8/2008 17:17'!
hierarchySwitchIndex
    ^2! !

!OBPackageBrowser class methodsFor: 'initializing' stamp: 'dr 11/19/2008 14:27'!
initialize
	"self initialize"
	self registerInOpenMenu.
	self addPreferences.
	
	Smalltalk at: #SystemChangeNotifier ifPresent: [:cls |
		cls uniqueInstance noMoreNotificationsFor: self.
	].
     self registerForNotifications.	
	
     "to be removed in a while"
     TheWorldMenu unregisterOpenCommand: 'SmartGroup Browser'.! !

!OBPackageBrowser class methodsFor: 'testing' stamp: 'dr 4/10/2008 16:34'!
isDeveloperImage
    ^(Smalltalk classNamed: #DEVImageCreator) notNil! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 5/14/2008 10:59'!
mercuryPanel
	^Preferences mercuryPanel ifTrue: [OBEnrichedMercuryPanel new] ifFalse: [nil]! !

!OBPackageBrowser class methodsFor: 'system changes' stamp: 'dr 7/10/2008 12:04'!
methodModified: anEvent
	MCWorkingCopy managersForClass: anEvent itemClass selector: anEvent itemSelector do: [:mgr | self modifiedPackage: mgr].! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 7/10/2008 12:07'!
modificationOfPackage: aWorkingCopy
    ^self packageModification at: aWorkingCopy ifAbsent: [0] ! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 7/10/2008 16:26'!
modifiedPackage: aWorkingCopy
    self packageModification at: aWorkingCopy put: DateAndTime now asSeconds.! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 10/28/2008 10:34'!
navigationPanel
	^OBSmartGroupColumnPanel minPanes: self minPanes maxPanes: self maxPanes ! !

!OBPackageBrowser class methodsFor: 'instance creation' stamp: 'dr 7/20/2007 15:06'!
onMonticelloClassCategory: aString
	^self selection: (OBMonticelloClassCategoryNode on: aString)! !

!OBPackageBrowser class methodsFor: 'instance creation' stamp: 'dr 12/10/2007 10:22'!
onPackage: aPackage
	^self selection: aPackage asNode! !

!OBPackageBrowser class methodsFor: 'opening' stamp: 'dr 7/20/2007 15:07'!
openOnMonticelloClassCategory: aString
	^ (self onMonticelloClassCategory: aString) open! !

!OBPackageBrowser class methodsFor: 'opening' stamp: 'dr 7/20/2007 15:07'!
openOnPackage: aPackage
	^ (self onPackage: aPackage) open! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 10/28/2008 10:34'!
optionalButtonPanel
	^ OBPlatform current optionalButtons ifTrue: [OBEnhancementFixedButtonPanel new] ! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 11/19/2008 15:04'!
orderedPackages
	^self packageOrganization packages! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 7/10/2008 12:03'!
packageModification
    packageModification ifNil: [packageModification := Dictionary new].
    ^packageModification! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 11/19/2008 15:04'!
packageOrganization
    packageOrganization ifNil: [packageOrganization := OBPackageOrganizer default].
    ^packageOrganization! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 10/29/2008 16:11'!
packageSwitchIndex
    ^1! !

!OBPackageBrowser class methodsFor: 'system changes' stamp: 'dr 7/10/2008 11:53'!
registerForNotifications
	Smalltalk at: #SystemChangeNotifier ifPresent: [:cls |
	(cls uniqueInstance)
		noMoreNotificationsFor: self;
		notify: self ofSystemChangesOfItem: #class change: #Added using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Modified using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Renamed using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Commented using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Recategorized using: #classMoved:;
		notify: self ofSystemChangesOfItem: #class change: #Removed using: #classModified:;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Recategorized using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #methodModified:
	].! !

!OBPackageBrowser class methodsFor: 'initializing' stamp: 'dr 2/23/2008 15:22'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Image Browser'. {self. #open}}.! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 9/9/2008 17:29'!
removeTopPackage: aWorkingCopy
    ^self alwaysOnTopPackages remove: aWorkingCopy! !

!OBPackageBrowser class methodsFor: 'package ordering' stamp: 'dr 12/1/2008 15:04'!
resetPackageOrganization
	self packageOrganization reset! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 8/15/2008 11:39'!
setDynamicBrowser: aBoolean
    Preferences setPreference: #beDynamic toValue: aBoolean.
! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 7/8/2008 16:26'!
smartGroupSwitchIndex
    ^3! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 4/11/2008 11:32'!
title
    ^'OB Package Browser'! !

!OBPackageBrowser class methodsFor: 'initializing' stamp: 'dr 10/18/2008 10:28'!
unload
    TheWorldMenu unregisterOpenCommandWithReceiver: self.
    Smalltalk at: #SystemChangeNotifier ifPresent: [:cls | cls uniqueInstance noMoreNotificationsFor: self].
    Preferences removePreference: #visualizations.
    Preferences removePreference: #classCommentOnClassSelect.
    Preferences removePreference: #beDynamic.! !

!OBPackageBrowser methodsFor: 'morphic' stamp: 'dr 1/9/2008 15:41'!
addModelItemsToWindowMenu: aMenu
	Smalltalk 
		at: #SystemBrowser 
		ifPresent: [:class | class 
								addRegistryMenuItemsTo: aMenu 
								inAccountOf: OBPackageBrowserAdaptor new].! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 16:23'!
browseHistory
    browseHistory ifNil: [browseHistory := OrderedCollection new].
    ^browseHistory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 9/9/2008 17:51'!
cmdAddPackageOnTop
	^OBCmdAddPackageOnTop! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdAddSmartCategory
	^OBCmdAddSmartCategory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdAddToSmartGroup
	^OBCmdAddToSmartGroup! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:33'!
cmdAddWorkingCopy
    ^OBCmdAddWorkingCopy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdBrowse
	^OBCmdSmartGroupBrowse! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 9/13/2007 11:13'!
cmdBrowseDynamicImplementors
	^OBCmdDynamicImplementors! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 11/16/2007 16:19'!
cmdBrowseDynamicReferences
    ^OBCmdBrowseDynamicReferences! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/5/2007 16:49'!
cmdBrowseDynamicSenders
	^OBCmdDynamicSenders! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 2/15/2008 17:57'!
cmdBrowseHierarchy
	^OBEnhancementCmdBrowseHierarchy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/11/2008 14:11'!
cmdBrowsePackage
	^ OBCmdBrowsePackage! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/21/2008 11:43'!
cmdCheckRecentStatus
	^OBCmdCheckRecentStatus! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 12/18/2007 17:02'!
cmdCreateMonticelloCategory
    ^OBCmdCreateMonticelloCategory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/15/2007 11:01'!
cmdDisplayReferencingPlaces
	^OBCmdDisplayReferencingPlaces! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 9/22/2008 15:25'!
cmdFindClass
	^{OBCmdFindClassOrTrait. OBCmdRecentClasses}! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/3/2008 17:49'!
cmdImportPackage
    ^OBCmdImportPackage! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/15/2007 11:01'!
cmdJumpToReference
	^OBCmdJumpToReference! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/3/2008 16:39'!
cmdMethodToExtendClass
	^OBCmdMethodToExtendClass! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/16/2007 10:35'!
cmdObserveDynamically
	^OBCmdObserveDynamically! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'cb 7/16/2008 15:43'!
cmdOpenMonticello
	^ OBCmdOpenMC ! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 5/9/2008 14:10'!
cmdPackageToScope
	^ OBCmdPackageToScope! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdPublishPackage
	^OBCmdPublishPackage! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/21/2008 11:49'!
cmdReferencingMethods
	^OBCmdReferencingMethods! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 9/19/2008 17:26'!
cmdRemoveCat
	^OBCmdRemoveMonticelloCategory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdRemoveFromSmartGroup
	^OBCmdRemoveFromSmartGroup! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 9/30/2008 11:23'!
cmdRemoveMethodCat
	^OBCmdRemoveMethodCategory ! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/11/2008 14:11'!
cmdRemovePackage
	^ OBCmdRemovePackage! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdRenameSmartCategory
	^OBCmdRenameSmartCategory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 11/19/2008 15:14'!
cmdReorgPackages
    ^OBCmdReorgPackages! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/17/2008 11:35'!
cmdResetSearchSmartGroups
	^OBCmdResetSearchSmartGroups! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 8/11/2008 16:24'!
cmdSearchGroupClassRefs
	^OBCmdSearchGroupClassRefs! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 8/11/2008 15:02'!
cmdSearchGroupImplementors
	^OBCmdSearchGroupImplementors! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 8/11/2008 15:32'!
cmdSearchGroupSenders
	^OBCmdSearchGroupSenders! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/21/2008 17:15'!
cmdShowCollaborators
    ^OBCmdShowCollaborators! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/25/2008 14:41'!
cmdShowCollaboratorsFrequency
    ^OBCmdShowFrequencyMethodInvocations! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/23/2008 12:00'!
cmdShowMethodInvocations
    ^OBCmdShowMethodInvocations! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/16/2007 10:57'!
cmdStopObservingDynamically
	^OBCmdStopObservingDynamically! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 5/9/2008 14:12'!
cmdTogglePackageScope
	^ OBCmdTogglePackageScope! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 12/14/2007 15:16'!
cmdUpdatePackage
	^OBCmdUpdatePackage ! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdViewChanges
	^OBCmdViewChanges! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdViewHistory
	^OBCmdViewHistory! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 17:18'!
historyAtCursor
   ^self browseHistory at: self historyCursor ifAbsent: [nil]! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 15:30'!
historyCursor
    ^historyCursor ifNil: [0]! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 16:21'!
historyCursor: anInteger
    historyCursor := anInteger! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:23'!
historyIndexOnSwitch
    historyIndexOnSwitch ifNil: [historyIndexOnSwitch := 0].
    ^historyIndexOnSwitch! !

!OBPackageBrowser methodsFor: 'initializing' stamp: 'dr 10/20/2008 18:53'!
initialExtent
    super initialExtent.
    ^self class defaultExtent! !

!OBPackageBrowser methodsFor: 'initializing' stamp: 'dr 2/21/2008 11:31'!
initialize
    super initialize.! !

!OBPackageBrowser methodsFor: 'testing' stamp: 'dr 4/10/2008 16:52'!
isSearchBrowser
    ^true! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:23'!
markSwitch
    historyIndexOnSwitch := self historyCursor.! !

!OBPackageBrowser methodsFor: 'panels' stamp: 'dr 3/13/2008 13:21'!
optionalButtonPanel
	^ panels 
		detect: [:ea | ea isKindOf: OBFixedButtonPanel] 
		ifNone: [self error: 'No optional button panel configured']! !

!OBPackageBrowser methodsFor: 'updating' stamp: 'dr 10/24/2008 16:10'!
register
	super register.
	PackageOrganizer default addDependent: self.
	MCWorkingCopy addDependent: self.			! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:24'!
resetHistoryIndexOnSwitch
    historyIndexOnSwitch := 0! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 16:48'!
setHistory: aCollection
    browseHistory := aCollection! !

!OBPackageBrowser methodsFor: 'accessing' stamp: 'dr 4/21/2008 15:41'!
setMetaNode: aMetaNode root: aNode
    self navigationPanel setMetaNode: aMetaNode node: aNode.! !

!OBPackageBrowser methodsFor: 'updating' stamp: 'dr 10/24/2008 16:03'!
unregister
	super unregister.
	PackageOrganizer default removeDependent: self.
	MCWorkingCopy removeDependent: self.			! !

!OBPackageBrowser methodsFor: 'updating' stamp: 'dr 10/24/2008 16:43'!
update: aSymbol
	(aSymbol = #packages or: [aSymbol = #allManagers]) ifTrue: [self signalRefresh]	! !

!OBSystemBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 10/29/2008 15:22'!
hierarchyBrowserClass
    ^OBEnhancementHierarchyBrowser! !

!OBSystemBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 4/21/2008 17:35'!
openOnNode: aNode
    | class |
    class := aNode theClass.
    aNode isMethodNode ifTrue: [self openOnClass: class selector: aNode selector] ifFalse: [self openOnClass: class].! !

!OBClassCategoryNode methodsFor: '*ob-enhancements' stamp: 'jk 8/13/2007 16:23'!
addTraitsOf: aClassOrTrait into: aCollection ofParentNode: aNode
	aClassOrTrait traitTransformations do: [ :t | | n |
			n := t asNodeOf: aNode.
			aCollection add: (t asNodeOf: aNode).
			self addTraitsOf: t into: aCollection ofParentNode: n.
		].
	^ aCollection
! !

!OBClassCategoryNode methodsFor: '*ob-enhancements' stamp: 'jk 8/13/2007 16:23'!
usedTraits
	| classes result |
	classes := self classes.
	result := OrderedCollection new.
	classes do: [ :node |
				result add: node.
				self addTraitsOf: node theClass into: result ofParentNode: node. ].
	^ result! !

OBClassCategoryNode subclass: #OBMonticelloClassCategoryNode
	instanceVariableNames: 'workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMonticelloClassCategoryNode commentStamp: 'dr 7/16/2007 10:37' prior: 0!
I represent a class category contained in a Monticello package.!

!OBMonticelloClassCategoryNode class methodsFor: 'instance creation' stamp: 'dr 7/4/2008 11:49'!
on: aString workingCopy: workingCopy
    ^(self on: aString) workingCopy: workingCopy! !

!OBMonticelloClassCategoryNode methodsFor: 'actions' stamp: 'dr 2/15/2008 16:51'!
browse
	OBCodeBrowser defaultBrowserClass openOnMonticelloClassCategory: name! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 12/9/2008 20:26'!
displayFullString 
    ^self name! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 6/7/2007 16:35'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 11/27/2008 11:35'!
environment
	^environment! !

!OBMonticelloClassCategoryNode methodsFor: 'actions' stamp: 'dr 12/22/2008 14:05'!
icon
     (Smalltalk hasClassNamed: #HODataBase) ifFalse: [^#blankSmall].
     OBPackageBrowser dynamicBrowser ifFalse:  [^#blankSmall].
    ^((Smalltalk at: #HODataBase) default analyzedClasses anySatisfy: [:class | self realClasses includes: class]) ifTrue: [#flag] ifFalse: [#blankSmall]! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 9/30/2008 10:23'!
indentedName
    | indent | 
    indent := '     '.
    ^indent, self name! !

!OBMonticelloClassCategoryNode methodsFor: 'ancestry' stamp: 'dr 11/19/2008 14:11'!
isDescendantOf: packageNode 
	^packageNode isPackage 
		and: [packageNode classCatNames includes: self name]! !

!OBMonticelloClassCategoryNode methodsFor: 'ancestry' stamp: 'dr 5/2/2007 15:13'!
isDescendantOfClass: other
     ^false! !

!OBMonticelloClassCategoryNode methodsFor: 'ancestry' stamp: 'dr 12/2/2008 18:43'!
isDescendantOfMethodCat: category
	^ false! !

!OBMonticelloClassCategoryNode methodsFor: 'ancestry' stamp: 'dr 10/24/2008 11:00'!
isDescendantOfPackage: aPackageNode
    ^aPackageNode includesCategoryWithName: self name! !

!OBMonticelloClassCategoryNode methodsFor: 'testing' stamp: 'dr 2/7/2008 12:08'!
isInstrumented
    ^self classes allSatisfy: [:ea | ea isInstrumented]! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 10/18/2008 10:10'!
nameWithoutPrefix 
    ^self systemCategoryPrefix 
             ifNotEmpty: [super name allButFirst: self systemCategoryPrefix size + 1] 
             ifEmpty: [super name]! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 10/17/2007 12:12'!
realClasses
    ^self classNames collect: [:ea | environment at: ea] ! !

!OBMonticelloClassCategoryNode methodsFor: 'updating' stamp: 'dr 10/24/2008 10:32'!
remove
 	super remove. 
	self workingCopy isDummyPackage ifTrue: [self workingCopy removeCategory: self name].! !

!OBMonticelloClassCategoryNode methodsFor: 'actions' stamp: 'dr 2/10/2009 11:15'!
renameTo: aString forRoot: aNode
	| packageNode |
	super renameTo: aString forRoot: aNode.
	packageNode := aNode packages detect: [:pkg | pkg workingCopy = self workingCopy].
	packageNode resetCache.		! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 9/30/2008 10:32'!
systemCategoryPrefix
    ^workingCopy packageInfo systemCategoryPrefix! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:37'!
workingCopy
    ^workingCopy! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:37'!
workingCopy: aWorkingCopy
    workingCopy := aWorkingCopy! !

PluggableListMorphOfMany subclass: #OBPluggableListMorphOfMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBPluggableListMorphOfMany commentStamp: 'dr 7/14/2008 11:37' prior: 0!
OBPluggableListMorphOfMany makes sure that a multiple selection list as implemented in PluggableListMorphOfMany can be integrated in OmniBrowser.
In particular, it assures that icons can be displayed for list elements and that drag & drop works. This multiple selection list is only used in the method column in the class browser, here methods can be dragged by selecting a particular method while holding the mouse down. Moving the mouse cursor while a method is dragged to a method category allows the user to drop this method in this category. There are currently no other means to drag & drop list elements.
!

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 8/21/2007 15:20'!
iconAt: index
	^ model iconAt: index! !

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 6/7/2007 15:53'!
listMorphClass
    ^OBLazyListMorph! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 10:51'!
mouseDown: evt
	| selectors row oldIndex oldVal |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	row := self rowAtLocation: evt position.
	row = 0  ifTrue: [^super mouseDown: evt].
	"self dragEnabled ifTrue: [aMorph highlightForMouseDown]."
	
	model okToChange ifFalse: [^ self].  "No change if model is locked"

	"Set meaning for subsequent dragging of selection"
	dragOnOrOff := (self listSelectionAt: row) not.
	oldIndex := self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.	
	
	selectors := Array 
		with: nil"#click:"
		with: (doubleClickSelector ifNotNil:[#doubleClick:])
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10 ! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 7/14/2008 11:17'!
mouseMove: evt
	| oldIndex oldVal row |
	(self dropEnabled and: [evt hand hasSubmorphs]) 
		ifFalse:[^super mouseMove: evt].
	potentialDropRow ifNotNil:[
		potentialDropRow = (self rowAtLocation: evt position)
			ifTrue:[^self]. 
	].
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) 
		ifTrue:[self mouseEnterDragging: evt].
		
	"Set meaning for subsequent dragging of selection"
	oldIndex := self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].

     row := self rowAtLocation: evt position.
	"Set or clear new primary selection (listIndex)"
	(dragOnOrOff ifNil: [dragOnOrOff := (self listSelectionAt: row) not. ])
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.
	row changed! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 11:18'!
mouseUp: event 
	"The mouse came up within the list; take appropriate action"
	| row |
	row := self rowAtLocation: event position.
	"aMorph ifNotNil: [aMorph highlightForMouseDown: false]."
	model okToChange
		ifFalse: [^ self].
	"No change if model is locked"
	
	dragOnOrOff := nil.  "So improperly started drags will have not effect"	
	
	"row == self selectionIndex
		ifTrue: [(autoDeselect ifNil: [true]) ifTrue:[row == 0 ifFalse: [self changeModelSelection: 0] ]]
		ifFalse: [self changeModelSelection: row]."
	Cursor normal show! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 2/8/2008 10:00'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection result |
	oldSelection := self getCurrentSelectionIndex.
	result := super specialKeyPressed: asciiValue.	
	self listSelectionAt: oldSelection put: false.
	^result! !

!OBSwitch methodsFor: '*ob-enhancements' stamp: 'dr 10/21/2008 13:52'!
column
    ^column! !

!OBAnnotationRequest methodsFor: '*ob-enhancements' stamp: 'dr 9/25/2008 16:42'!
defaultAnnotationRequests
	^#(
				#timeStamp
				#messageComesFrom
				#messageCategory
				#implementorsCount
				#allChangeSets
	)! !

!OBAnnotationRequest methodsFor: '*ob-enhancements' stamp: 'jk 6/20/2007 14:03'!
messageComesFrom
	class isNil ifTrue: [^ String new].
	selector isNil ifTrue: [^ class printString ].
	^ (class traitOrClassOfSelector: selector) printString! !

!OBTextMorphEditor methodsFor: '*ob-enhancements' stamp: 'damiencassou 1/21/2009 13:36'!
findClass
	| requestor target | 
	
	"locate package column to be able to use find class command"
	requestor := model browser navigationPanel columns first.
	target := requestor selectedNode.

	(OBCmdFindClass on: target for: requestor) execute.! !

!OBTextMorphEditor methodsFor: '*ob-enhancements' stamp: 'damiencassou 1/21/2009 13:36'!
findClass: characterStream
	sensor keyboard.
	self closeTypeIn: characterStream.
	self findClass.
	^ true! !

!OBColumnPanel methodsFor: '*ob-enhancements' stamp: 'dr 11/4/2008 19:58'!
definitionPanel
    ^browser definitionPanel ! !

OBColumnPanel subclass: #OBEnhancementColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 4/14/2008 16:23'!
addColumn: aColumn
    self pushColumn: aColumn! !

!OBEnhancementColumnPanel methodsFor: 'selecting' stamp: 'dr 2/14/2008 15:34'!
autoSelect: aColumn 
	aColumn next ifNotNilDo: 
		[:next | next autoSelect].! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/26/2008 15:51'!
changeRootNode: aNode 
	| metaNode |
	metaNode := browser class defaultMetaNode.
	metaNode addFilter: (OBClassHierarchyFilter columnPanel: self).	
	self changeRootNode: aNode metaNode: metaNode.! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 3/5/2008 16:19'!
changeRootNode: aNode metaNode: aMetaNode
	| firstColumn  |	
	root := aNode.
     root metaNode: aMetaNode.
	
	firstColumn := columns first.
	firstColumn clear.
	firstColumn basicParent: aNode.		
     self clearAfter: firstColumn.
     self jumpTo: aNode.! !

!OBEnhancementColumnPanel methodsFor: 'search integration' stamp: 'dr 5/15/2008 15:30'!
cleanMetagraph! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 9/17/2008 14:53'!
columnClass
    | secondLevelEdges |
    secondLevelEdges := root metaNode edges first metaNode edges.
    secondLevelEdges ifNotEmpty: [(secondLevelEdges first isTreeEdge and: [columns isEmpty]) ifTrue: [^OBTreeColumn]].
    ^OBEnhancementColumn! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/14/2008 15:02'!
emptyColumn
	^self columnClass inPanel: self! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 4/14/2008 16:33'!
emptyColumnWithDoubleClick: aBoolean
	^self emptyColumn useDoubleClick: aBoolean; yourself! !

!OBEnhancementColumnPanel methodsFor: 'selecting' stamp: 'dr 10/29/2008 16:09'!
selectSwitchTab: anInteger
    columns first switch selection: anInteger! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 9/19/2008 17:38'!
setMetaNode: aMetaNode node: aNode 
	| metaNode useDoubleClick |
     
	root := aNode.
	root metaNode: aMetaNode.
	root browser: browser.
	self addColumn: (self columnClass inPanel: self metaNode: aMetaNode node: root).

	metaNode := aMetaNode next. "go to second metanode as this one has already been handled in first column"
	minPanes - self columns size timesRepeat: [
	    metaNode := metaNode next. 
	    useDoubleClick := metaNode notNil and: [metaNode supportsDoubleClick].
	    self addColumn: (self emptyColumnWithDoubleClick: useDoubleClick)].
	
	browser class isHierarchyBrowser ifTrue: [aMetaNode addFilter: (OBClassHierarchyFilter columnPanel: self)].! !

OBEnhancementColumnPanel subclass: #OBSmartGroupColumnPanel
	instanceVariableNames: 'smartGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

OBSmartGroupColumnPanel subclass: #OBMultipleSelectionColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMultipleSelectionColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/14/2008 12:09'!
columnClass
     | columnClass methodColumnIdx |
     columnClass := OBEnhancementColumn.

     browser class useMultipleSelection ifTrue: [
	    methodColumnIdx := browser class methodColumnIndex.    
         self columns size = (methodColumnIdx - 1) ifTrue: [columnClass := OBMultipleSelectionColumn].
     ].
	^columnClass! !

!OBMultipleSelectionColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/14/2008 12:09'!
emptyColumn
	^self columnClass inPanel: self! !

!OBSmartGroupColumnPanel methodsFor: 'search integration' stamp: 'dr 5/15/2008 15:08'!
adaptMetagraphFor: aSearchNode
    "adapt metagraph to precisely highlight search results"
    | metaNodes | 
    metaNodes := self retrieveMetaNodes.
    self addAutoSelectToMetaNode: metaNodes first for: aSearchNode.
    self addSearchFilterToMetaNode: metaNodes second for: aSearchNode.! !

!OBSmartGroupColumnPanel methodsFor: 'private' stamp: 'dr 5/15/2008 15:35'!
addAutoSelectToMetaNode: aMetaNode for: aSearchNode
    "add an auto-select metanode to metagraph to auto-select first method complying with the search query"
    | searchMetaNode |

    self removeAutoSelectFromMetaNode: aMetaNode.
    searchMetaNode := (OBEnhancementMetaNode named: #SmartGroupJump) addSearchNode: aSearchNode.
    searchMetaNode updateOnAutoSelect.
    aMetaNode childAt: #smartGroupJump put: searchMetaNode.
    aMetaNode autoSelect: searchMetaNode.! !

!OBSmartGroupColumnPanel methodsFor: 'initializing' stamp: 'dr 9/24/2008 11:08'!
addColumn: aColumn
	self columns addLast: aColumn.! !

!OBSmartGroupColumnPanel methodsFor: 'private' stamp: 'dr 5/15/2008 15:10'!
addSearchFilterToMetaNode: aMetaNode for: aSearchNode
    "add filter to metagraph to highlight method nodes covered by search query"
    self removeSearchFilterFromMetaNode: aMetaNode.
    aMetaNode addFilter: (OBSearchQueryFilter on: aSearchNode).! !

!OBSmartGroupColumnPanel methodsFor: 'search integration' stamp: 'dr 10/29/2008 22:14'!
addSearchToSmartGroup: aSearchNode
    | alias |
    alias := self smartGroup addSearchNode: aSearchNode.
    self selectSwitchTab: browser class smartGroupSwitchIndex.
    alias jumpIn: self.! !

!OBSmartGroupColumnPanel methodsFor: 'search integration' stamp: 'dr 5/15/2008 15:09'!
cleanMetagraph
    "clean metagraph from any adaptions added for highlighting of search results"
    | metaNodes | 
    metaNodes := self retrieveMetaNodes.
    self removeAutoSelectFromMetaNode: metaNodes first.
    self removeSearchFilterFromMetaNode: metaNodes second.! !

!OBSmartGroupColumnPanel methodsFor: 'private' stamp: 'dr 5/15/2008 15:12'!
removeAutoSelectFromMetaNode: aMetaNode
    aMetaNode removeChildAt: #smartGroupJump.
    aMetaNode autoSelect: nil.! !

!OBSmartGroupColumnPanel methodsFor: 'private' stamp: 'dr 5/15/2008 15:10'!
removeSearchFilterFromMetaNode: aMetaNode
    aMetaNode removeFilter: OBSearchQueryFilter new.! !

!OBSmartGroupColumnPanel methodsFor: 'private' stamp: 'dr 5/15/2008 15:03'!
retrieveMetaNodes
    "locate all method category and method metanode in metagraph"
    | metaNode cur allMethodCategory | 

    metaNode := cur := root metaNode.
    [cur notNil] whileTrue: [
	   metaNode := cur. cur := metaNode next.
	   metaNode name = #AllMethodCategory ifTrue: [allMethodCategory := metaNode].
    ].
    ^{allMethodCategory. metaNode}! !

!OBSmartGroupColumnPanel methodsFor: 'navigating' stamp: 'dr 9/24/2008 13:52'!
selectSubtree: aSubtree
	| myColumns |
	myColumns := smartGroup ifNil: [columns] ifNotNil: [columns allButFirst].
	aSubtree selectInColumns: myColumns! !

!OBSmartGroupColumnPanel methodsFor: 'updating' stamp: 'dr 11/10/2008 11:56'!
selectionChanged: ann
     ann node ifNotNilDo: [:node | node isSmartGroupCategory ifTrue: [^self]].
     super selectionChanged: ann.! !

!OBSmartGroupColumnPanel methodsFor: 'initializing' stamp: 'dr 9/24/2008 11:08'!
setMetaNode: aMetaNode node: aNode 
	columns := OrderedCollection new.
     super setMetaNode: aMetaNode node: aNode.	
	"update columns at the end to not break layout"	
	self changed: #columns.! !

!OBSmartGroupColumnPanel methodsFor: 'accessing' stamp: 'dr 3/1/2008 17:06'!
smartGroup
    ^OBSmartRootNode default! !

OBCmdRemoveCat subclass: #OBCmdRemoveMethodCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveMethodCategory methodsFor: 'testing' stamp: 'dr 10/30/2008 09:49'!
isActive
    	^ target isMethodCategoryNode and: [requestor isSelected: target]! !

OBCmdRemoveCat subclass: #OBCmdRemoveMonticelloCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveMonticelloCategory methodsFor: 'execution' stamp: 'dr 2/10/2009 10:59'!
execute
	| list choice packageNode classCats |
	packageNode := requestor browser root packages detect: [:pkg | pkg workingCopy = target workingCopy].
	list := target container organization listAtCategoryNamed: target name. 
	list isEmpty ifTrue: [
		target remove. 
		packageNode resetCache.		
		requestor listChanged. 
		classCats := packageNode classCategories.
		classCats ifNotEmpty: [self select: classCats first with: requestor announcer]
		           ifEmpty: [self select: packageNode with: requestor announcer].
		^self].
	
	choice := OBConfirmationRequest prompt: 'Are you sure you want to
remove this category 
and all its elements?' confirm: 'Remove'.
	(choice notNil and: [choice]) ifTrue: [
		target remove. 
		packageNode resetCache.
		requestor listChanged.
		classCats := packageNode classCategories.
		classCats ifNotEmpty: [self select: classCats first with: requestor announcer]
		           ifEmpty: [self select: packageNode with: requestor announcer]]! !

!OBCmdRemoveMonticelloCategory methodsFor: 'testing' stamp: 'dr 10/30/2008 09:49'!
isActive
     target ifNil: [^false].
    	^ target isClassCategoryNode and: [requestor isSelected: target]! !

OBSendersBrowser subclass: #OBDynamicSendersBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicSendersBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 17:17'!
chasingBrowsers
    ^false! !

!OBDynamicSendersBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:41'!
defaultMetaNode
	^self sendersNav: #dynamicSenders! !

!OBDynamicSendersBrowser class methodsFor: 'configuration' stamp: 'dr 4/11/2008 17:25'!
definitionPanel
     ^OBEnrichedDefinitionPanel new! !

!OBDynamicSendersBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:40'!
title
	^'Dynamic Senders of'! !

!MCWorkingCopy methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2007 10:14'!
asNode
    ^OBMonticelloPackageNode on: self! !

!MCWorkingCopy methodsFor: '*ob-enhancements' stamp: 'dr 10/24/2008 11:01'!
includesCategoryWithName: aString
   ^aString beginsWith: self packageName! !

!MCWorkingCopy methodsFor: '*ob-enhancements' stamp: 'dr 7/11/2008 11:03'!
isDummyPackage
    ^false! !

!OBClassSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/11/2008 14:50'!
isClassSearch
    ^true! !

!OBClassSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 17:31'!
isDescendantOfClassCat: aClassCategoryNode
    ^true! !

!OBClassSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 2/7/2008 17:10'!
isEnrichedDefinition
    ^false! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 10/31/2008 10:54'!
addPaneSplitters
	| splitter remaining target targetX sameX minY maxY targetY sameY minX maxX |
	self removePaneSplitters.
	self removeCornerGrips. 
	remaining := transform submorphs reject: [ : each | each layoutFrame rightFraction = 1 ].
	[ remaining notEmpty ] whileTrue: 
		[ target := remaining first.
		targetX := target layoutFrame rightFraction.
		sameX := transform submorphs select: [ : each | each layoutFrame rightFraction = targetX ].
		minY := (sameX detectMin: [ : each | each layoutFrame topFraction ]) layoutFrame topFraction.
		maxY := (sameX detectMax: [ : each | each layoutFrame bottomFraction ]) layoutFrame bottomFraction.
		splitter := ProportionalSplitterMorph new.
		splitter layoutFrame: (LayoutFrame 
				fractions: (targetX @ minY corner: targetX @ maxY)
				offsets: ((0 @ (target layoutFrame topOffset ifNil: [ 0 ]) corner: 4 @ (target layoutFrame bottomOffset ifNil: [ 0 ])) translateBy: (target layoutFrame rightOffset ifNil: [ 0 ]) @ 0)).
		transform addMorphBack: (splitter position: self position).
		remaining := remaining copyWithoutAll: sameX ].
	remaining := transform submorphs copy reject: [ : each | each layoutFrame bottomFraction = 1 ].
	[ remaining notEmpty ] whileTrue: 
		[ target := remaining first.
		targetY := target layoutFrame bottomFraction.
		sameY := transform submorphs select: [ : each | each layoutFrame bottomFraction = targetY ].
		minX := (sameY detectMin: [ : each | each layoutFrame leftFraction ]) layoutFrame leftFraction.
		maxX := (sameY detectMax: [ : each | each layoutFrame rightFraction ]) layoutFrame rightFraction.
		splitter := ProportionalSplitterMorph new
			beSplitsTopAndBottom ;
			yourself.
		splitter layoutFrame: (LayoutFrame 
				fractions: (minX @ targetY corner: maxX @ targetY)
				offsets: (((target layoutFrame leftOffset ifNil: [ 0 ]) @ 0 corner: (target layoutFrame rightOffset ifNil: [ 0 ]) @ 4) translateBy: 0 @ (target layoutFrame bottomOffset ifNil: [ 0 ]))).
		transform addMorphBack: (splitter position: self position).
		remaining := remaining copyWithoutAll: sameY ].
	self linkSubmorphsToSplitters. 
	self splitters do: [ : each | each comeToFront ]! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 2/19/2008 11:11'!
linkSubmorphsToSplitters

	self splitters do:
		[:each |
		each splitsTopAndBottom
			ifTrue:
				[transform submorphsDo:
					[:eachMorph |
					(eachMorph ~= each and: [eachMorph layoutFrame bottomFraction = each layoutFrame topFraction]) ifTrue: [each addLeftOrTop: eachMorph].
					(eachMorph ~= each and: [eachMorph layoutFrame topFraction = each layoutFrame bottomFraction]) ifTrue: [each addRightOrBottom: eachMorph]]]
			ifFalse:
				[transform submorphsDo:
					[:eachMorph |
					(eachMorph ~= each and: [eachMorph layoutFrame rightFraction = each layoutFrame leftFraction]) ifTrue: [each addLeftOrTop: eachMorph].
					(eachMorph ~= each and: [eachMorph layoutFrame leftFraction = each layoutFrame rightFraction]) ifTrue: [each addRightOrBottom: eachMorph]]]]! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 2/19/2008 11:23'!
removeCornerGrips

	| corners |
	corners := transform submorphsSatisfying: [:each | each isKindOf: CornerGripMorph].
	corners do: [:each | each delete]! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 2/19/2008 11:24'!
splitters

	^ transform submorphsSatisfying: [:each | each isKindOf: ProportionalSplitterMorph]! !

OBMetagraphBuilder subclass: #OBEnhancementMetagraphBuilder
	instanceVariableNames: 'updateOnAutoSelect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

OBEnhancementMetagraphBuilder subclass: #OBDynamicMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicMetagraphBuilder methodsFor: 'private' stamp: 'dr 11/12/2007 11:01'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBClassAnnotationFilter new! !

!OBDynamicMetagraphBuilder methodsFor: 'private' stamp: 'dr 11/19/2007 16:42'!
populateMetaclassNode
     super populateMetaclassNode.
	(self metaclassMetaNode)
		addFilter: OBClassAnnotationFilter new! !

!OBDynamicMetagraphBuilder methodsFor: 'private' stamp: 'dr 11/12/2007 11:06'!
populateMethodNode
	self methodMetaNode 
		ancestrySelector: #isDescendantOfMethod:;
		addFilter: OBDynamicInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'accessing - metanodes' stamp: 'dr 4/14/2008 15:56'!
classMetaNode
   ^(self metaNodes
		at: #Class
		ifAbsentPut: [OBEnhancementMetaNode named: #Class])! !

!OBEnhancementMetagraphBuilder methodsFor: 'accessing - metanodes' stamp: 'dr 2/14/2008 15:59'!
lastSelectionMetaNode 
    ^ (self metaNodes
		at: #LastSelection
		ifAbsentPut: [OBEnhancementMetaNode named: #LastSelection]) updateOnAutoSelect! !

!OBEnhancementMetagraphBuilder methodsFor: 'accessing - metanodes' stamp: 'cb 4/17/2008 12:38'!
metaclassMetaNode
   ^(self metaNodes
		at: #Metaclass
		ifAbsentPut: [OBEnhancementMetaNode named: #Metaclass])! !

!OBEnhancementMetagraphBuilder methodsFor: 'accessing - metanodes' stamp: 'cb 4/17/2008 13:13'!
methodMetaNode
   ^(self metaNodes
		at: #Method
		ifAbsentPut: [OBEnhancementMetaNode named: #Method])! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 1/28/2009 15:36'!
populateAllMethodCategoryNode
     super populateAllMethodCategoryNode.
	(self allMethodCategoryMetaNode) 
		childAt: #lastSelection put: self lastSelectionMetaNode;
	    	autoSelect: (OBPreviousWithSingleAutoSelection on: self lastSelectionMetaNode);
	     addFilter: OBMethodCategoryFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 3/13/2008 16:51'!
populateClassCommentNode
	(self classCommentMetaNode)
	     ancestrySelector: #isDescendantOfClass:;
		addFilter: OBClassInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 4/21/2008 10:19'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBClassInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 4/21/2008 10:19'!
populateMetaclassNode
     super populateMetaclassNode.
	(self metaclassMetaNode)
		addFilter: OBClassInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 1/28/2009 15:54'!
populateMethodCategoryNode
	super populateMethodCategoryNode.
	self methodCategoryMetaNode 
			addFilter: OBMethodCategoryFilter new;
			autoSelect: (OBPreviousWithSingleAutoSelection on: self lastSelectionMetaNode);
	        	displaySelector: #fullName! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 11/20/2008 09:32'!
populateMethodNode
	self methodMetaNode 
		ancestrySelector: #isDescendantOfMethod:;
		addFilter: OBEnhancementInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 9/15/2008 16:50'!
populateRoot
     super populateRoot.
	self root
		removeFilter: OBClassSortFilter new;
		addFilter: OBQueryingClassSortFilter new.! !

!OBMetagraphBuilder methodsFor: '*ob-enhancements' stamp: 'jk 8/26/2007 17:24'!
classWithUsedTraitsMetaNode
	^ self metaNode: 'ClassWithUsedTraits'! !

!OBMetagraphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 4/14/2008 15:48'!
doubleClickCommand
    ^nil! !

!OBMetagraphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 9/22/2008 15:35'!
populateConflictMethodFilter
	self methodMetaNode
		addFilter: OBTraitConflictMethodFilter new.! !

!OBMetagraphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 9/22/2008 15:35'!
populateRequiredMethodFilter
	self methodMetaNode
		addFilter: OBTraitRequiredMethodFilter new.! !

!OBMetagraphBuilder methodsFor: '*ob-enhancements' stamp: 'jk 8/26/2007 18:04'!
populateTraitFilter
	self root 
		childAt: self classSelector
		labeled: 'traits'
		put: self classWithUsedTraitsMetaNode.
	self classWithUsedTraitsMetaNode
		childAt: #usedTraits
			labeled: 'instance'
			put: self classMetaNode;
		childAt: #commentsOfUsedTraits
			labeled: '?'
			put: self classCommentMetaNode;
		childAt: #metaclassesOfUsedTraits
			labeled: 'class'
			put: self metaclassMetaNode;
		addFilter: OBModalFilter new;
		addFilter: OBTraitSortFilter new.! !

!Text methodsFor: '*ob-enhancements' stamp: 'dr 10/21/2008 14:08'!
hasColor
    ^(self colorAt: 1) ~= TextColor black! !

OBCmdBrowseHierarchy subclass: #OBEnhancementCmdBrowseHierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementCmdBrowseHierarchy methodsFor: 'execution' stamp: 'dr 2/15/2008 17:58'!
execute
     | browserClass |
     browserClass := OBCodeBrowser defaultHierarchyBrowserClass.
     target isMethodNode ifTrue: [browserClass openOnClass: target theClass selector: target selector] 
                             ifFalse: [browserClass openOnClass: target theClass] ! !

!OBMessageNode class methodsFor: '*ob-enhancements' stamp: 'dr 2/15/2008 15:39'!
enhancedOn: aSelector inMethodReference: ref
     | class |
     class := ref isInstrumented ifTrue: [OBEnrichedMessageNode] ifFalse: [self].
	^ class 
		on: aSelector 
		inMethod: ref methodSymbol
		inClass: ref actualClass! !

!OBCmdBrowseHierarchyImplementors methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 11:19'!
implementorsSelector
    ^#hierarchyImplementorsOf:! !

OBCmdBrowse subclass: #OBCmdSmartGroupBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBCmdSmartGroupBrowse methodsFor: 'as yet unclassified' stamp: 'dr 3/12/2008 15:36'!
isActive
    ^super isActive and: [target isBrowseable]! !

!TraitDescription methodsFor: '*ob-enhancements' stamp: 'jk 8/20/2007 12:24'!
asCommentNodeOf: aParentNode 
	^ OBUsedTraitCommentNode on: self of: aParentNode! !

!TraitDescription methodsFor: '*ob-enhancements' stamp: 'dr 9/24/2008 16:37'!
browserIcon
    ^nil! !

PluggableButtonMorphPlus subclass: #OBDraggableButtonMorph
	instanceVariableNames: 'dropOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBDraggableButtonMorph commentStamp: 'dr 6/12/2007 15:21' prior: 0!
I represent a button morph which is draggable. Other draggable button morphs can be dropped on me.!

OBDraggableButtonMorph subclass: #OBBackButtonMorph
	instanceVariableNames: 'panel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBBackButtonMorph methodsFor: 'mouse events' stamp: 'dr 2/8/2008 16:46'!
handlesMouseStillDown: evt
    ^true! !

!OBBackButtonMorph methodsFor: 'mouse events' stamp: 'dr 3/4/2008 15:10'!
mouseStillDown: evt
     panel navigateHistoryInDirection: actionSelector.
     super mouseStillDown: evt.
     showSelectionFeedback := false.
     self changed.! !

!OBBackButtonMorph methodsFor: 'mouse events' stamp: 'dr 2/8/2008 16:48'!
mouseStillDownThreshold
    ^1000! !

!OBBackButtonMorph methodsFor: 'accessing' stamp: 'dr 2/8/2008 16:07'!
panel: aPanel
    panel := aPanel! !

!OBDraggableButtonMorph methodsFor: 'events-processing' stamp: 'dr 6/11/2007 15:44'!
acceptDroppingMorph: aMorph event: evt 
     model dropMorph: aMorph.
	
	self resetDropOn.
	evt hand releaseMouseFocus: self.
	Cursor normal show. 
! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:25'!
click: evt
    super mouseDown: evt! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 2/2/2009 10:23'!
drawOn: aCanvas
	super drawOn: aCanvas. 
	
    dropOn ifNotNil: [self highlightOn: aCanvas].! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 6/11/2007 11:39'!
highlightOn: aCanvas
	| topLeft drawBounds |
	topLeft := self topLeft x @ (self topLeft y + 1).
	drawBounds := topLeft extent: self width @ (self height + 1).
	drawBounds := drawBounds intersect: self bounds.
	aCanvas frameRectangle: self innerBounds width: 1 color: Color blue! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 2/8/2008 14:27'!
mouseDown: evt
	| selectors |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].

	selectors := Array 
		with: #click:
		with: nil
		with: nil
		with: #startDrag:.
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:34'!
mouseEnterDragging: evt
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseEnterDragging: evt].
	
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt)
		ifTrue: [
			dropOn := true.
			
			evt hand newMouseFocus: self.
			"test ifNil: [test := (evt hand firstSubmorph passenger == model). ""evt hand firstSubmorph passenger insertAfter: model."
				
			self changed.
		].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 9/10/2007 16:55'!
mouseLeaveDragging: evt
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseLeaveDragging: evt].
	self resetDropOn.
	evt hand releaseMouseFocus: self.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 2/2/2009 10:23'!
mouseMove: evt
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseMove: evt].
		
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) ifTrue: [self mouseEnterDragging: evt].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:18'!
resetDropOn
    dropOn ifNotNil: [dropOn := nil. self changed].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:54'!
startDrag: evt 
	| ddm |
	evt hand hasSubmorphs ifTrue: [^self].

	[  (self dragEnabled and: [model okToChange]) ifFalse: [^self].
	   ddm := TransferMorph withPassenger: model from: self.
        evt hand grabMorph: ddm]
	ensure: [Cursor normal show. evt hand releaseMouseFocus: self]! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:33'!
wantsDroppedMorph: transferMorph event: evt
	(transferMorph isKindOf: TransferMorph) ifFalse: [^false].
	(transferMorph passenger isKindOf: model class) ifFalse: [^false]. 
	transferMorph passenger == model ifTrue: [^false].
	
     ^true! !

OBListBrowser subclass: #OBDynamicReferenceBrowser
	instanceVariableNames: 'browseHistory historyCursor historyIndexOnSwitch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 4/21/2008 11:44'!
defaultMetaNode
	| class referencingClasses referencingMethods |
	class := OBMetaNode named: 'Class'.
	referencingClasses := OBMetaNode named: 'Dynamic references'.
	referencingMethods := OBMetaNode named: 'ReferencingMethods'.
	
	class childAt: #referencingClasses put: referencingClasses.
	
	referencingClasses 
	    childAt: #referencingMethods put: referencingMethods;
	    ancestrySelector: #isDescendantOfClassRef:.
	
	referencingMethods 
		displaySelector: #usageName;
		ancestrySelector: #isDescendantOfMethod:;
		addFilter: OBDynamicInheritanceFilter new.
		
	^ class! !

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 4/21/2008 11:52'!
definitionPanel
     ^OBEnrichedDefinitionPanel new! !

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 2/27/2008 15:43'!
hasHistoryButtons
    ^true! !

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 10/9/2007 17:03'!
title
   ^'Dynamic references in'! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:30'!
browseHistory
    browseHistory ifNil: [browseHistory := OrderedCollection new].
    ^browseHistory! !

!OBDynamicReferenceBrowser methodsFor: 'accessing' stamp: 'dr 9/10/2007 11:55'!
defaultLabel
	^ self labelPrefix, ' ', self root name asString! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:32'!
historyAtCursor
   ^self browseHistory at: self historyCursor ifAbsent: [nil]! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:32'!
historyCursor
    ^historyCursor ifNil: [0]! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:31'!
historyCursor: anInteger
    historyCursor := anInteger! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:25'!
historyIndexOnSwitch
    historyIndexOnSwitch ifNil: [historyIndexOnSwitch := 0].
    ^historyIndexOnSwitch! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:25'!
resetHistoryIndexOnSwitch
    historyIndexOnSwitch := 0! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:31'!
setHistory: aCollection
    browseHistory := aCollection! !

!OBListBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/11/2008 10:34'!
definitionPanel
     ^OBDefinitionPanel new! !

!OBListBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:37'!
hasReferencePanel
    ^self dynamicBrowser! !

OBListBrowser subclass: #OBReferencingMethodsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBReferencingMethodsBrowser class methodsFor: 'configuration' stamp: 'dr 4/21/2008 11:52'!
defaultMetaNode
	| classReference referencingMethods |
	classReference := OBMetaNode named: 'Class Reference'.
	referencingMethods := OBMetaNode named: 'ReferencingMethods'.
	
	classReference 
	    childAt: #referencingMethods put: referencingMethods;
	    ancestrySelector: #isDescendantOfClassRef:.
	
	referencingMethods 
		displaySelector: #usageName;
		ancestrySelector: #isDescendantOfMethod:;
		addFilter: OBDynamicInheritanceFilter new.
		
	^ classReference! !

!OBReferencingMethodsBrowser class methodsFor: 'configuration' stamp: 'dr 4/21/2008 11:52'!
definitionPanel
     ^OBEnrichedDefinitionPanel new! !

!OBReferencingMethodsBrowser class methodsFor: 'configuration' stamp: 'dr 4/23/2008 09:47'!
title
    ^'Methods referencing'! !

OBNode subclass: #OBFakeDNUNode
	instanceVariableNames: 'name children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-TraitsTests'!

!OBFakeDNUNode class methodsFor: 'instance creation' stamp: 'jk 1/2/2008 15:44'!
tree: anObject
	" Structure: #(nodeName ((edgeName children) (edgeName children) ...)).
	  #(nodeName ((edgeName noChildren) ...))  means no children at edgeName (returns empty array)."
	^ anObject isSymbol 
		ifTrue: [self new setName: anObject]
		ifFalse: [self new setName: anObject first children: anObject second].
! !

!OBFakeDNUNode methodsFor: 'comparing' stamp: 'jk 1/1/2008 22:56'!
= aNode
	^ self name = aNode name! !

!OBFakeDNUNode methodsFor: 'accessing' stamp: 'jk 1/1/2008 21:31'!
allChildren
	^ self children gather: [:e | e]! !

!OBFakeDNUNode methodsFor: 'accessing' stamp: 'jk 1/1/2008 20:12'!
children
	^ children ifNil: [children := Dictionary new]! !

!OBFakeDNUNode methodsFor: 'accessing' stamp: 'jk 1/1/2008 20:15'!
childrenAt: aSymbol
	^ self children at: aSymbol ifAbsent: [nil]! !

!OBFakeDNUNode methodsFor: 'error handling' stamp: 'jk 1/1/2008 21:26'!
doesNotUnderstand: aMessage
	^ self children at: aMessage selector ifAbsent: [super doesNotUnderstand: aMessage]! !

!OBFakeDNUNode methodsFor: 'comparing' stamp: 'jk 1/1/2008 22:56'!
hash
	^ name hash! !

!OBFakeDNUNode methodsFor: 'ancestry' stamp: 'jk 1/1/2008 21:30'!
isAncestorOf: aNode using: aSelector
	^ self = aNode or: [self allChildren anySatisfy: [:ea | ea isAncestorOf: aNode]]! !

!OBFakeDNUNode methodsFor: 'accessing' stamp: 'jk 1/1/2008 22:56'!
name
	^ name! !

!OBFakeDNUNode methodsFor: 'accessing' stamp: 'jk 1/1/2008 20:27'!
noChildren
	^ #()! !

!OBFakeDNUNode methodsFor: 'printing' stamp: 'jk 1/1/2008 21:18'!
printOn: aStream
	aStream
		nextPutAll: 'FakeDNU<';
		nextPutAll: name;
		nextPut: $>! !

!OBFakeDNUNode methodsFor: 'initialize-release' stamp: 'jk 1/2/2008 15:43'!
putChildren: anArray
	anArray do: [ :e | 
		self children at: e first put: 
			((e allButFirst collect: [:ea | self class tree: ea]) reject: [ :node | node name = #noChildren])
	]! !

!OBFakeDNUNode methodsFor: 'initialize-release' stamp: 'jk 1/1/2008 21:00'!
setName: aByteSymbol 
	name := aByteSymbol! !

!OBFakeDNUNode methodsFor: 'initialize-release' stamp: 'jk 1/1/2008 20:51'!
setName: aSymbol children: anArray
	name := aSymbol.
	self putChildren: anArray! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 2/29/2008 10:19'!
annotationString
	"Provide a line of content for an annotation pane, representing information about the method associated with the selected node."
	
	^ nil! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 9/22/2008 15:32'!
childNodesWithinTree
	^ metaNode childrenWithinTreeForNode: self! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'jk 12/18/2007 09:39'!
getTreeChildren
	^ self childNodesWithinTree! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'jk 12/18/2007 09:37'!
hasTreeChildren
	^ self childNodesWithinTree notEmpty! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 3/12/2008 15:31'!
isBrowseable
    ^true! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 11/26/2008 10:48'!
isDummy
    ^false! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 11/14/2008 11:32'!
isNode
	^true! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 11/26/2008 10:47'!
isSearch
    ^false! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 11/26/2008 10:47'!
isSmartAlias
    ^false! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 11/26/2008 10:47'!
isSmartGroup
    ^false! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 11/26/2008 10:47'!
isSmartGroupCategory
    ^false! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 9/12/2008 12:01'!
isTreeNavigation
	^ self navigation isTreeNavigation! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 12/16/2008 15:43'!
runTestCommandClass
	"answer cmd class to run tests of this type of node"
	^nil! !

!OBPluggableListMorph methodsFor: '*ob-enhancements' stamp: 'dr 12/4/2008 11:14'!
listItemHeight
	^ 15! !

!OBPluggableListMorph methodsFor: '*ob-enhancements' stamp: 'dr 9/4/2008 16:58'!
nodeAt: index
    ^model children at: index! !

!OBClassAwareNode methodsFor: '*ob-enhancements' stamp: 'dr 10/22/2008 09:08'!
isDescendantOfPackage: aPackageNode
	^ aPackageNode realClasses includes: self theNonMetaClass

! !

!OBClassAwareNode methodsFor: '*ob-enhancements' stamp: 'jk 8/20/2007 15:33'!
numberOfPredecessors
	^ 0! !

!OBClassAwareNode methodsFor: '*ob-enhancements' stamp: 'jk 8/14/2007 08:57'!
withAllParents
	^ (OrderedCollection new)
		add: self theClass;
		yourself! !

!OBAllMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 10/16/2007 15:21'!
icon
    ^#blank! !

!OBAllMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:55'!
lastSelection
    ^#()
! !

!OBAllMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 5/15/2008 14:39'!
smartGroupJump
    ^#()
! !

OBAllMethodCategoryNode subclass: #OBAllMethodExtensionCategoryNode
	instanceVariableNames: 'classExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:23'!
classExtensionNode
    ^classExtensionNode! !

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 15:06'!
classExtensionNode: aClassExtensionNode 
    classExtensionNode := aClassExtensionNode! !

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 15:11'!
extensionName
	^classExtensionNode extensionName ! !

!OBAllMethodExtensionCategoryNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 15:39'!
isDescendantOfClass: aClassNode 
   ^((super isDescendantOfClass: aClassNode) and: [aClassNode isKindOf: OBClassExtensionNode]) 
                                                    and: [self classExtensionNode = aClassNode] ! !

!OBAllMethodExtensionCategoryNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 17:23'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self classExtensionNode package ifFalse: [^false]. 
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.
! !

!OBAllMethodExtensionCategoryNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 15:27'!
isDescendantOfMethodCat: other
   ^(super isDescendantOfMethodCat: other) and: [self class = other class]! !

!OBAllMethodExtensionCategoryNode methodsFor: 'navigating' stamp: 'dr 2/24/2008 14:00'!
methodReferences
	^ self theClass selectors asSortedArray 
		collect: [:ea | MethodExtensionReference new setStandardClass: self theClass methodSymbol: ea; categoryExtensionNode: self]! !

!OBAllMethodExtensionCategoryNode methodsFor: 'navigating' stamp: 'dr 2/24/2008 15:22'!
methods
   ^self methodReferences collect: [:ea | (OBMethodExtensionNode on: ea) categoryExtensionNode: self; yourself]! !

OBAllMethodCategoryNode subclass: #OBPackageAllMethodCategoryNode
	instanceVariableNames: 'packageNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackageAllMethodCategoryNode methodsFor: 'navigating' stamp: 'dr 7/10/2008 16:11'!
methods
    ^self methodReferences collect: [:ea | (OBPackageMethodNode on: ea) packageNode: packageNode]! !

!OBPackageAllMethodCategoryNode methodsFor: 'accessing' stamp: 'dr 7/10/2008 16:11'!
packageNode: aPackageNode
    packageNode := aPackageNode! !

OBMercuryQuery subclass: #OBEnrichedMercuryQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBEnrichedMercuryQuery class methodsFor: 'private' stamp: 'dr 10/18/2008 10:00'!
selectClassForQuery: rawQuery 
    | queryClasses |
    queryClasses := {OBMClassCollaboratorsQuery. OBMMethodInvocationQuery}. 
    queryClasses do: [:class | (rawQuery beginsWith: class new keyWord) ifTrue: [^class]].

	^ rawQuery first = $# 
		ifTrue: 
			[(rawQuery allButFirst first isUppercase) 
				ifTrue: [OBEnhancementMClassRefsQuery]
				ifFalse: [OBEnhancementMMethodSendersQuery]]
		ifFalse: 
			[(self isClassQuery: rawQuery) 
				ifTrue: [OBEnhancementMClassQuery]
				ifFalse: [OBEnhancementMMethodQuery]]! !

!OBEnrichedMercuryQuery methodsFor: 'accessing' stamp: 'dr 4/25/2008 15:16'!
keyWord
    ^self searchNodeClass keyWord! !

!OBEnrichedMercuryQuery methodsFor: 'actions' stamp: 'dr 4/21/2008 11:00'!
openSearchBrowser
	^ self openSearchInSameBrowserOn: self searchNode! !

!OBEnrichedMercuryQuery methodsFor: 'accessing' stamp: 'dr 4/25/2008 15:17'!
searchNodeClass
    ^self subclassResponsibility! !

!OBEnrichedMercuryQuery methodsFor: 'initialization' stamp: 'dr 4/25/2008 15:32'!
setRawQuery: aString
    ^aString copyFrom: self keyWord size + 1 to: aString size! !

OBEnrichedMercuryQuery subclass: #OBMClassCollaboratorsQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBMClassCollaboratorsQuery methodsFor: 'actions' stamp: 'dr 4/21/2008 11:27'!
find 
    (Smalltalk hasClassNamed: pattern) ifTrue: [self openSearchBrowser]! !

!OBMClassCollaboratorsQuery methodsFor: 'accessing' stamp: 'dr 4/21/2008 11:07'!
searchNode
	^ OBCollaboratorsSearchNode on: pattern! !

!OBMClassCollaboratorsQuery methodsFor: 'accessing' stamp: 'dr 4/25/2008 15:15'!
searchNodeClass
    ^OBCollaboratorsSearchNode! !

!OBMClassCollaboratorsQuery methodsFor: 'initialization' stamp: 'dr 5/2/2008 17:29'!
setRawQuery: aString 
	| tokens queryString | 
	queryString := super setRawQuery: aString.
	
	tokens := Scanner new scanTokens: queryString.
	pattern := tokens at: 1 ifAbsent: [^self]. 
	pattern = #* ifTrue: [isWild := true] ifFalse: [isWild := false].
	^ self! !

OBEnrichedMercuryQuery subclass: #OBMMethodInvocationQuery
	instanceVariableNames: 'searchFrequency limit forceType searchEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBMMethodInvocationQuery commentStamp: 'dr 8/15/2008 14:49' prior: 0!
I am a query to search for all methods that have been invoked by any instance of a given class or within a given package.
I know the query string, the limit for number of results, and the type of search scope (forceType, eg. class or package).!

!OBMMethodInvocationQuery methodsFor: 'initialization' stamp: 'dr 5/2/2008 16:12'!
checkPattern: aString    
    | pkg |

    forceType ifNotNil: [
	   forceType = #class ifTrue: [(Smalltalk hasClassNamed: aString) ifFalse: [self error: 'No class specified']. 
		                               searchEntity := Smalltalk at: aString].
	   forceType = #package ifTrue: [pkg := MCWorkingCopy allManagers detect: [:wc | wc packageName = aString] 
                                                                                       ifNone: [self error: 'No package specified'].
                                            searchEntity := pkg].
        pattern := aString.     
        ^self
    ].


    (Smalltalk hasClassNamed: aString) ifFalse: [
         pkg := MCWorkingCopy allManagers detect: [:wc | wc packageName = aString] 
                                           ifNone: [self error: 'Search pattern should either be the name of a class or a package!!'].
         searchEntity := pkg.
    ] ifTrue: [searchEntity := Smalltalk at: aString].

    pattern := aString! !

!OBMMethodInvocationQuery methodsFor: 'actions' stamp: 'dr 5/2/2008 14:38'!
find
    self openSearchBrowser! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:22'!
forceType
    ^forceType! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 4/25/2008 15:16'!
keyWord
    ^self searchNodeClass keyWord! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:22'!
limit
    ^limit! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:23'!
query
    ^pattern! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:25'!
queryString
    ^pattern! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:22'!
searchEntity
    ^searchEntity! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:24'!
searchNode
	^self searchNodeClass on: self! !

!OBMMethodInvocationQuery methodsFor: 'accessing' stamp: 'dr 4/25/2008 15:05'!
searchNodeClass
    ^(searchFrequency notNil and: [searchFrequency]) 
            ifTrue: [OBMethodInvocationFrequencySearchNode]
            ifFalse: [OBMethodInvocationSearchNode]! !

!OBMMethodInvocationQuery methodsFor: 'initialization' stamp: 'dr 5/2/2008 17:27'!
setRawQuery: aString 
	| tokens patternToken frequencyToken limitToken typeToken tokenCounter queryString | 
	queryString := super setRawQuery: aString.	
	tokenCounter := 1.
	
	tokens := Scanner new scanTokens: queryString.
	frequencyToken := tokens at: tokenCounter.
	tokenCounter := tokenCounter + 1.
	frequencyToken = 'frequency' ifTrue: [searchFrequency := true] ifFalse: [typeToken := frequencyToken].
	
	"method invocation [frequency] [package | class] aClass/aPackage LIMIT aNumber"	
	
	typeToken ifNil: [
	    typeToken := tokens at: tokenCounter ifAbsent: [^self].
	    tokenCounter := tokenCounter + 1].
	(#('package' 'class') includes: typeToken) 
	   ifTrue: [
		  forceType := typeToken asSymbol.
		  patternToken := tokens at: tokenCounter.
		  tokenCounter := tokenCounter + 1.]
	   ifFalse: [patternToken := typeToken].	
	 
	patternToken = #* ifTrue: [isWild := true] ifFalse: [isWild := false. self checkPattern: patternToken].
	
	limitToken := tokens at: tokenCounter ifAbsent: [^self]. 
	tokenCounter := tokenCounter + 1.
	limitToken asLowercase = 'limit' ifTrue: [limit := (tokens at: tokenCounter ifAbsent: [self error: 'limit number missing']) asInteger].
	
	^ self! !

!OBMercuryQuery methodsFor: '*ob-enhancements' stamp: 'dr 7/8/2008 16:55'!
openSearchInSameBrowserOn: searchNode 
	^ self browser isSearchBrowser 
		ifFalse: [(OBSearchBrowser with: searchNode) open]
		ifTrue: 
			[searchNode classes ifEmpty: [self inform: 'Nothing found.'. ^self]. 
			self browser navigationPanel addSearchToSmartGroup: searchNode.
			(self announce: OBAboutToChange) isVetoed 
				ifTrue: [self browser noteChanges]
				ifFalse: ["self announce: (OBSelectingNode node: searchNode)"]]! !

OBMMethodQuery subclass: #OBEnhancementMMethodQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBEnhancementMMethodQuery methodsFor: 'executing' stamp: 'dr 7/2/2008 15:29'!
find
	self searchNode hasOnlyOneResult
		ifTrue: [self browser jumpTo: self searchNode methodsInFirstClass first]
		ifFalse: [self openSearchInSameBrowserOn: self searchNode]! !

!OBEnhancementMMethodQuery methodsFor: 'accessing' stamp: 'dr 5/14/2008 13:26'!
searchNode 
	^ OBEnhancementMethodSearchNode on: pattern isWild: isWild! !

OBClassDefinition subclass: #OBEnrichedClassDefinition
	instanceVariableNames: 'formatter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 15:49'!
formatter
    ^formatter! !

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 15:58'!
isEnrichedDefinition
    ^true! !

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 15:49'!
setFormatter: aHOFormatter
    formatter := aHOFormatter! !

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 16:56'!
text
    ^formatter formatClassDefinition! !

OBRadioButtonBar subclass: #OBEnhancementRadioButtonBar
	instanceVariableNames: 'dropOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBEnhancementRadioButtonBar methodsFor: 'as yet unclassified' stamp: 'dr 10/21/2008 14:06'!
getLabels
    | labels selectedNode |
    labels := super getLabels.
    selectedNode := model column selectedNode.
    (labels includes: '?') ifTrue: [(selectedNode isNil or: [selectedNode hasComment]) ifTrue: [^labels]].
    
    ^labels collect: [:ea | ea = '?' ifTrue: [ ea asText addAttribute: TextEmphasis bold;
		                                                   addAttribute: TextColor red] 
	                                 ifFalse: [ea]].! !

!OBRadioButtonBar methodsFor: '*ob-enhancements' stamp: 'dr 1/28/2008 11:38'!
buttons
    ^buttons! !

OBDefinitionPanel subclass: #OBClosableDefinitionPanel
	instanceVariableNames: 'node morph isPinned owner contentMorph codeTabPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/8/2007 15:54'!
asDraggableMorph
	^(StringMorph contents: '*')
		color: Color white;
		yourself! !

!OBClosableDefinitionPanel methodsFor: 'building' stamp: 'dr 7/18/2007 15:25'!
buildOn: aBuilder
    morph ifNil: [morph := aBuilder closableDefinitionPanel: self with: []].
    ^morph! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 12/6/2007 11:48'!
changeToSourceCodePanel
    self exchangeContentWith: self createContentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 7/23/2007 14:41'!
changed
    (self respondsTo: #codeTabPanel) ifTrue: [
	     self codeTabPanel selection = 1 ifFalse: [self codeTabPanel selection: 1]].! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
classLabel
	| classLabel |
	classLabel := self className.
	self node ifNotNil: [self node isMethodHolderNode ifTrue: [classLabel := classLabel,' >>']].
	^classLabel! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
className
     ^self methodClass ifNotNil: [self methodClass name] ifNil: ['']! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
close
   browser definitionPanel panels size < 2 ifTrue: [^self inform: 'You cannot close the last panel.'].
   browser definitionPanel removePanel: self column: nil.! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
closeLabel
	^ (StringMorph 
		contents: 'x'
		font: ("TextStyle defaultFont" StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:49'!
color
	^browser defaultBackgroundColor ! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:45'!
commands
	| myNode |
	myNode := self currentNode.
	myNode ifNil: [^ #()].
     ^{OBCmdSystemComplexity on: myNode for: self. OBCmdUmlDiagram on: myNode for: self}
    ! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/12/2007 13:55'!
createClassLabel
	| classLabel |		
     classLabel := (StringMorph 
		contents: (Text string: self classLabel attribute: TextEmphasis bold)	
		font: (StrikeFontSet familyName: #NewYork size: 10))
			color: Color black;
			yourself.
	classLabel on: #mouseDown send: #selectClass to: self.			
	classLabel hResizing: #spaceFill; vResizing: #spaceFill; setWidth: 100; height: 20.						
			
	^classLabel		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/5/2007 17:45'!
createCloseButton						
	^PluggableButtonMorph
		on: self
		getState: #isSelected
		action: #close
		label: #closeLabel.! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 11/19/2007 10:26'!
createContentMorph
	| textEditor shoutInstalled morphClass |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	morphClass := shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].	
	textEditor := (morphClass
		on: self
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		font: Preferences standardCodeFont;
		yourself.
	textEditor 
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		color: Color white.
     ^textEditor! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 2/2/2009 09:34'!
createDragButton
	| dragButton paneColor |
	dragButton := (OBDraggableButtonMorph 
					on: self
					getState: nil
					action: #drag
					label: #dragLabel)
						getEnabledSelector: #isDragged.
	dragButton enableDragNDrop.
	paneColor := browser defaultBackgroundColor.
	dragButton onColor: Color lightGray lighter offColor: paneColor.
	^ dragButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/19/2007 14:05'!
createMorph			
     morph := nil.						
	^self buildOn: OBMorphBuilder new		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 2/2/2009 09:34'!
createPinButton
	| pinButton paneColor |
	pinButton := (OBDraggableButtonMorph 
					on: self
					getState: nil
					action: #pin
					label: #pinLabel)
						getEnabledSelector: #isPinned.
	paneColor := browser defaultBackgroundColor.
	pinButton onColor: Color lightGray lighter offColor: paneColor.
	^ pinButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/11/2007 11:48'!
createTitleBar
	| titleBar |		
	titleBar := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		"borderColor: Color black;"
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
			
	titleBar addMorphBack: self createClassLabel; 
	          addMorphBack: self createDragButton; 
	          addMorphBack: self createPinButton; 
	          addMorphBack: self createCloseButton.			
	^titleBar		! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 15:50'!
currentNode
    ^self node ifNil: [super currentNode]! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
    ^self node ifNil: [super currentOrRootNode]! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:47'!
drag
    "do nothing"! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:49'!
dragLabel
	^ (StringMorph 
		contents: '<- ->'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:43'!
dropMorph: aMorph
    | panelToBeMoved |
    panelToBeMoved := aMorph passenger.

    (self isPlacedBefore: panelToBeMoved) ifTrue: [
	   panelToBeMoved insertBefore: self. 
    ] ifFalse: [
        panelToBeMoved insertAfter: self.
    ].! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 12/6/2007 11:47'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill. 
    aMorph hResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.
    contentMorph changed.! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 10/19/2007 11:34'!
getDefinition
     definition ifNotNil: [^definition]. 
	^ browser currentNode ifNotNilDo: [:ea | ea definition]! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 7/18/2007 15:32'!
hasSeveralPanels	
	^browser definitionPanel panels size > 1! !

!OBClosableDefinitionPanel methodsFor: 'initializing' stamp: 'dr 6/7/2007 11:20'!
initialize
    isPinned := false! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:33'!
insertAfter: aPanel
    ^self owner insert: self after: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:44'!
insertBefore: aPanel
    ^self owner insert: self before: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
isChangeable
    ^self isPinned not! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/11/2007 11:47'!
isDragged
    ^false! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/6/2007 15:59'!
isPinned
    ^isPinned! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:35'!
isPlacedBefore: aClosableDefinitionPanel
    ^self owner is: self placedBefore: aClosableDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
isSelected
    ^false
   ! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
methodClass
     ^(self node respondsTo: #theClass) ifTrue: [self node theClass] ifFalse: [nil]! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/18/2007 15:41'!
morph
	^morph
! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 11:45'!
node
    ^node! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/29/2007 15:15'!
node: aNode
    node := aNode. 
    "self selectSourceTab."! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner
	^owner! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner: aMultipleDefinitionPanel
	owner := aMultipleDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/7/2007 11:50'!
pin
    self isPinned ifTrue: [isPinned := false] ifFalse: [isPinned := true] ! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/6/2007 15:20'!
pinLabel
	^ (StringMorph 
		contents: '!!'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
selectClass
    browser jumpTo: (OBClassNode on: self methodClass)! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/29/2007 16:31'!
selectSourceTab
    self exchangeContentWith: self createContentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'updating' stamp: 'dr 2/28/2008 16:43'!
selectionChanged: ann
     self hasSeveralPanels ifTrue: [self updateClassLabel].
	self definition: self getDefinition! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/18/2007 15:35'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/6/2007 15:59'!
setIsPinned
    isPinned := true! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 8/21/2008 15:19'!
shoutAboutToStyle: aPluggableShoutMorph
	^self currentNode ifNotNilDo: [:n | n shouldBeStyledBy: aPluggableShoutMorph] ifNil: [false]! !

!OBClosableDefinitionPanel methodsFor: 'updating' stamp: 'dr 2/19/2008 09:58'!
subscribe
	self announcer 
		observe: OBAboutToChange
		send: #aboutToChange:
		to: self;
		
		observe: OBAboutToChangeSilently
		send: #aboutToChangeSilently:
		to: self;
		
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self;
				
		observe: OBNodeChanged
		send: #nodeChanged:
		to: self;		
				
		observe: OBRefreshRequired
		send: #refresh:
		to: self.! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:19'!
swapWith: aPanel
    ^self owner swap: self with: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 2/29/2008 10:13'!
updateClassLabel
    | stringMorph |
    stringMorph := morph submorphs first submorphs first.
    (stringMorph isKindOf: StringMorph) ifTrue: [stringMorph contents: self classLabel].! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 15:39'!
currentNode
	^browser currentNode! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
	^browser currentOrRootNode! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 15:39'!
node
	^nil! !

OBDefinitionPanel subclass: #OBEnhancementDefinitionPanel
	instanceVariableNames: 'codeTabPanel morph contentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementDefinitionPanel methodsFor: 'callbacks' stamp: ''!
accept: aText notifying: aController
	(Smalltalk hasClassNamed: #CMModel) ifTrue: [
		"CMModel recentlyModified updateEntity: self currentNode entity.
		CMModel versionModel updateEntity: self currentNode entity.
		CMModel modifiedByMeModel updateEntity: self currentNode entity.
		CMModel authorModel updateEntity: self currentNode entity"].
	^super accept: aText notifying: aController.! !

!OBEnhancementDefinitionPanel methodsFor: 'accessing' stamp: 'dr 2/22/2008 15:24'!
buildOn: aBuilder
	morph ifNil: [morph := aBuilder enrichedTextarea: self with: []].
	^morph! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/22/2008 15:21'!
changeToSourceCodePanel
    self exchangeContentWith: self createContentMorph.! !

!OBEnhancementDefinitionPanel methodsFor: 'morphic' stamp: 'dr 2/22/2008 15:34'!
createContentMorph
	| textMorph |
	
	textMorph := self textMorphClass 
				on: self
				text: #text
				accept: #accept:notifying:
				readSelection: #selection
				menu: #menu:shifted:. 
	textMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^textMorph! !

!OBEnhancementDefinitionPanel methodsFor: 'accessing' stamp: 'dr 10/20/2008 14:52'!
definition: aDefinition
	aDefinition ifNotNil: [definition := aDefinition]. 
	self changed: #text! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/22/2008 15:23'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill. 
    aMorph hResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.
    contentMorph changed.! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 3/6/2008 15:37'!
hasCodeTabPanel
   ^self respondsTo: #codeTabPanel! !

!OBEnhancementDefinitionPanel methodsFor: 'testing' stamp: 'dr 2/22/2008 15:24'!
hasReferencePanel
    ^browser class hasReferencePanel! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/23/2008 17:12'!
selectSourceTab
    codeTabPanel ifNotNil: [codeTabPanel isSourceTabSelected ifFalse: [codeTabPanel selectFirst]].! !

!OBEnhancementDefinitionPanel methodsFor: 'updating' stamp: 'dr 4/30/2008 11:42'!
selectionChanged: ann
     | column |
     column := ann column.
     "make sure that if the auto-selected node does not have a def, the def of the node selected in the previous column is taken"
     (column selectedNode notNil and: [column selectedNode getDefinition isNil]) ifTrue: [column previous ifNotNilDo: [:col | column := col]].
	self definition: (column selectedNode ifNotNilDo: [:n | n getDefinition])! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/22/2008 15:23'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBEnhancementDefinitionPanel methodsFor: 'configuration' stamp: 'dr 2/22/2008 15:34'!
textMorphClass
	| shoutInstalled |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	^shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].! !

OBEnhancementDefinitionPanel subclass: #OBEnrichedDefinitionPanel
	instanceVariableNames: 'referenceList tmpText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedDefinitionPanel commentStamp: 'dr 10/9/2007 17:10' prior: 0!
I am an enriched definition panel. The definition I contain is enriched with dynamic information about the method being displayed.!

!OBEnrichedDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 4/25/2008 11:09'!
accept: aText notifying: aController
    | attributes methodRef result formatter source |
    (self currentNode notNil and: [self currentNode isMethodNode]) ifTrue: [methodRef := self currentNode reference].

    "remove all attributes from aText prior to save"
    attributes := Set new.
    1 to: aText size do: [:i | attributes addAll: (aText attributesAt: i)].
    attributes do: [:attr | aText removeAttribute: attr from: 1 to: aText size].

    result := super accept: aText notifying: aController.

    (methodRef notNil and: [definition notNil and: [definition selector = methodRef methodSymbol]]) ifTrue: [
    	   "this is cumbersome, but works ok"
        formatter := RBFormatter new.
        source := formatter format: methodRef compiledMethod methodNode.
        super accept: source notifying: aController.

        "make sure an instrumented method is still instrumented after re-compile"
        (HODataBase default isInstrumentedMethod: methodRef) ifTrue: [
	       HOCollector default reinstallInMethod: methodRef compiledMethod.
        ].

        self currentNode updateModelMethod.
        definition := self currentNode definition. 
        self changed: #text.
    ].

    ^result! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 11/19/2007 11:26'!
formatter
    ^self getDefinition ifNotNilDo: [:def | def isEnrichedDefinition ifTrue: [def formatter]]! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 4/21/2008 15:37'!
getDefinition
     definition ifNotNil: [^definition].
     ^super getDefinition! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 4/16/2008 15:53'!
methodReference
    | node |
    node := self currentNode.
    (node notNil and: [node isMethodNode]) ifTrue: [^node reference].
    ^nil! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 1/28/2008 11:13'!
morph
    ^morph! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 10/12/2007 17:02'!
referenceList
    referenceList ifNil: [referenceList := OBReferenceList panel: self].
    ^referenceList! !

!OBEnrichedDefinitionPanel methodsFor: 'highlighting' stamp: 'dr 12/22/2008 14:05'!
selectReferencingCodeNodes: aCollection
    | method formatter |
    method _ self currentNode theClass compiledMethodAt: self currentNode selector.
    formatter _ HOFormatter metaMethod: ((Smalltalk at: #HODataBase) default 
                         		modelMethodFor: method methodReference)
							referencedClass: self currentNode referencedClass.
    formatter setSelectedNodes: aCollection. 
    tmpText _ (formatter formatCodeForMethod: method) makeSelectorBold.
    self changed: #text.
    tmpText _ nil.! !

!OBEnrichedDefinitionPanel methodsFor: 'updating' stamp: 'dr 3/4/2008 14:57'!
selectionChanged: ann
	super selectionChanged: ann.
		
	self selectSourceTab. 
	
	self referenceList selectionChanged: ann.
	self referenceList referencedNode ifNotNilDo: [:n | 
		(self currentNode notNil and: [self currentNode respondsTo: #isMethodNode]) ifTrue: [
		(self currentNode isMethodNode and: [(Smalltalk at: #HODataBase) default isInstrumentedMethod: self currentNode reference]) ifTrue: [
		    self selectReferencingCodeNodes: ((Smalltalk at: #HODataBase) default nodesReferencingClass: n theClass inMethod: self currentNode reference)]]].! !

!OBEnrichedDefinitionPanel methodsFor: 'highlighting' stamp: 'dr 10/15/2007 15:30'!
text
    tmpText ifNotNil: [^tmpText].
    ^super text! !

!OBEnrichedDefinitionPanel methodsFor: 'configuration' stamp: 'dr 4/21/2008 15:41'!
textMorphClass
    ^OBEnrichedPluggableTextMorph! !

OBEnhancementDefinitionPanel subclass: #OBMultipleDefinitionPanel
	instanceVariableNames: 'panels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/21/2007 16:44'!
aboutToChange: ann
   " self panels first aboutToChange: ann."! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 2/19/2008 17:39'!
addPanel: aPanel
    "remove empty standard panel"
    (panels size = 1 and: [panels first node isNil]) ifTrue: [panels := OrderedCollection new].

    aPanel owner: self.
    panels add: aPanel.

    "make sure that the first panel also get buttons as soon as a second panel is added"
    panels size = 2 ifTrue: [panels first createMorph].

    self browser ifNotNil: [aPanel browser: self browser].

    self changed: #columns.
    "morph ifNotNil: [morph addPaneSplitters]."! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/8/2007 11:40'!
browser: aBrowser
    super browser: aBrowser.
    self panels do: [:ea | ea browser: aBrowser].! !

!OBMultipleDefinitionPanel methodsFor: 'building' stamp: 'dr 2/19/2008 10:36'!
buildOn: aBuilder
	morph := aBuilder multipleDefinitionPanel: self with: [].
	^morph! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/12/2007 16:12'!
columns
   ^self panels! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 3/1/2008 17:08'!
currentDefinitionPanel
   ^self panels detect: [:ea | ea node = self currentNode] ifNone: [nil]! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:29'!
defaultBackgroundColor
	^ browser defaultBackgroundColor! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 3/1/2008 17:08'!
definitionChanged: ann
    self currentDefinitionPanel ifNotNilDo: [:panel | panel definitionChanged: ann].! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 2/19/2008 09:59'!
definitionPanel
   ^self currentDefinitionPanel! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
hasChangeablePanel
    ^self panels anySatisfy: [:ea | ea isChangeable].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/25/2007 17:29'!
hasMethodPanel
    ^self panels anySatisfy: [:ea | ea node isKindOf: OBMethodNode].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/29/2007 10:40'!
includesNode: aNode
    ^self panels anySatisfy: [:ea | ea node = aNode].! !

!OBMultipleDefinitionPanel methodsFor: 'initializing' stamp: 'dr 2/27/2008 15:56'!
initialize
    super initialize.

    panels := OrderedCollection new.    
    self addPanel: OBClosableDefinitionPanel new.
    ! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel after: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel after: secondPanel.
    self panels removeAt: removeIdx.
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel before: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel before: secondPanel.
    self panels removeAt: (removeIdx + 1).
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:45'!
is: firstClosableDefinitionPanel placedBefore: secondClosableDefinitionPanel
    ^(self panels indexOf: firstClosableDefinitionPanel) < (self panels indexOf: secondClosableDefinitionPanel)! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/24/2007 12:20'!
isDefinition
   ^true! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/7/2007 11:50'!
lastChangeablePanel "self halt."
    ^self panels reversed detect: [:ea | ea isChangeable] ifNone: [nil].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/31/2007 17:12'!
lastIsNonMetaPanel
    ^(self lastPanel node isKindOf: OBMethodNode) not and: [self lastPanel isKindOf: OBClosableDefinitionPanel]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/31/2007 17:06'!
lastPanel
    ^self panels last! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:27'!
morph
	^ (OBPaneScroller withModel: self)
		name: 'def';
		yourself! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:32'!
morphHeight
	^ 0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 15:28'!
nodeDeleted: ann
    | deletedNodePanel  |
    (ann node isKindOf: OBMethodNode) ifTrue: [
	   deletedNodePanel := self panels detect: [:ea | ea node = ann node] ifNone: [nil].
	   deletedNodePanel ifNotNil: [self removePanel: deletedNodePanel column: nil]
    ].! !

!OBMultipleDefinitionPanel methodsFor: 'class comment opening' stamp: 'dr 3/4/2008 10:37'!
openClassCommentFor: aClassNode
    | classCommentNode newPanel panel |
    Preferences classCommentOnClassSelect ifFalse: [^self].

    classCommentNode := OBClassCommentNode on: aClassNode theNonMetaClass.
    panel := panels detect: [:ea | ea node isKindOf: OBClassCommentNode] ifNone: [nil].
    panel ifNotNil: [self removePanel: panel].

    newPanel := OBClosableDefinitionPanel new.
    newPanel definition: classCommentNode definition.
    newPanel node: classCommentNode.
    self addPanel: newPanel.! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/24/2007 12:27'!
panels
   ^panels! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:26'!
panes
    ^panels collect: [:ea | ea morph]! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:44'!
reclaimPanes
    ^0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/18/2007 11:40'!
refresh: ann
    self panels first refresh: ann.! !

!OBMultipleDefinitionPanel methodsFor: 'class comment opening' stamp: 'dr 3/4/2008 10:36'!
removeClassCommentPanels
    | panel | 
    panel := panels detect: [:ea | ea node isKindOf: OBClassCommentNode] ifNone: [nil].
    panel ifNotNil: [self removePanel: panel].! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 18:00'!
removeNonMethodPanels
	self panels copy do: [:ea | (ea node isKindOf: OBMethodNode) ifFalse: [self removePanel: ea]]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/25/2007 17:55'!
removePanel: aPanel
    ^self removePanel: aPanel column: nil! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/14/2007 10:39'!
removePanel: aPanel column: aColumn
    | newPanel theClass |
    panels remove: aPanel.
 
    "make sure that the last panels does not have any buttons"
    panels size = 1 ifTrue: [panels first createMorph].
    
    "make sure that there is always at least a standard panel"
    panels ifEmpty: [ 
	    newPanel := OBClosableDefinitionPanel new. 
	    aColumn ifNotNil: [newPanel definition: aColumn selectedNode definition]
	               ifNil: [aPanel node ifNotNil: [theClass := aPanel node theClass.
			            newPanel definition: (OBMethodDefinition source: theClass sourceCodeTemplate inClass: theClass)]]. 
	    self addPanel: newPanel.
    ].
    self changed: #columns! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 10/30/2008 09:45'!
selectionChanged: ann
    | newPanel newDefinition deselectedPanel panel |
    self removeClassCommentPanels.

	ann deselectedNode ifNotNil: [
       deselectedPanel := self panels detect: [:ea | ea node = ann deselectedNode] ifNone: [nil].
       deselectedPanel ifNotNil: [self removePanel: deselectedPanel column: ann column]
	] ifNil: [
        (self panels noneSatisfy: [:ea | ea node = ann node]) ifTrue: [
	       newDefinition := ann node ifNotNil: [ann node definition].
		  (newDefinition notNil and: [newDefinition text notEmpty]) ifTrue: [
	           (self hasChangeablePanel and: [ActiveEvent isNil or: [(ActiveEvent respondsTo: #shiftPressed) not 
			                                                            or: [ActiveEvent shiftPressed not]]]) ifTrue: [
		             self lastChangeablePanel definition: newDefinition.
		             self lastChangeablePanel node: ann node.
		             self lastChangeablePanel changed. 
		             self changed: #columns. 	
			
			         ann node isClassNode ifTrue: [self openClassCommentFor: ann node].
				
		       ] ifFalse: [
                      newPanel := OBClosableDefinitionPanel new.
                      newPanel definition: newDefinition.
                      newPanel node: ann node.
                      self addPanel: newPanel.
                ].
             ] 
         ] ifFalse: [
                "update panel for this node with new source code"
                ann node ifNotNil: [
                    panel := self panels detect: [:ea | ea node = ann node].
                    panel definition: ann node definition.
                ]
         ].
     ].! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/29/2007 15:28'!
sizing 
    self panels ifEmpty: [^1].
    ^self panels size! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 14:57'!
subscribe
	self announcer 
		observe: OBAboutToChange
		send: #aboutToChange:
		to: self;
		
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self;
		
		observe: OBRefreshRequired
		send: #refresh:
		to: self;
				
		observe: OBDefinitionChanged
		send: #definitionChanged: 
		to: self;
		
		observe: OBNodeDeleted
		send: #nodeDeleted: 
		to: self.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
swap: firstPanel with: secondPanel
    self panels swap: (self panels indexOf: firstPanel) with: (self panels indexOf: secondPanel).
    self changed: #columns.
"self halt."! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 9/25/2008 10:11'!
addSubtreeWithFan: aFan selection: anInteger
	self listHolder 
		at: anInteger
		putFan: aFan! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 6/26/2008 10:49'!
autoSelect
    "do nothing"! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 11/19/2008 14:09'!
fan
    ^self listHolder fan! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 9/11/2008 15:47'!
nextColumnForTreeNavigationWithFan: aFan selection: anInteger
	^self nextColumnForDefaultNavigationWithFan: aFan selection: anInteger! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 11:48'!
panel
	^panel ! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 2/28/2008 17:00'!
preselectNodes
    self next ifNotNil: [self next preselectNodes].! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 11/20/2007 16:23'!
refreshAll
    | requestor |
    requestor := self.
    [requestor notNil] whileTrue: [
	   requestor refresh.
	   requestor := requestor next.
    ]    ! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 8/15/2008 12:03'!
updateIcon
   self changed: #list! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 8/15/2008 12:07'!
updateIconOfAllColumns
    panel columns do: [:ea | ea updateIcon]! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 8/15/2008 12:05'!
updateIconOfAllPreviousColumns
    | col |
    col _ self.
    [col notNil] whileTrue: [
        col updateIcon.
        col _ col previous.
    ]! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 4/14/2008 15:33'!
useDoubleClick: aBoolean! !

OBColumn subclass: #OBEnhancementColumn
	instanceVariableNames: 'fan doubleClickSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementColumn commentStamp: 'dr 9/23/2008 16:19' prior: 0!
I am a slightly adapted version of OBColumn and I am used in all browsers provided by the enhancements package.
!

!OBEnhancementColumn methodsFor: 'callbacks' stamp: 'dr 1/29/2009 11:06'!
autoSelect
    self fan autoSelection ifNotNilDo: [:node | (selection = 0 or: [node = self selectedNode]) 
	 	ifTrue: [self jumpTo: node. 
				self fan shouldUpdateOnAutoSelect ifTrue: [self signalSelectionChanged]]]. 
    self next ifNotNilDo: [:next | next autoSelect] 
! !

!OBEnhancementColumn methodsFor: 'accessing' stamp: 'dr 12/15/2008 18:43'!
basicParent: aNode  
    super basicParent: aNode.
    fan := listHolder fan.! !

!OBEnhancementColumn methodsFor: 'building' stamp: 'dr 2/25/2008 15:15'!
buildOn: aBuilder
	| pane |
	pane := super buildOn: aBuilder.
	pane list doubleClickSelector: self doubleClickSelector.
	^pane! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 3/1/2008 16:52'!
childrenChanged: ann
     super childrenChanged: ann.
	ann node isSmartGroup ifTrue:
		[self refresh].! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 2/14/2008 11:07'!
clear
    super clear.
    fan := OBEnhancementFan new.! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 11/19/2008 14:08'!
deselectItem
     | previousColumn |
     self clearSelection.
     self changed: #selection.
     self fan removeAutoSelection.
	previousColumn := self previous. "this is ugly but works"
	"panel columns last = self ifTrue: [previousColumn := previousColumn previous]."
	previousColumn ifNotNil: [previousColumn signalSelectionChanged] 
	                    ifNil: [self signalSelectionChanged. 
		                       self announcer announce: (OBDefinitionChanged definition: OBDefinition new)].! !

!OBEnhancementColumn methodsFor: 'callbacks' stamp: 'dr 9/19/2008 16:08'!
doubleClick
    "only used in hierarchy browser in the first column to change focus to the selected class"
    "should be change to be based on metagraph"
    | commandClass |
    "panel browser class isHierarchyBrowser ifTrue: [
	   panel changeRootNode: self selectedNode
    ] ifFalse: [(OBEnhancementCmdBrowseHierarchy on: self selectedNode for: self) execute]."

    commandClass := self selectedNode metaNode doubleClickCommandClass.
    commandClass ifNotNil: [(commandClass on: self selectedNode for: self) execute]. ! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 2/25/2008 15:15'!
doubleClickSelector
    ^doubleClickSelector! !

!OBEnhancementColumn methodsFor: 'accessing' stamp: 'dr 11/19/2008 14:09'!
fan
    ^fan! !

!OBEnhancementColumn methodsFor: 'callbacks' stamp: 'dr 12/11/2008 14:43'!
fan: aFan selection: index
     super fan: aFan asEnhancedFan selection: index.
     self selectedNode ifNotNilDo: [:node | node isMethodNode ifTrue: [self fan setLastNode: self selectedNode]].! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 10/30/2008 09:47'!
handleNonAliasSwitchFor: oldNode currentNode: oldCurrentNode nextNode: nextOldNode
    | smartNode |
	panel columns first = self ifTrue: [ 
         "switched to 'hierarchy'"
	    (switch selection = panel browser class hierarchySwitchIndex and: [nextOldNode respondsTo: #theClass]) ifTrue: [
		   self selectClassInHierarchy: nextOldNode theNonMetaClass.
		   self selectPackageInHierarchyView.
		   oldCurrentNode isMethodNode ifTrue: [self selectHierarchyClassMethod: oldCurrentNode].		
	    ].
         "switched to 'packages'"
         (switch selection = panel browser class packageSwitchIndex and: [oldNode isClassNode]) ifTrue: [
	        (self selectedNode isNil or: [self selectedNode isClassNode not]) ifTrue: [panel jumpTo: oldNode].
	    ].
         "switched to 'smart groups'"  
         switch selection = panel  browser class smartGroupSwitchIndex ifTrue: [
	        smartNode := OBSmartRootNode default allSmartNodes detect: [:node | node alias = oldCurrentNode] ifNone: [nil].
	        smartNode ifNotNil: [smartNode jumpIn: panel].
	    ]
     ].

      (switch selection = panel browser class packageSwitchIndex and: [oldNode isClassNode]) ifTrue: [
	     self selectedNode = oldNode ifTrue: [panel clearAfter: self. panel jumpTo: oldNode]
	 ]! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 10/23/2008 09:49'!
handleSmartAliasSwitchFor: oldNode currentNode: oldCurrentNode
    oldNode isSearchOrPackageAlias ifFalse: [
        switch selection = 1 
		ifTrue: [oldNode jumpIn: panel]
          ifFalse: [(oldCurrentNode respondsTo: #theClass) ifTrue: [
		     self selectClassInHierarchy: oldCurrentNode theNonMetaClass.
		     self selectPackageInHierarchyView]].
        ^self
    ].

    oldNode isPackageAlias ifTrue: [
	   (oldCurrentNode notNil and: [oldCurrentNode isSmartAlias not]) ifTrue: [panel jumpTo: oldCurrentNode].
	   ^self
    ].

    (oldNode isSearchAlias and: [oldCurrentNode notNil and: [oldCurrentNode ~= oldNode]]) ifTrue: [
	    panel jumpTo: (oldNode selectThisOrNextNodeOnSwitch: oldCurrentNode)]                
	    ! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 10/21/2008 11:20'!
handleSwitchFor: oldNode node: oldCurrentNode nextNode: nextOldNode
	   oldNode isSmartAlias ifTrue: [self handleSmartAliasSwitchFor: oldNode currentNode: oldCurrentNode] 
	                           ifFalse: [self handleNonAliasSwitchFor: oldNode currentNode: oldCurrentNode nextNode: nextOldNode].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 9/26/2008 16:47'!
jumpToAliasNode
     (self selectedNode notNil and: [self selectedNode isSmartAlias]) ifTrue: [self selectedNode jumpIn: panel. ^self].! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 10/21/2008 11:19'!
listChanged 
     | oldNode oldCurrentNode nextOldNode |
     oldNode := self selectedNode.
     oldCurrentNode := panel currentNode.
     nextOldNode := self next ifNotNilDo: [:next | next selectedNode].

	"dirty hack to make sure that we find a clean metagraph when navigating in the first column"
	panel columns first = self ifTrue: [panel cleanMetagraph].
   
	self refreshAndSignal: true.
	
     oldNode ifNotNil: [self handleSwitchFor: oldNode node: oldCurrentNode nextNode: nextOldNode].

	"make sure that if we have a pre-selected method node before the change occurred, its defintion is displayed"
	panel currentNode ifNotNilDo: [:node | 
	    self announcer announce: (OBDefinitionChanged definition: node definition)].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 1/29/2009 11:12'!
parent: aNode 
	| cNode autoselectNode |
	autoselectNode := self fan lastNode.
	self basicParent: aNode.
	autoselectNode ifNotNil: [self fan setLastNode: autoselectNode].
	cNode := self fan autoSelection. 		
	self jumpTo: cNode.  
	"(self fan shouldUpdateOnAutoSelect and: [cNode notNil]) ifTrue: [self signalSelectionChanged]."
! !

!OBEnhancementColumn methodsFor: 'private' stamp: 'dr 7/11/2008 16:26'!
selectClassInHierarchy: aClass
    | selectNode |
    selectNode := self children detect: [:ea | (ea respondsTo: #theNonMetaClass) and: [ea theNonMetaClass = aClass]] ifNone: [nil].
    selectNode ifNotNil: [self select: selectNode]! !

!OBEnhancementColumn methodsFor: 'private' stamp: 'dr 10/21/2008 11:37'!
selectHierarchyClassMethod: aMethodNode
    | selectNode methodColumn |
    methodColumn := panel columns last.
    selectNode := methodColumn children detect: [:ea | ea = aMethodNode] ifNone: [nil].
    selectNode ifNotNil: [methodColumn select: aMethodNode]! !

!OBEnhancementColumn methodsFor: 'private' stamp: 'dr 10/21/2008 22:55'!
selectPackageInHierarchyView
    self selectPackageInHierarchyViewWith: nil! !

!OBEnhancementColumn methodsFor: 'private' stamp: 'dr 10/21/2008 23:13'!
selectPackageInHierarchyViewWith: lastNode
    | packageNodeOfClass last | 
    ((self selectedNode notNil and: [panel columns first = self])
                                  and: [switch selection = panel browser class hierarchySwitchIndex])
      ifTrue: [
	    self selectedNode ifNotNilDo: [:node | self next ifNotNilDo: [:next | next fan: node asFan selection: 0]].
	    packageNodeOfClass := self next children detect: [:pkgNode | 
		                          pkgNode includesClass: self selectedNode theNonMetaClass] ifNone: [nil].	   
	    self next selection: (self next children indexOf: packageNodeOfClass).
	    lastNode ifNotNil: [ "make sure to keep last selected node as it gets lost when selection changes"
	        last := panel columns last.
	        last fan setLastNode: lastNode. 
	        last previous signalSelectionChanged.
	        last fan autoSelection ifNotNilDo: [:node |
		      self announcer announce: (OBDefinitionChanged definition: node definition)]
	    ]
	].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 11/28/2008 13:39'!
selection: anInteger  
     "select the same item a second time => unselect"
     | oldSelectedNode newSelectedNode | 
     (selection = anInteger and: [doubleClickSelector isNil]) ifTrue: [
	     self selectedNode ifNotNil: [(self selectedNode isKindOf: OBAllMethodCategoryNode) ifFalse: [self deselectItem. ^self]].
	]. 

     "make sure that a click on an already selected item brings it up again (no auto-selection afterwards)" 
     oldSelectedNode := self selectedNode.
     newSelectedNode := self children at: anInteger ifAbsent: [nil].
     oldSelectedNode = newSelectedNode ifTrue: [panel clearAfter: self].

     "selecting of smart nodes"
     selection := anInteger.
     self jumpToAliasNode.
     super selection: anInteger.		
	
     panel autoSelect: self.
     (self selectedNode notNil and: [self selectedNode isMethodNode]) ifTrue: [
	    self fan setLastNode: self selectedNode].

	(Smalltalk hasClassNamed: #CMModel) ifTrue: [
		self selectedNode ifNotNilDo: [:node | CMModel recentlyBrowsed updateEntity: node entity]].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 2/25/2008 15:16'!
setDoubleClickSelector: aSymbol
    doubleClickSelector := aSymbol! !

!OBEnhancementColumn methodsFor: 'initializing' stamp: 'dr 12/2/2008 11:28'!
setPanel: aPanel
    super setPanel: aPanel.
    fan := OBEnhancementFan new.! !

!OBEnhancementColumn methodsFor: 'initializing' stamp: 'dr 4/14/2008 15:54'!
setPanel: aPanel metaNode: aMetaNode node: aNode
    super setPanel: aPanel metaNode: aMetaNode node: aNode.
    self useDoubleClick: aMetaNode next supportsDoubleClick.! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 10/20/2008 18:30'!
signalSelectionChanged
	super signalSelectionChanged. 
	self next ifNotNil: [self next preselectNodes]. ! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 2/25/2008 15:25'!
useDoubleClick
    self setDoubleClickSelector: #doubleClick.! !

!OBEnhancementColumn methodsFor: 'initializing' stamp: 'dr 9/19/2008 16:30'!
useDoubleClick: aBoolean
    aBoolean ifTrue: [self setDoubleClickSelector: #doubleClick].! !

OBEnhancementColumn subclass: #OBMultipleSelectionColumn
	instanceVariableNames: 'multipleSelection oldSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionColumn methodsFor: 'building' stamp: 'dr 7/4/2007 15:51'!
buildOn: aBuilder
	^ aBuilder
		multipleSelectionColumn: self 
		with: [switch buildOn: aBuilder]! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 2/28/2008 17:15'!
clearSelection
	super clearSelection.
	"multipleSelection _ Dictionary new."! !

!OBMultipleSelectionColumn methodsFor: 'testing' stamp: 'dr 2/29/2008 10:16'!
hasSeveralSelections
   ^(self multipleSelection values select: [:ea | ea]) size > 1! !

!OBMultipleSelectionColumn methodsFor: 'morphic' stamp: 'dr 7/4/2007 15:50'!
listMorph
	^ (OBPluggableListMorphOfMany
		on: self
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu: 
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: self dragEnabled;
			dropEnabled: self dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			adoptPaneColor: panel defaultBackgroundColor;
			yourself! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 2/29/2008 10:16'!
listSelectionAt: anIndex
	^self multipleSelection at: anIndex ifAbsent: [^false]! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 2/29/2008 10:16'!
listSelectionAt: anIndex put: aValue 
     | isSelected |
     isSelected := self multipleSelection at: anIndex ifAbsent: [false].

     "if we did not de-select the primary selection"
     (aValue not and: [anIndex = selection]) ifFalse: [
	     self multipleSelection at: anIndex put: aValue.
          "if we de-select this item"
	     (isSelected = true and: [aValue not]) ifTrue: [
		    self announcer announce: ((OBSelectionChanged column: self) deselectedNode: (self children at: anIndex)).
	     ] ifFalse: [ "if we select an new item => check all old items"
	         (self multipleSelection associationsDo: [:assoc | (assoc value = true and: [self paneExistsForSelection: assoc key]) ifFalse: [
			    self multipleSelection at: assoc key put: false.
			]])
	     ]
     ].! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 2/29/2008 10:15'!
multipleSelect: anInteger
    (self multipleSelection isEmpty and: [self = panel columns last]) ifTrue: [self multipleSelection at: anInteger put: true].! !

!OBMultipleSelectionColumn methodsFor: 'accessing' stamp: 'dr 2/29/2008 10:15'!
multipleSelection
    multipleSelection ifNil: [multipleSelection := Dictionary new].
    ^multipleSelection! !

!OBMultipleSelectionColumn methodsFor: 'testing' stamp: 'dr 2/27/2008 16:19'!
paneExistsForSelection: anIndex
    ^panel definitionPanel includesNode: (self children at: anIndex ifAbsent: [nil]).! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 8/11/2008 14:29'!
preselectNodes
     self children keysAndValuesDo: [:idx :node | self multipleSelection at: idx put: (panel definitionPanel includesNode: node)]. ! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 2/14/2008 12:05'!
selectSilently: aNode
	super selectSilently: aNode.
	self multipleSelect: selection.
! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 8/11/2008 14:25'!
selection: anInteger
     ((self hasSeveralSelections not and: [selection = anInteger or: [anInteger = 0]]) and: [doubleClickSelector isNil]) ifTrue: [ 
	    "select the same item a second time => unselect"
	    self deselectItem.
	    ^self
	].

     "de-selected an item"
	anInteger = 0 ifTrue: [
         selection := oldSelection. "self halt."
         "selection keysAndValuesDo: [:index :value | value ifTrue: [primarySelection := index]]."
	] ifFalse: [ 
	    oldSelection := selection.
	    selection := anInteger.
	    self multipleSelect: anInteger.
         self signalSelectionChanged.
	]. 
	self changed: #selection. 
     fan setLastNode: self selectedNode.! !

OBEnhancementColumn subclass: #OBTreeColumn
	instanceVariableNames: 'treeSelection treeNodeMediator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tree'!

!OBTreeColumn methodsFor: 'fan' stamp: 'dr 9/23/2008 15:14'!
addSubtreeWithFan: aFan selection: anInteger
	self treeNodeMediator putFan: aFan at: self treeSelection.
	self extendSelection: anInteger.! !

!OBTreeColumn methodsFor: 'accessing' stamp: 'dr 12/15/2008 16:07'!
basicParent: aNode 
	super basicParent: aNode.
	treeNodeMediator := OBTreeNodeMediator parent: aNode.
	treeNodeMediator fan: self fan.! !

!OBTreeColumn methodsFor: 'building' stamp: 'dr 9/11/2008 16:38'!
buildOn: aBuilder
	^ aBuilder
		treeColumn: self 
		with: [switch buildOn: aBuilder]! !

!OBTreeColumn methodsFor: 'accessing' stamp: 'dr 12/9/2008 20:09'!
childAt: anArray
	^ self nodeAt: anArray! !

!OBTreeColumn methodsFor: 'updating' stamp: 'dr 9/23/2008 15:13'!
clear
	super clear.
	treeNodeMediator := OBTreeNodeMediator fan: OBFan new! !

!OBTreeColumn methodsFor: 'selecting' stamp: 'dr 9/19/2008 11:12'!
clearSelection
	treeSelection := #(0)! !

!OBTreeColumn methodsFor: 'fan' stamp: 'dr 9/19/2008 11:25'!
currentFan
	^ self fanAt: self treeSelection! !

!OBTreeColumn methodsFor: 'fan' stamp: 'dr 9/22/2008 15:27'!
currentSelection
	^ self treeSelection notEmpty 
		ifTrue: [self treeSelection last]
		ifFalse: [0]! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 10/6/2008 10:42'!
dropNode: passengerNode on: targetNode "self haltOnce."
	^ [targetNode acceptDroppedNode: passengerNode] 
		on: OBAnnouncerRequest
		do: [:notification | notification resume: self announcer]! !

!OBTreeColumn methodsFor: 'selecting' stamp: 'dr 9/22/2008 17:07'!
extendSelection: anInteger
	^ anInteger = 0
		ifFalse: [self treeSelection: (self treeSelection copyWith: anInteger)]! !

!OBTreeColumn methodsFor: 'selecting' stamp: 'dr 12/18/2008 14:56'!
fan: aFan selection: index
	fan := aFan.
	self listHolder fan: aFan selection: index.
	treeNodeMediator fan: aFan.
	treeSelection := Array with: index.
	self selectedNode ifNotNilDo: [:node | self listHolder noteChild: node].
	self switchFilter: self listHolder switchFilter.
	switch refresh.
	self changed: #list! !

!OBTreeColumn methodsFor: 'fan' stamp: 'dr 9/23/2008 15:10'!
fanAt: anArray
	^ self treeNodeMediator fanAt: anArray! !

!OBTreeColumn methodsFor: 'fan' stamp: 'dr 9/23/2008 15:10'!
fanWithParentNodeAt: anOrderedCollection 
	^ self treeNodeMediator fanWithParentNodeAt: anOrderedCollection! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'jk 1/6/2008 03:28'!
getTreeChildrenOf: nodePosition
	| currentFan |
	currentFan := self fanWithParentNodeAt: nodePosition.
	currentFan restrictToTreeChildrenAndAdjustSelection: 0.
 	^ currentFan treeChildren collect: [:e | currentFan parent displayStringForChild: e ]! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 10/20/2008 18:25'!
getTreeLabelOf: aStringOrText
	^ aStringOrText ! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 9/19/2008 11:28'!
getTreeSelectionPath
	^ self treeSelection! !

!OBTreeColumn methodsFor: 'testing' stamp: 'dr 9/19/2008 11:36'!
hasSelection
	^ self treeSelection notEmpty and: [ self treeSelection last ~~ 0 ]! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 9/11/2008 17:24'!
hasTreeChildren: nodePosition
	| node |
	node := self nodeAt: nodePosition.
	^ node ifNotNil: [node hasTreeChildren] ifNil: [false]! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 12/9/2008 20:09'!
iconAt: anArray
	^(self childAt: anArray) icon! !

!OBTreeColumn methodsFor: 'compatibility' stamp: 'dr 9/12/2008 10:00'!
lastNode! !

!OBTreeColumn methodsFor: 'updating' stamp: 'dr 10/23/2008 13:43'!
listChanged
    | oldNode oldCurrentNode nextOldNode |
    "we might somehow have to update fans when the list changes, eg. when adding a new element"
    "self children do: [:node | self fan putFan: node asFan at: #(1)]."
     oldNode := self selectedNode.
     oldCurrentNode := panel currentNode.
     nextOldNode := self next ifNotNilDo: [:next | next selectedNode].

	"dirty hack to make sure that we find a clean metagraph when navigating in the first column"
	panel columns first = self ifTrue: [panel cleanMetagraph].
     treeSelection := #(0).  

	self refreshAndSignal: true.

     oldNode ifNotNil: [self handleSwitchFor: oldNode node: oldCurrentNode nextNode: nextOldNode].
     self changed: #list.
	"make sure that if we have a pre-selected method node before the change occurred, its defintion is displayed"
	panel currentNode ifNotNilDo: [:node | 
	    self announcer announce: (OBDefinitionChanged definition: node definition)].! !

!OBTreeColumn methodsFor: 'fan' stamp: 'dr 9/23/2008 16:12'!
nextColumnForTreeNavigationWithFan: aFan selection: anInteger
	| nextColumn | 
	nextColumn := self addSubtreeWithFan: aFan selection: anInteger.
	^ nextColumn! !

!OBTreeColumn methodsFor: 'node' stamp: 'dr 9/23/2008 15:10'!
nodeAt: anArray
	^ self treeNodeMediator nodeAt: anArray! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 11/19/2008 11:51'!
nodeForDropEvent: evt inMorph: pluggableTreeMorph 
	| item label itemParent classCat | 
	item := pluggableTreeMorph itemFromPoint: evt position. 
	item ifNil: [^nil].
	label := item contents asString withBlanksTrimmed.

	"search for class cat node in opened packages first"
	itemParent := item complexContents parent.
	itemParent isNullParent ifFalse: [
		classCat := itemParent item, '-', label.
		self treeNodeMediator subTreeNodeMediators values do: [:ea | 
	     	ea fan children do: [:n | n name = classCat ifTrue: [^n]]].
	].

	"if no class cat found, search for a package with the name label"
	^self children 
		detect: [:child | child displayString asString withBlanksTrimmed = label]
		ifNone: [nil]. ! !

!OBTreeColumn methodsFor: 'updating' stamp: 'dr 11/19/2008 16:23'!
refreshAndSignal: aBoolean
     self treeNodeMediator refresh.
    "self listHolder fan refresh.  " 

    	super refreshAndSignal: aBoolean.
	self changed: #list.! !

!OBTreeColumn methodsFor: 'private' stamp: 'dr 9/12/2008 10:57'!
selectedNode
	^ self currentFan children at: self currentSelection ifAbsent: [nil]! !

!OBTreeColumn methodsFor: 'selecting' stamp: 'dr 11/10/2008 15:36'!
selection: anInteger
	treeSelection := OrderedCollection with: anInteger.
    	super selection: anInteger.! !

!OBTreeColumn methodsFor: 'compatibility' stamp: 'dr 9/12/2008 10:00'!
setLastNode: aNode! !

!OBTreeColumn methodsFor: 'accessing' stamp: 'dr 9/23/2008 15:13'!
setPanel: aPanel 
	super setPanel: aPanel.
	treeNodeMediator := OBTreeNodeMediator fan: OBFan new! !

!OBTreeColumn methodsFor: 'compatibility' stamp: 'dr 9/12/2008 10:59'!
shouldBeLast
    ^self currentFan parent isNil! !

!OBTreeColumn methodsFor: 'accessing' stamp: 'dr 9/23/2008 15:10'!
treeNodeMediator
    ^treeNodeMediator! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 9/19/2008 11:24'!
treeSelection
	^ treeSelection ifNil: [#(0)]! !

!OBTreeColumn methodsFor: 'callbacks' stamp: 'dr 10/24/2008 18:17'!
treeSelection: anArray
     | lastNode |
     treeSelection := anArray.
	self listHolder selection: anArray.
	lastNode := panel columns last fan lastNode.
	self signalSelectionChanged.
	self changed: #selection.
     self jumpToAliasNode.
     self selectPackageInHierarchyViewWith: lastNode.		
	switch currentNode: self selectedNode.	! !

OBNavigate subclass: #OBShowDynamicImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBShowDynamicImplementors methodsFor: 'as yet unclassified' stamp: 'dr 10/1/2007 16:07'!
browserClass
	^ OBDynamicImplementorsBrowser! !

!OBShowDynamicImplementors methodsFor: 'as yet unclassified' stamp: 'dr 10/1/2007 16:07'!
noChildrenMessage
	^'no dynamic implementors'! !

OBNavigate subclass: #OBShowDynamicSenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBShowDynamicSenders methodsFor: 'as yet unclassified' stamp: 'dr 10/5/2007 16:42'!
browserClass
	^ OBDynamicSendersBrowser! !

!OBShowDynamicSenders methodsFor: 'as yet unclassified' stamp: 'dr 10/5/2007 16:42'!
noChildrenMessage
	^'no dynamic senders'! !

OBButtonBar subclass: #OBEnhancementButtonBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBEnhancementButtonBar methodsFor: 'visual' stamp: 'dr 2/2/2009 11:05'!
adoptPaneColor: aColor
	(self submorphs reject: [:ea | ea isKindOf: OBBackButtonMorph]) do: [:ea | ea onColor: aColor offColor: aColor whiter].
	super adoptPaneColor: aColor! !

!OBEnhancementButtonBar methodsFor: 'updating' stamp: 'dr 3/13/2008 11:00'!
updateCommands
	self removeAllMorphs.
	
	self addMorphBack: model createBackButton.		
	self addMorphBack: model createForwardButton.	
				
	model commands do: [:ea | self addButtonFor: ea].! !

!OBMorphBuilder class methodsFor: '*ob-enhancements' stamp: 'dr 2/16/2008 15:39'!
openWithExtent: aBrowser
	^ (self build: aBrowser) openInWorldExtent: aBrowser extent! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 2/27/2008 11:05'!
closableDefinitionPanel: aDefinitionPanel with: aBlock
	| morph contentMorph | 
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
     
     ((Preferences visualizations and: [aDefinitionPanel respondsTo: #codeTabPanel]) and: [aDefinitionPanel codeTabPanel commands notEmpty]) ifTrue: [
	    morph addMorphBack: (aDefinitionPanel codeTabPanel buildOn: self).	
	].	
	aDefinitionPanel hasSeveralPanels ifTrue: [morph addMorphBack: aDefinitionPanel createTitleBar].	
	contentMorph := aDefinitionPanel createContentMorph.
	aDefinitionPanel setContentMorph: contentMorph.
	morph addMorphBack: contentMorph.
	
	current ifNotNil: [current addMorphBack: morph].
	^ self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:28'!
createPaneForColumn: aColumn with: listSelector
	| pane |
	pane := OBPane new.
	pane 
		model: aColumn;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self perform: listSelector with: aColumn).
		
	^pane	! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 17:07'!
createReferencePaneFor: aDefinitionPanel
	| columnPanel paneScroller saved referenceMorph |
	columnPanel := OBColumnPanel minPanes: 1 maxPanes: 1.
	columnPanel pushColumn: aDefinitionPanel referenceList.
	
	paneScroller := (OBPaneScroller withModel: columnPanel)
				name: 'scroller';
				vResizing: #spaceFill;
				hResizing: #spaceFill;
				yourself.	
			
	[saved := current.
	      self current: paneScroller do: [aDefinitionPanel referenceList buildOn: self]] 
     ensure: [current := saved].	
	
	referenceMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #rigid;
		width: aDefinitionPanel referenceList defaultWidth;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.     

	referenceMorph addMorphBack: aDefinitionPanel referenceList createTitleBar.	
	referenceMorph addMorphBack: paneScroller.	
		
	^referenceMorph
! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 12:05'!
enhancementFixedButtonBar: aPanel with: aBlock 
	| morph |
	morph := OBEnhancementButtonBar on: aPanel.
	morph
		height: Preferences standardCodeFont height * 2.2;
		layoutPolicy: TableLayout new;
		vResizing: #rigid;
		hResizing: #spaceFill;
		listDirection: #leftToRight;
		rubberBandCells: true;
		borderWidth: 0.		
		
	current addMorphBack: morph.
	self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 10/20/2008 08:48'!
enrichedTextarea: aDefinitionPanel with: aBlock 
	| morph definitionMorph tabBarMorph textMorph |
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 0;
		cellInset: 0;
		color: Color white;
		yourself. 
			
	definitionMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;	
		minWidth: 300;	
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 0;
		cellInset: 0;
		color: Color white;
		yourself.     
		
	tabBarMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 0;
		cellInset: 0;
		color: Color white;
		yourself.
				
     ((Preferences visualizations and: [aDefinitionPanel hasCodeTabPanel]) 
                                      and: [aDefinitionPanel codeTabPanel commands notEmpty]) ifTrue: [
	     tabBarMorph addMorphBack: (aDefinitionPanel codeTabPanel buildOn: self).	
		definitionMorph addMorphBack: tabBarMorph
	].			
		
	textMorph := aDefinitionPanel createContentMorph.		
     aDefinitionPanel setContentMorph: textMorph.		
	definitionMorph addMorphBack: textMorph.	
	morph addMorphBack: definitionMorph.
	
	aDefinitionPanel hasReferencePanel ifTrue: [morph addMorphBack: (self createReferencePaneFor: aDefinitionPanel)].	
			
	current ifNotNil: [current addMorphBack: morph].
	self current: morph do: aBlock.
     ^definitionMorph! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 13:24'!
multipleDefinitionPanel: aMultipleDefinitionPanel with: aBlock
	| morph defMorph |
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself. 
			
	defMorph := (OBPaneScroller withModel: aMultipleDefinitionPanel)
		name: 'def';
		yourself.	
				
	morph addMorphBack: defMorph.			
				
	current ifNotNil: [current addMorphBack: morph].
	self current: morph do: aBlock.
	
	^defMorph! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:27'!
multipleSelectionColumn: aColumn with: aBlock
   	| pane |
     pane := self createPaneForColumn: aColumn with: #multipleSelectionListMorphForColumn:.
	current ifNotNil: [current pushPane: pane].
	^ self current: pane do: aBlock
! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:23'!
multipleSelectionListMorphForColumn: aColumn
	^ (OBPluggableListMorphOfMany
		on: aColumn
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu:
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: aColumn dragEnabled;
			dropEnabled: aColumn dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			yourself! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 11:29'!
referenceList: aReferenceList with: aBlock
	| pane |
			
	pane := OBPane new.
	pane
		model: aReferenceList;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self listMorphForColumn: aReferenceList).	
	current ifNotNil: [current pushPane: pane].
	^self current: pane do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 9/11/2008 16:38'!
treeColumn: aColumn with: aBlock
   	| pane | 
     pane := self createPaneForColumn: aColumn with: #treeMorphForColumn:.
	current ifNotNil: [current pushPane: pane].
	^ self current: pane do: aBlock
! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 12/9/2008 19:59'!
treeMorphForColumn: aColumn
	"See MorphicToolBuilder>>buildPluggableTree:"
	^ OBPluggableTreeMorph new
		model: aColumn;
		getLabelSelector: #getTreeLabelOf:;		
		getSelectedPathSelector: #getTreeSelectionPath;				
		getChildrenSelector: #getTreeChildrenOf:;
		hasChildrenSelector: #hasTreeChildren:;
		setSelectedSelector: #treeSelection:;
		getIconSelector: #iconAt:;						
		getRootsSelector: #list;
		getMenuSelector: #menu:;
		dragEnabled: aColumn dragEnabled;
		dropEnabled: aColumn dropEnabled;		
		dropItemSelector: #drop:on:;		
		wantsDropSelector: #canDrop:on:;
		keystrokeActionSelector: #keystroke:from:;
		borderWidth: 0;
		autoDeselect: false;
		yourself! !

OBMClassRefsQuery subclass: #OBEnhancementMClassRefsQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBEnhancementMClassRefsQuery methodsFor: 'executing' stamp: 'dr 7/3/2008 11:15'!
find
	self searchNode hasOnlyOneResult
		ifTrue: [self browser jumpTo: self searchNode methodsInFirstClass first]
		ifFalse: [self openSearchInSameBrowserOn: self searchNode]! !

!OBMClassRefsQuery methodsFor: '*ob-enhancements' stamp: 'dr 2/26/2008 16:56'!
openSearchBrowserOn: searchNode 
	^ self openSearchInSameBrowserOn: searchNode ! !

!OBClassRefSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/21/2008 15:38'!
methodSatisfiesQuery: methodRef
    ^methodRef actualClass = (Smalltalk at: query) ifTrue: [
	    methodRef compiledMethod getSource asString includesSubString: query 
	] ifFalse: [
	    methodRef compiledMethod hasLiteral: (Smalltalk associationAt: query)
	]! !

OBFan subclass: #OBEnhancementFan
	instanceVariableNames: 'lastNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementFan methodsFor: 'accessing' stamp: 'dr 1/28/2009 15:37'!
autoSelection
	^super autoSelection
	"| auto |
	auto := parent ifNotNilDo: [:node | node metaNode autoSelect].
	auto ifNotNil: [
		auto name == #LastSelection ifTrue: [
			^lastNode ifNotNil: [children detect: [:ea | ea selector = lastNode selector] ifNone: [nil]].			
		].
		auto name == #SmartGroupJump ifTrue: [
			^children detect: [:ea | auto methodSatisfiesQuery: ea reference] ifNone: [nil].			
		].	
		^children detect: [:ea | ea metaNode == auto] ifNone: [nil]
	].
     ^nil"! !

!OBEnhancementFan methodsFor: 'accessing' stamp: 'dr 1/29/2009 10:56'!
lastNode
	^lastNode! !

!OBEnhancementFan methodsFor: 'selecting' stamp: 'dr 2/25/2008 10:52'!
removeAutoSelection
    lastNode := nil! !

!OBEnhancementFan methodsFor: 'accessing' stamp: 'dr 10/21/2008 21:51'!
setLastNode: aNode
	(aNode notNil and: [aNode isMethodNode]) ifTrue: [lastNode := aNode]! !

!OBEnhancementFan methodsFor: 'testing' stamp: 'dr 1/28/2009 15:42'!
shouldUpdateOnAutoSelect
    ^parent metaNode autoSelect ifNotNilDo: [:autoSelect | autoSelect metaNode shouldUpdateOnAutoSelect]                                                        ifNil: [false].! !

!OBFan class methodsFor: '*ob-enhancements' stamp: 'jk 1/13/2008 18:46'!
defaultParent: aNode
	^ self parent: aNode children: aNode childNodesWithinDefaultNavigation! !

!OBFan class methodsFor: '*ob-enhancements' stamp: 'jk 12/18/2007 14:42'!
treeParent: aNode
	^ self parent: aNode children: aNode childNodesWithinTree! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:53'!
asEnhancedFan
    ^OBEnhancementFan new setParent: parent children: children; yourself 
! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 9/12/2008 15:58'!
asTreeFan
	^ OBTreeNodeMediator fan: self! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 9/12/2008 10:33'!
fan
    ^self! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 2/24/2008 13:29'!
lastNode
    ^nil! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 2/25/2008 11:16'!
removeAutoSelection! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 9/22/2008 15:28'!
restrictToTreeChildrenAndAdjustSelection: anInteger
	| child |
	anInteger = 0 ifFalse: [child := self childAt: anInteger].
	children := (self children select: [ :e | e isTreeNavigation ]).
	^ anInteger = 0 
		ifFalse: [self children identityIndexOf: child ifAbsent: [0]]
		ifTrue: [0]! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 9/15/2008 11:51'!
treeChildren
	"Returns children with tree navigation." 
	^ self children select: [ :e | e isTreeNavigation ]! !

!ClassDescription methodsFor: '*ob-enhancements' stamp: 'dr 9/24/2008 15:44'!
browserIcon
    ^nil! !

!ClassDescription methodsFor: '*ob-enhancements' stamp: 'dr 9/24/2008 16:07'!
theClass
    ^self! !

!MCPackageManager methodsFor: '*ob-enhancements' stamp: 'dr 7/4/2008 16:04'!
modifiedTimeStamp
    modifiedTimeStamp ifNil: [modifiedTimeStamp := 0].
    ^modifiedTimeStamp! !

OBMClassQuery subclass: #OBEnhancementMClassQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBEnhancementMClassQuery methodsFor: 'private' stamp: 'cb 7/16/2008 11:53'!
find
	((isWild not and: [pattern size = 1 and: [(Smalltalk hasClassNamed: pattern first)]]) or: [self searchNode classes size = 1])
		ifTrue: [self openClassBrowser]
		ifFalse: [self openSearchBrowser]! !

!OBEnhancementMClassQuery methodsFor: 'private' stamp: 'dr 7/16/2008 14:27'!
openClassBrowser
	| classNode |
	classNode := (Smalltalk hasClassNamed: pattern first)
	                 ifTrue: [OBClassNode on: (Smalltalk at: pattern first asSymbol)] 
	                 ifFalse: [self searchNode classes first].
	^self browser isClassBrowser
		ifTrue: [self browser jumpTo: classNode]
		ifFalse: [classNode browse]! !

!OBMClassQuery methodsFor: '*ob-enhancements' stamp: 'dr 5/14/2008 13:36'!
openSearchBrowserOn: searchNode 
     ^(browser isKindOf: OBPackageBrowser) 
        ifTrue: [self openSearchInSameBrowserOn: searchNode]
        ifFalse: [super openSearchBrowserOn: searchNode] 

	     ! !

!OBMorphicPlatform methodsFor: '*ob-enhancements' stamp: 'dr 2/16/2008 15:42'!
handleBrowseRequestWithExtent: request
	^ OBMorphBuilder openWithExtent: request browser! !

OBHierarchyBrowser subclass: #OBEnhancementHierarchyBrowser
	instanceVariableNames: 'browseHistory historyCursor historyIndexOnSwitch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementHierarchyBrowser class methodsFor: 'configuration' stamp: 'dr 10/29/2008 15:20'!
defaultMetaNode
     | metaGraph | 
     metaGraph := (self dynamicBrowser ifTrue: [OBDynamicMetagraphBuilder] ifFalse: [OBEnhancementMetagraphBuilder])
		on: (OBMetaNode named: 'RootClass')
		class: #classHierarchy 
		comment: #commentHierarchy 
		metaclass: #metaclassHierarchy.
	metaGraph classMetaNode doubleClickCommandClass: OBCmdFocusOnClassInHierarchy.
	metaGraph metaclassMetaNode doubleClickCommandClass: OBCmdFocusOnClassInHierarchy.
	"metaGraph methodMetaNode doubleClickCommandClass: OBCmdSelectMethodCategory."
	^metaGraph execute.! !

!OBEnhancementHierarchyBrowser class methodsFor: 'configuration' stamp: 'dr 2/15/2008 14:32'!
definitionPanel
     ^(self dynamicBrowser ifTrue: [OBEnrichedDefinitionPanel] ifFalse: [OBEnhancementDefinitionPanel]) new! !

!OBEnhancementHierarchyBrowser class methodsFor: 'configuration' stamp: 'dr 2/15/2008 14:29'!
dynamicBrowser
    ^false! !

!OBEnhancementHierarchyBrowser class methodsFor: 'configuration' stamp: 'dr 4/14/2008 16:44'!
optionalButtonPanel
	^ OBPlatform current optionalButtons ifTrue: [OBEnhancementFixedButtonPanel new]! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:49'!
browseHistory
    browseHistory ifNil: [browseHistory := OrderedCollection new].
    ^browseHistory! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:50'!
historyAtCursor
   ^self browseHistory at: self historyCursor ifAbsent: [nil]! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:50'!
historyCursor
    ^historyCursor ifNil: [0]! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:50'!
historyCursor: anInteger
    historyCursor := anInteger! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:50'!
historyIndexOnSwitch
    historyIndexOnSwitch ifNil: [historyIndexOnSwitch := 0].
    ^historyIndexOnSwitch! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:50'!
markSwitch
    historyIndexOnSwitch := self historyCursor.! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:50'!
resetHistoryIndexOnSwitch
    historyIndexOnSwitch := 0! !

!OBEnhancementHierarchyBrowser methodsFor: 'history' stamp: 'dr 4/14/2008 16:50'!
setHistory: aCollection
    browseHistory := aCollection! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/28/2008 15:21'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
     "to make sure that the enh. graph builder is also used if package browser is not default browser"
	^ (OBEnhancementMetagraphBuilder
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/15/2008 14:32'!
definitionPanel
     ^OBEnhancementDefinitionPanel new! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:36'!
hasReferencePanel
    ^self dynamicBrowser! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/25/2008 15:20'!
isHierarchyBrowser
    ^true! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 16:04'!
navigationPanel
	^OBEnhancementColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 3/12/2008 14:45'!
onClass: aClass selector: aSelector
     | methodNode |
     methodNode := OBMethodNode on: aSelector inClass: aClass.
	^ self root: aClass asNode selection: methodNode.! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/11/2008 12:05'!
openOnClass: aClass selector: aSelector
	^(self onClass: aClass selector: aSelector) open! !

OBMMethodSendersQuery subclass: #OBEnhancementMMethodSendersQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBEnhancementMMethodSendersQuery methodsFor: 'executing' stamp: 'dr 7/3/2008 11:03'!
find
	self searchNode hasOnlyOneResult
		ifTrue: [self browser jumpTo: self searchNode methodsInFirstClass first]
		ifFalse: [self openSearchInSameBrowserOn: self searchNode]! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:37'!
dynamicBrowser
    ^false! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/27/2008 15:43'!
hasHistoryButtons
    ^false! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 7/10/2008 12:15'!
hierarchySwitchIndex
     ^0! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 10/29/2008 16:11'!
packageSwitchIndex
     ^0! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 7/10/2008 12:15'!
smartGroupSwitchIndex
     ^0! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 7/18/2007 16:14'!
useMultipleSelection
    ^false! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:35'!
browseHistory
    ^OrderedCollection new! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/26/2008 16:48'!
clearHistoryAfter: anInteger
    "remove all following elements"
    self setHistory: (self browseHistory copyFrom: 1 to: anInteger).! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'jk 6/20/2007 17:23'!
cmdBrowseMethodImplementor
	^ OBCmdBrowseMethodImplementor! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'ab 6/5/2007 23:50'!
cmdBrowseTraitUser
	^OBCmdBrowseTraitUsers! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 16:18'!
cmdDisplayReferencingPlaces
	^OBCmdDisplayReferencingPlaces! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'ab 8/31/2007 19:09'!
cmdMoveMethodCategoryToTrait
	^ OBCmdMoveMethodCategoryToTrait! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'ab 8/31/2007 18:50'!
cmdMoveMethodToTrait
	^ OBCmdMoveMethodToTrait! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dc 4/23/2007 15:04'!
cmdNewTraitTemplate
	^ OBCmdNewTraitTemplate ! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dc 8/2/2007 17:51'!
cmdSUnitIntegration
	^ {  OBCmdTestPackage. OBCmdTestClass. OBCmdTestMethod. OBCmdTestProtocol }! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 9/22/2008 17:02'!
cmdTraitsIntegration
	^{OBCmdExcludeMethod. OBCmdExcludeClass}! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:32'!
hasBackHistory
    ^self hasHistory and: [self historyPrevious notNil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 17:44'!
hasForwardHistory  
    ^self hasHistory and: [self historyNext notNil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:24'!
hasHistory
    ^self browseHistory isEmpty not and: [self browseHistory last notNil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:09'!
historyAtCursor
    ^nil! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/26/2008 16:20'!
historyBack
    self browseHistory isEmpty ifTrue: [^false]. 
    ^self historyGoToIndex: self historyCursor - 1. ! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:56'!
historyBackNodes
    ^(self browseHistory copyFrom: 1 to: self historyCursor - 1) reversed reject: [:ea | ea isNil].! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:10'!
historyCursor
    ^0
! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:09'!
historyCursor: anInteger
! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 15:40'!
historyForward
    self browseHistory isEmpty ifTrue: [^false].
    ^self historyGoToIndex: self historyCursor + 1. ! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 17:22'!
historyForwardNodes "self halt."
    ^(self browseHistory copyFrom: self historyCursor + 1 to: self browseHistory size) reject: [:ea | ea isNil].! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 3/3/2008 11:34'!
historyGoToIndex: anInteger
    | node | "self halt."
    self browseHistory at: anInteger ifAbsent: [^false].
    self historyCursor: anInteger. 
    node := self historyAtCursor.
    node ifNotNil: [
        self historyIndexOnSwitch >= anInteger ifTrue: [
		  self setMetaNode: self class defaultMetaNode root: self class defaultRootNode. 
		  self clearHistoryAfter: anInteger.
		  self resetHistoryIndexOnSwitch]. 
	   self jumpTo: node. 
	   ^true
    ].

    ^false! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 17:50'!
historyIncrementCursor
   self historyCursor: self historyCursor + 1! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:29'!
historyNext
    ^self browseHistory at: self historyCursor + 1 ifAbsent: [nil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:48'!
historyNodes
    ^self browseHistory reject: [:ea | ea isNil].! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:29'!
historyPrevious
    ^self browseHistory at: self historyCursor - 1 ifAbsent: [nil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 5/9/2008 11:31'!
historyPush: aNode 
    aNode ifNotNil: [
	   self historyCursor < self browseHistory size ifTrue: [
		   self clearHistoryAfter: self historyCursor.
	   ]. 
	   self historyAtCursor = aNode ifFalse: [self browseHistory addLast: aNode. self historyIncrementCursor].
    ]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 11:25'!
historySizeOnSwitch
    ^0! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 11:28'!
resetHistorySize
    "do nothing"! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:47'!
setHistory: aCollection! !

!TraitTransformation methodsFor: '*ob-enhancements' stamp: 'jk 8/20/2007 15:13'!
asClassSideNodeOf: aParentNode 
	^ OBTraitTransformationMetaclassNode on: self of: aParentNode! !

!TraitTransformation methodsFor: '*ob-enhancements' stamp: 'jk 8/14/2007 11:42'!
asCommentNodeOf: aParentNode 
	^ OBTraitTransformationCommentNode on: self of: aParentNode! !

!TraitTransformation methodsFor: '*ob-enhancements' stamp: 'jk 12/18/2007 11:11'!
asNode
	^ OBClassNode on: self! !

!TraitTransformation methodsFor: '*ob-enhancements' stamp: 'jk 8/14/2007 08:53'!
asNodeOf: aParentNode
	^ OBTraitTransformationNode on: self of: aParentNode! !

OBFilter subclass: #OBClassAnnotationFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBClassAnnotationFilter methodsFor: 'filtering' stamp: 'dr 2/23/2008 16:10'!
icon: aSymbol forNode: aNode
     (Smalltalk classNamed: #HODataBase) ifNil: [^nil].
	^((Smalltalk at: #HODataBase) default includesClass: aNode theClass) ifTrue: [#flag] ifFalse: [#blank]! !

OBFilter subclass: #OBClassHierarchyFilter
	instanceVariableNames: 'columnPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBClassHierarchyFilter class methodsFor: 'instance creation' stamp: 'dr 2/25/2008 16:43'!
columnPanel: aColumnPanel
    ^self new columnPanel: aColumnPanel; yourself! !

!OBClassHierarchyFilter methodsFor: 'accessing' stamp: 'dr 2/25/2008 16:43'!
columnPanel: aColumnPanel
    columnPanel := aColumnPanel! !

!OBClassHierarchyFilter methodsFor: 'filtering' stamp: 'dr 3/12/2008 14:20'!
displayString: aStringOrText forParent: pNode child: cNode
	^ columnPanel root theNonMetaClass = cNode theNonMetaClass ifTrue: [aStringOrText asText addAttribute: TextEmphasis bold; yourself] ifFalse: [aStringOrText]! !

OBFilter subclass: #OBClassInheritanceFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBClassInheritanceFilter methodsFor: 'filtering' stamp: 'dr 12/12/2008 10:57'!
icon: aSymbol forNode: aNode
	| theClass passed failed ratio |
	theClass := aNode theNonMetaClass.
     theClass browserIcon ifNotNilDo: [:icon | ^icon].	

	(((theClass inheritsFrom: TestCase) and: [aNode methods anySatisfy: [:ref | ref selector beginsWith: 'test']])
	                                       and: [TestCase class includesSelector: #methodProgressed:]) ifTrue: [
		passed := theClass methodsPassed.
		failed := theClass methodsFailed.
		(failed size = 0 and: [passed size = 0]) ifTrue: [^ #testNotRun].
		failed size = 0 ifTrue: [^ #testGreen].
		passed size = 0 ifTrue: [^ #testRed].
		
		ratio := passed size / failed size.
		^ratio > 0.6 ifTrue: [#testMorePassed] ifFalse: [ratio < 0.4 ifTrue: [#testMoreFailed] ifFalse: [#testEqualPassedFailed]]].
	
     (theClass inheritsFrom: Exception) ifTrue: [^#exception].
	^#blank! !

OBFilter subclass: #OBMethodCategoryFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBMethodCategoryFilter methodsFor: 'filtering' stamp: 'dr 11/24/2008 15:45'!
displayString: aStringOrText forParent: pNode child: cNode
    | category |
    ((cNode reference actualClass includesSelector: cNode reference methodSymbol) 
        and: [cNode reference compiledMethod literals includes: #deprecated:])
           ifTrue: [^aStringOrText asText addAttribute: TextEmphasis struckOut].

    category := cNode category.
    (category beginsWith: '*') ifTrue: [
	    ^(category includesSubString: '-overrides') 
	        ifTrue: [aStringOrText asText addAttribute: TextEmphasis italic; addAttribute: TextColor red]	
	        ifFalse: [aStringOrText asText addAttribute: TextEmphasis italic]].

    ^aStringOrText ! !

!OBMethodCategoryFilter methodsFor: 'filtering' stamp: 'dr 12/22/2008 14:05'!
icon: aSymbol forNode: aNode 
	| theClass methodReferences |
	theClass _ aNode theNonMetaClass.
	methodReferences _ aNode methodReferences.
	
	((theClass inheritsFrom: TestCase) and: [TestCase class includesSelector: #methodProgressed:]) ifTrue: [
		(methodReferences anySatisfy: [:ref | ref methodSymbol beginsWith: 'test']) ifTrue: [ | passed failed  ratio |
			passed _ theClass methodsPassed reject: [:symbol | methodReferences noneSatisfy: [:ref | ref methodSymbol = symbol]].
			failed _ theClass methodsFailed reject: [:symbol | methodReferences noneSatisfy: [:ref | ref methodSymbol = symbol]].
			(failed size = 0 and: [passed size = 0]) ifTrue: [^ #testNotRun].
			failed size = 0 ifTrue: [^ #testGreen].
			passed size = 0 ifTrue: [^ #testRed].
		
			ratio _ passed size / failed size.
			^ratio > 1.2 ifTrue: [#testMorePassed] ifFalse: [ratio < 0.8 ifTrue: [#testMoreFailed] ifFalse: [#testEqualPassedFailed]].			
		] ifFalse: [^#blank]].

	(Smalltalk hasClassNamed: #HODataBase) ifFalse: [^ nil].
	^ (methodReferences anySatisfy:
		[ : methodRef | 
		(Smalltalk at: #HODataBase) default isInstrumentedMethod: methodRef ]) 
		ifTrue: [ #flag ]
		ifFalse: [ #blank ]! !

OBFilter subclass: #OBSearchQueryFilter
	instanceVariableNames: 'searchNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBSearchQueryFilter class methodsFor: 'instance creation' stamp: 'dr 5/14/2008 14:24'!
on: aSearchNode
    ^self new setSearchNode: aSearchNode! !

!OBSearchQueryFilter methodsFor: 'filtering' stamp: 'dr 5/14/2008 16:19'!
displayString: aString forNode: aNode
     (searchNode methodSatisfiesQuery: aNode reference) ifTrue: [^aString asText addAttribute: TextColor red].
     ^aString! !

!OBSearchQueryFilter methodsFor: 'accessing' stamp: 'dr 5/14/2008 14:24'!
setSearchNode: aSearchNode
    searchNode := aSearchNode! !

OBFilter subclass: #OBTraitConflictMethodFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBTraitConflictMethodFilter methodsFor: 'filtering' stamp: 'jk 8/29/2007 11:41'!
displayString: aString forNode: aNode
	^ aNode isConflict 
		ifTrue: [aString asText addAttribute: TextColor red] 
		ifFalse: [aString]! !

OBFilter subclass: #OBTraitRequiredMethodFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBTraitRequiredMethodFilter methodsFor: 'filtering' stamp: 'jk 8/30/2007 10:36'!
displayString: aString forNode: aNode
	^ aNode isRequired 
		ifTrue: [aString asText addAttribute: TextColor blue] 
		ifFalse: [aString]! !

OBFilter subclass: #OBTraitSortFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBTraitSortFilter methodsFor: 'filtering' stamp: 'jk 8/20/2007 15:37'!
displayString: aString forParent: pNode child: cNode
	^ (String new: cNode numberOfPredecessors withAll: $ ), aString! !

!MCFileBasedRepository methodsFor: '*ob-enhancements' stamp: 'dr 12/14/2007 14:35'!
versionsAvailableForPackage: aPackage
    ^self allVersionNames select: [:versionName | versionName beginsWith: aPackage packageName]! !

PluggableTreeItemNode subclass: #OBPluggableTreeItemWithParentNode
	instanceVariableNames: 'parent position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tree'!

!OBPluggableTreeItemWithParentNode commentStamp: 'jk 12/9/2007 13:35' prior: 0!
A PluggableTreeItemWithParentNode is wrapper for items in OBPluggableTreeMorph instances. Each instance remembers its parent wrapper (same kind of instance) and position in a subtree.

Instance Variables
	parent:		<PluggableTreeItemWithParentNode>
	position:		<Number>

parent
	- parent wrapper

position
	- position in subtree (among siblings)
!

!OBPluggableTreeItemWithParentNode class methodsFor: 'as yet unclassified' stamp: 'jk 11/28/2007 14:26'!
with: item parent: parent model: model
	^ (self with: item model: model) parent: parent ! !

!OBPluggableTreeItemWithParentNode class methodsFor: 'as yet unclassified' stamp: 'jk 12/8/2007 15:27'!
with: item parent: parent position: index model: model 
	^ (self 
		with: item
		parent: parent
		model: model) position: index! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'dr 1/20/2009 19:38'!
backgroundColor
	^(model model childAt: self fullPosition) ifNotNilDo: [:node | node backgroundColor]! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'dr 12/9/2008 20:00'!
fullPosition
	| positions node |
	positions := OrderedCollection new. 
	node := self.
	[node isNullParent] whileFalse: [
		positions addFirst: node position.
		node := node parent.
	].
	^positions asArray! !

!OBPluggableTreeItemWithParentNode methodsFor: 'testing' stamp: 'jk 12/8/2007 16:06'!
hasParent
	^ self parent notNil! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'dr 12/9/2008 20:21'!
highlightingColor
	^self backgroundColor ifNotNil: [Color blue] ifNil: [Color red]! !

!OBPluggableTreeItemWithParentNode methodsFor: 'testing' stamp: 'dr 11/19/2008 11:42'!
isNullParent
	^false! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'dr 9/22/2008 11:50'!
parent
	^ parent ifNil: [ parent := OBNullParent new ]! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'jk 11/28/2007 14:18'!
parent: anObject
	parent := anObject! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'jk 12/9/2007 13:28'!
path
	^ self parent path add: self position; yourself! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'jk 12/8/2007 15:25'!
position
	^ position! !

!OBPluggableTreeItemWithParentNode methodsFor: 'accessing' stamp: 'jk 12/8/2007 15:25'!
position: anObject
	position := anObject! !

!OBClassSortFilter methodsFor: '*ob-enhancements' stamp: 'dr 9/24/2008 16:13'!
indents
    ^indents! !

!OBClassSortFilter methodsFor: '*ob-enhancements' stamp: 'dr 9/29/2008 10:53'!
initialize
    super initialize.
    indents := Dictionary new.! !

OBClassSortFilter subclass: #OBQueryingClassSortFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBQueryingClassSortFilter methodsFor: 'filtering' stamp: 'dr 9/25/2008 11:12'!
displayString: aStringOrText forParent: pNode child: cNode
   (pNode isSmartAlias and: [pNode node isSearch and: [pNode node isFrequencySearch]]) ifFalse: [
       ^super displayString: aStringOrText forParent: pNode child: cNode.
   ].
   ^aStringOrText! !

!OBQueryingClassSortFilter methodsFor: 'filtering' stamp: 'dr 12/10/2008 10:40'!
icon: aSymbol forNode: aNode 
	aNode isDummy ifTrue: [^#blank].
	aNode moreRecentOnServer ifTrue: [^#moreRecentOnServer]. 
	^aNode modified ifTrue: [#dirtyPackage] 
	                    ifFalse: [#package]! !

!OBQueryingClassSortFilter methodsFor: 'filtering' stamp: 'dr 10/23/2008 10:25'!
nodesFrom: nodes forNode: pNode 
   (pNode isSmartAlias and: [pNode node isSearch and: [pNode node isFrequencySearch]]) ifFalse: [
       ^super nodesFrom: nodes forNode: pNode.
   ].
   ^nodes! !

!TraitBehavior methodsFor: '*ob-enhancements' stamp: 'dr 1/20/2009 20:16'!
allSubclassesWithLevelDo: classAndLevelBlock startingLevel: level ! !

!OBTextPanel methodsFor: '*ob-enhancements' stamp: 'dr 10/20/2008 16:43'!
notifyMouseEnter
    "do nothing"! !

OBCmdRemoveMethod subclass: #OBCmdRemoveLocalMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdRemoveLocalMethod methodsFor: 'testing' stamp: 'jk 9/21/2007 00:59'!
isActive
	^ super isActive and: [target isLocalSelector]! !

!OBMetaEdge methodsFor: '*ob-enhancements' stamp: 'dr 9/12/2008 11:48'!
navigateTree
	self navigation: OBTreeEdgeNavigation new! !

OBMethodCategoryNode subclass: #OBMethodCategoryExtensionNode
	instanceVariableNames: 'classExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMethodCategoryExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:13'!
classExtensionNode
    ^classExtensionNode! !

!OBMethodCategoryExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:13'!
classExtensionNode: aClassExtensionNode
    classExtensionNode := aClassExtensionNode! !

!OBMethodCategoryExtensionNode methodsFor: 'displaying' stamp: 'dr 3/5/2008 16:11'!
displayString
    | text |
    text := super displayString asText.
    (self category asString asLowercase allButFirst beginsWith: self extensionName asLowercase) ifTrue: [
	   text addAttribute: TextEmphasis bold.
	   (self category includesSubString: '-overrides') ifTrue: [text addAttribute: TextColor red].	   	      
    ].
    ^text! !

!OBMethodCategoryExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:16'!
extensionName
   ^self classExtensionNode extensionName! !

!OBMethodCategoryExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 14:13'!
isDescendantOfClass: aClassNode
   ^((super isDescendantOfClass: aClassNode) and: [aClassNode isKindOf: OBClassExtensionNode]) 
                                                    and: [self classExtensionNode = aClassNode]! !

!OBMethodCategoryExtensionNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 17:23'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self classExtensionNode package ifFalse: [^false].
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.
! !

!OBMethodCategoryExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 11:50'!
isDescendantOfMethodCat: other
   ^(super isDescendantOfMethodCat: other) and: [self class = other class]! !

!OBMethodCategoryExtensionNode methodsFor: 'navigating' stamp: 'dr 2/24/2008 15:26'!
methods
   ^self methodReferences collect: [:ea | (OBMethodExtensionNode on: ea) categoryExtensionNode: self; yourself]! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:34'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 10/21/2008 09:26'!
fullName
    ^self name! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:07'!
isMethodHolderNode
    ^true! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 12/16/2008 15:44'!
runTestCommandClass
	"answer cmd class to run tests of this type of node"
	^OBCmdTestProtocol! !

OBMethodCategoryNode subclass: #OBPackageMethodCategoryNode
	instanceVariableNames: 'packageNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackageMethodCategoryNode methodsFor: 'displaying' stamp: 'dr 10/21/2008 09:27'!
fullName
    | catText cat |
    cat := self name. 
    catText := self name asText.
    (packageNode realClasses includes: theClass theNonMetaClass) ifTrue: [
	   ^(cat beginsWith: '*') ifTrue: [catText addAttribute: TextEmphasis italic] ifFalse: [catText].
    ] ifFalse: [
	   ^((cat beginsWith: '*') and: [cat allButFirst asLowercase beginsWith: packageNode name asLowercase]) 
	       ifTrue: [catText addAttribute: TextEmphasis bold] ifFalse: [catText addAttribute: TextEmphasis italic].        
    ]! !

!OBPackageMethodCategoryNode methodsFor: 'navigating' stamp: 'dr 7/10/2008 16:01'!
methods
    ^self methodReferences collect: [:ea | (OBPackageMethodNode on: ea) packageNode: packageNode]! !

!OBPackageMethodCategoryNode methodsFor: 'accessing' stamp: 'dr 7/10/2008 15:22'!
packageNode: aPackageNode
    packageNode := aPackageNode! !

OBAutoSelection subclass: #OBPreviousAutoSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBPreviousAutoSelection commentStamp: 'dr 1/28/2009 15:05' prior: 0!
Automatically select methods with the same selector as the method had we previously selected. !

!OBPreviousAutoSelection methodsFor: 'selecting' stamp: 'dr 1/28/2009 16:04'!
autoSelection
	^fan lastNode ifNotNil: [fan children detect: [:ea | ea selector = fan lastNode selector] ifNone: [nil]]! !

OBPreviousAutoSelection subclass: #OBPreviousWithSingleAutoSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBPreviousWithSingleAutoSelection commentStamp: 'dr 1/28/2009 15:08' prior: 0!
Automatically select methods with the same selector as the method had we previously selected and also select automatically for a method protocol with just one method inside this single method. !

!OBPreviousWithSingleAutoSelection methodsFor: 'selecting' stamp: 'dr 1/29/2009 11:08'!
autoSelection
	fan children size = 1 ifTrue: [fan setLastNode: fan children first. ^fan children first].
	^super autoSelection! !

OBAutoSelection subclass: #OBSmartGroupAutoSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBSmartGroupAutoSelection commentStamp: 'dr 1/28/2009 15:07' prior: 0!
Automatically select the first method in the search results that satisfy the search query. !

!OBSmartGroupAutoSelection methodsFor: 'selecting' stamp: 'dr 1/28/2009 15:03'!
autoSelection
	^fan children detect: [:ea | metaNode methodSatisfiesQuery: ea reference] ifNone: [nil].	! !

OBMetaNode subclass: #OBEnhancementMetaNode
	instanceVariableNames: 'updateOnAutoSelect doubleClickCommandClass searchNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementMetaNode methodsFor: 'searching' stamp: 'dr 5/15/2008 14:35'!
addSearchNode: aSearchNode
    searchNode := aSearchNode! !

!OBEnhancementMetaNode methodsFor: 'double-clicking' stamp: 'dr 4/21/2008 10:16'!
doubleClickCommandClass
    ^doubleClickCommandClass! !

!OBEnhancementMetaNode methodsFor: 'double-clicking' stamp: 'dr 9/19/2008 16:22'!
doubleClickCommandClass: aCommandClass
    doubleClickCommandClass := aCommandClass! !

!OBEnhancementMetaNode methodsFor: 'searching' stamp: 'dr 5/15/2008 14:36'!
methodSatisfiesQuery: methodRef
    searchNode ifNil: [^false].
    ^searchNode methodSatisfiesQuery: methodRef! !

!OBEnhancementMetaNode methodsFor: 'auto-selecting' stamp: 'dr 2/13/2008 16:15'!
shouldUpdateOnAutoSelect
    updateOnAutoSelect ifNotNil: [^updateOnAutoSelect].
    ^false
    ! !

!OBEnhancementMetaNode methodsFor: 'auto-selecting' stamp: 'dr 2/13/2008 15:48'!
updateOnAutoSelect
    updateOnAutoSelect := true
    ! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 5/14/2008 15:15'!
addEdge: anEdge
    edges add: anEdge! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 9/12/2008 09:57'!
childrenFromEdges: aCollection forNode: aNode
	^ aCollection gather: 
		[:edge | 
		filters 
			inject: (edge nodesForParent: aNode)
			into: [:list :filter | filter nodesFrom: list forNode: aNode]].! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'jk 12/18/2007 09:34'!
childrenWithinTreeForNode: aNode 
	| chosenEdges |
	chosenEdges := self edgesWithTreeNavigationForNode: aNode.
	^ self childrenFromEdges: chosenEdges forNode: aNode
! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 10/28/2008 10:30'!
doubleClickCommandClass
    ^nil! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 9/15/2008 11:19'!
edgesWithDefaultNavigationForNode: aNode 
	| chosenEdges |
	chosenEdges := self edgesForNode: aNode.
	^chosenEdges select: [:chosenEdge | chosenEdge isDefaultNavigation].! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'jk 12/18/2007 09:32'!
edgesWithTreeNavigationForNode: aNode 
	| chosenEdges |
	chosenEdges := self edgesForNode: aNode.
	chosenEdges := chosenEdges select: [:chosenEdge | chosenEdge isTreeEdge].
	^ chosenEdges! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 9/19/2008 16:29'!
next
    ^self edges ifNotEmpty: [(self edges reject: [:edge | edge isTreeEdge]) first metaNode] ifEmpty: [nil]! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 5/15/2008 15:34'!
removeChildAt: aSymbol
    | edge |
    edge := edges detect: [:ea | ea name = aSymbol] ifNone: [nil].
    edge ifNotNil: [edges remove: edge]! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 4/25/2008 11:33'!
removeFilter: aFilter
    filters removeAllSuchThat: [:filter | filter class = aFilter class]! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:53'!
shouldUpdateOnAutoSelect
    ^false! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 4/29/2008 10:08'!
supportsDoubleClick
    ^self doubleClickCommandClass notNil! !

OBClassCommentNode subclass: #OBClassCommentExtensionNode
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBClassCommentExtensionNode methodsFor: 'ancestry' stamp: 'dr 9/17/2008 11:43'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self package ifFalse: [^false].
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.! !

!OBClassCommentExtensionNode methodsFor: 'ancestry' stamp: 'dr 9/17/2008 11:43'!
isDescendantOfPackage: aNode
     aNode isPackage ifTrue: [^self package = aNode].
	^false! !

!OBClassCommentExtensionNode methodsFor: 'ancestry' stamp: 'dr 9/17/2008 11:43'!
name 
	^Text string: super name asString emphasis: {TextEmphasis italic} ! !

!OBClassCommentExtensionNode methodsFor: 'ancestry' stamp: 'dr 9/17/2008 11:43'!
package
	^ package! !

!OBClassCommentExtensionNode methodsFor: 'ancestry' stamp: 'dr 9/17/2008 11:43'!
package: aPackageNode
	package := aPackageNode ! !

!OBClassCommentNode methodsFor: '*ob-enhancements' stamp: 'dr 10/21/2008 14:00'!
hasComment
    ^theClass hasComment! !

!OBClassCommentNode methodsFor: '*ob-enhancements' stamp: 'dr 7/11/2008 16:28'!
indentedName
    ^self name! !

!OBClassCommentNode methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 16:52'!
isDescendantOfClass: aClass
    ^self class = aClass class and: [super isDescendantOfClass: aClass]! !

!OBClassCommentNode methodsFor: '*ob-enhancements' stamp: 'dr 11/5/2007 16:55'!
isDescendantOfMethodCat: aString
    ^false! !

!OBClassCommentNode methodsFor: '*ob-enhancements' stamp: 'dr 12/15/2008 16:17'!
methods
	^#()! !

OBClassCommentNode subclass: #OBTraitTransformationCommentNode
	uses: OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBTraitTransformationCommentNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:26'!
nestedObject
	^ transformation! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:26'!
nestedObject: anObject
	transformation := anObject! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:27'!
parentNode
	^ parentNode! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:27'!
parentNode: anObject
	parentNode := anObject! !

OBClassCommentNode subclass: #OBUsedTraitCommentNode
	uses: OBTParentNode - {#theClass. #name}
	instanceVariableNames: 'parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBUsedTraitCommentNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:01'!
nestedObject
	^ self theClass! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:01'!
nestedObject: anObject
	self theClass: anObject ! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:46'!
parentNode
	^ parentNode! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:47'!
parentNode: anObject
	parentNode := anObject ! !

!OBPluggableTextMorph methodsFor: '*ob-enhancements' stamp: 'dr 10/20/2008 17:48'!
handleMouseDown: event
	super handleMouseDown: event.
	model notifyMouseEnter.! !

!OBPluggableTextMorph methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 16:15'!
removeIcons! !

!Class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:09'!
asEnhancedNode
	((self respondsTo: #isInstrumented) and: [self isInstrumented]) ifTrue: [
		^OBEnrichedClassNode on: ((Smalltalk at: #HODataBase) default modelClassFor: self).
	].
	^ OBClassNode on: self

! !

MethodReference subclass: #MethodExtensionReference
	instanceVariableNames: 'categoryExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!MethodExtensionReference methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:10'!
asNode
	^((self category asString asLowercase copyFrom: 2 to: self category size) beginsWith: self extensionName asLowercase)
			ifTrue: [(OBMethodExtensionNode on: self) categoryExtensionNode: categoryExtensionNode; yourself]
			ifFalse: [OBMethodNode on: self]! !

!MethodExtensionReference methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:00'!
categoryExtensionNode: aCategoryExtensionNode
	categoryExtensionNode := aCategoryExtensionNode! !

!MethodExtensionReference methodsFor: 'accessing' stamp: 'dr 2/24/2008 13:58'!
extensionName
	^categoryExtensionNode extensionName! !

!MethodReference methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:10'!
asEnhancedNode
	((self respondsTo: #isInstrumented) and: [self isInstrumented]) ifTrue: [
		^OBEnrichedMethodNode on: ((Smalltalk at: #HODataBase) default modelMethodFor: self).
	].
	^OBMethodNode on: self   ! !

!MethodReference methodsFor: '*ob-enhancements' stamp: 'dr 10/8/2007 15:41'!
prettyName
    ^self actualClass name, ' >> ', methodSymbol! !

!ClassTrait methodsFor: '*ob-enhancements' stamp: 'dc 4/21/2007 15:33'!
asClassSideNode
	^ OBMetaclassNode on: self baseTrait
! !

!ClassTrait methodsFor: '*ob-enhancements' stamp: 'jk 8/23/2007 16:59'!
asClassSideNodeOf: aParentNode 
	^ OBUsedTraitMetaclassNode on: self of: aParentNode! !

!ClassTrait methodsFor: '*ob-enhancements' stamp: 'dc 4/21/2007 15:33'!
asNode
	^ OBMetaclassNode on: self
! !

!ClassTrait methodsFor: '*ob-enhancements' stamp: 'jk 8/23/2007 16:57'!
asNodeOf: aParentNode
	^ OBUsedTraitNode on: self of: aParentNode! !

Object subclass: #OBDummyPackage
	instanceVariableNames: 'categories packageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBDummyPackage commentStamp: 'dr 7/16/2007 10:42' prior: 0!
I am a dummy for a Monticello package. I am used for class categories existing in the image that are not contained in any Monticello package. I list all these ownerless class categories in alphabetical order. !

!OBDummyPackage class methodsFor: 'instance creation' stamp: 'dr 7/22/2007 12:00'!
categories: aCollection
    ^self new categories: aCollection! !

!OBDummyPackage class methodsFor: 'instance creation' stamp: 'dr 7/11/2008 10:56'!
packageName: aString
    ^self new packageName: aString; yourself! !

!OBDummyPackage methodsFor: 'converting' stamp: 'dr 10/24/2008 10:30'!
asNode
	^OBMonticelloPackageNode new workingCopy: self! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 6/18/2007 17:10'!
categories
    ^categories! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 6/18/2007 17:09'!
categories: aCollection
    categories := aCollection! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 9/15/2008 14:38'!
cats
    ^self categories collect: [:classCategory | OBMonticelloClassCategoryNode on: classCategory].! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:09'!
classes
    ^(self categories gather: 
		[:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]])
				sortBy: [:a :b | a className <= b className]! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:10'!
extensionClasses
    ^OrderedCollection new! !

!OBDummyPackage methodsFor: 'testing' stamp: 'dr 10/24/2008 11:00'!
includesCategoryWithName: aString
    ^self categories includes: aString! !

!OBDummyPackage methodsFor: 'initializing' stamp: 'dr 7/11/2008 10:56'!
initialize
    categories := OrderedCollection new.! !

!OBDummyPackage methodsFor: 'testing' stamp: 'dr 7/11/2008 11:02'!
isDummyPackage
    ^true! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 16:57'!
modified
    ^false! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:08'!
packageInfo
    ^self! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 7/11/2008 10:55'!
packageName
    packageName ifNotNil: [^packageName].
    ^'Unpackaged'! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 7/11/2008 10:55'!
packageName: aString
    packageName := aString! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 7/11/2008 11:00'!
possiblyNewerVersionsIn: repository
    ^#()! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 10/24/2008 10:27'!
removeCategory: aString
    ^self categories remove: aString! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 16:57'!
repositories
    ^OrderedCollection new! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 7/3/2008 17:35'!
repositoryGroup
    ^MCRepositoryGroup new! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 9/2/2008 15:13'!
systemCategoryPrefix
    ^''! !

Object subclass: #OBNullParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tree'!

!OBNullParent commentStamp: 'jk 12/9/2007 13:31' prior: 0!
A NullParent is representation of a parent node for PluggableTreeItemWithParentNode.

It corresponds to Null Design Pattern.!

!OBNullParent methodsFor: 'testing' stamp: 'dr 11/19/2008 11:43'!
isNullParent
	^true! !

!OBNullParent methodsFor: 'accessing' stamp: 'jk 12/9/2007 13:27'!
path
	^ OrderedCollection new! !

Object subclass: #OBPackageOrganizer
	instanceVariableNames: 'packages'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBPackageOrganizer class methodsFor: 'instance creation' stamp: 'dr 11/19/2008 15:03'!
default
	Instance ifNil: [Instance := self new].
	^Instance! !

!OBPackageOrganizer methodsFor: 'accessing' stamp: 'dr 11/19/2008 15:44'!
changeFromString: aString 
	"Parse the argument, aString, and make this be the receiver's structure."

	| packageSpecs |
	packageSpecs := Scanner new scanTokens: aString.
	packageSpecs isEmpty ifTrue: [^ (packages := OrderedCollection new)].
	
	packages := OrderedCollection new.
	packageSpecs do: [:arr | packages add: (MCWorkingCopy forPackage: (MCPackage named: arr first))].! !

!OBPackageOrganizer methodsFor: 'initialization' stamp: 'dr 12/1/2008 15:05'!
initialize
	self reset! !

!OBPackageOrganizer methodsFor: 'accessing' stamp: 'dr 11/19/2008 15:05'!
packages
	^packages! !

!OBPackageOrganizer methodsFor: 'private' stamp: 'dr 11/19/2008 15:24'!
packagesInDefaultOrder
	| allPackages uniquePackages |
	allPackages := OBPackagesOrClassesNode new packagesInDefaultOrder reject: [:ea | ea isDummy].
	uniquePackages := OrderedCollection new.
	allPackages do: [:ea | (uniquePackages includes: ea) ifFalse: [uniquePackages add: ea]].
	^uniquePackages
	! !

!OBPackageOrganizer methodsFor: 'printing' stamp: 'dr 11/19/2008 15:40'!
printOn: aStream
     | pkgs |
	pkgs := packages.
	pkgs ifEmpty: [pkgs := self packagesInDefaultOrder].
	
	1 to: pkgs size do: 
		[:i | 
		aStream nextPut: $(.
		(pkgs at: i) packageName printOn: aStream.
		aStream nextPut: $); cr]! !

!OBPackageOrganizer methodsFor: 'printing' stamp: 'dr 11/19/2008 15:01'!
printString
	^String streamContents: [:stream | self printOn: stream].! !

!OBPackageOrganizer methodsFor: 'initialization' stamp: 'dr 12/1/2008 15:05'!
reset
	packages := OrderedCollection new.! !

Object subclass: #OBReferenceList
	instanceVariableNames: 'panel children selection textMorph referencedNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBReferenceList class methodsFor: 'instance creation' stamp: 'dr 10/11/2007 17:05'!
panel: aPanel
    ^self new setPanel: aPanel! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/15/2007 10:59'!
addCommandsToMenu: aMenu 
	| scan |
	scan := self announce: OBNodeCommandScan.
	self hasSelection 
		ifTrue: 
			[scan 
				populateMenu: aMenu
				withNode: self selectedNode
				forRequestor: self
				filter: [:cmd | cmd isReferenceListCmd and: [cmd isActive]]]! !

!OBReferenceList methodsFor: 'updating' stamp: 'dr 10/15/2007 10:50'!
announce: anAnnouncement 
	^panel announce: anAnnouncement! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/15/2007 10:52'!
browser
    ^panel browser! !

!OBReferenceList methodsFor: 'building' stamp: 'dr 10/12/2007 10:28'!
buildOn: aBuilder 
	^aBuilder referenceList: self with: []! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 14:20'!
children
     children ifNil: [self refreshChildren].
     ^children! !

!OBReferenceList methodsFor: 'building' stamp: 'dr 10/12/2007 14:35'!
createTitleBar
	| titleBar |		
	titleBar := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
			
	titleBar addMorphBack: self textMorph.			
	^titleBar! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/30/2008 09:49'!
currentNode
    | curNode |
    curNode := panel currentNode.
    (curNode notNil and: [curNode isMethodCategoryNode]) ifTrue: [curNode := OBClassNode on: curNode theClass].
    ^curNode! !

!OBReferenceList methodsFor: 'building' stamp: 'dr 10/12/2007 14:34'!
defaultWidth
    ^160! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:00'!
dragEnabled
	^false! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:00'!
dropEnabled
	^false! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/12/2007 13:33'!
hasReferences
    ^self children notEmpty! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/15/2007 10:50'!
hasSelection
	^ self selection > 0! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:17'!
iconAt: index 
	^(self children at: index) icon! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/15/2007 10:49'!
isEmpty
    ^self children isEmpty! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/15/2007 10:51'!
isSelected: aNode
	^ self selectedNode == aNode! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/15/2007 10:47'!
jumpTo: aNode
    panel browser jumpTo: aNode asClassNode.! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 16:59'!
keystroke: aChar from: aMorph! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:17'!
list
	^self children collect: [:ea | ea displayString]! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:16'!
listAt: index 
	^(self children at: index ifAbsent: [^'']) displayString! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 16:58'!
listSize
    ^self children size! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 14:23'!
listTitle
    ^self hasReferences ifTrue: ['References in ', self currentNode prefixedName] ifFalse: [' ']! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/15/2007 10:48'!
menu: aMenu 
	self isEmpty ifFalse: [self addCommandsToMenu: aMenu].
	^aMenu! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/15/2007 16:53'!
referencedNode
    ^referencedNode! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 11/5/2007 16:45'!
refreshChildren
     children := self currentNode ifNotNilDo: [:node | node referencingClasses] ifNil: [OrderedCollection new]! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/15/2007 11:20'!
selectReferencingCodeNodes: aCollection
    panel selectReferencingCodeNodes: aCollection! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/16/2007 10:01'!
selectReferencingMethods: aCollection
    | column |
    column := panel browser navigationPanel columns last.
    column children do: [:node | (aCollection includes: node reference) ifTrue: [node setIsHighlighted] ifFalse: [node setUnhighlighted]].
    column changed: #list.
    referencedNode := self selectedNode.! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/15/2007 10:51'!
selectedNode
	^self children at: self selection ifAbsent: [].! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 11/5/2007 16:50'!
selection 
	(selection isNil or: [selection = 0]) ifTrue: [
		 self referencedNode ifNotNil: [selection := self children indexOf: self referencedNode ifAbsent: [0]] ifNil: [^0]].
	^selection! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/15/2007 10:38'!
selection: anInteger
	selection := anInteger.
	self changed: #selection.
	"panel browser jumpTo: (self children at: anInteger) asClassNode."! !

!OBReferenceList methodsFor: 'updating' stamp: 'dr 11/20/2007 10:09'!
selectionChanged: ann
    "do not change list if the current node's parent might have references (eg method protocol nodes)" 
    ((self currentNode notNil and: [self currentNode isNodeWithReferences not]) and: [self currentNode respondsTo: #theClass]) ifTrue: [^self].

    selection := 0.
    self refreshChildren.
    self changed: #list.
    self updateText.! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/11/2007 17:06'!
setPanel: aPanel
    panel := aPanel! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 14:11'!
textMorph
    textMorph ifNil: [textMorph := TextMorph new. self updateText].
    ^textMorph! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 13:30'!
title
    ^'References in ', self currentNode name! !

!OBReferenceList methodsFor: 'updating' stamp: 'dr 10/12/2007 14:33'!
updateText
    | text |
    text := Text string: self listTitle attribute: TextEmphasis bold.
    self textMorph contents: text wrappedTo: 160! !

Object subclass: #OBTreeEdgeNavigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tree'!

!OBTreeEdgeNavigation methodsFor: 'comparing' stamp: 'jk 4/2/2008 12:58'!
= anObject 
	^ self class = anObject class! !

!OBTreeEdgeNavigation methodsFor: 'navigation' stamp: 'dr 9/22/2008 17:09'!
columnAfter: currentColumn withFan: aFan selection: anInteger
	| newIndex |
	newIndex := aFan restrictToTreeChildrenAndAdjustSelection: anInteger.
	^ currentColumn nextColumnForTreeNavigationWithFan: aFan selection: newIndex! !

!OBTreeEdgeNavigation methodsFor: 'testing' stamp: 'jk 12/29/2007 14:54'!
isDefaultNavigation
	^ false! !

!OBTreeEdgeNavigation methodsFor: 'testing' stamp: 'jk 12/29/2007 14:55'!
isTreeNavigation
	^ true! !

Object subclass: #OBTreeNodeMediator
	instanceVariableNames: 'fan subTreeNodeMediators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tree'!

!OBTreeNodeMediator commentStamp: 'dr 9/12/2008 15:59' prior: 0!
I represent a tree node that manages the node's fan (represented by OBFan) and subtree nodes.

Instance Variables
	fan:		<Object>
	subfans:		<Object>

fan
	- xxxxx

subfans
	- xxxxx
!

!OBTreeNodeMediator class methodsFor: 'instance creation' stamp: 'dr 12/15/2008 18:48'!
fan: aFan 
	^ self new fan: aFan ! !

!OBTreeNodeMediator class methodsFor: 'instance creation' stamp: 'dr 12/15/2008 18:47'!
parent: aNode
	^ self new! !

!OBTreeNodeMediator methodsFor: 'accessing' stamp: 'dr 9/12/2008 10:01'!
autoSelection
   ^nil! !

!OBTreeNodeMediator methodsFor: 'fan' stamp: 'dr 10/24/2008 21:48'!
currentOrNewFanWithParentAt: anInteger
     | newFan oldFan |
     newFan := (self fan childAt: anInteger) asFan.
     oldFan := self subTreeNodeMediators at: anInteger ifAbsent: [ nil ].
	oldFan = newFan ifFalse: [self subTreeNodeMediators at: anInteger put: newFan asTreeFan].
     ^newFan
	"^ (self subTreeNodeMediators 
		at: anInteger
		ifAbsentPut: [ (self fan childAt: anInteger) asFan asTreeFan ]) fan"! !

!OBTreeNodeMediator methodsFor: 'accessing' stamp: 'dr 9/23/2008 15:09'!
fan
	^ fan! !

!OBTreeNodeMediator methodsFor: 'accessing' stamp: 'dr 12/18/2008 15:24'!
fan: anObject 
	fan := anObject! !

!OBTreeNodeMediator methodsFor: 'fan' stamp: 'jk 12/31/2007 15:34'!
fanAt: anArray 
	^ anArray size > 1 
		ifTrue: [(self treeFanAt: anArray first) fanAt: anArray allButFirst]
		ifFalse: [self fan]! !

!OBTreeNodeMediator methodsFor: 'fan' stamp: 'jk 12/31/2007 15:46'!
fanWithParentNodeAt: anOrderedCollection 
	^ anOrderedCollection size > 1
		ifTrue: [(self treeFanAt: anOrderedCollection first) 
					fanWithParentNodeAt: anOrderedCollection allButFirst]
		ifFalse: [self currentOrNewFanWithParentAt: anOrderedCollection first]! !

!OBTreeNodeMediator methodsFor: 'compatibility' stamp: 'dr 9/23/2008 16:55'!
lastNode
    ^nil! !

!OBTreeNodeMediator methodsFor: 'node' stamp: 'dr 9/11/2008 17:26'!
nodeAt: anArray 
	^ (self fanAt: anArray) ifNotNilDo: [:node | node childAt: anArray last] ifNil: [nil].! !

!OBTreeNodeMediator methodsFor: 'subfan' stamp: 'dr 9/18/2008 16:32'!
parent: aTreeFan at: anInteger 
	aTreeFan putTreeFan: self at: anInteger! !

!OBTreeNodeMediator methodsFor: 'printing' stamp: 'dr 9/23/2008 15:03'!
printOn: aStream
	aStream
		nextPutAll: 'TreeNodeMediator <'.
	self fan printOn: aStream.
	aStream
		nextPut: $>! !

!OBTreeNodeMediator methodsFor: 'fan' stamp: 'dr 9/18/2008 16:51'!
putFan: aFan at: anArray 
	^ self putTreeFan: aFan asTreeFan atSubtree: anArray! !

!OBTreeNodeMediator methodsFor: 'subfan' stamp: 'dr 9/23/2008 15:08'!
putTreeFan: aTreeNodeMediator at: anInteger 
	^ self subTreeNodeMediators 
		at: anInteger
		put: aTreeNodeMediator! !

!OBTreeNodeMediator methodsFor: 'subfan' stamp: 'dr 9/23/2008 15:08'!
putTreeFan: aTreeNodeMediator atSubtree: anArray 
	^ anArray size > 1 
		ifTrue: 
			[ (self subTreeNodeMediators at: anArray first) 
				putTreeFan: aTreeNodeMediator
				atSubtree: anArray allButFirst ]
		ifFalse: 
			[ self 
				putTreeFan: aTreeNodeMediator
				at: anArray first ]! !

!OBTreeNodeMediator methodsFor: 'accessing' stamp: 'dr 9/22/2008 17:10'!
refresh
	self fan refresh. 
	self updateSubTreeNodes.! !

!OBTreeNodeMediator methodsFor: 'compatibility' stamp: 'dr 9/12/2008 11:31'!
removeAutoSelection! !

!OBTreeNodeMediator methodsFor: 'compatibility' stamp: 'dr 9/12/2008 10:00'!
setLastNode: aNode! !

!OBTreeNodeMediator methodsFor: 'accessing' stamp: 'dr 9/12/2008 10:43'!
shouldUpdateOnAutoSelect
    ^false! !

!OBTreeNodeMediator methodsFor: 'accessing' stamp: 'dr 9/23/2008 15:08'!
subTreeNodeMediators
	^ subTreeNodeMediators ifNil: [ subTreeNodeMediators := Dictionary new ]! !

!OBTreeNodeMediator methodsFor: 'subfan' stamp: 'dr 10/24/2008 18:11'!
treeFanAt: anInteger
	^ self subTreeNodeMediators at: anInteger! !

!OBTreeNodeMediator methodsFor: 'printing' stamp: 'dr 9/23/2008 15:08'!
updateSubTreeNodes
	self subTreeNodeMediators copy keysAndValuesDo: 
		[ : key : value | 
		| child |
		child := self fan children 
			at: key
			ifAbsent: [ ^ self ].
		child = value fan parent ifFalse: 
			[ self subTreeNodeMediators 
				at: key
				put: child asFan asTreeFan ] ]! !

!Object methodsFor: '*ob-enhancements' stamp: 'jk 12/5/2007 14:06'!
asArray
	^ Array with: self! !

!Object methodsFor: '*ob-enhancements' stamp: 'dr 11/14/2008 11:32'!
isNode
	^false! !

!OBMorphicIcons class methodsFor: '*ob-enhancements' stamp: 'dr 12/11/2008 14:42'!
iconImporter
    | image stream |
    image := ColorForm fromFileNamed: '/Users/davidroethlisberger/Pictures/roethlis/icons/samuel/overriddenAndSuperNoSuperMethod.png'.
    stream := WriteStream with: String new.
    image storeOn: stream.
    stream contents.! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 9/25/2008 15:15'!
abstractWithOverrideAction
	^self overriddenAction! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/22/2007 16:06'!
arrowLeft
	^((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 185272842 185273099 185273099 185207050 185273099 185273099 168364298 168430091 185273098 151456009 151587339 185272841 134349056 592395 185272841 328710 50924043 185273098 150997257 151587339 185273099 168364298 168430091 185273099 185207050 185273099 185273099 185272842 185273099 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( )  ))
! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 1/16/2008 12:07'!
arrowLeftBig
    ^((ColorForm
	extent: 14@14
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185270272 185273099 185273098 168495883 185270272 185273099 185272841 168495883 185270272 185273099 185207049 168430090 168493056 185273099 185207049 168430090 168493056 185273098 168363785 151587081 168493056 185272841 151519745 2313 168493056 185272841 150996228 100862217 168493056 185273098 168361993 151587081 168493056 185273099 185207049 168430090 168493056 185273099 185272841 168495883 185270272 185273099 185272841 168495883 185270272 185273099 185273098 168495883 185270272 185273099 185273099 185273099 185270272)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( ) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/17/2007 14:38'!
arrowRight
	^((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 168430347 185273099 185273099 168364555 185273099 185207306 168364298 185273099 185207049 151584777 168495883 185207043 100926720 151653131 185207040 66056 151653131 185207049 151586569 168495883 185207306 168364298 185273099 185273099 168364555 185273099 185273099 168430347 185273099 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( )  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 1/16/2008 12:08'!
arrowRightBig
    ^((ColorForm
	extent: 14@14
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185270272 185273099 185207307 185273099 185270272 185273099 185207050 185273099 185270272 185207306 168429833 168495883 185270272 185207306 168429833 168495883 185270272 185207049 151587072 151653131 185270272 185207043 50725893 592394 185270272 185207040 258 134810122 185270272 185207049 151587079 151653131 185270272 185207306 168429833 168495883 185270272 185273099 185207050 185273099 185270272 185273099 185207050 185273099 185270272 185273099 185207307 185273099 185270272 185273099 185273099 185273099 185270272)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( ) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 4/16/2008 15:20'!
arrowRightWithText
	^((ColorForm
	extent: 12@12
	depth: 4
	fromArray: #( 3435973834 2863267840 3435973834 3149529088 3435904202 3132751872 3435895754 3149529088 3149633978 3132751872 3113851034 3149529088 3107274890 2863267840 3112728089 3167485952 3113849499 3435921408 3149633980 3435921408 3435895756 3435921408 3435904204 3435921408)
	offset: 0@0)
	colorsFromArray: #(#(0.599 0.843 0.353) #(0.486 0.682 0.353) #(0.544 0.772 0.349) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.564 0.804 0.328) #(0.576 0.804 0.372) #(0.564 0.768 0.412) #(0.572 0.804 0.369) #(0.388 0.56 0.27) #(0.211 0.285 0.301) #(1.0 1.0 1.0) #( ) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 4/16/2008 15:23'!
arrowRightWithTextBig
	^((ColorForm
	extent: 14@14
	depth: 8
	fromArray: #( 1061109567 1061109567 1027423549 1027407872 1061109567 1061109567 1024995623 909967360 1061109566 1044266559 1025195582 1010630656 1061109566 50726718 1027358270 1010630656 1044266558 67243264 1027358243 943521792 1040515387 505555218 1024736789 456982528 1040715802 204680239 1025916478 473759744 1041118998 707595037 1026243636 893190144 1041045306 420092192 1027423549 1027407872 1040714041 674374945 774127167 1061093376 1040515343 504438547 809385791 1061093376 1044266558 67243264 1044332351 1061093376 1061109566 50726718 1061109567 1061093376 1061109566 1044266559 1061109567 1061093376)
	offset: 0@0)
	colorsFromArray: #(#(0.901 0.925 0.886) #(0.729 0.8 0.686) #(0.345 0.529 0.215) #(0.913 0.936 0.893) #(0.886 0.917 0.862) #(0.819 0.874 0.788) #(0.525 0.658 0.435) #(0.925 0.944 0.905) #(0.505 0.638 0.419) #(0.285 0.501 0.133) #(0.576 0.788 0.415) #(0.603 0.847 0.353) #(0.372 0.572 0.215) #(0.525 0.646 0.447) #(0.525 0.646 0.451) #(0.768 0.823 0.733) #(0.285 0.501 0.129) #(0.376 0.544 0.258) #(0.619 0.737 0.533) #(0.591 0.721 0.494) #(0.615 0.646 0.654) #(0.827 0.839 0.843) #(0.591 0.847 0.341) #(0.439 0.662 0.262) #(0.525 0.568 0.58) #(0.587 0.815 0.38) #(0.361 0.572 0.199) #(0.807 0.823 0.827) #(0.772 0.792 0.796) #(0.607 0.847 0.376) #(0.686 0.764 0.634) #(0.337 0.56 0.172) #(0.544 0.761 0.376) #(0.376 0.603 0.203) #(0.372 0.541 0.266) #(0.882 0.893 0.893) #(0.964 0.976 0.956) #(0.568 0.792 0.372) #(0.638 0.674 0.678) #(0.717 0.741 0.749) #(0.372 0.568 0.227) #(0.349 0.572 0.184) #(0.58 0.823 0.341) #(0.412 0.466 0.478) #(0.595 0.831 0.376) #(0.599 0.843 0.357) #(0.548 0.671 0.47) #(0.466 0.69 0.282) #(0.929 0.94 0.917) #(0.737 0.761 0.768) #(0.427 0.603 0.305) #(0.435 0.623 0.285) #(0.623 0.658 0.667) #(0.455 0.505 0.517) #(0.466 0.513 0.525) #(0.431 0.662 0.239) #(0.768 0.788 0.792) #(0.365 0.572 0.211) #(0.607 0.85 0.38) #(0.768 0.823 0.737) #(0.607 0.642 0.65) #(0.211 0.285 0.301) #(1.0 1.0 1.0) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( )  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/9/2008 20:18'!
blankSmall
	^ Form extent: 5@2 depth: 8! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 16:31'!
dirtyPackage
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4289901233 4286216568 4285558638 4285690224 4285690223 4285690223 4285690223 4285690223 4285690223 4285887603 4289243047 4294769916 4294967295 4289769391 4286413172 4287989103 4288449136 4288449136 4288449136 4283387470 4288449136 4288449136 4288449136 4288054895 4286544241 4288387737 4294572537 4285887603 4288252274 4288778359 4288778359 4288382061 4288580979 4283512631 4288580979 4288382061 4288778359 4288778359 4288580979 4285492845 4292730333 4285558638 4288778359 4289041531 4286923833 4286526250 4294967295 4288286993 4294967295 4286525994 4286858040 4288844409 4288778359 4286150257 4290295992 4285690224 4289041531 4288777077 4286592300 4294901760 4294967295 4294901760 4294967295 4294901760 4286526508 4288119149 4289041531 4286216050 4289769648 4285690224 4289239168 4289239168 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289042046 4289239168 4286281586 4289638062 4285690224 4283387470 4283512631 4288286993 4294901760 4294967295 4294967295 4294967295 4294901760 4288286993 4283118130 4283387470 4286281843 4289638062 4285690480 4289765770 4289765770 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4289173891 4289765770 4286347637 4289638062 4285756017 4290028943 4289237886 4286723887 4294901760 4294967295 4294901760 4294967295 4294901760 4286658094 4287659371 4290028943 4286413430 4289638062 4285690224 4290226579 4290028943 4287318849 4286789681 4294967295 4288286993 4294967295 4286789424 4286858556 4288450428 4290226579 4286413686 4289638062 4285427310 4290292118 4290226579 4290029201 4288974974 4290292118 4283118130 4289831824 4288054130 4288647807 4289371529 4290489496 4285821809 4290493371 4288980131 4287399808 4290687132 4290687132 4290687132 4290687132 4283387470 4290687132 4290687132 4290687132 4290687132 4287662721 4286677375 4291875024 4294769916 4288519580 4285492846 4286610809 4286742395 4286742394 4286742394 4286742394 4286742394 4286742394 4285624431 4286808961 4290690750 4293125091 4294967295 4294506744 4292927712 4290295992 4289506476 4289374890 4289374890 4289374890 4289374890 4289374890 4290822336 4291940817 4293190884 4294375158)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 9/2/2008 14:33'!
dirtyPackageLabel
    ^'Package modified locally'! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2008 10:30'!
moreRecentOnServer
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4289901233 4286216568 4285558638 4285690224 4285690223 4285690223 4285690223 4285690223 4285690223 4285887603 4289243047 4294769916 4294967295 4289769391 4286413172 4287989103 4288449136 4288449136 4288449136 4283387470 4288449136 4288449136 4288449136 4288054895 4286544241 4288387737 4294572537 4285887603 4288252274 4288778359 4288778359 4288382061 4288580979 4283512631 4288580979 4288382061 4288778359 4288778359 4288580979 4285492845 4292730333 4285558638 4288778359 4289041531 4286923833 4286526250 4286526250 4288286993 4286526250 4286525994 4286858040 4288844409 4288778359 4286150257 4290295992 4285690224 4289041531 4288777077 4286592300 4294901760 4294901760 4294901760 4294901760 4294901760 4286526508 4288119149 4289041531 4286216050 4289769648 4285690224 4289239168 4289239168 4286526250 4294901760 4294901760 4294901760 4294901760 4294901760 4286526250 4289042046 4289239168 4286281586 4289638062 4285690224 4283387470 4283512631 4288286993 4294901760 4294901760 4294901760 4294901760 4294901760 4288286993 4283118130 4283387470 4286281843 4289638062 4285690480 4289765770 4289765770 4286526250 4294901760 4294901760 4294901760 4294901760 4294901760 4286526250 4289173891 4289765770 4286347637 4289638062 4285756017 4290028943 4289237886 4286723887 4294901760 4294901760 4294901760 4294901760 4294901760 4286658094 4287659371 4290028943 4286413430 4289638062 4285690224 4290226579 4290028943 4287318849 4286789681 4286526250 4288286993 4286526250 4286789424 4286858556 4288450428 4290226579 4286413686 4289638062 4285427310 4290292118 4290226579 4290029201 4288974974 4290292118 4283118130 4289831824 4288054130 4288647807 4289371529 4290489496 4285821809 4290493371 4288980131 4287399808 4290687132 4290687132 4290687132 4290687132 4283387470 4290687132 4290687132 4290687132 4290687132 4287662721 4286677375 4291875024 4294769916 4288519580 4285492846 4286610809 4286742395 4286742394 4286742394 4286742394 4286742394 4286742394 4285624431 4286808961 4290690750 4293125091 4294967295 4294506744 4292927712 4290295992 4289506476 4289374890 4289374890 4289374890 4289374890 4289374890 4290822336 4291940817 4293190884 4294375158)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 9/2/2008 14:32'!
moreRecentOnServerLabel
    ^'Newer version available in repository'! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/18/2008 20:40'!
overriddenAction
	^[:node :column | | subclasses subclass filter labels |  
		 subclasses := OBClassAwareNode sortHierarchicallyOptimized: node findOverriddingClasses.
		 subclasses size > 1 ifTrue: [
		    filter := OBClassSortFilter new nodesFrom: subclasses forNode: nil; yourself.	
	         labels := subclasses collect: [:ea | filter displayString: ea name forParent:  nil child: ea].	
		    subclass := OBChoiceRequest prompt: 'Open overridder in ...' labels: labels values: subclasses lines: nil
		 ] ifFalse: [subclass := subclasses first].
           subclass ifNotNil: [column panel jumpTo: (MethodReference class: subclass selector: node selector) asNode]]! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/18/2008 20:39'!
overriddenAndOverridesAction
	^[:node :column | | superclasses subclasses class subFilter superFilter values labels |  		
		 superclasses := OBClassAwareNode sortHierarchicallyOptimized: node findOverriddenClasses.
		 subclasses := OBClassAwareNode sortHierarchicallyOptimized: node findOverriddingClasses.
		 values := (OrderedCollection with: nil) addAll: superclasses; add: nil; add: nil; addAll: subclasses; yourself.
		
		 superFilter := OBClassSortFilter new nodesFrom: superclasses forNode: nil; yourself.
		 subFilter := OBClassSortFilter new nodesFrom: subclasses forNode: nil; yourself.
			
		 labels := OrderedCollection with: 'Overridden Classes:'.
	      superclasses collect: [:ea | labels add: (superFilter displayString: ea name forParent: nil child: ea)].
	      labels add: ' '; add: 'Overridding Classes:'.
	      subclasses collect: [:ea | labels add: (subFilter displayString: ea name forParent:  nil child: ea)].	      
		
		 class := OBChoiceRequest prompt: 'Open method in...' labels: labels values: values lines: {1. superclasses size + 3}.
		 
           class ifNotNil: [column panel jumpTo: (MethodReference class: class selector: node selector) asNode]]! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 9/4/2008 17:03'!
overridesAction
	^[:node :column | | superclass | 
		  superclass := node findOverriddenClass.
		  superclass ifNotNil: [column panel jumpTo: (MethodReference class: superclass selector: node selector) asNode]]! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/11/2008 14:18'!
package
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294960327 4289901233 4286216568 4285558638 4285690224 4285690223 4285690223 4285690223 4285690223 4285690223 4285887603 4289243047 4294769916 4294960327 4289769391 4286413172 4287989103 4288449136 4288449136 4288449136 4283387470 4288449136 4288449136 4288449136 4288054895 4286544241 4288387737 4294572537 4285887603 4288252274 4288580979 4288580979 4288580979 4288580979 4283387470 4288580979 4288580979 4288580979 4288580979 4288580979 4285492845 4292730333 4285558638 4288778359 4288778359 4288778359 4288778359 4288778359 4283387470 4288778359 4288778359 4288778359 4288778359 4288778359 4286150257 4290295992 4285690224 4289041531 4289041531 4289041531 4289041531 4289041531 4283387470 4289041531 4289041531 4289041531 4289041531 4289041531 4286216050 4289769648 4285690224 4289239168 4289239168 4289239168 4289239168 4289239168 4283387470 4289239168 4289239168 4289239168 4289239168 4289239168 4286281586 4289638062 4285690224 4283387470 4283387470 4283387470 4283387470 4283387470 4283387470 4283387470 4283387470 4283387470 4283387470 4283387470 4286281843 4289638062 4285690480 4289765770 4289765770 4289765770 4289765770 4289765770 4283387470 4289765770 4289765770 4289765770 4289765770 4289765770 4286347637 4289638062 4285756017 4290028943 4290028943 4290028943 4290028943 4290028943 4283387470 4290028943 4290028943 4290028943 4290028943 4290028943 4286413430 4289638062 4285690224 4290226579 4290226579 4290226579 4290226579 4290226579 4283387470 4290226579 4290226579 4290226579 4290226579 4290226579 4286413686 4289638062 4285427310 4290292118 4290489496 4290489496 4290489496 4290489496 4283387470 4290489496 4290489496 4290489496 4290489496 4290489496 4285821809 4290493371 4288980131 4287399808 4290687132 4290687132 4290687132 4290687132 4283387470 4290687132 4290687132 4290687132 4290687132 4287662721 4286677375 4291875024 4294769916 4288519580 4285492846 4286610809 4286742395 4286742394 4286742394 4286742394 4286742394 4286742394 4285624431 4286808961 4290690750 4293125091 4294960327 4294506744 4292927712 4290295992 4289506476 4289374890 4289374890 4289374890 4289374890 4289374890 4290822336 4291940817 4293190884 4294960327)
	offset: 0@0)

! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 16:32'!
packageLabel
	^'Monticello package'


! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 9/25/2008 15:14'!
superSendWithOverrideAction
	^self overriddenAndOverridesAction! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 16:28'!
superSendWithOverrideNoSuperMethodAction
	^self superSendWithOverrideAction! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 16:28'!
superSendWithOverrideOtherSelectorAction
	^self superSendWithOverrideAction
! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 9/25/2008 10:59'!
superSendWithoutOverrideAction
	^self overridesAction! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 16:29'!
superSendWithoutOverrideNoSuperMethodAction
	^self superSendWithoutOverrideAction
! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 16:29'!
superSendWithoutOverrideOtherSelectorAction
	^self superSendWithoutOverrideAction
! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2008 11:23'!
testEqualPassedFailed
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848814 4290690750 4287993237 4286216826 4286151033 4287795858 4290230199 4293388263 4294704123 4294901502 4294967295 4294967295 4294967295 4292796126 4288256409 4286940549 4287861651 4288519581 4288519581 4287861651 4286940549 4287664272 4291743438 4294440951 4294901502 4294967295 4293848814 4288256409 4287730065 4289045668 4280412426 4279739143 4279739143 4279739143 4278253824 4287730065 4287335307 4292335575 4294440951 4294967295 4290690750 4287137928 4289243304 4279739143 4279739143 4278253824 4278253824 4279739143 4280412426 4289065352 4287137928 4288848546 4293519849 4293519849 4287993237 4288387995 4280412426 4279739143 4278253824 4289065352 4289065352 4280412426 4279739143 4280412426 4289065352 4286808963 4292401368 4293519849 4286216826 4289506476 4279739143 4280412426 4278253824 4278253824 4280614667 4280412426 4280412426 4278253824 4289065352 4285822068 4291480266 4293519849 4286151033 4289769648 4288610326 4292878111 4294925170 4294903338 4294903338 4294903338 4293722138 4294925170 4294929001 4285822068 4290953922 4293519849 4287795858 4289111461 4288610326 4293722138 4294901760 4293722138 4294903338 4294903338 4294903338 4294925170 4294929001 4286545791 4290953922 4294967295 4290230199 4287795858 4294929001 4293722138 4293722138 4294903338 4294903338 4294903338 4294925170 4294929001 4287795858 4287795858 4291480266 4294967295 4293388263 4287664272 4289045668 4294929001 4294903338 4294903338 4294925170 4294925170 4294929001 4289045668 4286677377 4289638062 4292401368 4294967295 4294704123 4291743438 4287335307 4288059030 4289638062 4294929001 4294929001 4294929001 4288059030 4286677377 4288848546 4291480266 4293519849 4294967295 4294901502 4294440951 4292335575 4288848546 4286808963 4285822068 4285822068 4286545791 4287795858 4289638062 4291480266 4293190884 4294440951 4294967295 4294967295 4294901502 4294440951 4293519849 4292401368 4291480266 4290953922 4290953922 4291480266 4292401368 4293519849 4294440951 4294901502)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/15/2008 19:16'!
testEqualPassedFailedLabel
    ^'Almost the same number of tests passed as failed'! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 10:46'!
testGreen
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848814 4290690750 4287993237 4286216826 4286151033 4287795858 4290230199 4293388263 4294704123 4294901502 4294967295 4294967295 4294967295 4292796126 4288256409 4286940549 4287861651 4288519581 4288519581 4287861651 4286940549 4287664272 4291743438 4294440951 4294901502 4294967295 4293848814 4288256409 4287730065 4289045668 4280412426 4279739143 4279739143 4279739143 4278253824 4287730065 4287335307 4292335575 4294440951 4294967295 4290690750 4287137928 4289243304 4279739143 4279739143 4278253824 4278253824 4279739143 4280412426 4289065352 4287137928 4288848546 4293519849 4293519849 4287993237 4288387995 4280412426 4279739143 4278253824 4289065352 4289065352 4280412426 4279739143 4280412426 4289065352 4286808963 4292401368 4293519849 4286216826 4289506476 4279739143 4280412426 4278253824 4278253824 4280614667 4280412426 4280412426 4278253824 4289065352 4285822068 4291480266 4293519849 4286151033 4289769648 4279739143 4280412426 4289065352 4278253824 4278253824 4278253824 4280412426 4280412426 4289065352 4285822068 4290953922 4293519849 4287795858 4289111461 4279739143 4280412426 4280614667 4280412426 4278253824 4278253824 4278253824 4280412426 4289065352 4286545791 4290953922 4294967295 4290230199 4287795858 4289065352 4280412426 4280412426 4278253824 4278253824 4278253824 4280412426 4289065352 4287795858 4287795858 4291480266 4294967295 4293388263 4287664272 4289045668 4289065352 4278253824 4278253824 4288015190 4288015190 4289065352 4289045668 4286677377 4289638062 4292401368 4294967295 4294967295 4291743438 4287335307 4288059030 4289638062 4289065352 4289065352 4289065352 4288059030 4286677377 4288848546 4291480266 4293519849 4294967295 4294901502 4294440951 4292335575 4288848546 4286808963 4285822068 4285822068 4286545791 4287795858 4289638062 4291480266 4293190884 4294440951 4294967295 4294967295 4294901502 4294440951 4293519849 4292401368 4291480266 4290953922 4290953922 4291480266 4292401368 4293519849 4294440951 4294901502)
	offset: 0@0)


! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'AlexandreBergel 10/22/2008 13:17'!
testGreenLabel
    ^'Test passed'


! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2008 11:22'!
testMoreFailed
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848814 4290690750 4287993237 4286216826 4286151033 4287795858 4290230199 4293388263 4294704123 4294901502 4294967295 4294967295 4294967295 4292796126 4288256409 4286940549 4287861651 4288519581 4288519581 4287861651 4286940549 4287664272 4291743438 4294440951 4294901502 4294967295 4293848814 4288256409 4287730065 4289045668 4280412426 4279739143 4279739143 4279739143 4278253824 4287730065 4287335307 4292335575 4294440951 4294967295 4290690750 4287137928 4289243304 4279739143 4279739143 4278253824 4278253824 4279739143 4280412426 4289065352 4287137928 4288848546 4293519849 4293519849 4287993237 4288387995 4292878111 4288610326 4294903338 4294925170 4294925170 4293722138 4288610326 4294925170 4294929001 4286808963 4292401368 4293519849 4286216826 4289506476 4288610326 4292878111 4294925170 4294903338 4294903338 4293722138 4293722138 4294903338 4294929001 4285822068 4291480266 4293519849 4286151033 4289769648 4288610326 4292878111 4294925170 4294903338 4294903338 4294903338 4293722138 4294925170 4294929001 4285822068 4290953922 4293519849 4287795858 4289111461 4288610326 4293722138 4294901760 4293722138 4294903338 4294903338 4294903338 4294925170 4294929001 4286545791 4290953922 4294967295 4290230199 4287795858 4294929001 4293722138 4293722138 4294903338 4294903338 4294903338 4294925170 4294929001 4287795858 4287795858 4291480266 4294967295 4293388263 4287664272 4289045668 4294929001 4294903338 4294903338 4294925170 4294925170 4294929001 4289045668 4286677377 4289638062 4292401368 4294967295 4294704123 4291743438 4287335307 4288059030 4289638062 4294929001 4294929001 4294929001 4288059030 4286677377 4288848546 4291480266 4293519849 4294967295 4294901502 4294440951 4292335575 4288848546 4286808963 4285822068 4285822068 4286545791 4287795858 4289638062 4291480266 4293190884 4294440951 4294967295 4294967295 4294901502 4294440951 4293519849 4292401368 4291480266 4290953922 4290953922 4291480266 4292401368 4293519849 4294440951 4294901502)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/15/2008 19:16'!
testMoreFailedLabel
    ^'More tests failed than succeeded'! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2008 11:22'!
testMorePassed
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848814 4290690750 4287993237 4286216826 4286151033 4287795858 4290230199 4293388263 4294704123 4294901502 4294967295 4294967295 4294967295 4292796126 4288256409 4286940549 4287861651 4288519581 4288519581 4287861651 4286940549 4287664272 4291743438 4294440951 4294901502 4294967295 4293848814 4288256409 4287730065 4289045668 4280412426 4279739143 4279739143 4279739143 4278253824 4287730065 4287335307 4292335575 4294440951 4294967295 4290690750 4287137928 4289243304 4279739143 4279739143 4278253824 4278253824 4279739143 4280412426 4289065352 4287137928 4288848546 4293519849 4293519849 4287993237 4288387995 4280412426 4279739143 4278253824 4289065352 4289065352 4280412426 4279739143 4280412426 4289065352 4286808963 4292401368 4293519849 4286216826 4289506476 4279739143 4280412426 4278253824 4278253824 4280614667 4280412426 4280412426 4278253824 4289065352 4285822068 4291480266 4293519849 4286151033 4289769648 4279739143 4280412426 4289065352 4278253824 4278253824 4278253824 4280412426 4280412426 4289065352 4285822068 4290953922 4293519849 4287795858 4289111461 4279739143 4280412426 4280614667 4280412426 4278253824 4278253824 4278253824 4280412426 4289065352 4286545791 4290953922 4294967295 4290230199 4287795858 4294929001 4293722138 4293722138 4294903338 4294903338 4294903338 4294925170 4294929001 4287795858 4287795858 4291480266 4294967295 4293388263 4287664272 4289045668 4294929001 4294903338 4294903338 4294925170 4294925170 4294929001 4289045668 4286677377 4289638062 4292401368 4294967295 4294704123 4291743438 4287335307 4288059030 4289638062 4294929001 4294929001 4294929001 4288059030 4286677377 4288848546 4291480266 4293519849 4294967295 4294901502 4294440951 4292335575 4288848546 4286808963 4285822068 4285822068 4286545791 4287795858 4289638062 4291480266 4293190884 4294440951 4294967295 4294967295 4294901502 4294440951 4293519849 4292401368 4291480266 4290953922 4290953922 4291480266 4292401368 4293519849 4294440951 4294901502)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/15/2008 19:16'!
testMorePassedLabel
    ^'More tests passed than failed'! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 11:32'!
testNotRun
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848814 4290690750 4287993237 4286216826 4286151033 4287795858 4290230199 4293388263 4294704123 4294901502 4294967295 4294967295 4294967295 4292796126 4288256409 4286940549 4287861651 4286216826 4288519581 4287861651 4286940549 4287664272 4291743438 4294440951 4294901502 4294967295 4293848814 4288256409 4287730065 4286216826 4282400832 4281875001 4281875001 4281875001 4286216826 4287730065 4287335307 4292335575 4294440951 4294967295 4290690750 4287137928 4286216826 4281875001 4281875001 4281875001 4281875001 4281875001 4281875001 4282400832 4287137928 4288848546 4293519849 4293519849 4287993237 4288387995 4282400832 4281875001 4293388263 4288848546 4281875001 4281875001 4281875001 4281875001 4285822068 4286808963 4292401368 4293519849 4286216826 4286216826 4281875001 4288848546 4281875001 4281875001 4281875001 4281875001 4281875001 4281875001 4281875001 4285822068 4291480266 4293519849 4286151033 4289769648 4281875001 4281875001 4282400832 4282400832 4281875001 4281875001 4281875001 4281875001 4281875001 4285822068 4290953922 4293519849 4287795858 4289111461 4281875001 4281875001 4282400832 4281875001 4281875001 4281875001 4281875001 4281875001 4282400832 4286545791 4290953922 4294967295 4290230199 4287795858 4286216826 4281875001 4281875001 4281875001 4281875001 4281875001 4281875001 4281875001 4285822068 4287795858 4291480266 4294967295 4293388263 4287664272 4289045668 4282400832 4281875001 4281875001 4281875001 4281875001 4281875001 4282400832 4286677377 4289638062 4292401368 4294967295 4294967295 4291743438 4287335307 4288059030 4289638062 4281875001 4281875001 4281875001 4285822068 4286677377 4288848546 4291480266 4293519849 4294967295 4294901502 4294440951 4292335575 4288848546 4286808963 4285822068 4285822068 4286545791 4287795858 4289638062 4291480266 4293190884 4294440951 4294967295 4294967295 4294901502 4294440951 4293519849 4292401368 4291480266 4290953922 4290953922 4291480266 4292401368 4293519849 4294440951 4294901502)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/16/2008 15:44'!
testNotRunAction
	^[:node :column | node runTestCommandClass ifNotNilDo: [:cmdClass | (cmdClass on: node for: column) execute]]! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'AlexandreBergel 10/22/2008 13:17'!
testNotRunLabel
    ^'Test not yet run'


! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 10:46'!
testRed
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848814 4290690750 4287993237 4286216826 4286151033 4287795858 4290230199 4293388263 4294704123 4294901502 4294967295 4294967295 4294967295 4292796126 4288256409 4286940549 4287861651 4288519581 4288519581 4287861651 4286940549 4287664272 4291743438 4294440951 4294901502 4294967295 4293848814 4288256409 4287730065 4289045668 4292878111 4288610326 4288610326 4288610326 4294929001 4287730065 4287335307 4292335575 4294440951 4294967295 4290690750 4287137928 4289243304 4288610326 4288610326 4292878111 4292878111 4288610326 4294903338 4294929001 4287137928 4288848546 4293519849 4293519849 4287993237 4288387995 4292878111 4288610326 4294903338 4294925170 4294925170 4293722138 4288610326 4294925170 4294929001 4286808963 4292401368 4293519849 4286216826 4289506476 4288610326 4292878111 4294925170 4294903338 4294903338 4293722138 4293722138 4294903338 4294929001 4285822068 4291480266 4293519849 4286151033 4289769648 4288610326 4292878111 4294925170 4294903338 4294903338 4294903338 4293722138 4294925170 4294929001 4285822068 4290953922 4293519849 4287795858 4289111461 4288610326 4293722138 4294901760 4293722138 4294903338 4294903338 4294903338 4294925170 4294929001 4286545791 4290953922 4294967295 4290230199 4287795858 4294929001 4293722138 4293722138 4294903338 4294903338 4294903338 4294925170 4294929001 4287795858 4287795858 4291480266 4294967295 4293388263 4287664272 4289045668 4294929001 4294903338 4294903338 4294925170 4294925170 4294929001 4289045668 4286677377 4289638062 4292401368 4294967295 4294704123 4291743438 4287335307 4288059030 4289638062 4294929001 4294929001 4294929001 4288059030 4286677377 4288848546 4291480266 4293519849 4294967295 4294901502 4294440951 4292335575 4288848546 4286808963 4285822068 4285822068 4286545791 4287795858 4289638062 4291480266 4293190884 4294440951 4294967295 4294967295 4294901502 4294440951 4293519849 4292401368 4291480266 4290953922 4290953922 4291480266 4292401368 4293519849 4294440951 4294901502)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 10:48'!
testRedLabel
    ^'Test error'


! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 10:47'!
testYellow
    ^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848814 4290690750 4287993237 4286216826 4286151033 4287795858 4290230199 4293388263 4294704123 4294901502 4294967295 4294967295 4294967295 4292796126 4288256409 4286940549 4287861651 4288519581 4288519581 4287861651 4286940549 4287664272 4291743438 4294440951 4294901502 4294967295 4293848814 4288256409 4287730065 4289045668 4292466493 4294952704 4294952704 4294952704 4293849089 4287730065 4287335307 4292335575 4294440951 4294967295 4290690750 4287137928 4289243304 4294952704 4294952704 4294967040 4294967040 4294952704 4294959360 4293849089 4287137928 4288848546 4293519849 4293519849 4287993237 4288387995 4292466493 4294952704 4294967040 4294967295 4293190884 4294967040 4294952704 4294959360 4294967295 4286808963 4292401368 4293519849 4286216826 4289506476 4294952704 4294959360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294959360 4285822068 4291480266 4293519849 4286151033 4289769648 4294952704 4294959360 4294967295 4293190884 4294967040 4294967040 4294967040 4294959360 4294959360 4285822068 4290953922 4293519849 4287795858 4289111461 4294952704 4294959360 4294967040 4294959360 4294967040 4294967040 4294967040 4294959360 4292466493 4286545791 4290953922 4294967295 4290230199 4287795858 4293849089 4294959360 4294959360 4294967040 4294967040 4294967040 4294959360 4294967295 4287795858 4287795858 4291480266 4294967295 4293388263 4287664272 4289045668 4293849089 4294967040 4294967040 4294959360 4294959360 4294967295 4289045668 4286677377 4289638062 4292401368 4294967295 4294967295 4291743438 4287335307 4288059030 4289638062 4292466493 4292466493 4292466493 4288059030 4286677377 4288848546 4291480266 4293519849 4294967295 4294901502 4294440951 4292335575 4288848546 4286808963 4285822068 4285822068 4286545791 4287795858 4289638062 4291480266 4293190884 4294440951 4294967295 4294967295 4294901502 4294440951 4293519849 4292401368 4291480266 4290953922 4290953922 4291480266 4292401368 4293519849 4294440951 4294901502)
	offset: 0@0)

! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 12/1/2008 10:48'!
testYellowLabel
    ^'Test failed'


! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/17/2007 14:43'!
text
    ^((ColorForm
	extent: 12@12
	depth: 2
	fromArray: #( 2863311360 2840943104 2835356160 2836732416 2835356160 2836732416 2835356160 2836732416 2835356160 2840943104 2863311360 2863311360)
	offset: 0@0)
	colorsFromArray: #(#(1.0 1.0 1.0) #(0.211 0.285 0.301) #( ) #(0.0 0.0 0.0)  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 1/16/2008 12:17'!
textBig
    ^((ColorForm
	extent: 14@14
	depth: 2
	fromArray: #( 2863311520 2840941984 2839545248 2839889312 2839889312 2839545248 2839889312 2839545248 2839889312 2839545248 2840941984 2840941984 2863311520 2863311520)
	offset: 0@0)
	colorsFromArray: #(#(1.0 1.0 1.0) #(0.211 0.285 0.301) #( ) #(0.0 0.0 0.0)  ))
! !

OBFixedButtonPanel subclass: #OBEnhancementFixedButtonPanel
	instanceVariableNames: 'backPressed currentNode backButton forwardButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 3/13/2008 12:04'!
back
    backPressed := true.
    browser historyBack ifTrue: [self changed. self definitionPanel selectSourceTab].! !

!OBEnhancementFixedButtonPanel methodsFor: 'labeling' stamp: 'dr 3/13/2008 10:43'!
backLabel
	^self buttonLabel: '<<'.! !

!OBEnhancementFixedButtonPanel methodsFor: 'building' stamp: 'dr 3/13/2008 10:40'!
buildOn: aBuilder 
	^aBuilder enhancementFixedButtonBar: self with: []! !

!OBEnhancementFixedButtonPanel methodsFor: 'labeling' stamp: 'dr 2/11/2009 15:13'!
buttonLabel: aString
	| labelMorphClass |
	labelMorphClass := (Smalltalk hasClassNamed: #LabelMorph) 
						ifTrue: [Smalltalk classNamed: #LabelMorph] 
						ifFalse: [StringMorph].	
	^ (labelMorphClass 
		contents: aString
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBEnhancementFixedButtonPanel methodsFor: 'building' stamp: 'dr 4/10/2008 15:59'!
createBackButton
	backButton ifNil: [backButton := self createButton: #back].
	^backButton. ! !

!OBEnhancementFixedButtonPanel methodsFor: 'private' stamp: 'dr 2/11/2009 15:16'!
createButton: aSymbol
	| button | 
	button := (OBBackButtonMorph 
				on: self
				getState: nil
				action: aSymbol
				label: (aSymbol, 'Label') asSymbol) 
					onColor: self color duller offColor: self color duller;				
					getEnabledSelector: ('has', aSymbol capitalized, 'Node') asSymbol;
					height: Preferences standardCodeFont height * 1.84;
					vResizing: #rigid;
					panel: self.		
	^ button! !

!OBEnhancementFixedButtonPanel methodsFor: 'building' stamp: 'dr 4/10/2008 15:59'!
createForwardButton
	forwardButton ifNil: [forwardButton := self createButton: #forward].
	^forwardButton! !

!OBEnhancementFixedButtonPanel methodsFor: 'accessing' stamp: 'dr 3/13/2008 10:43'!
definitionPanel
    ^browser definitionPanel! !

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 3/13/2008 12:04'!
forward
    backPressed := true.
    browser historyForward ifTrue: [self changed. self definitionPanel selectSourceTab]. ! !

!OBEnhancementFixedButtonPanel methodsFor: 'labeling' stamp: 'dr 3/13/2008 10:44'!
forwardLabel
	^ self buttonLabel: '>>'.! !

!OBEnhancementFixedButtonPanel methodsFor: 'testing' stamp: 'dr 3/13/2008 11:05'!
hasBackNode
    ^browser hasBackHistory! !

!OBEnhancementFixedButtonPanel methodsFor: 'testing' stamp: 'dr 3/13/2008 10:53'!
hasForwardNode 
    ^browser hasForwardHistory! !

!OBEnhancementFixedButtonPanel methodsFor: 'initializing' stamp: 'dr 3/13/2008 12:02'!
initialize
    super initialize.
    backPressed := false.! !

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 3/13/2008 12:03'!
navigateHistoryInDirection: aSymbol
    | historyNodes index indices operation |
    historyNodes := browser perform: ('history', aSymbol capitalized, 'Nodes') asSymbol. 
    historyNodes ifEmpty: [^self].
    operation := aSymbol = #back ifTrue: [#-] ifFalse: [#+].
    indices := OrderedCollection new.

    historyNodes keysAndValuesDo: [:i :ea | indices add: (browser historyCursor perform: operation with: i)].

    index := OBChoiceRequest 
				prompt: nil
				labels: (historyNodes collect: [:ea | ea displayFullString])
				values: indices
				lines: #().
	index ifNotNil: [
		backPressed := true. 
		browser historyGoToIndex: index.
		self changed].! !

!OBEnhancementFixedButtonPanel methodsFor: 'updating' stamp: 'dr 3/13/2008 15:21'!
selectionChanged: ann
     super selectionChanged: ann.
     self updateBrowseHistory. ! !

!OBEnhancementFixedButtonPanel methodsFor: 'accessing' stamp: 'dr 3/13/2008 12:17'!
setBackPressed: aBoolean
    backPressed := aBoolean! !

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 2/11/2009 14:29'!
updateBrowseHistory
    | n |
    n := self currentNode.
    ((backPressed not and: [n isEnvironment not]) and: [
	     (n notNil and: [currentNode isNil]) or: [currentNode notNil and: [n ~= currentNode alias]]]) ifTrue: [
	    browser historyPush: n. self changed].
    (n notNil and: [n isMethodNode]) ifTrue: [n setCurrentParent: browser navigationPanel currentColumn parent].
    currentNode := n. 
    backPressed := false.
    self changed: #hasBackNode; changed: #hasForwardNode.! !

OBSearchNode subclass: #OBCollaboratorsSearchNode
	instanceVariableNames: 'referencingClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBCollaboratorsSearchNode class methodsFor: 'configuration' stamp: 'dr 4/21/2008 11:10'!
keyWord
    ^'collaborators'! !

!OBCollaboratorsSearchNode methodsFor: 'navigation' stamp: 'dr 4/21/2008 11:39'!
classes
    | classes |
    classes := HODataBase default referencedClassesInClass: self referencingClass.
    ^classes collect: [:ea | OBClassReferenceNode on: ea modelClass: (HODataBase default modelClassFor: self referencingClass)]! !

!OBCollaboratorsSearchNode methodsFor: 'ancestry' stamp: 'dr 8/15/2008 15:27'!
isDescendantOfClass: aClass
    ^false! !

!OBCollaboratorsSearchNode methodsFor: 'displaying' stamp: 'dr 4/21/2008 11:30'!
name
   ^query, ' (', self class keyWord, ')'! !

!OBCollaboratorsSearchNode methodsFor: 'accessing' stamp: 'dr 4/21/2008 11:37'!
referencingClass
    ^Smalltalk at: query! !

!OBCollaboratorsSearchNode methodsFor: 'navigation' stamp: 'dr 8/15/2008 16:08'!
selectThisOrNextNodeOnSwitch: nextNode
   ^nextNode ifNil: [self referencingClass asNode] ifNotNil: [nextNode selectThisOrNextNodeOnSwitch: nil]! !

!OBCollaboratorsSearchNode methodsFor: 'initialize-release' stamp: 'dr 4/23/2008 10:31'!
setRawQuery: aString
	query := aString! !

OBSearchNode subclass: #OBMethodInvocationSearchNode
	instanceVariableNames: 'limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBMethodInvocationSearchNode commentStamp: 'dr 8/15/2008 14:46' prior: 0!
I represent a node to search for all method that have invoked in instances of a given class.!

OBMethodInvocationSearchNode subclass: #OBMethodInvocationFrequencySearchNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBMethodInvocationFrequencySearchNode class methodsFor: 'configuration' stamp: 'dr 5/2/2008 15:40'!
keyWord
    ^super keyWord, ' frequency'! !

!OBMethodInvocationFrequencySearchNode methodsFor: 'navigation' stamp: 'dr 5/2/2008 16:26'!
classes
    | classes | 
    classes := super classes asSortedCollection: [:a :b | a methodInvocation occurrence >= b methodInvocation occurrence]. 
    classes ifEmpty: [^#()].
    self limit ifNotNil: [^classes first: self limit].
    ^classes! !

!OBMethodInvocationFrequencySearchNode methodsFor: 'testing' stamp: 'dr 4/25/2008 11:38'!
isFrequencySearch
    ^true! !

!OBMethodInvocationSearchNode class methodsFor: 'configuration' stamp: 'dr 4/23/2008 10:31'!
keyWord
   ^'method invocation'! !

!OBMethodInvocationSearchNode methodsFor: 'navigation' stamp: 'dr 5/2/2008 16:25'!
classes
    | modelEntity | 
    modelEntity := HODataBase default perform: self modelAccessor with: self searchEntity.
    modelEntity ifNil: [^#()].
    ^modelEntity methodInvocations collect: [:ea | OBEnrichedMethodInvocationNode on: ea inClass: self originClass].
! !

!OBMethodInvocationSearchNode methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:27'!
forceType
    ^query forceType! !

!OBMethodInvocationSearchNode methodsFor: 'testing' stamp: 'dr 5/2/2008 16:26'!
isClassWideSearch
    ^self searchEntity isBehavior! !

!OBMethodInvocationSearchNode methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:27'!
limit
    ^query limit! !

!OBMethodInvocationSearchNode methodsFor: 'accessing' stamp: 'dr 5/2/2008 14:50'!
modelAccessor
    ^self isClassWideSearch ifTrue: [#modelClassFor:] ifFalse: [#modelPackageFor:]! !

!OBMethodInvocationSearchNode methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:27'!
name
   | str |
   str := query queryString, ' (', self class keyWord.
   self forceType ifNotNil: [str := str, ', ', self forceType asString].
   self limit ifNotNil: [str := str, ', ', self limit asString].
   str := str,  ')'.
   ^str! !

!OBMethodInvocationSearchNode methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:25'!
originClass
    ^Smalltalk at: query queryString! !

!OBMethodInvocationSearchNode methodsFor: 'accessing' stamp: 'dr 5/2/2008 16:23'!
searchEntity
    ^query searchEntity! !

!OBMethodInvocationSearchNode methodsFor: 'initialize-release' stamp: 'dr 8/15/2008 15:10'!
setRawQuery: aQuery
	query _ aQuery.! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 7/3/2008 10:47'!
hasOnlyOneResult
   ^self classes size = 1 and: [self methodsInFirstClass size = 1]! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/11/2008 15:14'!
implementors
    self methodsInFirstClass ifEmpty: [^#()].
    ^self methodsInFirstClass first implementors! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 3/12/2008 15:32'!
isBrowseable
    ^false! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/11/2008 14:50'!
isClassSearch
    ^false! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 4/25/2008 11:38'!
isFrequencySearch
    ^false! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/11/2008 14:50'!
isMethodSearch
    ^false! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 16:22'!
isSearch
    ^true! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 7/3/2008 10:49'!
methodSatisfiesQuery: methodRef
    ^false! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 7/3/2008 11:01'!
methodsInFirstClass
   ^self classes first allMethods select: [:node | self methodSatisfiesQuery: node reference].! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/11/2008 15:32'!
senders
    self methodsInFirstClass ifEmpty: [^#()].
    ^self methodsInFirstClass first senders! !

OBCmdClassTemplate subclass: #OBCmdNewTraitTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdNewTraitTemplate methodsFor: 'accessing' stamp: 'dc 4/23/2007 15:03'!
label
	^ 'new trait template'! !

!OBCmdNewTraitTemplate methodsFor: 'private' stamp: 'dc 7/22/2007 21:04'!
templateDefinition
	^ OBClassDefinition 
			environment: self currentEnvironment
			template: (Trait newTemplateIn: self currentCategory)! !

OBMethodNode subclass: #OBEnrichedMethodInvocationNode
	instanceVariableNames: 'methodInvocation invokingClass formatter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedMethodInvocationNode class methodsFor: 'instance creation' stamp: 'dr 4/25/2008 11:23'!
on: methodInvocation inClass: aClass
   ^self new setMethodInvocation: methodInvocation; invokingClass: aClass! !

!OBEnrichedMethodInvocationNode methodsFor: 'navigating' stamp: 'dr 4/23/2008 12:11'!
allCategory
   ^#()! !

!OBEnrichedMethodInvocationNode methodsFor: 'navigating' stamp: 'dr 4/23/2008 12:23'!
categories
   ^self invokingClasses! !

!OBEnrichedMethodInvocationNode methodsFor: 'enriching' stamp: 'dr 4/25/2008 15:00'!
definition
	^ (OBEnrichedMethodDefinition
		selection: self selection
		source: self source
		inClass: self theClass) setFormatter: formatter! !

!OBEnrichedMethodInvocationNode methodsFor: 'displaying' stamp: 'dr 4/25/2008 11:24'!
displayString
   ^self theClass name, '>>', self selector asString, ' (', methodInvocation occurrence asString, ')'! !

!OBEnrichedMethodInvocationNode methodsFor: 'enriching' stamp: 'dr 4/25/2008 15:00'!
formatter
	^formatter! !

!OBEnrichedMethodInvocationNode methodsFor: 'accessing' stamp: 'dr 4/25/2008 11:24'!
icon
    ^((Smalltalk at: #HODataBase) default isInstrumentedMethod: methodInvocation) ifTrue: [#flag] ifFalse: [#blank].! !

!OBEnrichedMethodInvocationNode methodsFor: 'accessing' stamp: 'dr 4/23/2008 12:16'!
invokingClass
    ^invokingClass! !

!OBEnrichedMethodInvocationNode methodsFor: 'accessing' stamp: 'dr 4/23/2008 12:15'!
invokingClass: aClass
    invokingClass := aClass! !

!OBEnrichedMethodInvocationNode methodsFor: 'navigating' stamp: 'dr 4/25/2008 11:23'!
invokingClasses
    | classes | 
    classes := OrderedCollection new.
    invokingClass ifNotNil: [
	    classes add: ((OBEnrichedClassNode on: (HODataBase default modelClassFor: invokingClass)) setMethodInvocation: methodInvocation)].
    ^classes! !

!OBEnrichedMethodInvocationNode methodsFor: 'accessing' stamp: 'dr 4/25/2008 11:19'!
methodInvocation
    ^methodInvocation! !

!OBEnrichedMethodInvocationNode methodsFor: 'enriching' stamp: 'dr 4/25/2008 14:59'!
modelMethod
    ^HODataBase default modelMethodFor: methodInvocation! !

!OBEnrichedMethodInvocationNode methodsFor: 'navigating' stamp: 'dr 8/15/2008 16:18'!
selectThisOrNextNodeOnSwitch: nextNode
   ^OBMethodNode on: self selector inClass: self theClass! !

!OBEnrichedMethodInvocationNode methodsFor: 'accessing' stamp: 'dr 4/25/2008 11:21'!
setMethodInvocation: aMethodInvocation
    methodInvocation := aMethodInvocation.
    self theClass: aMethodInvocation actualClass.
    selector := aMethodInvocation methodSymbol! !

!OBEnrichedMethodInvocationNode methodsFor: 'enriching' stamp: 'dr 4/25/2008 14:57'!
source
	| method |
	(HODataBase default isInstrumentedMethod: methodInvocation) ifFalse: [^super source].
	method := self theClass compiledMethodAt: self selector ifAbsent: [^ self defaultSource].
	formatter := HOFormatter metaMethod: self modelMethod referencedClass: nil.
	^formatter formatCodeForMethod: method! !

OBMethodNode subclass: #OBEnrichedMethodNode
	instanceVariableNames: 'modelMethod formatter referencedClass isHighlighted currentParent definition totalNumberOfRefs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedMethodNode commentStamp: 'dr 10/9/2007 17:12' prior: 0!
I am an enriched method node. I know how the source of the method I represent has to be formatted to reflect dynamic information about this method in the definition view.!

OBEnrichedMethodNode subclass: #OBEnrichedMessageNode
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedMessageNode class methodsFor: 'instance creation' stamp: 'dr 11/16/2007 16:03'!
on: aSelector inMethod: aSelector2 inClass: classRef
     ^(self on: (HODataBase default modelMethodFor: (MethodReference class: classRef selector: aSelector2))) 
            setMessage: aSelector selector: aSelector2 class: classRef! !

!OBEnrichedMessageNode methodsFor: 'converting' stamp: 'dr 11/16/2007 15:50'!
asMethodNode
	^ OBEnrichedMethodNode on: selector inClass: self theClass! !

!OBEnrichedMessageNode methodsFor: 'displaying' stamp: 'dr 11/16/2007 15:51'!
name
	^ message! !

!OBEnrichedMessageNode methodsFor: 'accessing' stamp: 'dr 11/16/2007 15:50'!
selection
	| methodNode assoc |
	methodNode := Parser new 
					parse: self source
					class: self theClass.
	assoc := (methodNode encoder rawSourceRanges) 
			associations detect: [:ea | ea key selectorIs: message]
						ifNone: [nil -> (1 to: 0)].
						"Some messages are generated by the compiler."
	^ assoc value! !

!OBEnrichedMessageNode methodsFor: 'initializing' stamp: 'dr 11/16/2007 15:50'!
setMessage: aSelector selector: aSelector2 class: aClass
	message := aSelector.
	selector := aSelector2.
	self theClass: aClass! !

!OBEnrichedMethodNode class methodsFor: 'instance creation' stamp: 'dr 2/23/2008 16:11'!
fromMethodNode: aNode
    ^(self on: ((Smalltalk at: #HODataBase) default modelMethodFor: aNode reference)) metaNode: aNode metaNode; yourself! !

!OBEnrichedMethodNode class methodsFor: 'instance creation' stamp: 'dr 4/22/2008 17:21'!
on: aHOMethod
    ^(super on: aHOMethod methodReference) setModelMethod: aHOMethod; yourself! !

!OBEnrichedMethodNode class methodsFor: 'instance creation' stamp: 'dr 4/22/2008 17:21'!
on: aHOMethod referencedClass: aClass
    ^(super on: aHOMethod methodReference) setModelMethod: aHOMethod; setReferencedClass: aClass; yourself! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 2/21/2008 12:21'!
currentParent
    ^currentParent! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/10/2008 15:08'!
definition
	^ (OBEnrichedMethodDefinition
		selection: self selection
		source: self source
		inClass: self theClass) setFormatter: formatter! !

!OBEnrichedMethodNode methodsFor: 'displaying' stamp: 'dr 11/5/2007 16:58'!
displayString
    | string |
    string := super displayString.  
    self isHighlighted ifTrue: [^string asText addAttribute: TextColor green].
    ^string! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 1/29/2008 17:08'!
formatter
	^formatter! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/10/2008 15:06'!
getDefinition
	definition ifNil: [definition := self definition].
	^definition! !

!OBEnrichedMethodNode methodsFor: 'initializing' stamp: 'dr 10/15/2007 16:23'!
initialize
    super initialize.
    isHighlighted := false! !

!OBEnrichedMethodNode methodsFor: 'testing' stamp: 'dr 4/23/2008 14:29'!
invokesMethod: methodRef
    ^modelMethod invokesMethod: methodRef! !

!OBEnrichedMethodNode methodsFor: 'ancestry' stamp: 'dr 4/10/2008 14:41'!
isDescendantOf: aNode 
    ^aNode = self! !

!OBEnrichedMethodNode methodsFor: 'ancestry' stamp: 'dr 2/21/2008 14:49'!
isDescendantOfClassRef: aNode
    self currentParent ifNotNil: [self currentParent = aNode ifFalse: [^false]].
    ^self referencingClasses includes: aNode! !

!OBEnrichedMethodNode methodsFor: 'ancestry' stamp: 'dr 4/10/2008 14:00'!
isDescendantOfMethod: aNode
    ^aNode = self or: [aNode selector = self selector]! !

!OBEnrichedMethodNode methodsFor: 'highlighting' stamp: 'dr 10/15/2007 16:22'!
isHighlighted
    ^isHighlighted! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/22/2008 17:22'!
modelMethod
    ^modelMethod! !

!OBEnrichedMethodNode methodsFor: 'calculating' stamp: 'dr 4/23/2008 09:55'!
numberOfReferences
   ^self modelMethod numberOfReferencesToClass: self referencedClass! !

!OBEnrichedMethodNode methodsFor: 'calculating' stamp: 'dr 4/23/2008 10:02'!
ratioNumberOfReferences
   ^((100 * (self numberOfReferences / totalNumberOfRefs)) printShowingDecimalPlaces: 2), '%'! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 11/16/2007 16:38'!
referencedClass
    ^referencedClass! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 2/21/2008 12:22'!
setCurrentParent: aNode
    currentParent := aNode! !

!OBEnrichedMethodNode methodsFor: 'highlighting' stamp: 'dr 10/15/2007 16:22'!
setIsHighlighted
    isHighlighted := true! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/22/2008 17:22'!
setModelMethod: aMetaMethod
    modelMethod := aMetaMethod! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 10/5/2007 11:20'!
setReferencedClass: aClass
	referencedClass := aClass! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/23/2008 10:06'!
setTotalNumberOfRefs: anInteger
    totalNumberOfRefs := anInteger! !

!OBEnrichedMethodNode methodsFor: 'highlighting' stamp: 'dr 10/15/2007 16:40'!
setUnhighlighted
    isHighlighted := false! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/22/2008 17:22'!
source
	| method |
	method := self theClass compiledMethodAt: self selector ifAbsent: [^ self defaultSource].
	formatter := HOFormatter metaMethod: self modelMethod referencedClass: referencedClass.
	^formatter formatCodeForMethod: method! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/10/2008 14:00'!
species
    ^OBMethodNode! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/22/2008 17:23'!
updateModelMethod
    modelMethod := HODataBase default modelMethodFor: self reference! !

!OBEnrichedMethodNode methodsFor: 'displaying' stamp: 'dr 4/23/2008 10:07'!
usageName
    ^self fullName, ' (', self numberOfReferences asString, ', ', self ratioNumberOfReferences, ')'! !

OBMethodNode subclass: #OBMethodExtensionNode
	instanceVariableNames: 'categoryExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 3/5/2008 15:56'!
category
    ^self reference category asString asLowercase! !

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 13:55'!
categoryExtensionNode: aCategoryExtensionNode
    categoryExtensionNode := aCategoryExtensionNode! !

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:47'!
classExtensionNode
    ^categoryExtensionNode classExtensionNode! !

!OBMethodExtensionNode methodsFor: 'displaying' stamp: 'dr 3/5/2008 16:05'!
displayString
    | text |
    text := super displayString asText.
    (self category allButFirst beginsWith: self extensionName asLowercase) ifTrue: [
	   text addAttribute: TextEmphasis bold.
	   (self category includesSubString: '-overrides') ifTrue: [text addAttribute: TextColor red].	   	      
    ].
    ^text! !

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:21'!
extensionName
   ^categoryExtensionNode extensionName! !

!OBMethodExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 14:48'!
isDescendantOfClass: aClassNode
   ^((super isDescendantOfClass: aClassNode) and: [aClassNode isKindOf: OBClassExtensionNode]) 
                                                    and: [self classExtensionNode = aClassNode]! !

!OBMethodExtensionNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 17:22'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self classExtensionNode package ifFalse: [^false].
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.! !

!OBMethodExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 15:29'!
isDescendantOfMethodCat: other 
   ^(super isDescendantOfMethodCat: other) "and: [categoryExtensionNode class = other class]"! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:56'!
classHierarchy
    ^self classNode classHierarchy! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 17:14'!
comesFrom
	^ self theClass traitOrClassOfSelector: self selector! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 20:31'!
comesFromName
	^ self comesFrom asString! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 17:41'!
comesFromTrait
	^ self comesFrom isTrait! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 21:29'!
confirmSelectorExclusion
	| senders prompt m1 m2 m3 |
	senders := SystemNavigation default allCallsOn: self selector.
	prompt := 'The selector you want to remove comes from a trait.
What do you want to do:' translated.
	m1 := 'Exclude selector from use in the class ' translated , self theClassName.
	m2 := 'Remove selector in the trait ' translated , self comesFromName , ' (' , senders size asString , ' senders' translated , ')'.
	m3 := 'Cancel' translated.
	^ OBChoiceRequest
		prompt: prompt
		labels: (Array
				with: m1
				with: m2
				with: m3)
		values: #(#doExcludeSelector #removeFromTrait nil )! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:03'!
displayFullString
    ^self fullName! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 20:32'!
doExcludeSelector
	| traits composition |
	traits := self theClass traitComposition traits
				select: [:each | each canUnderstand: self selector].
	composition := traits
				inject: self theClass traitComposition
				into: [:newComposition :each | newComposition copyWithExclusionOf: self selector to: each].
	self theClass setTraitComposition: composition asTraitComposition.
	self signalDeletion! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 20:34'!
doNothing! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:16'!
dropOnSmartGroup: aNode

	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 21:08'!
excludeSelector
	| r |
	r := self confirmSelectorExclusion.
	r ifNotNil: [self perform: r]! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 9/4/2008 16:51'!
findOverriddenClass
	self theClass allSuperclassesDo: 
		[:class | (class includesSelector: self selector) ifTrue: [^ class]].
	^ nil! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 9/25/2008 15:02'!
findOverriddenClasses
	^self theClass allSuperclasses select: [:class | class includesSelector: self selector]! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 9/24/2008 16:00'!
findOverriddingClasses
	^self theClass allSubclasses select: [:class | class includesSelector: self selector]! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 4/23/2008 14:31'!
invokesMethod: methodRef
   ^false! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/30/2007 09:40'!
isConflict
	^ (self theClass compiledMethodAt: self selector ifAbsent: [^false]) isConflict! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/30/2007 09:41'!
isExplicitlyRequired
	^ (self theClass
		compiledMethodAt: self selector
		ifAbsent: [^ false]) isExplicitlyRequired! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 12/22/2008 14:05'!
isInstrumented 
    ^(Smalltalk hasClassNamed: #HODataBase) and: [(Smalltalk at: #HODataBase) default isInstrumentedMethod: self reference]! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:06'!
isMethodHolderNode
    ^true! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 14:05'!
isNodeWithReferences
    ^true! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/30/2007 10:36'!
isRequired
	^ (self theClass
		compiledMethodAt: self selector
		ifAbsent: [^ true]) isRequired! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 14:23'!
prefixedName
    ^'#', self name! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 1/18/2008 17:31'!
referencedClass
    ^nil! !

!OBMethodNode methodsFor: '*ob-enhancements-traits' stamp: 'jk 8/25/2007 21:30'!
removeFromTrait
	self comesFrom removeSelector: self selector.
	self signalDeletion! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 12/16/2008 15:43'!
runTestCommandClass
	"answer cmd class to run tests of this type of node"
	^OBCmdTestMethod! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 10/15/2007 16:43'!
setUnhighlighted
    ! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 4/22/2008 17:23'!
updateModelMethod! !

OBMethodNode subclass: #OBPackageMethodNode
	instanceVariableNames: 'packageNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackageMethodNode methodsFor: 'displaying' stamp: 'dr 7/10/2008 16:15'!
displayString
    | cat methodText |
    cat := self category. 
    methodText := self name asText.
    (packageNode realClasses includes: theClass theNonMetaClass) ifTrue: [
	   ^(cat beginsWith: '*') ifTrue: [methodText addAttribute: TextEmphasis italic] ifFalse: [methodText].
    ] ifFalse: [
	   ^((cat beginsWith: '*') and: [cat allButFirst asLowercase beginsWith: packageNode name asLowercase]) 
	       ifTrue: [methodText addAttribute: TextEmphasis bold] ifFalse: [methodText addAttribute: TextEmphasis italic].        
    ]! !

!OBPackageMethodNode methodsFor: 'accessing' stamp: 'dr 7/10/2008 16:01'!
packageNode: aPackageNode
    packageNode := aPackageNode! !

!OBPackageMethodNode methodsFor: 'accessing' stamp: 'dr 10/21/2008 09:51'!
species
    ^OBMethodNode! !

OBCmdRemoveClass subclass: #OBCmdRemoveClassButUsedTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdRemoveClassButUsedTrait methodsFor: 'testing' stamp: 'jk 9/21/2007 00:54'!
isActive
	^ super isActive
		and: [target isUsedTrait not]! !

OBMethodSearchNode subclass: #OBEnhancementMethodSearchNode
	instanceVariableNames: 'isWild'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBEnhancementMethodSearchNode class methodsFor: 'instance creation' stamp: 'dr 5/14/2008 10:53'!
on: aString isWild: aBoolean
   ^(self on: aString) setIsWild: aBoolean; yourself.! !

!OBEnhancementMethodSearchNode methodsFor: 'searching' stamp: 'dr 10/22/2008 09:48'!
classSatisfiesQuery: aClass
	^ aClass selectors anySatisfy: [:ea | ea includesSubstring: query caseSensitive: false]
	     ! !

!OBEnhancementMethodSearchNode methodsFor: 'searching' stamp: 'dr 10/22/2008 09:48'!
classes 
	| nav classes |  self flag: #optimize.
	nav := self systemNavigation.
	classes := IdentitySet new.
	classes  addAll: (nav allClassesImplementing: query).
	classes ifEmpty: [
	    (Symbol selectorsContaining: query) do: [:ea | classes addAll: (nav allClassesImplementing: ea)]].
	^ classes asArray collect: [:ea | OBClassNode on: ea]! !

!OBEnhancementMethodSearchNode methodsFor: 'searching' stamp: 'dr 10/22/2008 09:41'!
methodSatisfiesQuery: methodRef
    ^methodRef methodSymbol includesSubstring: query caseSensitive: false! !

!OBEnhancementMethodSearchNode methodsFor: 'display' stamp: 'dr 5/14/2008 13:31'!
name
     | name |
     name := query.
     isWild ifTrue: [name := name, '*'].
	^name, ' (implementors)'! !

!OBEnhancementMethodSearchNode methodsFor: 'accessing' stamp: 'dr 5/14/2008 10:54'!
setIsWild: aBoolean
    isWild := aBoolean! !

!OBMethodSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 8/11/2008 14:52'!
isMethodSearch
    ^true! !

!OBCmdBrowseList methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 11:21'!
implementorsSelector
    ^#implementorsOf:! !

OBCmdBrowseList subclass: #OBCmdDynamicImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdDynamicImplementors methodsFor: 'configuration' stamp: 'dr 10/1/2007 16:08'!
announcementClass
	^ OBShowDynamicImplementors! !

!OBCmdDynamicImplementors methodsFor: 'configuration' stamp: 'dr 9/13/2007 11:01'!
browserClass
    ^OBDynamicImplementorsBrowser! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 10/8/2007 16:44'!
execute
    | method selectors selection messages messageNode implementors |
    method := target reference compiledMethod.
    (method isNil or: [(messages := method reflectiveMethod messages) size == 0])
		 ifTrue: [self inform: 'No messages sent in this method'. ^self].
		
    selectors := OrderedCollection new.
    selectors addAll: messages asSortedCollection.

    selection := OBChoiceRequest labels: selectors.
    selection ifNotNil: [implementors := target perform: self implementorsSelector with: selection.
		                implementors ifNotEmpty: [messageNode := OBMessageNode on: selection inMethod: target selector inClass: target theClass].
         messageNode ifNil: [self inform: 'No ', self label, ' found!!']
                         ifNotNil: [(requestor announce: (self announcementClass of: messageNode)) execute].	
    ].! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 10/16/2007 10:15'!
group
	^ #dynamic! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 12/22/2008 14:03'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(target isKindOf: OBMethodNode) and: [(requestor isSelected: target) and: [Smalltalk hasClassNamed: #HODataBase]]! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 9/13/2007 11:01'!
label
    ^'dynamic implementors'! !

OBCmdBrowseList subclass: #OBCmdDynamicSenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:43'!
announcementClass
	^ OBShowDynamicSenders! !

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:45'!
browserClass
    ^OBDynamicSendersBrowser! !

!OBCmdDynamicSenders methodsFor: 'command' stamp: 'dr 10/16/2007 10:15'!
group
	^ #dynamic! !

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 12/22/2008 14:03'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(target isKindOf: OBMethodNode) and: [(requestor isSelected: target) and: [Smalltalk hasClassNamed: #HODataBase]]! !

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:45'!
label
    ^'dynamic senders'! !

OBPluggableTextMorphWithShout subclass: #OBEnrichedPluggableTextMorph
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedPluggableTextMorph commentStamp: 'dr 10/11/2007 10:39' prior: 0!
I am an enriched text morph. I can display icons to depict special, dynamic information about the method whose source code is represented in this text morph.
I need to access the formatter stored in the model (an enriched definition panel) to insert the icons.!

!OBEnrichedPluggableTextMorph methodsFor: 'private' stamp: 'dr 5/5/2008 11:42'!
insertIconsOffset: offset 

     model formatter ifNotNilDo: [:formatter | 
	    formatter iconPositions keysAndValuesDo: [:node :iconPos | | x y yDelta lineStartPos lineTextMorph position iconName imageMorph |
		   iconPos ifNotNil: [
	        x := iconPos first. y := iconPos second. 
	        lineStartPos := text string findString: (text string lineNumber: y). 
	        lineTextMorph := OBTextMorph new contents: (text copyFrom: lineStartPos to: x + lineStartPos). 
	        textMorph ifNotNil: [lineTextMorph setTextStyle: textMorph textStyle].
	        yDelta := 2.
             iconName := node iconNameFor: self methodReference.
             iconName ifNil: [^self].
             lineTextMorph height > 16 ifTrue: [yDelta := 5. iconName := (iconName, 'Big') asSymbol].

	        position := (self position x + lineTextMorph width + 3) @ (self position y + (lineTextMorph height * (y - 1) - ((y -1) * 2) + yDelta)).
	        position := position x @ (position y - offset).
	        (self containsPoint: (position x @ (position y + 4))) ifTrue: [
	            imageMorph := ImageMorph new setNewImageFrom: (OBMorphicIcons iconNamed: iconName).
	            imageMorph on: #click send: #openDynamicListFor:event:from: to: self withValue: node.	         
		       self addMorphFront: imageMorph fromWorldPosition: position].
	        ]
	    ]
     ]! !

!OBEnrichedPluggableTextMorph methodsFor: 'accessing' stamp: 'dr 10/2/2007 16:11'!
methodReference
    ^model methodReference! !

!OBEnrichedPluggableTextMorph methodsFor: 'events' stamp: 'dr 4/21/2008 17:31'!
openDynamicListFor: anRBNode event: evt from: aMorph
    | selection references values uiFeedback | 
    references := anRBNode referencesInMethod: self methodReference.
    values := anRBNode valuesForReferences: references. 

    values ifNotEmpty: [
         (selection := anRBNode preselectionForValues: values) ifNil: [
		   selection := OBChoiceRequest prompt: nil labels: (anRBNode labelsForReferences: references) values: values].
         selection ifNotNil: [
	          model browser isClassBrowser 
	                 ifTrue: [model browser jumpTo: selection asNode]
	                 ifFalse: [OBCodeBrowser defaultBrowserClass openOnNode: selection asNode]. 
	          "model browser announce: (SBAnnouncement browser: model browser action: anRBNode actionLabel)"]
    ] ifEmpty: [
        uiFeedback := (UIManager default perform: anRBNode informSelector with: anRBNode noReferencesFoundMsg).
        (uiFeedback isBoolean and: [uiFeedback]) ifTrue: [
	       anRBNode executeAlternativeActionFor: self methodReference.
	   ]
    ]. ! !

!OBEnrichedPluggableTextMorph methodsFor: 'private' stamp: 'dr 4/10/2008 14:09'!
refreshIconsOffset: offset
    self removeIcons. 
    self insertIconsOffset: offset.! !

!OBEnrichedPluggableTextMorph methodsFor: 'private' stamp: 'dr 10/1/2007 14:45'!
removeIcons
     (self submorphsSatisfying: [:ea | ea basicType = #Image]) do: [:ea | ea delete].

	

! !

!OBEnrichedPluggableTextMorph methodsFor: 'model access' stamp: 'dr 4/10/2008 14:17'!
setText: aText
     text := aText.
     super setText: aText.

	

! !

!OBEnrichedPluggableTextMorph methodsFor: 'events' stamp: 'dr 11/21/2007 10:21'!
vScrollBarValue: scrollValue
    super vScrollBarValue: scrollValue.
    self refreshIconsOffset: (self vLeftoverScrollRange * scrollValue) rounded.! !

OBImplementorsBrowser subclass: #OBDynamicImplementorsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicImplementorsBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 17:17'!
chasingBrowsers
    ^false! !

!OBDynamicImplementorsBrowser class methodsFor: 'configuration' stamp: 'dr 9/13/2007 11:20'!
defaultMetaNode
	^self implementorsNav: #dynamicImplementors! !

!OBDynamicImplementorsBrowser class methodsFor: 'configuration' stamp: 'dr 4/11/2008 16:43'!
definitionPanel
     ^OBEnrichedDefinitionPanel new! !

!OBDynamicImplementorsBrowser class methodsFor: 'configuration' stamp: 'dr 9/13/2007 11:20'!
title
	^'Dynamic Implementors of'! !

!OBImplementorsBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:36'!
hasReferencePanel
    ^self dynamicBrowser! !

!OBPosition methodsFor: '*ob-enhancements' stamp: 'jk 4/4/2008 10:43'!
asTreePosition
	^ OBTreePosition index: self index! !

OBCommand subclass: #OBCmdAddPackageOnTop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddPackageOnTop methodsFor: 'execution' stamp: 'dr 11/10/2008 15:50'!
execute
    target isOnTop ifTrue: [OBPackageBrowser removeTopPackage: target workingCopy] 
                     ifFalse: [OBPackageBrowser addTopPackage: target workingCopy]. 
	requestor browser root resetCache.
	requestor listChanged.
	self select: target with: requestor announcer! !

!OBCmdAddPackageOnTop methodsFor: 'accessing' stamp: 'dr 9/9/2008 17:52'!
group
    ^#navigation! !

!OBCmdAddPackageOnTop methodsFor: 'testing' stamp: 'dr 9/9/2008 17:41'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdAddPackageOnTop methodsFor: 'accessing' stamp: 'dr 9/10/2008 10:28'!
label
    ^target isOnTop ifTrue: ['remove packge from top'] 
                      ifFalse: ['place package on top']! !

OBCommand subclass: #OBCmdAddSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 15:52'!
execute
	| name |
	name := OBTextRequest 
					prompt: 'Please type new category name' 
					template: ''.
	name ifNil: [^self].

    requestor panel smartGroup addNode: (OBSmartGroupNode name: name).
    requestor panel columns first refresh.! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:18'!
group
	^ #general! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 7/8/2008 16:41'!
isActive
     target isEnvironment ifFalse: [^false].
	^(target isSmartGroup and: [requestor isSelected: target]) or: [requestor switch selection = requestor browser class smartGroupSwitchIndex]! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 3/1/2008 17:06'!
label
    ^'new smart group...'! !

OBCommand subclass: #OBCmdAddToSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 3/18/2008 17:09'!
execute
    | selection smartGroups |

    smartGroups := requestor panel smartGroup nodes select: [:ea | ea isSmartGroupCategory and: [ea isSearchGroup not]].

    selection := OBChoiceRequest prompt: nil labels: (smartGroups collect: [:ea | ea name]) values: smartGroups.
    selection ifNotNil: [selection addAlias: target].

    requestor panel columns first refresh.
    self select: target with: requestor announcer! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
group
	^ #navigation! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 7/11/2008 11:11'!
isActive
	^target isSmartGroup not
		and: [target isDummy not and: [requestor isSelected: target]]! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
label
    ^'add to smart group'! !

OBCommand subclass: #OBCmdAddWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 12/15/2008 10:31'!
execute
	| name package workingCopy |
	name := FillInTheBlankMorph request: 'Name of package:'. 
	name isEmptyOrNil ifTrue: [^self].
	PackageInfo named: name. 
	package := (MCPackage new name: name).
	workingCopy := MCWorkingCopy forPackage: package. 
	requestor browser root resetCache.	
	requestor listChanged. 
	self select: (OBMonticelloPackageNode on: workingCopy) with: requestor announcer.
	requestor changed: #list.! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 5/3/2007 16:15'!
group
	^ #general! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 12/18/2007 16:37'!
icon
	^ #newIcon! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 3/12/2008 15:16'!
isActive
	^ target isEnvironment and: [requestor switch selection < 2]! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 5/3/2007 16:15'!
label
    ^'add package'! !

OBCommand subclass: #OBCmdBrowseDynamicReferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdBrowseDynamicReferences methodsFor: 'execution' stamp: 'dr 10/9/2007 17:04'!
execute
	OBDynamicReferenceBrowser browseRoot: target theNonMetaClass asNode ! !

!OBCmdBrowseDynamicReferences methodsFor: 'accessing' stamp: 'dr 10/16/2007 10:16'!
group
	^ #dynamic! !

!OBCmdBrowseDynamicReferences methodsFor: 'testing' stamp: 'dr 12/22/2008 14:02'!
isActive
	^(((target isKindOf: OBClassAwareNode)
		and: [requestor isSelected: target]) and: [Smalltalk hasClassNamed: #HODataBase]) 
		and: [(Smalltalk at: #HODataBase) default includesClass: target theClass]! !

!OBCmdBrowseDynamicReferences methodsFor: 'testing' stamp: 'dr 10/15/2007 11:02'!
isReferenceListCmd
    ^true! !

!OBCmdBrowseDynamicReferences methodsFor: 'accessing' stamp: 'dr 11/12/2007 10:49'!
label
	^ 'browse dynamic references'! !

OBCommand subclass: #OBCmdBrowseMethodImplementor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdBrowseMethodImplementor methodsFor: 'execution' stamp: 'jk 6/20/2007 16:33'!
execute
	| class |
	class := target theClass traitOrClassOfSelector: target selector.
	(OBMethodNode on: target selector inClass: class) browse! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:34'!
group
	^ #navigation! !

!OBCmdBrowseMethodImplementor methodsFor: 'testing' stamp: 'dr 9/22/2008 11:18'!
isActive 
	^ (target isKindOf: OBMethodNode)
		and: [requestor isSelected: target]! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:38'!
keystroke
	^ $M! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:27'!
label
	^ 'browse method implementor'! !

OBCommand subclass: #OBCmdBrowsePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdBrowsePackage methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:34'!
execute
	(MCSnapshotBrowser forSnapshot: target package snapshot)
			label: 'Snapshot Browser: ', target packageName;
			show! !

!OBCmdBrowsePackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:34'!
group
    ^#general! !

!OBCmdBrowsePackage methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:08'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdBrowsePackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:34'!
label
    ^'browse package'! !

OBCommand subclass: #OBCmdBrowseTraitUsers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdBrowseTraitUsers methodsFor: 'execution' stamp: 'ab 6/6/2007 00:00'!
execute
	| users usersNames selection |
	"ugly hack to get rid of double..."
	users := target theClass users asOrderedCollection asSet asOrderedCollection.
	(users size = 0)
		ifTrue: [Beeper beep. ^ self].
	(users size = 1)
		ifTrue: [users first browse. ^ self].
		
	usersNames := users asOrderedCollection collect: [:clsOrTrait| clsOrTrait name].
	selection := OBChoiceRequest prompt: nil labels: usersNames values: users.
	selection ifNotNil: [selection browse].! !

!OBCmdBrowseTraitUsers methodsFor: 'testing' stamp: 'ab 6/5/2007 23:52'!
isActive

	^ ((target isKindOf: OBClassNode) and: 
		[target theClass isTrait]) and:
			[requestor isSelected: target]! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
keystroke
	^ $u! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
label
	^ 'browse trait users...'! !

OBCommand subclass: #OBCmdCheckRecentStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdCheckRecentStatus methodsFor: 'execution' stamp: 'dr 12/10/2008 10:47'!
execute
    target updateRecentStatus.
	requestor changed: #list.! !

!OBCmdCheckRecentStatus methodsFor: 'accessing' stamp: 'dr 7/21/2008 10:44'!
group
    ^#general! !

!OBCmdCheckRecentStatus methodsFor: 'testing' stamp: 'dr 7/21/2008 11:17'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdCheckRecentStatus methodsFor: 'accessing' stamp: 'dr 7/21/2008 10:46'!
label
    ^'check recent status'! !

OBCommand subclass: #OBCmdCreateMonticelloCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdCreateMonticelloCategory methodsFor: 'execution' stamp: 'dr 2/9/2009 16:29'!
execute
	| organization catName |
	organization := target organization.
	catName := OBTextRequest 
					prompt: 'Please type new category name' 
					template: self template.
	catName ifNil: [^self].
	(catName beginsWith: self template) ifFalse: [^self inform: 'Class category should start with package name.']. 				
					
	catName ifNotNil: [
	   	organization addCategory: catName.
		target resetCache.	
	   	requestor listChanged.
	   	self select: (OBMonticelloClassCategoryNode on: catName workingCopy: target workingCopy) with: requestor announcer.
	   	requestor changed: #list.
	].! !

!OBCmdCreateMonticelloCategory methodsFor: 'accessing' stamp: 'dr 12/18/2007 16:37'!
icon
	^ #newIcon! !

!OBCmdCreateMonticelloCategory methodsFor: 'testing' stamp: 'dr 4/11/2008 14:06'!
isActive
    ^(requestor isSelected: target) and: [target isPackage]! !

!OBCmdCreateMonticelloCategory methodsFor: 'accessing' stamp: 'dr 12/18/2007 17:03'!
label
   ^'create category'! !

!OBCmdCreateMonticelloCategory methodsFor: 'accessing' stamp: 'dr 8/11/2008 11:43'!
template
    ^target systemCategoryPrefix, '-'! !

OBCommand subclass: #OBCmdDisplayReferencingPlaces
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 2/23/2008 16:11'!
execute
    | nodesToSelect |
    requestor currentNode isMethodHolderNode ifTrue: [
        nodesToSelect := (Smalltalk at: #HODataBase) default nodesReferencingClass: target theClass inMethod: requestor currentNode reference.
        requestor selectReferencingCodeNodes: nodesToSelect.
    ] ifFalse: [
        nodesToSelect := (Smalltalk at: #HODataBase) default methodsReferencingClass: target theClass inClass: requestor currentNode theClass.
        requestor selectReferencingMethods: nodesToSelect.
    ].
    ! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/15/2007 11:09'!
group
	^ #navigation! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/16/2007 10:33'!
isActive
    ^requestor isKindOf: OBReferenceList! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/15/2007 10:59'!
isReferenceListCmd
    ^true! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/16/2007 10:31'!
label
     ^requestor currentNode isMethodHolderNode ifTrue: ['select referencing variables']
                                                        ifFalse: ['select referencing methods']
! !

OBCommand subclass: #OBCmdExcludeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdExcludeClass methodsFor: 'execution' stamp: 'jk 8/26/2007 14:57'!
execute
	(OBConfirmationRequest 
		prompt: 'Are you certain that you 
want to REMOVE the trait ' 
				, target theNonMetaClassName , ' from the composition of ', target parentNode theNonMetaClassName, '?'
		confirm: 'Remove') ifFalse: [^ self].

	target parentNode theNonMetaClass traitComposition removeFromComposition: target theNonMetaClass.
	target signalDeletion! !

!OBCmdExcludeClass methodsFor: 'accessing' stamp: 'jk 8/26/2007 12:27'!
group
	^ #identity! !

!OBCmdExcludeClass methodsFor: 'accessing' stamp: 'jk 8/26/2007 12:25'!
icon
	^ #deleteIcon! !

!OBCmdExcludeClass methodsFor: 'testing' stamp: 'jk 8/26/2007 12:26'!
isActive
	^ (target isKindOf: OBClassNode) and: [requestor isSelected: target] and: [target isUsedTrait]! !

!OBCmdExcludeClass methodsFor: 'accessing' stamp: 'jk 8/26/2007 12:26'!
keystroke
	^ $x! !

!OBCmdExcludeClass methodsFor: 'accessing' stamp: 'jk 8/26/2007 14:50'!
label
	^ 'remove from composition...'! !

OBCommand subclass: #OBCmdExcludeMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:28'!
execute
	target excludeSelector! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:50'!
icon
	^ #deleteIcon! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 16:44'!
isActive
	^(target isKindOf: OBMethodNode) and:
		[requestor isSelected: target] and:
		[ target isLocalSelector not ]! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:50'!
keystroke
	^ $x! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:51'!
label
	^ 'exclude/remove...'! !

OBCommand subclass: #OBCmdFocusOnClassInHierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdFocusOnClassInHierarchy commentStamp: 'dr 4/14/2008 15:40' prior: 0!
Special command triggered when a class in the class hierarchy browser gets double-clicked to focus in the hierarchy on that specific class.!

!OBCmdFocusOnClassInHierarchy methodsFor: 'execution' stamp: 'dr 4/14/2008 16:33'!
execute
   requestor panel changeRootNode: target.! !

!OBCmdFocusOnClassInHierarchy methodsFor: 'testing' stamp: 'dr 4/14/2008 15:39'!
isActive
    ^false! !

OBCommand subclass: #OBCmdImportPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdImportPackage methodsFor: 'execution' stamp: 'dr 7/4/2008 10:25'!
execute
    | repo repos newLabel labels lines values | 
	newLabel := 'new...'.
	labels := OrderedCollection with: newLabel. 
	values := OrderedCollection with: newLabel. 
     repos := MCRepositoryGroup default repositories asSortedCollection: [:a :b | a description <= b description].
     lines := #(1).
     labels addAll: (repos collect: [:ea | ea description]).
     repo := OBChoiceRequest prompt: 'Import package' labels: labels values: (values, repos) lines: lines.

     repo ifNotNil: [
         repo = newLabel ifTrue: [repo := self requestRepositoryToUser].    
	    repo ifNotNil: [target workingCopy repositoryGroup addRepository: repo] ifNil: [^self].
	
	    "now add that package to this repo..."
		target workingCopy newVersion ifNotNilDo:
			[:v |
			(MCVersionInspector new version: v) show.
			Cursor wait showWhile: [repo storeVersion: v].
			MCCacheRepository default cacheAllFileNamesDuring: 
				[repo cacheAllFileNamesDuring: 
					[v allAvailableDependenciesDo:
						[:dep |
						(repo includesVersionNamed: dep info name)
							ifFalse: [repo storeVersion: dep]]]]]
     ].! !

!OBCmdImportPackage methodsFor: 'accessing' stamp: 'dr 7/3/2008 17:47'!
group
	^ #general! !

!OBCmdImportPackage methodsFor: 'testing' stamp: 'dr 7/4/2008 10:21'!
isActive 
	^(target isPackage and: [requestor switch selection < 2]) and: [target workingCopy repositoryGroup repositories size < 2]! !

!OBCmdImportPackage methodsFor: 'accessing' stamp: 'dr 7/3/2008 17:46'!
label
   ^'import package in repository...'! !

!OBCmdImportPackage methodsFor: 'execution' stamp: 'dr 7/3/2008 18:11'!
requestRepositoryToUser
	^MCHttpRepository morphicConfigure! !

OBCommand subclass: #OBCmdJumpToReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 2/16/2008 16:15'!
execute
    requestor jumpTo: target! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 10/15/2007 11:04'!
group
	^ #navigation! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 2/16/2008 16:14'!
isActive
	^target isKindOf: OBClassReferenceNode! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 10/15/2007 10:59'!
isReferenceListCmd
    ^true! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 2/16/2008 16:16'!
label
    ^'browse'! !

OBCommand subclass: #OBCmdMethodToExtendClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdMethodToExtendClass methodsFor: 'execution' stamp: 'dr 7/17/2008 11:39'!
execute
    | className categoryName |
    className := OBTextRequest
					prompt: 'Type the name of the class ', String cr, 'you want to extend with this method:' 
					template: target theClass theNonMetaClass name asString.

    className ifNotNil: [
	    (Smalltalk hasClassNamed: className asSymbol) ifFalse: [^self inform: 'Class ', className, ' does not exist!!'].
	    categoryName := '*', target theClass basicCategory asLowercase.		
         (Smalltalk at: className asSymbol) compile: target source
						classified: categoryName
						notifying: nil.
						       
	   target theClass removeSelector: target selector.
	   requestor announce: (OBNodeDeleted node: target)
    ].! !

!OBCmdMethodToExtendClass methodsFor: 'testing' stamp: 'dr 7/17/2008 11:38'!
group
    ^#general! !

!OBCmdMethodToExtendClass methodsFor: 'testing' stamp: 'dr 7/3/2008 16:39'!
isActive
	^target isMethodNode and: [requestor isSelected: target]! !

!OBCmdMethodToExtendClass methodsFor: 'testing' stamp: 'dr 7/3/2008 16:40'!
label
    ^'move to extend class...'! !

OBCommand subclass: #OBCmdMoveMethodCategoryToTrait
	uses: TOBCmdMoveToTrait
	instanceVariableNames: 'ignoreNotification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBCmdMoveMethodCategoryToTrait class
	uses: TOBCmdMoveToTrait classTrait
	instanceVariableNames: ''!

!OBCmdMoveMethodCategoryToTrait methodsFor: 'requirement' stamp: 'AlexandreBergel 1/7/2009 11:28'!
doIgnoreNotification
	ignoreNotification := true
! !

!OBCmdMoveMethodCategoryToTrait methodsFor: 'as yet unclassified' stamp: 'ab 8/31/2007 19:27'!
execute
	| methodRefs newTrait |
	methodRefs := target allMethods collect: [:each| each reference].
	newTrait := self askForNewTraitFromClass: target theClass.
	methodRefs do: [:each| self 
		moveMethodNamed: each
		inTrait: newTrait]! !

!OBCmdMoveMethodCategoryToTrait methodsFor: 'requirement' stamp: 'AlexandreBergel 1/7/2009 11:31'!
ignoreNotification
	^ ignoreNotification ! !

!OBCmdMoveMethodCategoryToTrait methodsFor: 'initialize-release' stamp: 'AlexandreBergel 1/7/2009 11:27'!
initialize
	super initialize.
	ignoreNotification := false! !

!OBCmdMoveMethodCategoryToTrait methodsFor: 'as yet unclassified' stamp: 'ab 8/31/2007 19:03'!
isActive
	^(target isKindOf: OBMethodCategoryNode) and:
		[requestor isSelected: target]! !

!OBCmdMoveMethodCategoryToTrait methodsFor: 'as yet unclassified' stamp: 'ab 8/31/2007 19:24'!
label
	^ 'move methods into new trait...'! !

OBCommand subclass: #OBCmdMoveMethodToTrait
	uses: TOBCmdMoveToTrait
	instanceVariableNames: 'ignoreNotification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBCmdMoveMethodToTrait class
	uses: TOBCmdMoveToTrait classTrait
	instanceVariableNames: ''!

!OBCmdMoveMethodToTrait methodsFor: 'requirement' stamp: 'AlexandreBergel 1/7/2009 11:35'!
doIgnoreNotification
	ignoreNotification := true! !

!OBCmdMoveMethodToTrait methodsFor: 'as yet unclassified' stamp: 'ab 9/1/2007 01:12'!
execute
	| actualClass aTrait |
	actualClass := target theClass.
	aTrait := self askForNewTraitFromClass: actualClass.
	(aTrait = false) ifTrue: [^ false].
	^ self moveMethodNamed: target reference inTrait: aTrait! !

!OBCmdMoveMethodToTrait methodsFor: 'requirement' stamp: 'AlexandreBergel 1/7/2009 11:36'!
ignoreNotification
	^ ignoreNotification ! !

!OBCmdMoveMethodToTrait methodsFor: 'initialize-release' stamp: 'AlexandreBergel 1/7/2009 11:33'!
initialize
	super initialize.
	ignoreNotification := false! !

!OBCmdMoveMethodToTrait methodsFor: 'as yet unclassified' stamp: 'ab 8/31/2007 18:46'!
isActive
	^(target isKindOf: OBMethodNode) and:
		[requestor isSelected: target]! !

!OBCmdMoveMethodToTrait methodsFor: 'as yet unclassified' stamp: 'ab 8/31/2007 18:46'!
label
	^ 'move method into new trait...'! !

OBCommand subclass: #OBCmdObserveDynamically
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 8/15/2008 12:05'!
execute
    requestor selectedNode instrument.   
    requestor updateIconOfAllPreviousColumns.
! !

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:27'!
group
    ^#dynamic! !

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 12/22/2008 14:04'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(((((target isKindOf: OBClassAwareNode) and: [requestor isSelected: target])) or: [target isEnvironment])
          and: [Smalltalk hasClassNamed: #HODataBase]) 
		and: [requestor selectedNode notNil and: [requestor selectedNode isInstrumented not]]! !

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:28'!
label
	^ 'observe dynamically'! !

OBCommand subclass: #OBCmdOpenMC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdOpenMC methodsFor: 'as yet unclassified' stamp: 'cb 7/16/2008 16:22'!
execute

	MCWorkingCopyBrowser new
		workingCopy: target workingCopy ;
		show! !

!OBCmdOpenMC methodsFor: 'as yet unclassified' stamp: 'cb 7/16/2008 12:38'!
group
    ^#general! !

!OBCmdOpenMC methodsFor: 'as yet unclassified' stamp: 'cb 7/16/2008 15:49'!
isActive

	^target isPackage and: [requestor isSelected: target]! !

!OBCmdOpenMC methodsFor: 'as yet unclassified' stamp: 'cb 7/16/2008 16:28'!
label
    ^'open in MC'! !

OBCommand subclass: #OBCmdPackageToScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdPackageToScope methodsFor: 'execution' stamp: 'dr 5/9/2008 14:10'!
execute
    ((Smalltalk at: #HOCollector) default isInPackageScope: target workingCopy) 
        ifTrue: [(Smalltalk at: #HOCollector) default removePackageFromScope: target workingCopy]
        ifFalse: [(Smalltalk at: #HOCollector) default addPackageToScope: target workingCopy]! !

!OBCmdPackageToScope methodsFor: 'accessing' stamp: 'dr 5/5/2008 11:46'!
group
    ^#dynamic! !

!OBCmdPackageToScope methodsFor: 'testing' stamp: 'dr 12/22/2008 14:07'!
isActive
	^(Smalltalk hasClassNamed: #HOCollector) and: [target isPackage and: [requestor isSelected: target]]! !

!OBCmdPackageToScope methodsFor: 'accessing' stamp: 'dr 5/9/2008 14:11'!
label
    ^((Smalltalk at: #HOCollector) default isInPackageScope: target workingCopy) 
        ifTrue: ['remove package from scope']
        ifFalse: ['add package to scope'].! !

OBCommand subclass: #OBCmdPublishPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:35'!
execute
	| repository |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^self].
	(target checkForNewerVersionsAndAskIn: repository) ifFalse: [^self].
	
	target workingCopy newVersion ifNotNilDo:
		[:v |
		(MCVersionInspector new version: v) show.
		Cursor wait showWhile: [repository storeVersion: v].
		v allAvailableDependenciesDo:
			[:dep |
			(repository includesVersionNamed: dep info name)
				ifFalse: [repository storeVersion: dep]]].
	requestor announce: (OBChildrenChanged node: requestor parent).	! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:11'!
group
    ^#general! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:07'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:10'!
label
    ^'publish'! !

OBCommand subclass: #OBCmdReferencingMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBCmdReferencingMethods methodsFor: 'execution' stamp: 'dr 4/21/2008 11:48'!
execute
    OBReferencingMethodsBrowser browseRoot: target ! !

!OBCmdReferencingMethods methodsFor: 'accessing' stamp: 'dr 4/21/2008 11:47'!
group
    ^#dynamic! !

!OBCmdReferencingMethods methodsFor: 'testing' stamp: 'dr 4/21/2008 11:47'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(target isKindOf: OBClassReferenceNode) and: [requestor isSelected: target]! !

!OBCmdReferencingMethods methodsFor: 'accessing' stamp: 'dr 4/21/2008 11:47'!
label
	^ 'analyze collaboration'! !

OBCommand subclass: #OBCmdRemoveFromSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 7/21/2008 11:42'!
execute 
    target remove.
    requestor refresh.! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
group
	^ #navigation! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 7/9/2008 10:39'!
isActive
     (target isSmartGroupCategory and: [target name = 'default' or: [target name = OBSmartRootNode searchGroupName]]) ifTrue: [^false].
	^(target isSmartGroup and: [requestor isSelected: target]) and: [target isDummy not]! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 10/22/2008 09:45'!
keystroke
	^ $x! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
label
    ^'remove'! !

OBCommand subclass: #OBCmdRemovePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemovePackage methodsFor: 'execution' stamp: 'dr 11/19/2008 14:20'!
execute
	(PopUpMenu confirm: 'Really remove package?') ifTrue: [
		"remove all class cats first"
		target classCategories do: [:node | node remove].
		
		target workingCopy unload. 
		requestor listChanged]! !

!OBCmdRemovePackage methodsFor: 'accessing' stamp: 'dr 7/3/2008 17:19'!
group
	^ #general! !

!OBCmdRemovePackage methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:01'!
icon
	^ #deleteIcon! !

!OBCmdRemovePackage methodsFor: 'testing' stamp: 'dr 4/11/2008 14:07'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdRemovePackage methodsFor: 'accessing' stamp: 'dr 4/11/2008 14:02'!
keystroke
	^ $x! !

!OBCmdRemovePackage methodsFor: 'accessing' stamp: 'dr 4/24/2007 18:49'!
label
    ^'remove package'! !

OBCommand subclass: #OBCmdReorgPackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdReorgPackages methodsFor: 'execution' stamp: 'dr 11/19/2008 16:24'!
execute
	| definition |
	definition := OBOrganizationDefinition on: OBPackageBrowser packageOrganization.
	requestor browser root resetCache.
	requestor announce: definition! !

!OBCmdReorgPackages methodsFor: 'accessing' stamp: 'dr 11/19/2008 15:08'!
group
	^ #general! !

!OBCmdReorgPackages methodsFor: 'testing' stamp: 'dr 11/19/2008 15:08'!
isActive
	^ target isPackage and: [requestor isSelected: target]! !

!OBCmdReorgPackages methodsFor: 'accessing' stamp: 'dr 11/19/2008 15:09'!
label
	^'reorganize packages'! !

OBCommand subclass: #OBCmdResetSearchSmartGroups
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdResetSearchSmartGroups methodsFor: 'execution' stamp: 'dr 7/17/2008 11:34'!
execute
     | choice |
    choice := OBConfirmationRequest prompt: 'Are you sure you want to reset all searches smart groups?' confirm: 'Reset'.
	(choice notNil and: [choice])
			ifTrue: [target reset.
                        requestor panel columns first refresh].! !

!OBCmdResetSearchSmartGroups methodsFor: 'accessing' stamp: 'dr 7/17/2008 11:31'!
group
	^ #general! !

!OBCmdResetSearchSmartGroups methodsFor: 'testing' stamp: 'dr 7/17/2008 11:30'!
isActive 
	^target isSmartGroupCategory and: [target isSearchGroup]! !

!OBCmdResetSearchSmartGroups methodsFor: 'accessing' stamp: 'dr 7/17/2008 11:31'!
label
	^ 'reset searches smart group...'! !

OBCommand subclass: #OBCmdSUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SUnit'!

!OBCmdSUnit methodsFor: 'private' stamp: 'dc 8/2/2007 17:46'!
buildSuite
	self subclassResponsibility ! !

!OBCmdSUnit methodsFor: 'execution' stamp: 'ab 12/26/2008 12:27'!
execute
	| res defectSelectors shouldDebug whatShouldBeDebugged |
	res := self buildSuite run.

	self ifSUnitSupportHistory: [self updateTestHistoryWith: res. requestor listChanged].

	res hasPassed 
		ifTrue: [self successNotification]
		ifFalse: 
			[defectSelectors := res defects collect: [:ts | ts selector].
			defectSelectors size > 2
				ifTrue: [defectSelectors := (defectSelectors copyFrom: 1 to: 2), {'...'}].
			defectSelectors := defectSelectors inject: ''
						into: [:sum :el | sum , ' ' , el asString].
			shouldDebug := UIManager default 
								confirm: (res printString ,String cr, ' => ' , defectSelectors), 
											String cr, 'Do you want to debug?'.
			whatShouldBeDebugged := res errors asArray , res failures asArray.
			shouldDebug ifTrue: [whatShouldBeDebugged first debug]]! !

!OBCmdSUnit methodsFor: 'testing' stamp: 'dr 12/3/2008 20:57'!
ifSUnitSupportHistory: aBlock
	(TestResult includesSelector: #updateResultsInHistory) ifTrue: [aBlock value]! !

!OBCmdSUnit methodsFor: 'accessing' stamp: 'dc 7/22/2007 20:45'!
keystroke
	^ $t! !

!OBCmdSUnit methodsFor: 'accessing' stamp: 'dc 7/25/2007 16:12'!
label
	^ 'run the tests'! !

!OBCmdSUnit methodsFor: 'execution' stamp: 'dc 7/25/2007 16:13'!
successNotification
	OBInformRequest message: 'All tests pass!!'! !

!OBCmdSUnit methodsFor: 'private' stamp: 'dr 11/24/2008 14:44'!
updateTestHistoryWith: aResult
	aResult dispatchResultsIntoHistory.
! !

OBCmdSUnit subclass: #OBCmdTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SUnit'!

!OBCmdTestClass methodsFor: 'execution' stamp: 'alexandre@bergel.eu 9/17/2007 11:18'!
buildSuite
	^ target theClass suite! !

!OBCmdTestClass methodsFor: 'testing' stamp: 'dc 4/24/2007 13:38'!
isActive
	^ (target isKindOf: OBClassNode)
		and: [requestor isSelected: target]
		and: [target theClass inheritsFrom: TestCase]! !

OBCmdSUnit subclass: #OBCmdTestMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SUnit'!

!OBCmdTestMethod methodsFor: 'private' stamp: 'dr 11/24/2008 14:45'!
buildSuite
	| selector tests |

	selector := target selector.
	tests := target theClass suite tests select: [ :each | selector = each selector ].
	^ TestSuite new addTests: tests
! !

!OBCmdTestMethod methodsFor: 'testing' stamp: 'SergeStinckwich 1/9/2009 14:44'!
isActive
	^ (target isKindOf: OBMethodNode)
		and: [requestor isSelected: target]
		and: [target theClass inheritsFrom: TestCase]
		and: [target selector beginsWith: 'test']
		and: [target selector isUnary]! !

!OBCmdTestMethod methodsFor: 'private' stamp: 'dr 11/24/2008 14:42'!
updateTestHistoryWith: aResult

	aResult updateResultsInHistory 
! !

OBCmdSUnit subclass: #OBCmdTestPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SUnit'!

!OBCmdTestPackage methodsFor: 'private' stamp: 'alexandre@bergel.eu 9/24/2007 11:41'!
buildSuite
	^ target classes
		inject: TestSuite new
		into: [:suite :classNode | 
				(classNode theClass inheritsFrom: TestCase)
						ifTrue: [suite addTests: classNode theClass suite tests].
				suite]	! !

!OBCmdTestPackage methodsFor: 'testing' stamp: 'dr 10/1/2008 10:47'!
isActive
	^((target isKindOf: OBClassCategoryNode) or: [target isKindOf: OBMonticelloPackageNode])
		and: [requestor isSelected: target]
		and: [target classes anySatisfy: [:cls | cls theClass inheritsFrom: TestCase]]! !

OBCmdSUnit subclass: #OBCmdTestProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SUnit'!

!OBCmdTestProtocol methodsFor: 'private' stamp: 'alexandre@bergel.eu 9/24/2007 09:55'!
buildSuite
	| selectorUnderTheCategory tests |
	selectorUnderTheCategory := target theClass organization listAtCategoryNamed: target category.
	tests := target theClass suite tests select: [:each| selectorUnderTheCategory includes: each selector].
	^ TestSuite new addTests: tests! !

!OBCmdTestProtocol methodsFor: 'testing' stamp: 'dr 11/24/2008 14:42'!
isActive
	^(target isKindOf: OBMethodCategoryNode) 
	     and: [target theClass inheritsFrom: TestCase]
	     and: [target methodReferences anySatisfy: [:ref | ref methodSymbol beginsWith: 'test']]
		and: [requestor isSelected: target]! !

!OBCmdTestProtocol methodsFor: 'private' stamp: 'dr 11/24/2008 14:41'!
updateTestHistoryWith: aResult

	aResult updateResultsInHistory 
! !

OBCommand subclass: #OBCmdSearchGroupClassRefs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdSearchGroupClassRefs methodsFor: 'execution' stamp: 'dr 8/21/2008 14:48'!
execute
    | className |
    "needs some work to find classname for sure in query"
    className := target alias query first asSymbol.
    (Smalltalk hasClassNamed: className) ifTrue: [
	    "should also work for wildcard searches"
         OBReferencesBrowser browseRoot: (Smalltalk at: className) asNode.
         ^self
    ].
    self inform: 'No references found.'.! !

!OBCmdSearchGroupClassRefs methodsFor: 'accessing' stamp: 'dr 8/11/2008 16:21'!
group
	^ #general! !

!OBCmdSearchGroupClassRefs methodsFor: 'testing' stamp: 'dr 8/11/2008 16:22'!
isActive
	^(target isSmartAlias and: [target isSearchAlias and: [target alias isClassSearch]]) and: [requestor isSelected: target]! !

!OBCmdSearchGroupClassRefs methodsFor: 'accessing' stamp: 'dr 8/11/2008 16:21'!
label
    ^'all references'! !

OBCommand subclass: #OBCmdSearchGroupImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdSearchGroupImplementors methodsFor: 'execution' stamp: 'dr 8/11/2008 15:08'!
execute
    (requestor announce: (OBShowImplementors of: target alias)) execute! !

!OBCmdSearchGroupImplementors methodsFor: 'accessing' stamp: 'dr 8/11/2008 14:45'!
group
	^ #general! !

!OBCmdSearchGroupImplementors methodsFor: 'testing' stamp: 'dr 8/11/2008 15:07'!
isActive
	^(target isSmartAlias and: [target isSearchAlias and: [target alias isMethodSearch]]) and: [requestor isSelected: target]! !

!OBCmdSearchGroupImplementors methodsFor: 'accessing' stamp: 'dr 8/11/2008 14:45'!
label
    ^'all implementors'! !

OBCommand subclass: #OBCmdSearchGroupSenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdSearchGroupSenders methodsFor: 'execution' stamp: 'dr 8/11/2008 15:32'!
execute
    (requestor announce: (OBShowSenders of: target alias)) execute! !

!OBCmdSearchGroupSenders methodsFor: 'accessing' stamp: 'dr 8/11/2008 15:31'!
group
	^ #general! !

!OBCmdSearchGroupSenders methodsFor: 'testing' stamp: 'dr 8/11/2008 15:31'!
isActive
	^(target isSmartAlias and: [target isSearchAlias and: [target alias isMethodSearch]]) and: [requestor isSelected: target]! !

!OBCmdSearchGroupSenders methodsFor: 'accessing' stamp: 'dr 8/11/2008 15:31'!
label
    ^'all senders'! !

OBCommand subclass: #OBCmdShowCollaborators
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBCmdShowCollaborators methodsFor: 'execution' stamp: 'dr 4/21/2008 17:15'!
execute
     | searchNode |
     searchNode := (OBCollaboratorsSearchNode on: target theClass name).
     requestor panel addSearchToSmartGroup: searchNode.

     requestor panel columns first refresh.     
     self select: searchNode with: requestor announcer! !

!OBCmdShowCollaborators methodsFor: 'accessing' stamp: 'dr 4/23/2008 11:58'!
group
    ^#dynamic! !

!OBCmdShowCollaborators methodsFor: 'testing' stamp: 'dr 4/23/2008 12:00'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(target isKindOf: OBEnrichedClassNode) and: [requestor isSelected: target]! !

!OBCmdShowCollaborators methodsFor: 'accessing' stamp: 'dr 4/21/2008 17:08'!
label
    ^'show collaborators'! !

OBCommand subclass: #OBCmdShowMethodInvocations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

OBCmdShowMethodInvocations subclass: #OBCmdShowFrequencyMethodInvocations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Querying'!

!OBCmdShowFrequencyMethodInvocations methodsFor: 'accessing' stamp: 'dr 8/15/2008 15:28'!
label
    ^'show method invocations (sorted by frequency)'! !

!OBCmdShowFrequencyMethodInvocations methodsFor: 'configuration' stamp: 'dr 4/25/2008 14:42'!
searchNodeClass
    ^OBMethodInvocationFrequencySearchNode! !

!OBCmdShowMethodInvocations methodsFor: 'configuration' stamp: 'dr 4/25/2008 14:34'!
commandClass! !

!OBCmdShowMethodInvocations methodsFor: 'execution' stamp: 'dr 8/15/2008 14:56'!
execute
     | searchNode query |
     query _ OBEnrichedMercuryQuery from: 
                    self searchNodeClass keyWord, ' ', target theClass name.
     searchNode _ self searchNodeClass on: query.
     requestor panel addSearchToSmartGroup: searchNode.

     requestor panel columns first refresh.! !

!OBCmdShowMethodInvocations methodsFor: 'accessing' stamp: 'dr 4/23/2008 11:58'!
group
    ^#dynamic! !

!OBCmdShowMethodInvocations methodsFor: 'testing' stamp: 'dr 4/23/2008 12:00'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(target isKindOf: OBEnrichedClassNode) and: [requestor isSelected: target]! !

!OBCmdShowMethodInvocations methodsFor: 'accessing' stamp: 'dr 4/23/2008 11:58'!
label
    ^'show method invocations'! !

!OBCmdShowMethodInvocations methodsFor: 'configuration' stamp: 'dr 4/25/2008 14:43'!
searchNodeClass
    ^OBMethodInvocationSearchNode! !

OBCommand subclass: #OBCmdStopObservingDynamically
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 8/15/2008 12:06'!
execute
    requestor selectedNode uninstrument.
    requestor updateIconOfAllColumns.! !

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:56'!
group
    ^#dynamic! !

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 12/22/2008 14:04'!
isActive
	^(((((target isKindOf: OBClassAwareNode) and: [requestor isSelected: target])) or: [target isEnvironment])
		and: [Smalltalk hasClassNamed: #HODataBase]) 
		and: [requestor selectedNode notNil and: [requestor selectedNode isInstrumented]]! !

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:56'!
label
	^ 'stop observing dynamically'! !

OBCommand subclass: #OBCmdTogglePackageScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdTogglePackageScope methodsFor: 'execution' stamp: 'dr 5/9/2008 14:11'!
execute
    (Smalltalk at: #HOCollector) default toggleIgnorePackageScope! !

!OBCmdTogglePackageScope methodsFor: 'accessing' stamp: 'dr 5/5/2008 15:25'!
group
    ^#dynamic! !

!OBCmdTogglePackageScope methodsFor: 'testing' stamp: 'dr 12/22/2008 14:07'!
isActive
	^target isEnvironment and: [Smalltalk hasClassNamed: #HOCollector]! !

!OBCmdTogglePackageScope methodsFor: 'execution' stamp: 'dr 5/9/2008 14:11'!
label
    ^(Smalltalk at: #HOCollector) default ignorePackageScope
         ifTrue: ['do not show calls outside package']
         ifFalse: ['show calls outside package']! !

OBCommand subclass: #OBCmdTraitsIntegration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Traits'!

OBCommand subclass: #OBCmdUpdatePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 10/18/2008 20:30'!
execute
	| repository versions fileName | 
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^self]. 
	(target checkForNewerVersionsIn: repository) ifFalse: [self inform: 'There are no newer versions available in this repository.'. ^self].
	
	versions := (repository versionsAvailableForPackage: target workingCopy) select: [:version | version last isDigit].
	versions := versions asSortedCollection: [:a :b | | versionNr1 versionNr2 | 
	    	versionNr1 := (a copyAfterLast: $.) asInteger.
		versionNr2 := (b copyAfterLast: $.) asInteger.
		versionNr1 >= versionNr2
	].

     (self confirm: 'Do you want to load version ', versions first, '?') ifTrue: [
	    fileName := (repository allFileNamesForVersionNamed: versions first) first.
	    Cursor wait showWhile: [(repository versionFromFileNamed: fileName) load]
	].
	
	requestor announce: (OBChildrenChanged node: requestor parent).	! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
group
    ^#general! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:07'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
label
    ^'update'! !

OBCommand subclass: #OBCmdViewChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:33'!
execute
	| patch repository |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^ self].
	patch := target workingCopy changesRelativeToRepository: repository.
	patch isNil ifTrue: [^ self].
	patch isEmpty
		ifTrue: [target workingCopy modified: false.
				self inform: 'No changes' ]
		ifFalse:
				[target workingCopy modified: true.
				(MCPatchBrowser forPatch: patch)
					label: 'Patch Browser: ', target workingCopy description;
					show]! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:36'!
group
    ^#general! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:07'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:36'!
label
    ^'changes'! !

OBCommand subclass: #OBCmdViewHistory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:33'!
execute
	target workingCopy ifNil: [^self].
	(MCWorkingHistoryBrowser new
				ancestry: target workingCopy ancestry;
				package: target package)
			label:  'Version History: ', target packageName;
			show! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
group
    ^#general! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/11/2008 14:07'!
isActive
	^target isPackage and: [requestor isSelected: target]! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
label
    ^'history'! !

!OBCommand methodsFor: '*ob-enhancements' stamp: 'dr 10/15/2007 10:58'!
isReferenceListCmd
    ^false
! !

!OBCommand methodsFor: '*ob-enhancements' stamp: 'dr 6/28/2007 16:24'!
wantsTabButton
    ^false! !

OBSystemBrowserAdaptor subclass: #OBMultipleSelectionBrowserAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'configuration' stamp: 'dr 7/19/2007 16:36'!
browserClass
    ^OBMultipleSelectionBrowser! !

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 2/23/2008 17:08'!
initialize
     "deactivate registering me as default system browser"
	"self register"! !

OBSystemBrowserAdaptor subclass: #OBPackageBrowserAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackageBrowserAdaptor class methodsFor: 'configuration' stamp: 'dr 2/15/2008 14:34'!
browserClass
    ^OBPackageBrowser! !

!OBPackageBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 12/14/2007 11:39'!
initialize
	self register! !

!OBPackageBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 10/18/2008 10:31'!
unload
    	SystemBrowser unregister: self.! !

!OBPackageBrowserAdaptor methodsFor: 'registry protocol' stamp: 'dr 12/14/2007 09:56'!
labelString
    ^'Package Browser'! !

!OBPackageBrowserAdaptor methodsFor: 'actions' stamp: 'dr 10/29/2008 15:22'!
spawnHierarchy
	^OBEnhancementHierarchyBrowser openOnClass: self targetClass! !
OBSmartRootNode initialize!
OBTextMorphEditorWithShout initialize!
OBMultipleSelectionBrowser initialize!
OBPackageBrowser initialize!
OBMultipleSelectionBrowserAdaptor initialize!
OBPackageBrowserAdaptor initialize!
